#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <richedit.h>
#include "AkelDLL.h"

#ifndef GT_SELECTION
  #define GT_SELECTION 2
#endif

int GetSelTextW(HWND hWnd, wchar_t **wpText);
void FreeSelText(LPVOID pText);

//Plugin extern function
extern "C" void __declspec(dllexport) GetSelTextTest(PLUGINDATA *pd)
{
  char *pResult;
  wchar_t *wpResult;
  int nLen;

  if (nLen=GetSelTextW(pd->hWndEdit, &wpResult))
  {
    if (pd->bOldWindows)
    {
      if (pResult=(char *)HeapAlloc(GetProcessHeap(), 0, nLen + 1))
      {
        WideCharToMultiByte(CP_ACP, 0, wpResult, nLen, pResult, nLen, NULL, NULL);
        MessageBox(pd->hMainWnd, pResult, "Test", MB_OK);
        HeapFree(GetProcessHeap(), 0, pResult);
      }
    }
    else
    {
      MessageBoxW(pd->hMainWnd, wpResult, L"Test", MB_OK);
    }
    FreeSelText(wpResult);
  }
  else MessageBox(pd->hMainWnd, "Text doesn't selected", "Test", MB_OK);
}

//Plugin extern function
extern "C" void __declspec(dllexport) OpenDialogTest(PLUGINDATA *pd)
{
  SendMessage(pd->hMainWnd, WM_COMMAND, IDM_FILE_OPEN, 0);
}

int GetSelTextW(HWND hWnd, wchar_t **wpText)
{
  CHARRANGE cr;
  GETTEXTEX gt;
  int nLen;
  int nLenW;

  SendMessage(hWnd, EM_EXGETSEL, 0, (LPARAM)&cr);

  if (cr.cpMin == cr.cpMax) goto Error;
  nLen=(cr.cpMax - cr.cpMin) + 1;
  nLenW=nLen * sizeof(wchar_t);

  if (*wpText=(wchar_t *)HeapAlloc(GetProcessHeap(), 0, nLenW + 2))
  {
    gt.cb=nLenW;
    gt.flags=GT_SELECTION;
    gt.codepage=1200;
    gt.lpDefaultChar=NULL;
    gt.lpUsedDefChar=NULL;
    SendMessage(hWnd, EM_GETTEXTEX, (WPARAM)&gt, (LPARAM)*wpText);

    return nLen;
  }

  Error:
  *wpText=NULL;
  return 0;
}

void FreeSelText(LPVOID pText)
{
  if (pText) HeapFree(GetProcessHeap(), 0, pText);
}

//Entry point
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
  if (fdwReason == DLL_PROCESS_ATTACH)
  {
  }  
  else if (fdwReason == DLL_THREAD_ATTACH)
  {
  }
  else if (fdwReason == DLL_THREAD_DETACH)
  {
  }
  else if (fdwReason == DLL_PROCESS_DETACH)
  {
  }
  return TRUE;
}
