typedef struct _PLUGINDATA {
  DWORD cb;                 //Size of the structure
  HINSTANCE hInstance;      //Program instance
  HWND hMainWnd;            //Main window
  HWND hWndEdit;            //RichEdit window
  HWND hStatus;             //StatusBar window
  HMENU hMainMenu;          //Main menu
  HMENU hPopupMenu;         //Right click menu
  BOOL bOldWindows;         //Non-Unicode Windows
  BOOL bOldRichEdit;        //riched20.dll lower then 5.30 (v3.0)
  BOOL bOldComctl32;        //comctl32.dll lower then 4.71
  BOOL bMDI;                //MDI mode
  unsigned char *pFile;     //Current file
                            //char *pFile     if bOldWindows == TRUE
                            //wchar_t *pFile  if bOldWindows == FALSE
  int nCodePage;            //File codepage
  BOOL bBOM;                //File with BOM
  BOOL bModified;           //File has been modified
} PLUGINDATA;

//AkelPad messages:
#define IDM_FILE_NEW                    4101  //Create new RichEdit window
#define IDM_FILE_CREATENEW              4102  //Create new instance of program
#define IDM_FILE_OPEN                   4103  //Open file dialog
#define IDM_FILE_REOPEN                 4104  //Reopen file
#define IDM_FILE_SAVE                   4105  //Save file
#define IDM_FILE_SAVEAS                 4106  //Save file dialog
#define IDM_FILE_PAGESETUP              4107  //Print setup dialog
#define IDM_FILE_PRINT                  4108  //Print dialog
#define IDM_FILE_EXIT                   4109  //Exit program
#define IDM_EDIT_UNDO                   4151  //Undo last operation
#define IDM_EDIT_REDO                   4152  //Redo last operation
#define IDM_EDIT_CUT                    4153  //Cut
#define IDM_EDIT_COPY                   4154  //Copy
#define IDM_EDIT_PASTE                  4155  //Paste
#define IDM_EDIT_CLEAR                  4156  //Delete
#define IDM_EDIT_SELECTALL              4157  //Select all
#define IDM_EDIT_FIND                   4158  //Find dialog
#define IDM_EDIT_FINDNEXTDOWN           4159  //Find last string down
#define IDM_EDIT_FINDNEXTUP             4160  //Find last string up
#define IDM_EDIT_REPLACE                4161  //Replace dialog
#define IDM_EDIT_GOTOLINE               4162  //Go to line dialog
#define IDM_EDIT_INSERTCHAR             4163  //Charmap.exe program
#define IDM_EDIT_INSERT_TAB             4164  //Insert tabulation
#define IDM_EDIT_INSERT_TAB_MENU        4165  //Insert tabulation only if several lines selected
#define IDM_EDIT_DELETE_TAB             4166  //Delete tabulation
#define IDM_EDIT_DELETE_TAB_MENU        4167  //Delete tabulation only if several lines selected
#define IDM_EDIT_INSERT_SPACE           4168  //Insert space
#define IDM_EDIT_INSERT_SPACE_MENU      4169  //Insert space only if several lines selected
#define IDM_EDIT_DELETE_SPACE           4170  //Delete space
#define IDM_EDIT_DELETE_SPACE_MENU      4171  //Delete space only if several lines selected
#define IDM_EDIT_DELETE_TRAILING_WHITESPACES 4172  //Delete trailing whitespaces
#define IDM_EDIT_UPPERCASE              4173  //Convert text to UPPERCASE
#define IDM_EDIT_LOWERCASE              4174  //Convert text to lowercase
#define IDM_EDIT_SENTENCECASE           4175  //Convert text to Sentence case.
#define IDM_EDIT_TITLECASE              4176  //Convert text to Title Case
#define IDM_EDIT_INVERTCASE             4177  //Convert text to iNVERT cASE
#define IDM_EDIT_NEWLINE_WIN            4178  //Windows new line format
#define IDM_EDIT_NEWLINE_UNIX           4179  //Unix new line format
#define IDM_EDIT_RECODE                 4180  //Recode dialog
#define IDM_VIEW_FONT                   4201  //Font dialog
#define IDM_VIEW_TEXT_COLOR             4202  //Text color dialog
#define IDM_VIEW_BG_COLOR               4203  //Background color dialog
#define IDM_VIEW_DECREASE_FONT          4204  //Decrease font 1px
#define IDM_VIEW_INCREASE_FONT          4205  //Increase font 1px
#define IDM_VIEW_ALIGN_LEFT             4206  //Left text align
#define IDM_VIEW_ALIGN_CENTER           4207  //Center text align
#define IDM_VIEW_ALIGN_RIGHT            4208  //Right text align
#define IDM_VIEW_WORDWRAP               4209  //Word wrap (on\off)
#define IDM_VIEW_ONTOP                  4210  //Always on top (on\off)
#define IDM_VIEW_SHOW_STATUSBAR         4211  //Show statusbar (on\off)
#define IDM_OPTIONS_EXEC                4251  //Execute command
#define IDM_OPTIONS_SAVETIME            4252  //Save file time (on\off)
#define IDM_OPTIONS_KEEPSPACE           4253  //Keep space (on\off)
#define IDM_OPTIONS_SINGLEOPEN_FILE     4254  //Single open file (on\off)
#define IDM_OPTIONS_SINGLEOPEN_PROGRAM  4255  //Single open program (on\off)
#define IDM_OPTIONS_SDI                 4256  //SDI mode
#define IDM_OPTIONS_MDI                 4257  //MDI mode
#define IDM_OPTIONS_PLUGINS             4258  //Plugins dialog
#define IDM_OPTIONS                     4259  //Options dialog
#define IDM_WINDOW_TABVIEW_TOP          4301  //MDI tab window at the top of the main window
#define IDM_WINDOW_TABVIEW_BOTTOM       4302  //MDI tab window at the bottom of the main window
#define IDM_WINDOW_TABVIEW_NONE         4303  //Hide MDI tab 
#define IDM_WINDOW_TABTYPE_STANDART     4304  //Standart MDI tab style
#define IDM_WINDOW_TABTYPE_BUTTONS      4305  //Buttons MDI tab style
#define IDM_WINDOW_TABTYPE_FLATBUTTONS  4306  //Flat buttons MDI tab style
#define IDM_WINDOW_TILEHORIZONTAL       4307  //MDI windows - horizontal tile
#define IDM_WINDOW_TILEVERTICAL         4308  //MDI windows - vertical tile
#define IDM_WINDOW_CASCADE              4309  //MDI windows - cascade
#define IDM_ABOUT                       4351  //About dialog
#define IDM_NONMENU_CHANGESIZE          4401  //Change style of the main window SW_RESTORE\SW_MAXIMIZE
#define IDM_NONMENU_DELLINE             4402  //Delete current line
#define IDM_NONMENU_PASTEANSI           4403  //Paste as ANSI text
#define IDM_NONMENU_REOPENAS_ANSI       4404  //Reopen file as ANSI
#define IDM_NONMENU_REOPENAS_OEM        4405  //Reopen file as OEM
#define IDM_NONMENU_REOPENAS_UTF8       4406  //Reopen file as UTF8
#define IDM_NONMENU_REOPENAS_KOIR       4407  //Reopen file as KOI-R
#define IDM_NONMENU_MDINEXT             4408  //Activate next MDI window
#define IDM_NONMENU_MDIPREV             4409  //Activate previous MDI window
#define IDM_NONMENU_MDICLOSE            4410  //Close current MDI window
#define IDM_NONMENU_FILEOPEN            4411  //Open file:
                                              //LOWORD(wParam) == IDM_NONMENU_FILEOPEN
                                              //HIWORD(wParam) == ATOM returned by GlobalAddAtom(pFileToOpen)
                                              //LOWORD(lParam) == open flags
                                              //                  ADT_BINARY_ERROR     Check if file is binary
                                              //                  ADT_REG_CODEPAGE     Use last open code page, if not found ADT_DETECT_CODEPAGE|ADT_DETECT_BOM will be used
                                              //                  ADT_DETECT_CODEPAGE  Detect code page
                                              //                  ADT_DETECT_BOM       Detect BOM mark
                                              //HIWORD(lParam) == code page, ignored if LOWORD(lParam) == ADT_REG_CODEPAGE or LOWORD(lParam) == ADT_DETECT_CODEPAGE
                                              //
                                              //Example:
                                              //ATOM nAtom;
                                              //wAtom=GlobalAddAtom("C:\\MyFile.txt");
                                              //SendMessage(pd->hMainWnd, WM_COMMAND, MAKELONG(IDM_NONMENU_FILEOPEN, wAtom), MAKELONG(ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0));
#define IDM_NONMENU_SETFILEPRINT        4412  //Next opened file will be printed
#define IDM_NONMENU_SETMSGCREATE        4413  //Create unexisted file autoanswer:
                                              //wParam == IDM_NONMENU_SETMSGCREATE
                                              //lParam == autoanswer
                                              //          AUTOANSWER_ASK  Show message (default)
                                              //          AUTOANSWER_YES  Create unexisted file
                                              //          AUTOANSWER_NO   Don't create unexisted file
                                              //
                                              //Example:
                                              //SendMessage(pd->hMainWnd, WM_COMMAND, IDM_NONMENU_SETMSGCREATE, AUTOANSWER_YES);
#define IDM_NONMENU_SETMSGBINARY        4414  //Open binary file autoanswer:
                                              //wParam == IDM_NONMENU_SETMSGBINARY
                                              //lParam == autoanswer
                                              //          AUTOANSWER_ASK  Show message (default)
                                              //          AUTOANSWER_YES  Open binary file
                                              //          AUTOANSWER_NO   Don't open binary file
                                              //
                                              //Example:
                                              //SendMessage(pd->hMainWnd, WM_COMMAND, IDM_NONMENU_SETMSGBINARY, AUTOANSWER_YES);
#define IDM_RECENT_FILES                5001  //Delete dead recent files
                                              //5001 + n  open recent file n
#define IDM_LANGUAGE                    6001  //Activate internal language
                                              //6001 + n  activate language n

//Example:
//SendMessage(pd->hMainWnd, WM_COMMAND, IDM_FILE_NEW, 0);
