#ifndef __EDIT_H__
#define __EDIT_H__

////Defines

#define APP_MAIN_CLASS               "AkelPad3"
#define APP_MAIN_CLASSW             L"AkelPad3"
#define APP_MAIN_TITLE               "AkelPad"
#define APP_MAIN_TITLEW             L"AkelPad"
#define APP_SDI_CLASS                "AkelPad SDI Class"
#define APP_SDI_CLASSW              L"AkelPad SDI Class"
#define APP_SDI_TITLE                ""
#define APP_SDI_TITLEW              L""
#define APP_MDI_CLASS                "AkelPad MDI Class"
#define APP_MDI_CLASSW              L"AkelPad MDI Class"
#define APP_MUTEX                    "AkelPad Mutex"
#define APP_REGMSG                   "AkelPad Open-On-Start message"
#define APP_ABOUT_VERSION            "AkelPad 3.0 beta 10"
#define APP_ABOUT_VERSIONW          L"AkelPad 3.0 beta 10"
#define APP_ABOUT_HOMEPAGE           "http://akelpad.sf.net"
#define APP_ABOUT_HOMEPAGEW         L"http://akelpad.sf.net"
#define APP_ABOUT_EMAIL_KUZNETSOV    "developer@akelpad.net.ru"
#define APP_ABOUT_EMAIL_KUZNETSOVW  L"developer@akelpad.net.ru"
#define APP_ABOUT_ICQ_KUZNETSOV      "109590531"
#define APP_ABOUT_ICQ_KUZNETSOVW    L"109590531"
#define APP_ABOUT_EMAIL_SHENGALTS    "shengalts@mail.ru"
#define APP_ABOUT_EMAIL_SHENGALTSW  L"shengalts@mail.ru"

//Code pages strings
#define STR_SYSTEM_ANSI        "ANSI  (Windows)"
#define STR_SYSTEM_ANSIW      L"ANSI  (Windows)"
#define STR_SYSTEM_OEM         "OEM  (DOS)"
#define STR_SYSTEM_OEMW       L"OEM  (DOS)"
#define STR_UNICODE_UCS2_LE    "1200  (UTF-16 LE)"
#define STR_UNICODE_UCS2_LEW  L"1200  (UTF-16 LE)"
#define STR_UNICODE_UCS2_BE    "1201  (UTF-16 BE)"
#define STR_UNICODE_UCS2_BEW  L"1201  (UTF-16 BE)"
#define STR_UNICODE_UTF8       "65001 (UTF-8)"
#define STR_UNICODE_UTF8W     L"65001 (UTF-8)"

#ifndef IMF_AUTOFONTSIZEADJUST
  #define IMF_AUTOFONTSIZEADJUST 0x0010
#endif
#ifndef GT_SELECTION
  #define GT_SELECTION 2
#endif
#ifndef WM_MOUSEWHEEL
  #define WM_MOUSEWHEEL  0x020A
#endif
#ifndef BIF_NEWDIALOGSTYLE
  #define BIF_NEWDIALOGSTYLE 0x0040
#endif

#define BUFFER_SIZE                1024
#define FILELIST_BUFFER_SIZE       8192
#define TRANSLATE_BUFFER_SIZE      8192
#define PREVIEW_SIZE               8188  //4094*2; -1 preview all file
#define DELIMITERS_SIZE            128
#define DETECT_CODEPAGE_SIZE       1024
#define MAX_INI_SIZE               64000
#define RECENTFILES_AMOUNT         10
#define RECENTFILES_RECORD_LENGTH  90
#define SEARCHSTRINGS_AMOUNT       10
#define EDIT_MARGINS               MAKELONG(4, 4)
#define EDIT_TABSTOPS              8
#define ASSOCIATE_OPEN             "txt;log;ini;inf"
#define ASSOCIATE_OPENW           L"txt;log;ini;inf"
#define ASSOCIATE_EDIT             "bat;cmd;reg;htm;html"
#define ASSOCIATE_EDITW           L"bat;cmd;reg;htm;html"
#define ASSOCIATE_PRINT            "txt;log;ini;inf"
#define ASSOCIATE_PRINTW          L"txt;log;ini;inf"
#define WORD_DELIMITERSW          L" \t\r\\|[](){}<>,.;:+-=~!@#$%^&*/?'`\""
#define SENTENCE_SELIMITERS        "."
#define SENTENCE_SELIMITERSW      L"."
#define TITLE_DELIMITERS           " \t\r"
#define TITLE_DELIMITERSW         L" \t\r"

//Language identifiers
#define LANGID_ENGLISH  0x0409
#define LANGID_RUSSIAN  0x0419

//Code pages int
#define CP_UNICODE_UCS2_LE  1200
#define CP_UNICODE_UCS2_BE  1201
#define CP_UNICODE_UTF8     65001
#define CP_KOI8_R           20866

//Save type
#define SS_REGISTRY 1
#define SS_INI      2

//OpenDocument flags
#define CODEPAGE_AUTODETECT 0
#define BOM_AUTODETECT      3

//New line formats
#define NEWLINE_WIN  1
#define NEWLINE_UNIX 2

//Autodetect flags
#define ADT_BINARY_ERROR      0x00000001
#define ADT_REG_CODEPAGE      0x00000002
#define ADT_DETECT_CODEPAGE   0x00000004
#define ADT_DETECT_BOM        0x00000008

//Autodetect errors
#define EDT_OPEN       -1
#define EDT_ALLOC      -2
#define EDT_READ       -3
#define EDT_BINARY     -4
#define EDT_CANCEL     -5

//STARTUPINFO flags
#define STARTF_NOMUTEX 0x00001000

//Search/Replace options
#define FR_UP          0x00100000
#define FR_BEGINNING   0x00200000
#define FR_SELECTION   0x00400000
#define FR_ESCAPESEQ   0x00800000
#define FR_ALLFILES    0x01000000

//Insert/Delete char in selection
#define STRSEL_CHECK   1
#define STRSEL_INSERT  2
#define STRSEL_DELETE  3

//Selection case
#define UPPERCASE      1
#define LOWERCASE      2
#define SENTENCECASE   3
#define TITLECASE      4
#define INVERTCASE     5

//Change font size
#define DECREASE_FONT  1
#define INCREASE_FONT  2

//File types association
#define AE_ASSOCIATE     0x00000001
#define AE_DEASSOCIATE   0x00000002
#define AE_OPEN          0x00000004
#define AE_EDIT          0x00000008
#define AE_PRINT         0x00000010

//Autoanswer
#define AUTOANSWER_ASK 0
#define AUTOANSWER_YES 1
#define AUTOANSWER_NO  2

//Plugins list
#define LVI_FUNCTION_NAME    0
#define LVI_FUNCTION_HOTKEY  1


////Structures

typedef struct _MDIWINDOWDATA {
  HICON hIcon;
  BOOL bWordWrap;
  int nNewLine;
  BOOL bInsertState;
  BOOL bModified;
  int nCodePage;
  FILETIME ft;
} MDIWINDOWDATA;

typedef struct _PASTEDATA {
  unsigned char *pData;
  int nLength;
} PASTEDATA;

typedef struct _STREAMDATA {
  HANDLE hFile;
  int nCodePage;
  int nBytes;
  int nBytesRead;
} STREAMDATA;

typedef struct _PLUGINDATA {
  DWORD cb;
  HINSTANCE hInstance;
  HWND hMainWnd;
  HWND hWndEdit;
  HWND hStatus;
  HMENU hMainMenu;
  HMENU hPopupMenu;
  BOOL bOldWindows;
  BOOL bOldRichEdit;
  BOOL bOldComctl32;
  BOOL bMDI;
  unsigned char *pFile;
  int nCodePage;
  BOOL bBOM;
  BOOL bModified;
} PLUGINDATA;

typedef struct _PLUGINLISTDATA {
  HWND hWndList;
  HKEY hRegKey;
  BOOL bIniExists;
  unsigned char *pBaseName;
} PLUGINLISTDATA;

typedef BOOL (CALLBACK* EXPORTNAMESPROC)(char *, LPARAM);


////Functions prototype

void CreateEditWindowA(HWND hWnd);
void CreateEditWindowW(HWND hWnd);

BOOL DoFileNewA();
BOOL DoFileNewW();
HWND DoFileNewWindowA(DWORD dwAddFlags);
HWND DoFileNewWindowW(DWORD dwAddFlags);
BOOL CALLBACK EnumThreadWndProcA(HWND hwnd, LPARAM lParam);
BOOL CALLBACK EnumThreadWndProcW(HWND hwnd, LPARAM lParam);
BOOL DoFileOpenA();
BOOL DoFileOpenW();
void DoFileReopenAsA(DWORD Flags, int nCodePage, BOOL bBOM);
void DoFileReopenAsW(DWORD Flags, int nCodePage, BOOL bBOM);
BOOL DoFileSaveA();
BOOL DoFileSaveW();
BOOL DoFileSaveAsA();
BOOL DoFileSaveAsW();
void DoFilePageSetupA();
void DoFilePageSetupW();
void DoFilePrintA();
void DoFilePrintW();
BOOL DoFileExitA();
BOOL DoFileExitW();
void DoEditUndo(HWND hWnd);
void DoEditRedo(HWND hWnd);
void DoEditCut(HWND hWnd);
void DoEditCopy(HWND hWnd);
void DoEditPaste(HWND hWnd);
void DoEditPasteANSI(HWND hWnd);
void DoEditClear(HWND hWnd);
void DoEditSelectAll(HWND hWnd);
void DoEditInsertChar();
void DoEditRecodeA(HWND hWnd);
void DoEditRecodeW(HWND hWnd);
BOOL DoEditInsertStringInSelectionW(HWND hWnd, int nAction, wchar_t *wpString);
BOOL DoEditDeleteTrailingWhitespacesW(HWND hWnd);
BOOL DoEditChangeCaseA(HWND hWnd, int nCase);
BOOL DoEditChangeCaseW(HWND hWnd, int nCase);
void DoEditFindA();
void DoEditFindW();
void DoEditFindNextDownA(HWND hWnd);
void DoEditFindNextDownW(HWND hWnd);
void DoEditFindNextUpA(HWND hWnd);
void DoEditFindNextUpW(HWND hWnd);
void DoEditReplaceA();
void DoEditReplaceW();
void DoEditGoToLineA();
void DoEditGoToLineW();
void DoViewFontA(HWND hWnd);
void DoViewFontW(HWND hWnd);
void DoViewTextColorA(HWND hWnd);
void DoViewTextColorW(HWND hWnd);
void DoViewBGColorA(HWND hWnd);
void DoViewBGColorW(HWND hWnd);
void DoViewFontSizeA(HWND hWnd, int nAction);
void DoViewFontSizeW(HWND hWnd, int nAction);
void DoViewAlignment(HWND hWnd, WORD wAlignment);
void DoViewOnTop(BOOL bState, BOOL bFirst);
void DoViewWordWrap(HWND hWnd, BOOL bState, BOOL bFirst);
void DoViewShowStatusBar(BOOL bState, BOOL bFirst);
void DoSettingsExecA();
void DoSettingsExecW();
void DoSettingsSaveTime(BOOL bState);
void DoSettingsWatchFileA(BOOL bState);
void DoSettingsWatchFileW(BOOL bState);
void DoSettingsSingleOpenFile(BOOL bState);
void DoSettingsSingleOpenProgram(BOOL bState);
void DoSettingsKeepSpace(BOOL bState);
void DoSettingsPluginsA(HWND hWnd);
void DoSettingsPluginsW(HWND hWnd);
void DoSettingsOptionsA();
void DoSettingsOptionsW();
void DoWindowTabView(int nView, BOOL bFirst);
void DoWindowTabType(int nType, BOOL bFirst);
void DoHelpAboutA();
void DoHelpAboutW();
void DoNonMenuDelLine(HWND hWnd);

BOOL RegReadOptionsA();
BOOL RegReadOptionsW();
BOOL IniReadOptionsA();
BOOL IniReadOptionsW();
void RegReadSearchA();
void RegReadSearchW();
BOOL RegSaveOptionsA();
BOOL RegSaveOptionsW();
BOOL IniSaveOptionsA();
BOOL IniSaveOptionsW();

int OpenDocumentA(char *szFile, DWORD Flags, int nCodePage, BOOL bBOM);
int OpenDocumentW(wchar_t *wszFile, DWORD Flags, int nCodePage, BOOL bBOM);
DWORD CALLBACK InputStreamCallbackA(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
DWORD CALLBACK InputStreamCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
BOOL SaveDocumentA(char *szFile, int nCodePage, BOOL bBOM);
BOOL SaveDocumentW(wchar_t *wszFile, int nCodePage, BOOL bBOM);
DWORD CALLBACK OutputStreamCallbackA(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
DWORD CALLBACK OutputStreamCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
BOOL OpenDirectoryA(char *pPath, BOOL bSubDir);
BOOL OpenDirectoryW(wchar_t *wpPath, BOOL bSubDir);

unsigned int CALLBACK CodePageDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
unsigned int CALLBACK CodePageDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewPreviewProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewPreviewProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL RegEnumCodePages(int *codepages, int size);
void FillComboboxCodepageA(HWND hWnd);
void FillComboboxCodepageW(HWND hWnd);
int GetComboboxCodepageA(HWND hWnd);
int GetComboboxCodepageW(HWND hWnd);
int SelectComboboxCodepageA(HWND hWnd, int nCodepage);
int SelectComboboxCodepageW(HWND hWnd, int nCodepage);
int FilePreviewA(HWND hWnd, char *pFile, int nPreviewBytes, DWORD Flags, int *nCodePage, BOOL *bBOM);
int FilePreviewW(HWND hWnd, wchar_t *wpFile, int nPreviewBytes, DWORD Flags, int *nCodePage, BOOL *bBOM);
int AutodetectCodePageA(char *pFile, DWORD dwBytesToCheck, DWORD Flags, int *nCodePage, BOOL *bBOM);
int AutodetectCodePageW(wchar_t *wpFile, DWORD dwBytesToCheck, DWORD Flags, int *nCodePage, BOOL *bBOM);
BOOL AutodetectMultibyte(DWORD dwLangID, unsigned char *pBuffer, DWORD dwBytesToCheck, int *nCodePage);
unsigned int UTF8toUTF16(const char *buf, unsigned int *len, wchar_t *tbuf, unsigned int tlen);
unsigned int UTF16toUTF8(const wchar_t *tbuf, unsigned int tlen, char *buf, unsigned int len);
void ChangeByteOrder(unsigned char *buf, unsigned int len);
unsigned int TranslateNewLinesToUnixW(wchar_t *tbuf, unsigned int *tlen);

BOOL CALLBACK FindAndReplaceDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK FindAndReplaceDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
void FillComboboxSearchA(HWND hWndFind, HWND hWndReplace);
void FillComboboxSearchW(HWND hWndFind, HWND hWndReplace);
BOOL GetComboboxSearchTextA(HWND hWnd, char **szText_orig, char **szText);
BOOL GetComboboxSearchTextW(HWND hWnd, wchar_t **wszText_orig, wchar_t **wszText);
void SaveComboboxSearchA(HWND hWndFind, HWND hWndReplace);
void SaveComboboxSearchW(HWND hWndFind, HWND hWndReplace);
int FindTextA(HWND hWnd);
int FindTextW(HWND hWnd);
int ReplaceTextA(HWND hWnd, BOOL all);
int ReplaceTextW(HWND hWnd, BOOL all);
BOOL EscapeStringToEscapeDataA(char *pInput, char *szOutput);
BOOL EscapeStringToEscapeDataW(wchar_t *wpInput, wchar_t *wszOutput);
void EscapeDataToEscapeStringW(wchar_t *wpInput, wchar_t *wszOutput);

void ReplaceSelA(HWND hWnd, char *pData);
void ReplaceSelW(HWND hWnd, wchar_t *wpData);
DWORD CALLBACK ReplaceSelCallbackA(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
DWORD CALLBACK ReplaceSelCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
int GetSelTextA(HWND hWnd, char **pText);
int GetSelTextW(HWND hWnd, wchar_t **wpText);
void FreeSelText(LPVOID pText);

BOOL CALLBACK GoToLineDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK GoToLineDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

void RecentFilesZeroA();
void RecentFilesZeroW();
void RecentFilesReadA();
void RecentFilesReadW();
BOOL RecentFilesGetA(char *file, int *position, int *codepage);
BOOL RecentFilesGetW(wchar_t *wfile, int *position, int *codepage);
BOOL RecentFilesUpdateA(char *file, int position, int codepage);
BOOL RecentFilesUpdateW(wchar_t *wfile, int position, int codepage);
int RecentFilesDeleteDeadA();
int RecentFilesDeleteDeadW();
void RecentFilesSaveA();
void RecentFilesSaveW();
void RecentFilesMenuA();
void RecentFilesMenuW();
int TrimPathA(char *szResult, char *pPath, int nMax);
int TrimPathW(wchar_t *wszResult, wchar_t *wpPath, int nMax);

void LanguageMenuA();
void LanguageMenuW();

BOOL isInDelimiterList(wchar_t c);
int CALLBACK EditWordBreakProc(LPTSTR pchText, int ichCurrent, int cch, int code);

void RecodeTextW(HWND hWnd, int nCodePage);
BOOL CALLBACK RecodeDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK RecodeDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

BOOL CALLBACK PluginsDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK PluginsDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
void FillPluinsListA(HWND hWnd);
void FillPluinsListW(HWND hWnd);
BOOL CALLBACK FillPluinsListProcA(char *pExportName, LPARAM lParam);
BOOL CALLBACK FillPluinsListProcW(char *pExportName, LPARAM lParam);
void SavePluinsListA(HWND hWnd);
void SavePluinsListW(HWND hWnd);
void GetHotkeyStringA(DWORD dwHotkey, char *szString);
void GetHotkeyStringW(DWORD dwHotkey, wchar_t *wszString);
void RegRegisterPluginsHotkeysA();
void RegRegisterPluginsHotkeysW();
void IniRegisterPluginsHotkeysA();
void IniRegisterPluginsHotkeysW();
BOOL ParsePluginNameA(char *pFullName, char *szPlugin, char *szFunction);
BOOL ParsePluginNameW(wchar_t *wpFullName, wchar_t *wszPlugin, wchar_t *wszFunction);
void CallPluginA(char *pFullName);
void CallPluginW(wchar_t *wpFullName);
UINT HotKeyToModKey(WORD wHot);
BOOL GetExportNames(HMODULE hInstance, EXPORTNAMESPROC lpExportNamesProc, LPARAM lParam);

LRESULT CALLBACK CBTProc(int iCode, WPARAM wParam, LPARAM lParam);
int CALLBACK PropSheetProc(HWND hDlg, UINT uMsg, LPARAM lParam);
BOOL CALLBACK OptionsGeneralDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK OptionsGeneralDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
int CALLBACK BrowseCallbackProcA(HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData);
int CALLBACK BrowseCallbackProcW(HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData);
BOOL CALLBACK OptionsAdvancedDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK OptionsAdvancedDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

BOOL CALLBACK AboutDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK AboutDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

int SetLayout();
void RestoreLayout(int nLayout);
void SetChosenFontA(HWND hWnd, LOGFONT logfont);
void SetChosenFontW(HWND hWnd, LOGFONTW logfontW);
void SetChosenFontColor(HWND hWnd, COLORREF crFont);
void SetChosenFontSizeA(HWND hWnd, int nPixels);
void SetChosenFontSizeW(HWND hWnd, int nPixels);
void SetTabStopsA(HWND hWnd, int nTabStops);
void SetTabStopsW(HWND hWnd, int nTabStops);
int GetCharWidthTwipsA(HWND hWnd);
int GetCharWidthTwipsW(HWND hWnd);
void InsertTabStop(HWND hWnd);
void IndentTabStop(HWND hWnd, int nAction);
int PixelsToTwips(HWND hWnd, int nPixels);
void GetPrivateProfileDWORDA(LPCTSTR lpAppName, LPCTSTR lpKeyName, LPDWORD dwData, LPCTSTR lpFileName);
void GetPrivateProfileDWORDW(LPCWSTR lpAppName, LPCWSTR lpKeyName, LPDWORD dwData, LPCWSTR lpFileName);
BOOL WritePrivateProfileDWORDA(LPCTSTR lpAppName, LPCTSTR lpKeyName, DWORD dwData, LPCTSTR lpFileName);
BOOL WritePrivateProfileDWORDW(LPCWSTR lpAppName, LPCWSTR lpKeyName, DWORD dwData, LPCWSTR lpFileName);
char* GetCommandLineParamsA();
wchar_t* GetCommandLineParamsW();
int GetCommandLineArgA(char *lpCmdLine, char *szArg, char **lpNextArg);
int GetCommandLineArgW(wchar_t *lpCmdLine, wchar_t *szArg, wchar_t **lpNextArg);
void GetAssociatedIconA(char *pExt, char *szFile, int *nIconIndex, HICON *phiconLarge, HICON *phiconSmall);
void GetAssociatedIconW(wchar_t *pExt, wchar_t *wszFile, int *nIconIndex, HICON *phiconLarge, HICON *phiconSmall);
void AssociateFileTypesA(char *pFileTypes, char *pModule, DWORD Flags);
void AssociateFileTypesW(wchar_t *wpFileTypes, wchar_t *wpModule, DWORD Flags);
BOOL GetFileWriteTimeA(char *pFile, FILETIME *ft);
BOOL GetFileWriteTimeW(wchar_t *wpFile, FILETIME *ft);
BOOL SaveChangedA();
BOOL SaveChangedW();
void SetModifyA(BOOL bState, BOOL bFirst);
void SetModifyW(BOOL bState, BOOL bFirst);
void SetNewLineA(BOOL bState, BOOL bFirst);
void SetNewLineW(BOOL bState, BOOL bFirst);
void SetInsertStateA(BOOL bState, BOOL bFirst);
void SetInsertStateW(BOOL bState, BOOL bFirst);
void SetCodePageA(int nCodePage, BOOL bFirst);
void SetCodePageW(int nCodePage, BOOL bFirst);
BOOL FileExistsA(char *pFile);
BOOL FileExistsW(wchar_t *wpFile);
int IsFileA(char *pFile);
int IsFileW(wchar_t *wpFile);
BOOL IsPathFullA(char *pPath);
BOOL IsPathFullW(wchar_t *wpPath);
char* GetFileNameA(char *pFile);
wchar_t* GetFileNameW(wchar_t *wpFile);
char* GetBaseNameA(char *pFile, char *szBaseName);
wchar_t* GetBaseNameW(wchar_t *wpFile, wchar_t *wszBaseName);
char* GetFileExtA(char *fname);
wchar_t* GetFileExtW(wchar_t *fname);
void GetFileVersionA(char *pFile, int *nMajor, int *nMinor, int *nRelease, int *nBuild);
void GetFileVersionW(wchar_t *wpFile, int *nMajor, int *nMinor, int *nRelease, int *nBuild);
int ParseExecCommandA(char *pCommand, char *szBuffer, int nBufferSize);
int ParseExecCommandW(wchar_t *wpCommand, wchar_t *wszBuffer, int nBufferSize);
void UpdateSize(int nWidth, int nHeight);
void UpdateTitleA(char *szFile);
void UpdateTitleW(wchar_t *wszFile);
void FreeMemorySearchA();
void FreeMemorySearchW();
void FreeMemoryRecentFilesA();
void FreeMemoryRecentFilesW();

HMENU API_LoadMenuA(HINSTANCE hLoadInstance, LPCTSTR lpMenuName);
HMENU API_LoadMenuW(HINSTANCE hLoadInstance, LPCWSTR lpMenuName);
HACCEL API_LoadAcceleratorsA(HINSTANCE hLoadInstance, LPCTSTR lpTableName);
HACCEL API_LoadAcceleratorsW(HINSTANCE hLoadInstance, LPCWSTR lpTableName);
HICON API_LoadIconA(HINSTANCE hLoadInstance, LPCTSTR lpIconName);
HICON API_LoadIconW(HINSTANCE hLoadInstance, LPCWSTR lpIconName);
HANDLE API_LoadImageA(HINSTANCE hLoadInstance, LPCTSTR lpszName, UINT uType, int cxDesired, int cyDesired, UINT fuLoad);
HANDLE API_LoadImageW(HINSTANCE hLoadInstance, LPCWSTR lpszName, UINT uType, int cxDesired, int cyDesired, UINT fuLoad);
int API_LoadStringA(HINSTANCE hLoadInstance, UINT uID, LPTSTR lpBuffer, int nBufferMax);
int API_LoadStringW(HINSTANCE hLoadInstance, UINT uID, LPWSTR lpBuffer, int nBufferMax);
HWND API_CreateDialogA(HINSTANCE hLoadInstance, LPCTSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc);
HWND API_CreateDialogW(HINSTANCE hLoadInstance, LPCWSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc);
INT_PTR API_DialogBoxA(HINSTANCE hLoadInstance, LPCTSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc);
INT_PTR API_DialogBoxW(HINSTANCE hLoadInstance, LPCWSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc);
HANDLE API_CreateFileA(LPCTSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition, DWORD dwFlagsAndAttributes, HANDLE hTemplateFile);
HANDLE API_CreateFileW(LPCWSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition, DWORD dwFlagsAndAttributes, HANDLE hTemplateFile);
BOOL API_ReadFileA(HANDLE hFile, LPVOID lpBuffer, DWORD nNumberOfBytesToRead, LPDWORD lpNumberOfBytesRead, LPOVERLAPPED lpOverlapped);
BOOL API_ReadFileW(HANDLE hFile, LPVOID lpBuffer, DWORD nNumberOfBytesToRead, LPDWORD lpNumberOfBytesRead, LPOVERLAPPED lpOverlapped);
BOOL API_WriteFileA(HANDLE hFile, LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite, LPDWORD lpNumberOfBytesWritten, LPOVERLAPPED lpOverlapped);
BOOL API_WriteFileW(HANDLE hFile, LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite, LPDWORD lpNumberOfBytesWritten, LPOVERLAPPED lpOverlapped);
LPVOID API_HeapAlloc(HANDLE hHeap, DWORD dwFlags, SIZE_T dwBytes);
BOOL API_HeapFree(HANDLE hHeap, DWORD dwFlags, LPVOID lpMem);


//// OLE Drag'n'Drop

typedef struct _IRichEditOleCallbackVtbl {
  // IUnknown implementation
  HRESULT (WINAPI *QueryInterface)(LPUNKNOWN, REFIID, void **);
  ULONG (WINAPI *AddRef)(LPUNKNOWN);
  ULONG (WINAPI *Release)(LPUNKNOWN);

  // Methods of the IRichEditOleCallback interface
  HRESULT (WINAPI *GetNewStorage)(LPUNKNOWN, LPSTORAGE FAR *);
  HRESULT (WINAPI *GetInPlaceContext)(LPUNKNOWN, LPOLEINPLACEFRAME FAR *, LPOLEINPLACEUIWINDOW FAR *, LPOLEINPLACEFRAMEINFO);
  HRESULT (WINAPI *ShowContainerUI)(LPUNKNOWN, BOOL);
  HRESULT (WINAPI *QueryInsertObject)(LPUNKNOWN, LPCLSID, LPSTORAGE, LONG);
  HRESULT (WINAPI *DeleteObject)(LPUNKNOWN, LPOLEOBJECT);
  HRESULT (WINAPI *QueryAcceptData)(LPUNKNOWN, LPDATAOBJECT, CLIPFORMAT FAR *, DWORD, BOOL, HGLOBAL);
  HRESULT (WINAPI *ContextSensitiveHelp)(LPUNKNOWN, BOOL);
  HRESULT (WINAPI *GetClipboardData)(LPUNKNOWN, CHARRANGE FAR *, DWORD, LPDATAOBJECT FAR *);
  HRESULT (WINAPI *GetDragDropEffect)(LPUNKNOWN, BOOL, DWORD, LPDWORD);
  HRESULT (WINAPI *GetContextMenu)(LPUNKNOWN, WORD, LPOLEOBJECT, CHARRANGE FAR *, HMENU FAR *);
} IRichEditOleCallbackVtbl;

typedef struct _REOLE {
  IRichEditOleCallbackVtbl *lpTable;
  ULONG uRefCount;
} REOLE;

ULONG WINAPI REOLE_AddRef(LPUNKNOWN lpTable);
ULONG WINAPI REOLE_Release(LPUNKNOWN lpTable);
HRESULT WINAPI REOLE_QueryInterface(LPUNKNOWN lpTable, REFIID riid, void **ppvObj);
HRESULT WINAPI REOLE_GetNewStorage(LPUNKNOWN lpTable, LPSTORAGE FAR *lplpstg);
HRESULT WINAPI REOLE_GetInPlaceContext(LPUNKNOWN lpTable, LPOLEINPLACEFRAME FAR *lplpFrame, LPOLEINPLACEUIWINDOW FAR *lplpDoc, LPOLEINPLACEFRAMEINFO lpFrameInfo);
HRESULT WINAPI REOLE_ShowContainerUI(LPUNKNOWN lpTable, BOOL fShow);
HRESULT WINAPI REOLE_QueryInsertObject(LPUNKNOWN lpTable, LPCLSID lpclsid, LPSTORAGE lpstg, LONG cp);
HRESULT WINAPI REOLE_DeleteObject(LPUNKNOWN lpTable, LPOLEOBJECT lpoleobj);
HRESULT WINAPI REOLE_QueryAcceptData(LPUNKNOWN lpTable, LPDATAOBJECT lpdataobj, CLIPFORMAT FAR *lpcfFormat, DWORD reco, BOOL fReally, HGLOBAL hMetaPict);
HRESULT WINAPI REOLE_ContextSensitiveHelp(LPUNKNOWN lpTable, BOOL fEnterMode);
HRESULT WINAPI REOLE_GetClipboardData(LPUNKNOWN lpTable, CHARRANGE FAR *lpchrg, DWORD reco, LPDATAOBJECT FAR *lplpdataobj);
HRESULT WINAPI REOLE_GetDragDropEffect(LPUNKNOWN lpTable, BOOL fDrag, DWORD grfKeyState, LPDWORD pdwEffect);
HRESULT WINAPI REOLE_GetContextMenu(LPUNKNOWN lpTable, WORD seltype, LPOLEOBJECT lpoleobj, CHARRANGE FAR *lpchrg, HMENU FAR *lphmenu);

#endif
