#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <commdlg.h>
#include <shellapi.h>
#include <richedit.h>
#include <oleidl.h>
#include <richole.h>
#include <commctrl.h>
#include <shlobj.h>
#include "akelpad.h"
#include "edit.h"

#define xatoi
#define xatoiW
#define xatoui
#define xatouiW
#define xuitoa
#define xuitoaW
#define hex2dec
#define hex2decW
#include "ConvFunc.h"


//Process
extern HANDLE hHeap;
extern HANDLE hMutex;

//WinMain
extern HINSTANCE hInstance;
extern char *lpCmdLine;
extern wchar_t *wlpCmdLine;
extern int nCmdShow;
extern STARTUPINFO lpStartupInfo;
extern STARTUPINFOW lpStartupInfoW;

//Versions
extern BOOL bOldWindows;
extern BOOL bOldRichEdit;
extern BOOL bOldComctl32;

//Buffers
extern char buf[BUFFER_SIZE];
extern wchar_t wbuf[BUFFER_SIZE];
extern char buf2[BUFFER_SIZE];
extern wchar_t wbuf2[BUFFER_SIZE];
extern unsigned char pcTranslateBuffer[TRANSLATE_BUFFER_SIZE];

//Language
extern char szLangModule[MAX_PATH];
extern wchar_t wszLangModule[MAX_PATH];
extern HMODULE hLangLib;
extern int nLangModules;
extern LANGID wLangSystem;
extern LANGID wLangCodepageRecognition;

//INI
extern char szIniFile[MAX_PATH];
extern wchar_t wszIniFile[MAX_PATH];
extern int nSaveSettings;

//Main Window
extern HWND hMainWnd;
extern HWND hWndEdit;
extern HWND hDummyWindow;
extern HWND hStatus;
extern HWND hDlgModeless;
extern RECT rcMainWindow;
extern int nMainStyle;
extern int nLastMainSize;
extern int nStatusHeight;
extern HACCEL hMainAccel;
extern HICON hMainIcon;
extern HICON hIconEmpty;
extern HMENU hMainMenu;
extern HMENU hPopupMenu;
extern HMENU hPopupEdit;
extern HMENU hPopupView;

//Codepages
extern int codepages[65536];
extern BOOL bEnumCodePages;
extern BOOL bDefaultBOM;
extern BOOL bCurrentBOM;
extern int nRecodeCodePage;
extern int nCurrentCodePage;
extern int nDefaultCodePage;
extern int nAnsiCodePage;
extern int nOemCodePage;

//Recent files
extern char szCurrentFile[MAX_PATH];
extern wchar_t wszCurrentFile[MAX_PATH];
extern char (*szRecentNames)[MAX_PATH];
extern wchar_t (*wszRecentNames)[MAX_PATH];
extern DWORD *szRecentPositions;
extern DWORD *szRecentCodepages;
extern int nRecentFiles;

//Open/Save dialog
extern OPENFILENAME ofn;
extern OPENFILENAMEW ofnW;
extern char szFileBuffer[FILELIST_BUFFER_SIZE];
extern wchar_t wszFileBuffer[FILELIST_BUFFER_SIZE];
extern char szFilter[MAX_PATH];
extern wchar_t wszFilter[MAX_PATH];
extern BOOL bAutodetect;
extern BOOL bSaveDlg;
extern DWORD dwOfnFlags;
extern BOOL bOfnBOM;
extern int nOfnCodePage;
extern BOOL bNewLineDetected;
extern WNDPROC OldPreviewProc;
extern int nMsgCreate;
extern int nMsgBinary;

//Find/Replace dialog
extern DWORD ftflags;
extern BOOL bRecodeDlg;
extern BOOL bReplaceDlg;
extern int nReplaceCount;
extern int nSearchStrings;
extern char *szFind_orig;
extern wchar_t *wszFind_orig;
extern char *szReplace_orig;
extern wchar_t *wszReplace_orig;
extern char *szFind;
extern wchar_t *wszFind;
extern char *szReplace;
extern wchar_t *wszReplace;

//Options dialog
extern PROPSHEETHEADER psh;
extern PROPSHEETHEADERW pshW;
extern PROPSHEETPAGE psp[2];
extern PROPSHEETPAGEW pspW[2];
extern HHOOK cbtHook;

//Font/Color
extern LOGFONT logfont;
extern LOGFONTW logfontW;
extern CHOOSEFONT cf;
extern CHOOSEFONTW cfW;
extern CHOOSECOLOR cc;
extern CHOOSECOLORW ccW;
extern COLORREF crBackground;
extern COLORREF crFont;
extern COLORREF crCustColors[16];

//Print
extern PAGESETUPDLG psdPage;
extern PAGESETUPDLGW psdPageW;
extern PRINTDLG pd;
extern PRINTDLGW pdW;
extern BOOL bGlobalPrint;

//Edit position
extern CHARRANGE chrg;
extern int nPosition;
extern int nPositionOld;
extern int nMaxChars;
extern int nMcstep;

//Edit state
extern BOOL bModified;
extern BOOL bInsertState;
extern int nNewLine;
extern BOOL bWordWrap;
extern BOOL bOnTop;
extern BOOL bStatusBar;
extern BOOL bSaveTime;
extern BOOL bWatchFile;
extern BOOL bSingleOpenFile;
extern BOOL bSingleOpenProgram;
extern BOOL bKeepSpace;
extern int nTabStopSize;
extern BOOL bTabStopAsSpaces;
extern DWORD dwEditMargins;
extern FILETIME ft;

//Word breaking
extern wchar_t wszDelimiters[DELIMITERS_SIZE];
extern BOOL bFirstWordBreak;

//Execute
extern char szCommand[BUFFER_SIZE];
extern wchar_t wszCommand[BUFFER_SIZE];
extern char szWorkDir[MAX_PATH];
extern wchar_t wszWorkDir[MAX_PATH];
extern char szExeDir[MAX_PATH];
extern wchar_t wszExeDir[MAX_PATH];

//Associations
extern char szFileTypesOpen[MAX_PATH];
extern wchar_t wszFileTypesOpen[MAX_PATH];
extern char szFileTypesEdit[MAX_PATH];
extern wchar_t wszFileTypesEdit[MAX_PATH];
extern char szFileTypesPrint[MAX_PATH];
extern wchar_t wszFileTypesPrint[MAX_PATH];
extern DWORD dwFileTypesAssociated;

//Registered messages
extern UINT uiOpenOnStartMessage;

//OLE Drag'n'Drop
extern IRichEditOleCallbackVtbl REOLEVtbl;
extern REOLE rl;

//Mdi
extern BOOL bMDI;
extern BOOL bRegMDI;
extern HWND hMdiClient;
extern HWND hWndMdiActive;
extern HWND hWndMdiDestroyed;
extern BOOL bMdiMaximize;
extern BOOL bMdiNoWindows;
extern BOOL bMdiReopen;
extern HWND hTab;
extern HFONT hTabFont;
extern LOGFONT tabfont;
extern LOGFONTW tabfontW;
extern int nTabView;
extern int nTabType;
extern HIMAGELIST hImageList;
extern BOOL bTabPressed;
extern BOOL bFileExitError;
extern int nMdiStyle;
extern WNDPROC OldMdiClientProc;
extern WNDPROC OldTabProc;
extern MDIWINDOWDATA *lpWindowData;

//GetProcAddress
extern BOOL (WINAPI *GetCPInfoExAPtr) (UINT, DWORD, LPCPINFOEX);
extern BOOL (WINAPI *GetCPInfoExWPtr) (UINT, DWORD, LPCPINFOEXW);
extern DWORD (WINAPI *GetLongPathNameAPtr) (LPCTSTR, LPTSTR, DWORD);
extern DWORD (WINAPI *GetLongPathNameWPtr) (LPCWSTR, LPWSTR, DWORD);
extern UINT (WINAPI *ExtractIconExAPtr) (LPCTSTR, int, HICON *, HICON *, UINT);
extern UINT (WINAPI *ExtractIconExWPtr) (LPCWSTR, int, HICON *, HICON *, UINT);
extern BOOL (WINAPI *SHGetPathFromIDListAPrt) (LPCITEMIDLIST, LPTSTR);
extern BOOL (WINAPI *SHGetPathFromIDListWPrt) (LPCITEMIDLIST, LPWSTR);
extern LPITEMIDLIST (WINAPI *SHBrowseForFolderAPrt) (LPBROWSEINFOA);
extern LPITEMIDLIST (WINAPI *SHBrowseForFolderWPrt) (LPBROWSEINFOW);


//// Init function

void CreateEditWindowA(HWND hWnd)
{
  RECT rcRect;
  int nLangoptions;
  BOOL bModifiedTmp=bModified;

  GetClientRect(hWnd, &rcRect);

  hWndEdit=CreateWindow("richedit20a",
                        NULL,
                        WS_CHILD|WS_VISIBLE|WS_HSCROLL|WS_VSCROLL|
                          ES_LEFT|ES_MULTILINE|ES_AUTOHSCROLL|ES_AUTOVSCROLL|
                          ES_DISABLENOSCROLL|ES_SUNKEN|ES_NOHIDESEL,
                        0, 0, rcRect.right, rcRect.bottom - (bStatusBar?nStatusHeight:0),
                        hWnd,
                        (HMENU)ID_EDIT,
                        hInstance,
                        NULL);

  SendMessage(hWndEdit, EM_SETOLECALLBACK, 0, (LPARAM)&rl);
  SendMessage(hWndEdit, EM_EXLIMITTEXT, 0, nMaxChars);
  nLangoptions=SendMessage(hWndEdit, EM_GETLANGOPTIONS, 0, 0);
  nLangoptions&=~IMF_AUTOFONT;
  nLangoptions&=~IMF_AUTOFONTSIZEADJUST;
  SendMessage(hWndEdit, EM_SETLANGOPTIONS, 0, nLangoptions);
  SendMessage(hWndEdit, EM_SETTEXTMODE, TM_RICHTEXT|TM_MULTILEVELUNDO|TM_MULTICODEPAGE, 0);
  SendMessage(hWndEdit, EM_SETWORDBREAKPROC, 0, (LPARAM)EditWordBreakProc);
  SendMessage(hWndEdit, EM_SETEVENTMASK, 0, ENM_SELCHANGE|ENM_CHANGE|ENM_KEYEVENTS|ENM_MOUSEEVENTS);

  SetWindowText(hWndEdit, "");
  DoViewWordWrap(hWndEdit, bWordWrap, TRUE);
  SendMessage(hWndEdit, EM_SETMARGINS, EC_LEFTMARGIN|EC_RIGHTMARGIN, dwEditMargins);
  SendMessage(hWndEdit, EM_SETBKGNDCOLOR, 0, crBackground);
  SetChosenFontA(hWndEdit, logfont);
  SetChosenFontColor(hWndEdit, crFont);
  SetModifyA(bModifiedTmp, FALSE);
}

void CreateEditWindowW(HWND hWnd)
{
  RECT rcRect;
  int nLangoptions;
  BOOL bModifiedTmp=bModified;

  GetClientRect(hWnd, &rcRect);

  hWndEdit=CreateWindow("richedit20a",
                        NULL,
                        WS_CHILD|WS_VISIBLE|WS_HSCROLL|WS_VSCROLL|
                          ES_LEFT|ES_MULTILINE|ES_AUTOHSCROLL|ES_AUTOVSCROLL|
                          ES_DISABLENOSCROLL|ES_SUNKEN|ES_NOHIDESEL,
                        0, 0, rcRect.right, rcRect.bottom - (bStatusBar?nStatusHeight:0),
                        hWnd,
                        (HMENU)ID_EDIT,
                        hInstance,
                        NULL);

  SendMessage(hWndEdit, EM_SETOLECALLBACK, 0, (LPARAM)&rl);
  SendMessage(hWndEdit, EM_EXLIMITTEXT, 0, nMaxChars);
  nLangoptions=SendMessage(hWndEdit, EM_GETLANGOPTIONS, 0, 0);
  nLangoptions&=~IMF_AUTOFONT;
  nLangoptions&=~IMF_AUTOFONTSIZEADJUST;
  SendMessage(hWndEdit, EM_SETLANGOPTIONS, 0, nLangoptions);
  SendMessage(hWndEdit, EM_SETTEXTMODE, TM_RICHTEXT|TM_MULTILEVELUNDO|TM_MULTICODEPAGE, 0);
  SendMessage(hWndEdit, EM_SETWORDBREAKPROC, 0, (LPARAM)EditWordBreakProc);
  SendMessage(hWndEdit, EM_SETEVENTMASK, 0, ENM_SELCHANGE|ENM_CHANGE|ENM_KEYEVENTS|ENM_MOUSEEVENTS);

  SetWindowText(hWndEdit, "");
  DoViewWordWrap(hWndEdit, bWordWrap, TRUE);
  SendMessage(hWndEdit, EM_SETMARGINS, EC_LEFTMARGIN|EC_RIGHTMARGIN, dwEditMargins);
  SendMessage(hWndEdit, EM_SETBKGNDCOLOR, 0, crBackground);
  SetChosenFontW(hWndEdit, logfontW);
  SetChosenFontColor(hWndEdit, crFont);
  SetModifyW(bModifiedTmp, FALSE);
}


//// Menu functions

BOOL DoFileNewA()
{
  if (!bMDI)
  {
    if (!SaveChangedA()) return FALSE;

    if (nRecentFiles && *szCurrentFile)
    {
      RecentFilesZeroA();
      RecentFilesReadA();
      RecentFilesUpdateA(szCurrentFile, nPosition, MAKELONG(nCurrentCodePage, bCurrentBOM));
      RecentFilesSaveA();
    }

    HideCaret(NULL);
    SetWindowText(hWndEdit, "");
    ShowCaret(NULL);
    szCurrentFile[0]='\0';
    SetWindowTextA(hMainWnd, APP_MAIN_TITLE);
    SetNewLineA(NEWLINE_WIN, FALSE);
    SetModifyA(FALSE, FALSE);
    SetCodePageA(MAKELONG(nDefaultCodePage, bDefaultBOM), FALSE);
  }
  else
  {
    if (hWndMdiActive) SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
    hWndMdiActive=CreateMDIWindow(APP_MDI_CLASS, "", (bMdiMaximize == TRUE)?WS_MAXIMIZE:0, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hMdiClient, hInstance, 0);
  }
  return TRUE;
}

BOOL DoFileNewW()
{
  if (!bMDI)
  {
    if (!SaveChangedW()) return FALSE;

    if (nRecentFiles && *wszCurrentFile)
    {
      RecentFilesZeroW();
      RecentFilesReadW();
      RecentFilesUpdateW(wszCurrentFile, nPosition, MAKELONG(nCurrentCodePage, bCurrentBOM));
      RecentFilesSaveW();
    }

    HideCaret(NULL);
    SetWindowTextW(hWndEdit, L"");
    ShowCaret(NULL);
    wszCurrentFile[0]='\0';
    SetWindowTextW(hMainWnd, APP_MAIN_TITLEW);
    SetNewLineW(NEWLINE_WIN, FALSE);
    SetModifyW(FALSE, FALSE);
    SetCodePageW(MAKELONG(nDefaultCodePage, bDefaultBOM), FALSE);
  }
  else
  {
    if (hWndMdiActive) SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
    hWndMdiActive=CreateMDIWindowW(APP_MDI_CLASSW, L"", (bMdiMaximize == TRUE)?WS_MAXIMIZE:0, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hMdiClient, hInstance, 0);
  }
  return TRUE;
}

HWND DoFileNewWindowA(DWORD dwAddFlags)
{
  STARTUPINFO si={0};
  PROCESS_INFORMATION pi={0};
  HWND hWnd=0;

  if (!GetModuleFileName(hInstance, buf, MAX_PATH)) return 0;

  si.cb=sizeof(STARTUPINFO);
  si.dwFlags=STARTF_USESHOWWINDOW|dwAddFlags;
  si.wShowWindow=SW_SHOWNORMAL;

  if (CreateProcess(buf, NULL, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
  {
    WaitForInputIdle(pi.hProcess, INFINITE);
    EnumThreadWindows(pi.dwThreadId, EnumThreadWndProcA, (LPARAM)&hWnd);
    CloseHandle(pi.hProcess);
    CloseHandle(pi.hThread);
    return hWnd;
  }
  return 0;
}

HWND DoFileNewWindowW(DWORD dwAddFlags)
{
  STARTUPINFOW siW={0};
  PROCESS_INFORMATION pi={0};
  HWND hWnd=0;

  if (!GetModuleFileNameW(hInstance, wbuf, MAX_PATH)) return 0;

  siW.cb=sizeof(STARTUPINFOW);
  siW.dwFlags=STARTF_USESHOWWINDOW|dwAddFlags;
  siW.wShowWindow=SW_SHOWNORMAL;

  if (CreateProcessW(wbuf, NULL, NULL, NULL, FALSE, 0, NULL, NULL, &siW, &pi))
  {
    WaitForInputIdle(pi.hProcess, INFINITE);
    EnumThreadWindows(pi.dwThreadId, EnumThreadWndProcW, (LPARAM)&hWnd);
    CloseHandle(pi.hProcess);
    CloseHandle(pi.hThread);
    return hWnd;
  }
  return 0;
}

BOOL CALLBACK EnumThreadWndProcA(HWND hwnd, LPARAM lParam)
{
  HWND *hWnd=(HWND *)lParam;

  GetClassName(hwnd, buf, BUFFER_SIZE);
  if (!lstrcmp(buf, APP_MAIN_CLASS))
  {
    *hWnd=hwnd;
    return FALSE;
  }
  return TRUE;
}

BOOL CALLBACK EnumThreadWndProcW(HWND hwnd, LPARAM lParam)
{
  HWND *hWnd=(HWND *)lParam;

  GetClassNameW(hwnd, wbuf, BUFFER_SIZE);
  if (!lstrcmpW(wbuf, APP_MAIN_CLASSW))
  {
    *hWnd=hwnd;
    return FALSE;
  }
  return TRUE;
}

BOOL DoFileOpenA()
{
  if (!bMDI && !SaveChangedA()) return FALSE;

  bSaveDlg=FALSE;
  ofn.lStructSize=sizeof(OPENFILENAME);
  ofn.lpstrDefExt=NULL;
  if (!bMDI)
    ofn.Flags&=~OFN_ALLOWMULTISELECT;
  else
    ofn.Flags|=OFN_ALLOWMULTISELECT;
  lstrcpy(szFileBuffer, szCurrentFile);

  if (GetOpenFileName(&ofn))
  {
    if (!bMDI)
    {
      if (OpenDocumentA(szFileBuffer, dwOfnFlags, nOfnCodePage, bOfnBOM) < 0)
        return FALSE;
    }
    else
    {
      char szFile[MAX_PATH];
      char *pFile=szFileBuffer + lstrlen(szFileBuffer) + 1;

      if (*pFile)
      {
        if (*(pFile - 2) == '\\') *(pFile - 2)='\0';

        do
        {
          if (IsPathFullA(pFile))
            lstrcpy(szFile, pFile);  //.lnk target
          else
            wsprintf(szFile, "%s\\%s", szFileBuffer, pFile);
          OpenDocumentA(szFile, dwOfnFlags, nOfnCodePage, bOfnBOM);
        }
        while (*(pFile+=lstrlen(pFile) + 1));

        return TRUE;
      }
      else
      {
        if (OpenDocumentA(szFileBuffer, dwOfnFlags, nOfnCodePage, bOfnBOM) < 0)
          return FALSE;
      }
    }
  }
  return FALSE;
}

BOOL DoFileOpenW()
{
  if (!bMDI && !SaveChangedW()) return FALSE;

  bSaveDlg=FALSE;
  ofnW.lStructSize=sizeof(OPENFILENAMEW);
  ofnW.lpstrDefExt=NULL;
  if (!bMDI)
    ofnW.Flags&=~OFN_ALLOWMULTISELECT;
  else
    ofnW.Flags|=OFN_ALLOWMULTISELECT;
  lstrcpyW(wszFileBuffer, wszCurrentFile);

  if (GetOpenFileNameW(&ofnW))
  {
    if (!bMDI)
    {
      if (OpenDocumentW(wszFileBuffer, dwOfnFlags, nOfnCodePage, bOfnBOM) < 0)
        return FALSE;
    }
    else
    {
      wchar_t wszFile[MAX_PATH];
      wchar_t *wpFile=wszFileBuffer + lstrlenW(wszFileBuffer) + 1;

      if (*wpFile)
      {
        if (*(wpFile - 2) == '\\') *(wpFile - 2)='\0';

        do
        {
          if (IsPathFullW(wpFile))
            lstrcpyW(wszFile, wpFile);  //.lnk target
          else
            wsprintfW(wszFile, L"%s\\%s", wszFileBuffer, wpFile);
          OpenDocumentW(wszFile, dwOfnFlags, nOfnCodePage, bOfnBOM);
        }
        while (*(wpFile+=lstrlenW(wpFile) + 1));

        return TRUE;
      }
      else
      {
        if (OpenDocumentW(wszFileBuffer, dwOfnFlags, nOfnCodePage, bOfnBOM) < 0)
          return FALSE;
      }
    }
  }
  return FALSE;
}

void DoFileReopenAsA(DWORD Flags, int nCodePage, BOOL bBOM)
{
  int i;

  if (!*szCurrentFile) return;

  if (bModified)
  {
    API_LoadStringA(hLangLib, MSG_FILE_WILL_BE_REOPENED, buf, BUFFER_SIZE);
    i=MessageBox(hMainWnd, buf, APP_MAIN_TITLE, MB_OKCANCEL|MB_ICONEXCLAMATION);
  }
  if (!bModified || i == IDOK)
  {
    bMdiReopen=TRUE;
    OpenDocumentA(szCurrentFile, Flags, nCodePage, bBOM);
    bMdiReopen=FALSE;
  }
}

void DoFileReopenAsW(DWORD Flags, int nCodePage, BOOL bBOM)
{
  int i;

  if (!*wszCurrentFile) return;

  if (bModified)
  {
    API_LoadStringW(hLangLib, MSG_FILE_WILL_BE_REOPENED, wbuf, BUFFER_SIZE);
    i=MessageBoxW(hMainWnd, wbuf, APP_MAIN_TITLEW, MB_OKCANCEL|MB_ICONEXCLAMATION);
  }
  if (!bModified || i == IDOK)
  {
    bMdiReopen=TRUE;
    OpenDocumentW(wszCurrentFile, Flags, nCodePage, bBOM);
    bMdiReopen=FALSE;
  }
}

BOOL DoFileSaveA()
{
  if (!bModified && *szCurrentFile) return FALSE;
  if (!*szCurrentFile) return DoFileSaveAsA();
  SaveDocumentA(szCurrentFile, nCurrentCodePage, bCurrentBOM);
  return TRUE;
}

BOOL DoFileSaveW()
{
  if (!bModified && *wszCurrentFile) return FALSE;
  if (!*wszCurrentFile) return DoFileSaveAsW();
  SaveDocumentW(wszCurrentFile, nCurrentCodePage, bCurrentBOM);
  return TRUE;
}

BOOL DoFileSaveAsA()
{
  bSaveDlg=TRUE;
  ofn.lStructSize=sizeof(OPENFILENAME);
  ofn.lpstrDefExt="txt";
  ofn.Flags&=~OFN_ALLOWMULTISELECT;
  lstrcpy(szFileBuffer, szCurrentFile);

  if (GetSaveFileName(&ofn))
  {
    if (SaveDocumentA(szFileBuffer, nOfnCodePage, bOfnBOM))
      return TRUE;
  }
  return FALSE;
}

BOOL DoFileSaveAsW()
{
  bSaveDlg=TRUE;
  ofnW.lStructSize=sizeof(OPENFILENAMEW);
  ofnW.lpstrDefExt=L"txt";
  ofnW.Flags&=~OFN_ALLOWMULTISELECT;
  lstrcpyW(wszFileBuffer, wszCurrentFile);

  if (GetSaveFileNameW(&ofnW))
  {
    if (SaveDocumentW(wszFileBuffer, nOfnCodePage, bOfnBOM))
      return TRUE;
  }
  return FALSE;
}

void DoFilePageSetupA()
{
  PageSetupDlg(&psdPage);
}

void DoFilePageSetupW()
{
  PageSetupDlgW(&psdPageW);
}

void DoFilePrintA()
{
  FORMATRANGE fr;
  DOCINFO di={0};
  int nNextCh;
  int nWidth;
  int nHeight;

  pd.hDevMode=psdPage.hDevMode;
  pd.hDevNames=psdPage.hDevNames;

  API_LoadStringA(hLangLib, STR_DOCNAME, buf, BUFFER_SIZE);
  di.cbSize=sizeof(DOCINFO);
  di.lpszDocName=(*szCurrentFile)?szCurrentFile:buf;

  if (!PrintDlg(&pd)) return;

  nWidth=GetDeviceCaps(pd.hDC, HORZSIZE) * 56;  //about 56 twips per millimeter
  nHeight=GetDeviceCaps(pd.hDC, VERTSIZE) * 56;

  fr.hdc=pd.hDC;
  fr.hdcTarget=pd.hDC;

  if (psdPage.Flags & PSD_INHUNDREDTHSOFMILLIMETERS)
  {
    fr.rc.left=psdPage.rtMargin.left * 567 / 1000;
    fr.rc.top=psdPage.rtMargin.top * 567 / 1000;
    fr.rc.right=nWidth - psdPage.rtMargin.right * 567 / 1000;
    fr.rc.bottom=nHeight - psdPage.rtMargin.bottom * 567 / 1000;
  }
  else
  {
    fr.rc.left=psdPage.rtMargin.left * 144 / 100;
    fr.rc.top=psdPage.rtMargin.top * 144 / 100;
    fr.rc.right=nWidth - psdPage.rtMargin.right * 144 / 100;
    fr.rc.bottom=nHeight - psdPage.rtMargin.bottom * 144 / 100;
  }
  fr.rcPage.left=0;
  fr.rcPage.top=0;
  fr.rcPage.right=nWidth;
  fr.rcPage.bottom=nHeight;

  if (pd.Flags & PD_PRINTTOFILE) di.lpszOutput="FILE:";

  if (StartDoc(pd.hDC, &di) <= 0)
  {
    API_LoadStringA(hLangLib, MSG_ERROR_PRINT, buf, BUFFER_SIZE);
    MessageBox(hMainWnd, buf, APP_MAIN_TITLE, MB_OK|MB_ICONERROR);
    return;
  }

  if (pd.Flags & PD_SELECTION)
  {
    SendMessage(hWndEdit, EM_EXGETSEL, 0, (LPARAM)&fr.chrg);
  }
  else
  {
    fr.chrg.cpMin=0;
    fr.chrg.cpMax=-1;
  }

  while (1)
  {
    nNextCh=SendMessage(hWndEdit, EM_FORMATRANGE, FALSE, (LPARAM)&fr);
    if (nNextCh == fr.chrg.cpMin) break;
    fr.chrg.cpMin=nNextCh;
    StartPage(pd.hDC);
    if (!SendMessage(hWndEdit, EM_DISPLAYBAND, 0, (LPARAM)&fr.rc))
    {
      EndPage(pd.hDC);
      API_LoadStringA(hLangLib, MSG_ERROR_PRINT, buf, BUFFER_SIZE);
      MessageBox(hMainWnd, buf, APP_MAIN_TITLE, MB_OK|MB_ICONERROR);
      break;
    }
    EndPage(pd.hDC);
  }

  EndDoc(pd.hDC);
  DeleteDC(pd.hDC);
}

void DoFilePrintW()
{
  FORMATRANGE fr;
  DOCINFOW diW={0};
  int nNextCh;
  int nWidth;
  int nHeight;

  pdW.hDevMode=psdPageW.hDevMode;
  pdW.hDevNames=psdPageW.hDevNames;

  API_LoadStringW(hLangLib, STR_DOCNAME, wbuf, BUFFER_SIZE);
  diW.cbSize=sizeof(DOCINFOW);
  diW.lpszDocName=(*wszCurrentFile)?wszCurrentFile:wbuf;

  if (!PrintDlgW(&pdW)) return;

  nWidth=GetDeviceCaps(pdW.hDC, HORZSIZE) * 56;  //about 56 twips per millimeter
  nHeight=GetDeviceCaps(pdW.hDC, VERTSIZE) * 56;

  fr.hdc=pdW.hDC;
  fr.hdcTarget=pdW.hDC;

  if (psdPageW.Flags & PSD_INHUNDREDTHSOFMILLIMETERS)
  {
    fr.rc.left=psdPageW.rtMargin.left * 567 / 1000;
    fr.rc.top=psdPageW.rtMargin.top * 567 / 1000;
    fr.rc.right=nWidth - psdPageW.rtMargin.right * 567 / 1000;
    fr.rc.bottom=nHeight - psdPageW.rtMargin.bottom * 567 / 1000;
  }
  else
  {
    fr.rc.left=psdPageW.rtMargin.left * 144 / 100;
    fr.rc.top=psdPageW.rtMargin.top * 144 / 100;
    fr.rc.right=nWidth - psdPageW.rtMargin.right * 144 / 100;
    fr.rc.bottom=nHeight - psdPageW.rtMargin.bottom * 144 / 100;
  }
  fr.rcPage.left=0;
  fr.rcPage.top=0;
  fr.rcPage.right=nWidth;
  fr.rcPage.bottom=nHeight;

  if (pdW.Flags & PD_PRINTTOFILE) diW.lpszOutput=L"FILE:";

  if (StartDocW(pdW.hDC, &diW) <= 0)
  {
    API_LoadStringW(hLangLib, MSG_ERROR_PRINT, wbuf, BUFFER_SIZE);
    MessageBoxW(hMainWnd, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONERROR);
    return;
  }

  if (pdW.Flags & PD_SELECTION)
  {
    SendMessage(hWndEdit, EM_EXGETSEL, 0, (LPARAM)&fr.chrg);
  }
  else
  {
    fr.chrg.cpMin=0;
    fr.chrg.cpMax=-1;
  }

  while (1)
  {
    nNextCh=SendMessage(hWndEdit, EM_FORMATRANGE, FALSE, (LPARAM)&fr);
    if (nNextCh == fr.chrg.cpMin) break;
    fr.chrg.cpMin=nNextCh;
    StartPage(pdW.hDC);
    if (!SendMessage(hWndEdit, EM_DISPLAYBAND, 0, (LPARAM)&fr.rc))
    {
      EndPage(pdW.hDC);
      API_LoadStringW(hLangLib, MSG_ERROR_PRINT, wbuf, BUFFER_SIZE);
      MessageBoxW(hMainWnd, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONERROR);
      break;
    }
    EndPage(pdW.hDC);
  }

  EndDoc(pdW.hDC);
  DeleteDC(pdW.hDC);
}

BOOL DoFileExitA()
{
  if (!SaveChangedA()) return FALSE;

  if (nRecentFiles && *szCurrentFile)
  {
    RecentFilesZeroA();
    RecentFilesReadA();
    RecentFilesUpdateA(szCurrentFile, nPosition, MAKELONG(nCurrentCodePage, bCurrentBOM));
    RecentFilesSaveA();
  }
  return TRUE;
}

BOOL DoFileExitW()
{
  if (!SaveChangedW()) return FALSE;

  if (nRecentFiles && *wszCurrentFile)
  {
    RecentFilesZeroW();
    RecentFilesReadW();
    RecentFilesUpdateW(wszCurrentFile, nPosition, MAKELONG(nCurrentCodePage, bCurrentBOM));
    RecentFilesSaveW();
  }
  return TRUE;
}

void DoEditUndo(HWND hWnd)
{
  SendMessage(hWnd, EM_UNDO, 0, 0);
}

void DoEditRedo(HWND hWnd)
{
  SendMessage(hWnd, EM_REDO, 0, 0);
}

void DoEditCut(HWND hWnd)
{
  SendMessage(hWnd, WM_CUT, 0, 0);
}

void DoEditCopy(HWND hWnd)
{
  SendMessage(hWnd, WM_COPY, 0, 0);
}

void DoEditPaste(HWND hWnd)
{
  HGLOBAL hData;
  LPVOID pData;

  if (!OpenClipboard(hWnd))
    return;

  if ((hData=GetClipboardData(CF_UNICODETEXT)) && (pData=GlobalLock(hData)))
  {
    ReplaceSelW(hWnd, (wchar_t *)pData);
    GlobalUnlock(hData);
  }
  else if ((hData=GetClipboardData(CF_TEXT)) && (pData=GlobalLock(hData)))
  {
    ReplaceSelA(hWnd, (char *)pData);
    GlobalUnlock(hData);
  }
  CloseClipboard();
}

void DoEditPasteANSI(HWND hWnd)
{
  HGLOBAL hData;
  LPVOID pData;

  if (!OpenClipboard(hWnd))
    return;

  if ((hData=GetClipboardData(CF_TEXT)) && (pData=GlobalLock(hData)))
  {
    ReplaceSelA(hWnd, (char *)pData);
    GlobalUnlock(hData);
  }
  CloseClipboard();
}

void DoEditClear(HWND hWnd)
{
  SendMessage(hWnd, EM_REPLACESEL, TRUE, (LPARAM)"");
}

void DoEditSelectAll(HWND hWnd)
{
  SendMessage(hWnd, EM_SETSEL, 0, -1);
}

void DoEditInsertChar()
{
  ShellExecute(hMainWnd, "open", "charmap.exe", NULL, NULL, SW_SHOWDEFAULT);
}

void DoEditRecodeA(HWND hWnd)
{
  bRecodeDlg=TRUE;
  API_DialogBoxA(hLangLib, MAKEINTRESOURCE(IDD_RECODE), hMainWnd, (DLGPROC)RecodeDlgProcA);
  if (bRecodeDlg)
  {
    RecodeTextW(hWnd, nRecodeCodePage);
    bRecodeDlg=FALSE;
  }
}

void DoEditRecodeW(HWND hWnd)
{
  bRecodeDlg=TRUE;
  API_DialogBoxW(hLangLib, MAKEINTRESOURCEW(IDD_RECODE), hMainWnd, (DLGPROC)RecodeDlgProcW);
  if (bRecodeDlg)
  {
    RecodeTextW(hWnd, nRecodeCodePage);
    bRecodeDlg=FALSE;
  }
}

BOOL DoEditInsertStringInSelectionW(HWND hWnd, int nAction, wchar_t *wpString)
{
  CHARRANGE cr;
  GETTEXTEX gt;
  wchar_t *wpText;
  wchar_t *wpTextEnd;
  wchar_t *a;
  wchar_t *b;
  int nMinLine;
  int nMaxLine;
  int nMinLineIndex;
  int nMaxLineIndex;
  int nMaxLineLength;
  int nTextSize;
  int nStringsSum;
  int nStringsSize;
  int nStringLength;
  int nStringLengthW;
  int nStringCount;
  int nLen;

  cr.cpMin=chrg.cpMin;
  cr.cpMax=chrg.cpMax;

  if (cr.cpMin != cr.cpMax)
  {
    nMinLine=SendMessage(hWnd, EM_LINEFROMCHAR, cr.cpMin, 0);
    nMaxLine=SendMessage(hWnd, EM_LINEFROMCHAR, cr.cpMax, 0);
    nMinLineIndex=SendMessage(hWnd, EM_LINEINDEX, nMinLine, 0);
    nMaxLineIndex=SendMessage(hWnd, EM_LINEINDEX, nMaxLine, 0);
    nMaxLineLength=SendMessage(hWnd, EM_LINELENGTH, cr.cpMax, 0);

    if (nMinLine != nMaxLine || (nMinLineIndex == cr.cpMin && !nMaxLineLength))
    {
      if (nAction == STRSEL_CHECK) return TRUE;

      if (nMaxLineIndex == cr.cpMax) --nMaxLine;
      else if (nMaxLineLength) cr.cpMax=nMaxLineIndex + nMaxLineLength + 1;
      cr.cpMin=nMinLineIndex;
      SendMessage(hWnd, EM_EXSETSEL, 0, (LPARAM)&cr);

      nStringLength=wcslen(wpString);
      nStringLengthW=nStringLength * sizeof(wchar_t);
      nStringsSum=nMaxLine - nMinLine + 1;
      nStringsSize=nStringsSum * nStringLength;
      nTextSize=cr.cpMax - cr.cpMin + 1;
      nLen=nTextSize + nStringsSize;

      if (nAction == STRSEL_INSERT)
      {
        if (wpText=(wchar_t *)API_HeapAlloc(hHeap, 0, nLen * sizeof(wchar_t) + 2))
        {
          gt.cb=nLen * sizeof(wchar_t);
          gt.flags=GT_SELECTION;
          gt.codepage=1200;
          gt.lpDefaultChar=NULL;
          gt.lpUsedDefChar=NULL;
          SendMessage(hWnd, EM_GETTEXTEX, (WPARAM)&gt, (LPARAM)(wpText + nStringsSize));

          nStringCount=1;
          a=wpText + nStringLength;
          b=wpText + nStringsSize;
          memcpy(wpText, wpString, nStringLengthW);

          while (nStringCount < nStringsSum)
          {
            if (*b == '\r')
            {
              *a++=*b++;
              memcpy(a, wpString, nStringLengthW);
              a+=nStringLength;
              ++nStringCount;
            }
            else *a++=*b++;
          }
        }
        else return FALSE;
      }
      else if (nAction == STRSEL_DELETE)
      {
        if (wpText=(wchar_t *)API_HeapAlloc(hHeap, 0, nTextSize * sizeof(wchar_t) + 2))
        {
          gt.cb=nTextSize * sizeof(wchar_t);
          gt.flags=GT_SELECTION;
          gt.codepage=1200;
          gt.lpDefaultChar=NULL;
          gt.lpUsedDefChar=NULL;
          SendMessage(hWnd, EM_GETTEXTEX, (WPARAM)&gt, (LPARAM)wpText);

          wpTextEnd=wpText + nTextSize;
          a=wpText;
          b=wpText;
          if (!memcmp(wpText, wpString, nStringLengthW)) b+=nStringLength;

          while (b < wpTextEnd)
          {
            if (*b == '\r')
            {
              *a++=*b++;
              if (!memcmp(b, wpString, nStringLengthW)) b+=nStringLength;
            }
            else *a++=*b++;
          }
        }
        else return FALSE;
      }
      ReplaceSelW(hWnd, wpText);

      if (nAction == STRSEL_INSERT)
        SendMessage(hWnd, EM_SETSEL, cr.cpMin, cr.cpMin + nLen - 1);
      else if (nAction == STRSEL_DELETE)
        SendMessage(hWnd, EM_SETSEL, cr.cpMin, cr.cpMin + (a - wpText) - 1);
      API_HeapFree(hHeap, 0, (LPVOID)wpText);
      return TRUE;
    }
  }
  if (nAction == STRSEL_CHECK) return FALSE;
  return TRUE;
}

BOOL DoEditDeleteTrailingWhitespacesW(HWND hWnd)
{
  CHARRANGE cr;
  GETTEXTEX gt;
  wchar_t *wpText;
  int nLine;
  int nPos;
  int nLen;
  int nLenW;
  int a;
  int b;

  cr.cpMin=chrg.cpMin;
  cr.cpMax=chrg.cpMax;
  if (chrg.cpMin == chrg.cpMax)
  {
    nLine=SendMessage(hWnd, EM_LINEFROMCHAR, cr.cpMin, 0);
    nPos=cr.cpMin - SendMessage(hWnd, EM_LINEINDEX, nLine, 0);
    SendMessage(hWnd, EM_SETSEL, 0, -1);
  }
  nLen=(chrg.cpMax - chrg.cpMin) + 1;
  nLenW=nLen * sizeof(wchar_t);

  if (wpText=(wchar_t *)API_HeapAlloc(hHeap, 0, nLenW + 2))
  {
    gt.cb=nLenW;
    gt.flags=GT_SELECTION;
    gt.codepage=1200;
    gt.lpDefaultChar=NULL;
    gt.lpUsedDefChar=NULL;
    SendMessage(hWnd, EM_GETTEXTEX, (WPARAM)&gt, (LPARAM)wpText);

    for (a=0, b=0; b < nLen; wpText[a++]=wpText[b++])
    {
      if (wpText[b] == '\r' || wpText[b] == '\0')
      {
        while (--a >= 0 && (wpText[a] == '\t' || wpText[a] == ' '));
        ++a;
      }
    }

    ReplaceSelW(hWnd, wpText);
    if (cr.cpMin == cr.cpMax)
    {
      a=SendMessage(hWnd, EM_LINEINDEX, nLine, 0);
      b=SendMessage(hWnd, EM_LINELENGTH, a, 0);
      if (nPos > b) nPos=b;
      SendMessage(hWnd, EM_SETSEL, a + nPos, a + nPos);
    }
    else SendMessage(hWnd, EM_SETSEL, cr.cpMin, cr.cpMin + a - 1);

    API_HeapFree(hHeap, 0, (LPVOID)wpText);
    return TRUE;
  }
  return FALSE;
}

BOOL DoEditChangeCaseA(HWND hWnd, int nCase)
{
  CHARRANGE cr;
  TEXTRANGE txtrng;
  char *pText;
  char *pStart;
  char *pEnd;
  int nLen;
  int nLayout;

  cr.cpMin=chrg.cpMin;
  cr.cpMax=chrg.cpMax;
  if (chrg.cpMin == chrg.cpMax) SendMessage(hWnd, EM_SETSEL, 0, -1);
  nLen=(chrg.cpMax - chrg.cpMin) + 1;

  if (pText=(char *)API_HeapAlloc(hHeap, 0, nLen + 1))
  {
    nLayout=SetLayout();
    txtrng.chrg.cpMin=chrg.cpMin;
    txtrng.chrg.cpMax=chrg.cpMax;
    txtrng.lpstrText=pText;
    SendMessage(hWnd, EM_GETTEXTRANGE, 0, (LPARAM)&txtrng);
    RestoreLayout(nLayout);

    pStart=pText;
    pEnd=pStart + nLen;

    if (nCase == UPPERCASE)
    {
      CharUpperBuff(pText, nLen);
    }
    else if (nCase == LOWERCASE)
    {
      CharLowerBuff(pText, nLen);
    }
    else if (nCase == SENTENCECASE)
    {
      while (pStart < pEnd)
      {
        while (pStart < pEnd && (*pStart == ' ' || *pStart == '\t' || *pStart == '\r' || strchr(SENTENCE_SELIMITERS, *pStart)))
          ++pStart;

        if (pStart < pEnd) *pStart++=(char)CharUpper((char*)(unsigned)(unsigned char)*pStart);

        while (pStart < pEnd && !strchr(SENTENCE_SELIMITERS, *pStart))
          *pStart++=(char)CharLower((char*)(unsigned)(unsigned char)*pStart);
      }
    }
    else if (nCase == TITLECASE)
    {
      while (pStart < pEnd)
      {
        while (pStart < pEnd && strchr(TITLE_DELIMITERS, *pStart))
          ++pStart;

        if (pStart < pEnd) *pStart++=(char)CharUpper((char*)(unsigned)(unsigned char)*pStart);

        while (pStart < pEnd && !strchr(TITLE_DELIMITERS, *pStart))
          *pStart++=(char)CharLower((char*)(unsigned)(unsigned char)*pStart);
      }
    }
    else if (nCase == INVERTCASE)
    {
      while (pStart < pEnd)
      {
        if (IsCharLower(*pStart))
          *pStart++=(char)CharUpper((char*)(unsigned)(unsigned char)*pStart);
        else
          *pStart++=(char)CharLower((char*)(unsigned)(unsigned char)*pStart);
      }
    }

    ReplaceSelA(hWnd, pText);
    SendMessage(hWnd, EM_SETSEL, cr.cpMin, (cr.cpMin == cr.cpMax)?(cr.cpMin):(cr.cpMin + nLen - 1));

    API_HeapFree(hHeap, 0, (LPVOID)pText);
    return TRUE;
  }
  return FALSE;
}

BOOL DoEditChangeCaseW(HWND hWnd, int nCase)
{
  CHARRANGE cr;
  GETTEXTEX gt;
  wchar_t *wpText;
  wchar_t *wpStart;
  wchar_t *wpEnd;
  int nLen;
  int nLenW;

  cr.cpMin=chrg.cpMin;
  cr.cpMax=chrg.cpMax;
  if (chrg.cpMin == chrg.cpMax) SendMessage(hWnd, EM_SETSEL, 0, -1);
  nLen=(chrg.cpMax - chrg.cpMin) + 1;
  nLenW=nLen * sizeof(wchar_t);

  if (wpText=(wchar_t *)API_HeapAlloc(hHeap, 0, nLenW + 2))
  {
    gt.cb=nLenW;
    gt.flags=GT_SELECTION;
    gt.codepage=1200;
    gt.lpDefaultChar=NULL;
    gt.lpUsedDefChar=NULL;
    SendMessage(hWnd, EM_GETTEXTEX, (WPARAM)&gt, (LPARAM)wpText);

    wpStart=wpText;
    wpEnd=wpStart + nLen;

    if (nCase == UPPERCASE)
    {
      CharUpperBuffW(wpText, nLen);
    }
    else if (nCase == LOWERCASE)
    {
      CharLowerBuffW(wpText, nLen);
    }
    else if (nCase == SENTENCECASE)
    {
      while (wpStart < wpEnd)
      {
        while (wpStart < wpEnd && (*wpStart == ' ' || *wpStart == '\t' || *wpStart == '\r' || wcschr(SENTENCE_SELIMITERSW, *wpStart)))
          ++wpStart;

        if (wpStart < wpEnd) *wpStart++=(wchar_t)CharUpperW((wchar_t*)(unsigned)(unsigned short)*wpStart);

        while (wpStart < wpEnd && !wcschr(SENTENCE_SELIMITERSW, *wpStart))
          *wpStart++=(wchar_t)CharLowerW((wchar_t*)(unsigned)(unsigned short)*wpStart);
      }
    }
    else if (nCase == TITLECASE)
    {
      while (wpStart < wpEnd)
      {
        while (wpStart < wpEnd && wcschr(TITLE_DELIMITERSW, *wpStart))
          ++wpStart;

        if (wpStart < wpEnd) *wpStart++=(wchar_t)CharUpperW((wchar_t*)(unsigned)(unsigned short)*wpStart);

        while (wpStart < wpEnd && !wcschr(TITLE_DELIMITERSW, *wpStart))
          *wpStart++=(wchar_t)CharLowerW((wchar_t*)(unsigned)(unsigned short)*wpStart);
      }
    }
    else if (nCase == INVERTCASE)
    {
      while (wpStart < wpEnd)
      {
        if (IsCharLowerW(*wpStart))
          *wpStart++=(wchar_t)CharUpperW((wchar_t*)(unsigned)(unsigned short)*wpStart);
        else
          *wpStart++=(wchar_t)CharLowerW((wchar_t*)(unsigned)(unsigned short)*wpStart);
      }
    }

    ReplaceSelW(hWnd, wpText);
    SendMessage(hWnd, EM_SETSEL, cr.cpMin, (cr.cpMin == cr.cpMax)?(cr.cpMin):(cr.cpMin + nLen - 1));

    API_HeapFree(hHeap, 0, (LPVOID)wpText);
    return TRUE;
  }
  return FALSE;
}

void DoEditFindA()
{
  if (!hDlgModeless)
  {
    bReplaceDlg=FALSE;
    if (ftflags & FR_SELECTION) ftflags&=~FR_SELECTION;
    else if (!bMDI && (ftflags & FR_ALLFILES)) ftflags&=~FR_ALLFILES;

    if (hDlgModeless=API_CreateDialogA(hLangLib, MAKEINTRESOURCE(IDD_FIND), hMainWnd, (DLGPROC)FindAndReplaceDlgProcA))
    {
      ShowWindow(hDlgModeless, SW_SHOW);
    }
  }
}

void DoEditFindW()
{
  if (!hDlgModeless)
  {
    bReplaceDlg=FALSE;
    if (ftflags & FR_SELECTION) ftflags&=~FR_SELECTION;
    else if (!bMDI && (ftflags & FR_ALLFILES)) ftflags&=~FR_ALLFILES;

    if (hDlgModeless=API_CreateDialogW(hLangLib, MAKEINTRESOURCEW(IDD_FIND), hMainWnd, (DLGPROC)FindAndReplaceDlgProcW))
    {
      ShowWindow(hDlgModeless, SW_SHOW);
    }
  }
}

void DoEditFindNextDownA(HWND hWnd)
{
  DWORD tmpflags=ftflags;

  if (szFind)
  {
    ftflags&=~FR_UP&~FR_BEGINNING&~FR_SELECTION&~FR_ALLFILES;
    ftflags|=FR_DOWN;

    FindTextA(hWnd);

    ftflags=tmpflags;
  }
  else DoEditFindA();
}

void DoEditFindNextDownW(HWND hWnd)
{
  DWORD tmpflags=ftflags;

  if (wszFind)
  {
    ftflags&=~FR_UP&~FR_BEGINNING&~FR_SELECTION&~FR_ALLFILES;
    ftflags|=FR_DOWN;

    FindTextW(hWnd);

    ftflags=tmpflags;
  }
  else DoEditFindW();
}

void DoEditFindNextUpA(HWND hWnd)
{
  DWORD tmpflags=ftflags;

  if (szFind)
  {
    ftflags&=~FR_DOWN&~FR_BEGINNING&~FR_SELECTION&~FR_ALLFILES;
    ftflags|=FR_UP;

    FindTextA(hWnd);

    ftflags=tmpflags;
  }
  else DoEditFindA();
}

void DoEditFindNextUpW(HWND hWnd)
{
  DWORD tmpflags=ftflags;

  if (wszFind)
  {
    ftflags&=~FR_DOWN&~FR_BEGINNING&~FR_SELECTION&~FR_ALLFILES;
    ftflags|=FR_UP;

    FindTextW(hWnd);

    ftflags=tmpflags;
  }
  else DoEditFindW();
}

void DoEditReplaceA()
{
  if (!hDlgModeless)
  {
    bReplaceDlg=TRUE;
    if (!bMDI && (ftflags & FR_ALLFILES)) ftflags&=~FR_ALLFILES;

    if (hDlgModeless=API_CreateDialogA(hLangLib, MAKEINTRESOURCE(IDD_REPLACE), hMainWnd, (DLGPROC)FindAndReplaceDlgProcA))
    {
      ShowWindow(hDlgModeless, SW_SHOW);
    }
  }
}

void DoEditReplaceW()
{
  if (!hDlgModeless)
  {
    bReplaceDlg=TRUE;
    if (!bMDI && (ftflags & FR_ALLFILES)) ftflags&=~FR_ALLFILES;

    if (hDlgModeless=API_CreateDialogW(hLangLib, MAKEINTRESOURCEW(IDD_REPLACE), hMainWnd, (DLGPROC)FindAndReplaceDlgProcW))
    {
      ShowWindow(hDlgModeless, SW_SHOW);
    }
  }
}

void DoEditGoToLineA()
{
  if (!hDlgModeless)
  {
    if (hDlgModeless=API_CreateDialogA(hLangLib, MAKEINTRESOURCE(IDD_GOTOLINE), hMainWnd, (DLGPROC)GoToLineDlgProcA))
    {
      ShowWindow(hDlgModeless, SW_SHOW);
    }
  }
}

void DoEditGoToLineW()
{
  if (!hDlgModeless)
  {
    if (hDlgModeless=API_CreateDialogW(hLangLib, MAKEINTRESOURCEW(IDD_GOTOLINE), hMainWnd, (DLGPROC)GoToLineDlgProcW))
    {
      ShowWindow(hDlgModeless, SW_SHOW);
    }
  }
}

void DoViewFontA(HWND hWnd)
{
  LOGFONT tmp;

  memcpy(&tmp, &logfont, sizeof(LOGFONT));

  if (ChooseFont(&cf))
  {
    SetChosenFontA(hWnd, logfont);
  }
  else memcpy(&logfont, &tmp, sizeof(LOGFONT));
}

void DoViewFontW(HWND hWnd)
{
  LOGFONTW tmpW;

  memcpy(&tmpW, &logfontW, sizeof(LOGFONTW));

  if (ChooseFontW(&cfW))
  {
    SetChosenFontW(hWnd, logfontW);
  }
  else memcpy(&logfontW, &tmpW, sizeof(LOGFONTW));
}

void DoViewTextColorA(HWND hWnd)
{
  COLORREF tmp=cc.rgbResult=crFont;

  if (ChooseColor(&cc))
  {
    crFont=cc.rgbResult;
    SetChosenFontColor(hWnd, crFont);
  }
  else crFont=tmp;
}

void DoViewTextColorW(HWND hWnd)
{
  COLORREF tmp=ccW.rgbResult=crFont;

  if (ChooseColorW(&ccW))
  {
    crFont=ccW.rgbResult;
    SetChosenFontColor(hWnd, crFont);
  }
  else crFont=tmp;
}

void DoViewBGColorA(HWND hWnd)
{
  COLORREF tmp=cc.rgbResult=crBackground;

  if (ChooseColor(&cc))
  {
    crBackground=cc.rgbResult;
    SendMessage(hWnd, EM_SETBKGNDCOLOR, 0, crBackground);
  }
  else crBackground=tmp;
}

void DoViewBGColorW(HWND hWnd)
{
  COLORREF tmp=ccW.rgbResult=crBackground;

  if (ChooseColorW(&ccW))
  {
    crBackground=ccW.rgbResult;
    SendMessage(hWnd, EM_SETBKGNDCOLOR, 0, crBackground);
  }
  else crBackground=tmp;
}

void DoViewFontSizeA(HWND hWnd, int nAction)
{
  if (nAction == INCREASE_FONT)
  {
    if (logfont.lfHeight >= 0)
      logfont.lfHeight+=1;
    else
      logfont.lfHeight-=1;
    SetChosenFontSizeA(hWnd, logfont.lfHeight);
  }
  else if (nAction == DECREASE_FONT)
  {
    if (logfont.lfHeight >= 0)
      logfont.lfHeight-=1;
    else
      logfont.lfHeight+=1;
    SetChosenFontSizeA(hWnd, logfont.lfHeight);
  }
}

void DoViewFontSizeW(HWND hWnd, int nAction)
{
  if (nAction == INCREASE_FONT)
  {
    if (logfontW.lfHeight >= 0)
      logfontW.lfHeight+=1;
    else
      logfontW.lfHeight-=1;
    SetChosenFontSizeW(hWnd, logfontW.lfHeight);
  }
  else if (nAction == DECREASE_FONT)
  {
    if (logfontW.lfHeight >= 0)
      logfontW.lfHeight-=1;
    else
      logfontW.lfHeight+=1;
    SetChosenFontSizeW(hWnd, logfontW.lfHeight);
  }
}

void DoViewAlignment(HWND hWnd, WORD wAlignment)
{
  PARAFORMAT2 pf;

  pf.cbSize=sizeof(PARAFORMAT2);
  pf.dwMask=PFM_ALIGNMENT;
  pf.wAlignment=wAlignment;
  SendMessage(hWnd, EM_SETPARAFORMAT, 0, (LPARAM)&pf);
}

void DoViewWordWrap(HWND hWnd, BOOL bState, BOOL bFirst)
{
  NMHDR nmhdr={hWnd, ID_EDIT, EN_SELCHANGE};

  CheckMenuItem(hMainMenu, IDM_VIEW_WORDWRAP, bState?MF_CHECKED:MF_UNCHECKED);
  if (bFirst != TRUE && bState == bWordWrap) return;
  if (bFirst == TRUE && bState == FALSE) return;

  if (bWordWrap=bState)
    SendMessage(hWnd, EM_SETTARGETDEVICE, NULL, 0);
  else
    SendMessage(hWnd, EM_SETTARGETDEVICE, NULL, -1);
  SendMessage(hMainWnd, WM_NOTIFY, ID_EDIT, (LPARAM)&nmhdr);
}

void DoViewOnTop(BOOL bState, BOOL bFirst)
{
  CheckMenuItem(hMainMenu, IDM_VIEW_ONTOP, bState?MF_CHECKED:MF_UNCHECKED);
  if (bFirst != TRUE && bState == bOnTop) return;

  if (bOnTop=bState)
    SetWindowPos(hMainWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
  else
    SetWindowPos(hMainWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
}

void DoViewShowStatusBar(BOOL bState, BOOL bFirst)
{
  RECT rcRect;

  CheckMenuItem(hMainMenu, IDM_VIEW_SHOW_STATUSBAR, bState?MF_CHECKED:MF_UNCHECKED);
  if (bFirst != TRUE && bState == bStatusBar) return;
  bStatusBar=bState;

  ShowWindow(hStatus, bStatusBar?SW_SHOW:SW_HIDE);
  GetClientRect(hMainWnd, &rcRect);
  UpdateSize(rcRect.right, rcRect.bottom);
}

void DoSettingsExecA()
{
  STARTUPINFO si={0};
  PROCESS_INFORMATION pi={0};
  char *szResult;
  int nLen;
  int i;

  nLen=ParseExecCommandA(szCommand, NULL, 0) + 1;

  if (szResult=(char *)API_HeapAlloc(hHeap, 0, nLen + 1))
  {
    ParseExecCommandA(szCommand, szResult, nLen);
    si.cb=sizeof(STARTUPINFO);
    if (i=CreateProcess(NULL, szResult, NULL, NULL, FALSE, 0, NULL, *szWorkDir?szWorkDir:NULL, &si, &pi))
    {
      CloseHandle(pi.hProcess);
      CloseHandle(pi.hThread);
    }
    else
    {
      API_LoadStringA(hLangLib, MSG_ERROR_RUN, buf, BUFFER_SIZE);
      MessageBox(hMainWnd, buf, APP_MAIN_TITLE, MB_OK|MB_ICONEXCLAMATION);
    }
    API_HeapFree(hHeap, 0, (LPVOID)szResult);
  }
}

void DoSettingsExecW()
{
  STARTUPINFOW siW={0};
  PROCESS_INFORMATION pi={0};
  wchar_t *wszResult;
  int nLen;
  int i;

  nLen=ParseExecCommandW(wszCommand, NULL, 0) + 1;

  if (wszResult=(wchar_t *)API_HeapAlloc(hHeap, 0, nLen * sizeof(wchar_t) + 2))
  {
    ParseExecCommandW(wszCommand, wszResult, nLen);
    siW.cb=sizeof(STARTUPINFOW);
    if (i=CreateProcessW(NULL, wszResult, NULL, NULL, FALSE, 0, NULL, *wszWorkDir?wszWorkDir:NULL, &siW, &pi))
    {
      CloseHandle(pi.hProcess);
      CloseHandle(pi.hThread);
    }
    else
    {
      API_LoadStringW(hLangLib, MSG_ERROR_RUN, wbuf, BUFFER_SIZE);
      MessageBoxW(hMainWnd, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONEXCLAMATION);
    }
    API_HeapFree(hHeap, 0, (LPVOID)wszResult);
  }
}

void DoSettingsSaveTime(BOOL bState)
{
  CheckMenuItem(hMainMenu, IDM_OPTIONS_SAVETIME, bState?MF_CHECKED:MF_UNCHECKED);
  bSaveTime=bState;
}

void DoSettingsKeepSpace(BOOL bState)
{
  CheckMenuItem(hMainMenu, IDM_OPTIONS_KEEPSPACE, bState?MF_CHECKED:MF_UNCHECKED);
  bKeepSpace=bState;
}

void DoSettingsWatchFileA(BOOL bState)
{
  CheckMenuItem(hMainMenu, IDM_OPTIONS_WATCHFILE, bState?MF_CHECKED:MF_UNCHECKED);
  bWatchFile=bState;
  if (bWatchFile) SetFocus(hMainWnd);
}

void DoSettingsWatchFileW(BOOL bState)
{
  CheckMenuItem(hMainMenu, IDM_OPTIONS_WATCHFILE, bState?MF_CHECKED:MF_UNCHECKED);
  bWatchFile=bState;
  if (bWatchFile) SetFocus(hMainWnd);
}

void DoSettingsSingleOpenFile(BOOL bState)
{
  CheckMenuItem(hMainMenu, IDM_OPTIONS_SINGLEOPEN_FILE, bState?MF_CHECKED:MF_UNCHECKED);
  bSingleOpenFile=bState;
}

void DoSettingsSingleOpenProgram(BOOL bState)
{
  CheckMenuItem(hMainMenu, IDM_OPTIONS_SINGLEOPEN_PROGRAM, bState?MF_CHECKED:MF_UNCHECKED);
  bSingleOpenProgram=bState;
}

void DoSettingsPluginsA(HWND hWnd)
{
  if (!hDlgModeless)
  {
    if (hDlgModeless=API_CreateDialogA(hLangLib, MAKEINTRESOURCE(IDD_PLUGINS), hMainWnd, (DLGPROC)PluginsDlgProcA))
    {
      ShowWindow(hDlgModeless, SW_SHOW);
    }
  }
}

void DoSettingsPluginsW(HWND hWnd)
{
  if (!hDlgModeless)
  {
    if (hDlgModeless=API_CreateDialogW(hLangLib, MAKEINTRESOURCEW(IDD_PLUGINS), hMainWnd, (DLGPROC)PluginsDlgProcW))
    {
      ShowWindow(hDlgModeless, SW_SHOW);
    }
  }
}

void DoSettingsOptionsA()
{
  API_LoadStringA(hLangLib, STR_OPTIONS, buf, BUFFER_SIZE);
  psh.pszCaption=buf;

  cbtHook=SetWindowsHookEx(WH_CBT, CBTProc, NULL, GetCurrentThreadId());

  PropertySheet(&psh);
}

void DoSettingsOptionsW()
{
  API_LoadStringW(hLangLib, STR_OPTIONS, wbuf, BUFFER_SIZE);
  pshW.pszCaption=wbuf;

  cbtHook=SetWindowsHookEx(WH_CBT, CBTProc, NULL, GetCurrentThreadId());

  PropertySheetW(&pshW);
}

void DoWindowTabView(int nView, BOOL bFirst)
{
  RECT rcRect;
  int i;

  CheckMenuItem(hMainMenu, IDM_WINDOW_TABVIEW_TOP, (nView == TAB_VIEW_TOP)?MF_CHECKED:MF_UNCHECKED);
  CheckMenuItem(hMainMenu, IDM_WINDOW_TABVIEW_BOTTOM, (nView == TAB_VIEW_BOTTOM)?MF_CHECKED:MF_UNCHECKED);
  CheckMenuItem(hMainMenu, IDM_WINDOW_TABVIEW_NONE, (nView == TAB_VIEW_NONE)?MF_CHECKED:MF_UNCHECKED);
  EnableMenuItem(hMainMenu, IDM_WINDOW_TABTYPE_STANDART, nView?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMainMenu, IDM_WINDOW_TABTYPE_BUTTONS, nView?MF_ENABLED:MF_GRAYED);
  if (!bOldComctl32) EnableMenuItem(hMainMenu, IDM_WINDOW_TABTYPE_FLATBUTTONS, nView?MF_ENABLED:MF_GRAYED);
  if (bFirst != TRUE && nView == nTabView) return;
  nTabView=nView;

  if (nTabView == TAB_VIEW_TOP)
  {
    i=GetWindowLong(hTab, GWL_STYLE) & ~TCS_BOTTOM;
    SetWindowLong(hTab, GWL_STYLE, i);
  }
  else if (nTabView == TAB_VIEW_BOTTOM)
  {
    i=GetWindowLong(hTab, GWL_STYLE);
    SetWindowLong(hTab, GWL_STYLE, i|TCS_BOTTOM);
  }
  ShowWindow(hTab, nTabView?SW_SHOW:SW_HIDE);
  GetClientRect(hMainWnd, &rcRect);
  UpdateSize(rcRect.right, rcRect.bottom);
}

void DoWindowTabType(int nType, BOOL bFirst)
{
  int i;

  CheckMenuItem(hMainMenu, IDM_WINDOW_TABTYPE_STANDART, (nType == TAB_TYPE_STANDART)?MF_CHECKED:MF_UNCHECKED);
  CheckMenuItem(hMainMenu, IDM_WINDOW_TABTYPE_BUTTONS, (nType == TAB_TYPE_BUTTONS)?MF_CHECKED:MF_UNCHECKED);
  CheckMenuItem(hMainMenu, IDM_WINDOW_TABTYPE_FLATBUTTONS, (nType == TAB_TYPE_FLATBUTTONS)?MF_CHECKED:MF_UNCHECKED);
  if (bFirst != TRUE && nType == nTabType) return;
  nTabType=nType;

  if (nTabType == TAB_TYPE_STANDART)
  {
    i=GetWindowLong(hTab, GWL_STYLE) & ~TCS_BUTTONS & ~TCS_FLATBUTTONS;
    SetWindowLong(hTab, GWL_STYLE, i);
    SendMessage(hTab, TCM_SETITEMSIZE, 0, (LPARAM)MAKELPARAM(TAB_WIDTH, TAB_HEIGHT - 4));
  }
  else if (nTabType == TAB_TYPE_BUTTONS)
  {
    i=GetWindowLong(hTab, GWL_STYLE) & ~TCS_FLATBUTTONS;
    SetWindowLong(hTab, GWL_STYLE, i|TCS_BUTTONS);
    SendMessage(hTab, TCM_SETITEMSIZE, 0, (LPARAM)MAKELPARAM(TAB_WIDTH, TAB_HEIGHT));
  }
  else if (nTabType == TAB_TYPE_FLATBUTTONS)
  {
    i=GetWindowLong(hTab, GWL_STYLE);
    SetWindowLong(hTab, GWL_STYLE, i|TCS_BUTTONS|TCS_FLATBUTTONS);
    SendMessage(hTab, TCM_SETITEMSIZE, 0, (LPARAM)MAKELPARAM(TAB_WIDTH, TAB_HEIGHT));
  }
}

void DoHelpAboutA()
{
  API_DialogBoxA(hLangLib, MAKEINTRESOURCE(IDD_ABOUT), hMainWnd, (DLGPROC)AboutDlgProcA);
}

void DoHelpAboutW()
{
  API_DialogBoxW(hLangLib, MAKEINTRESOURCEW(IDD_ABOUT), hMainWnd, (DLGPROC)AboutDlgProcW);
}

void DoNonMenuDelLine(HWND hWnd)
{
  int nLine;
  CHARRANGE selrng;

  nLine=SendMessage(hWnd, EM_LINEFROMCHAR, nPosition, 0);
  selrng.cpMin=SendMessage(hWnd, EM_LINEINDEX, nLine, 0);
  selrng.cpMax=selrng.cpMin + SendMessage(hWnd, EM_LINELENGTH, nPosition, 0) + 1;

  SendMessage(hWnd, EM_EXSETSEL, 0, (LPARAM)&selrng);
  SendMessage(hWnd, EM_REPLACESEL, TRUE, (LPARAM)"");
}


//// Read/Save options

BOOL RegReadOptionsA()
{
  HKEY hKey;
  DWORD dwType;
  DWORD dwSize;

  if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad\\Options", 0, KEY_READ, &hKey) != ERROR_SUCCESS)
    return FALSE;

  dwSize=MAX_PATH;
  RegQueryValueEx(hKey, "LanguageModule", NULL, &dwType, (LPBYTE)szLangModule, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "WordWrap", NULL, &dwType, (LPBYTE)&bWordWrap, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "OnTop", NULL, &dwType, (LPBYTE)&bOnTop, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "StatusBar", NULL, &dwType, (LPBYTE)&bStatusBar, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "SaveTime", NULL, &dwType, (LPBYTE)&bSaveTime, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "KeepSpace", NULL, &dwType, (LPBYTE)&bKeepSpace, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "WatchFile", NULL, &dwType, (LPBYTE)&bWatchFile, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "SingleOpenFile", NULL, &dwType, (LPBYTE)&bSingleOpenFile, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "SingleOpenProgram", NULL, &dwType, (LPBYTE)&bSingleOpenProgram, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "MDI", NULL, &dwType, (LPBYTE)&bRegMDI, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "DefaultCodepage", NULL, &dwType, (LPBYTE)&nDefaultCodePage, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "CodepageRecognition", NULL, &dwType, (LPBYTE)&wLangCodepageRecognition, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "RecentFiles", NULL, &dwType, (LPBYTE)&nRecentFiles, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "SearchStrings", NULL, &dwType, (LPBYTE)&nSearchStrings, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "SearchOptions", NULL, &dwType, (LPBYTE)&ftflags, &dwSize);

  dwSize=DELIMITERS_SIZE * sizeof(wchar_t);
  RegQueryValueEx(hKey, "WordDelimiters", NULL, &dwType, (LPBYTE)wszDelimiters, &dwSize);

  dwSize=BUFFER_SIZE;
  RegQueryValueEx(hKey, "ExecuteCommand", NULL, &dwType, (LPBYTE)szCommand, &dwSize);

  dwSize=MAX_PATH;
  RegQueryValueEx(hKey, "ExecuteDirectory", NULL, &dwType, (LPBYTE)szWorkDir, &dwSize);

  dwSize=MAX_PATH;
  RegQueryValueEx(hKey, "FileTypesOpen", NULL, &dwType, (LPBYTE)szFileTypesOpen, &dwSize);

  dwSize=MAX_PATH;
  RegQueryValueEx(hKey, "FileTypesEdit", NULL, &dwType, (LPBYTE)szFileTypesEdit, &dwSize);

  dwSize=MAX_PATH;
  RegQueryValueEx(hKey, "FileTypesPrint", NULL, &dwType, (LPBYTE)szFileTypesPrint, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "FileTypesAssociated", NULL, &dwType, (LPBYTE)&dwFileTypesAssociated, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "TabStopSize", NULL, &dwType, (LPBYTE)&nTabStopSize, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "TabStopAsSpaces", NULL, &dwType, (LPBYTE)&bTabStopAsSpaces, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "MarginsEdit", NULL, &dwType, (LPBYTE)&dwEditMargins, &dwSize);

  dwSize=sizeof(RECT);
  RegQueryValueEx(hKey, "MarginsPrint", NULL, &dwType, (LPBYTE)&psdPage.rtMargin, &dwSize);

  dwSize=sizeof(LOGFONT);
  RegQueryValueEx(hKey, "FontA", NULL, &dwType, (LPBYTE)&logfont, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "TextColor", NULL, &dwType, (LPBYTE)&crFont, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "BackgroundColor", NULL, &dwType, (LPBYTE)&crBackground, &dwSize);


  dwSize=sizeof(DWORD);
  RegQueryValueEx(hKey, "WindowStyle", NULL, &dwType, (LPBYTE)&nMainStyle, &dwSize);

  dwSize=sizeof(RECT);
  RegQueryValueEx(hKey, "WindowPosition", NULL, &dwType, (LPBYTE)&rcMainWindow, &dwSize);

  if (bRegMDI)
  {
    dwSize=sizeof(DWORD);
    RegQueryValueEx(hKey, "TabViewMDI", NULL, &dwType, (LPBYTE)&nTabView, &dwSize);

    dwSize=sizeof(DWORD);
    RegQueryValueEx(hKey, "TabTypeMDI", NULL, &dwType, (LPBYTE)&nTabType, &dwSize);

    dwSize=sizeof(DWORD);
    RegQueryValueEx(hKey, "WindowStyleMDI", NULL, &dwType, (LPBYTE)&nMdiStyle, &dwSize);
  }

  RegCloseKey(hKey);
  return TRUE;
}

BOOL RegReadOptionsW()
{
  HKEY hKey;
  DWORD dwType;
  DWORD dwSize;

  if (RegOpenKeyExW(HKEY_CURRENT_USER, L"Software\\Akelsoft\\AkelPad\\Options", 0, KEY_READ, &hKey) != ERROR_SUCCESS)
    return FALSE;

  dwSize=MAX_PATH * sizeof(wchar_t);
  RegQueryValueExW(hKey, L"LanguageModule", NULL, &dwType, (LPBYTE)wszLangModule, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"WordWrap", NULL, &dwType, (LPBYTE)&bWordWrap, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"OnTop", NULL, &dwType, (LPBYTE)&bOnTop, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"StatusBar", NULL, &dwType, (LPBYTE)&bStatusBar, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"SaveTime", NULL, &dwType, (LPBYTE)&bSaveTime, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"KeepSpace", NULL, &dwType, (LPBYTE)&bKeepSpace, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"WatchFile", NULL, &dwType, (LPBYTE)&bWatchFile, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"SingleOpenFile", NULL, &dwType, (LPBYTE)&bSingleOpenFile, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"SingleOpenProgram", NULL, &dwType, (LPBYTE)&bSingleOpenProgram, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"MDI", NULL, &dwType, (LPBYTE)&bRegMDI, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"DefaultCodepage", NULL, &dwType, (LPBYTE)&nDefaultCodePage, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"CodepageRecognition", NULL, &dwType, (LPBYTE)&wLangCodepageRecognition, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"RecentFiles", NULL, &dwType, (LPBYTE)&nRecentFiles, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"SearchStrings", NULL, &dwType, (LPBYTE)&nSearchStrings, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"SearchOptions", NULL, &dwType, (LPBYTE)&ftflags, &dwSize);

  dwSize=DELIMITERS_SIZE * sizeof(wchar_t);
  RegQueryValueExW(hKey, L"WordDelimiters", NULL, &dwType, (LPBYTE)wszDelimiters, &dwSize);

  dwSize=BUFFER_SIZE * sizeof(wchar_t);
  RegQueryValueExW(hKey, L"ExecuteCommand", NULL, &dwType, (LPBYTE)wszCommand, &dwSize);

  dwSize=MAX_PATH * sizeof(wchar_t);
  RegQueryValueExW(hKey, L"ExecuteDirectory", NULL, &dwType, (LPBYTE)wszWorkDir, &dwSize);

  dwSize=MAX_PATH * sizeof(wchar_t);
  RegQueryValueExW(hKey, L"FileTypesOpen", NULL, &dwType, (LPBYTE)wszFileTypesOpen, &dwSize);

  dwSize=MAX_PATH * sizeof(wchar_t);
  RegQueryValueExW(hKey, L"FileTypesEdit", NULL, &dwType, (LPBYTE)wszFileTypesEdit, &dwSize);

  dwSize=MAX_PATH * sizeof(wchar_t);
  RegQueryValueExW(hKey, L"FileTypesPrint", NULL, &dwType, (LPBYTE)wszFileTypesPrint, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"FileTypesAssociated", NULL, &dwType, (LPBYTE)&dwFileTypesAssociated, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"TabStopSize", NULL, &dwType, (LPBYTE)&nTabStopSize, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"TabStopAsSpaces", NULL, &dwType, (LPBYTE)&bTabStopAsSpaces, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"MarginsEdit", NULL, &dwType, (LPBYTE)&dwEditMargins, &dwSize);

  dwSize=sizeof(RECT);
  RegQueryValueExW(hKey, L"MarginsPrint", NULL, &dwType, (LPBYTE)&psdPageW.rtMargin, &dwSize);

  dwSize=sizeof(LOGFONTW);
  RegQueryValueExW(hKey, L"FontW", NULL, &dwType, (LPBYTE)&logfontW, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"TextColor", NULL, &dwType, (LPBYTE)&crFont, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"BackgroundColor", NULL, &dwType, (LPBYTE)&crBackground, &dwSize);

  dwSize=sizeof(DWORD);
  RegQueryValueExW(hKey, L"WindowStyle", NULL, &dwType, (LPBYTE)&nMainStyle, &dwSize);

  dwSize=sizeof(RECT);
  RegQueryValueExW(hKey, L"WindowPosition", NULL, &dwType, (LPBYTE)&rcMainWindow, &dwSize);

  if (bRegMDI)
  {
    dwSize=sizeof(DWORD);
    RegQueryValueExW(hKey, L"TabViewMDI", NULL, &dwType, (LPBYTE)&nTabView, &dwSize);

    dwSize=sizeof(DWORD);
    RegQueryValueExW(hKey, L"TabTypeMDI", NULL, &dwType, (LPBYTE)&nTabType, &dwSize);

    dwSize=sizeof(DWORD);
    RegQueryValueExW(hKey, L"WindowStyleMDI", NULL, &dwType, (LPBYTE)&nMdiStyle, &dwSize);
  }

  RegCloseKey(hKey);
  return TRUE;
}

BOOL IniReadOptionsA()
{
  int i;

  GetPrivateProfileString("Options", "LanguageModule", "", szLangModule, MAX_PATH, szIniFile);
  GetPrivateProfileDWORDA("Options", "WordWrap", (LPDWORD)&bWordWrap, szIniFile);
  GetPrivateProfileDWORDA("Options", "OnTop", (LPDWORD)&bOnTop, szIniFile);
  GetPrivateProfileDWORDA("Options", "StatusBar", (LPDWORD)&bStatusBar, szIniFile);
  GetPrivateProfileDWORDA("Options", "SaveTime", (LPDWORD)&bSaveTime, szIniFile);
  GetPrivateProfileDWORDA("Options", "KeepSpace", (LPDWORD)&bKeepSpace, szIniFile);
  GetPrivateProfileDWORDA("Options", "WatchFile", (LPDWORD)&bWatchFile, szIniFile);
  GetPrivateProfileDWORDA("Options", "SingleOpenFile", (LPDWORD)&bSingleOpenFile, szIniFile);
  GetPrivateProfileDWORDA("Options", "SingleOpenProgram", (LPDWORD)&bSingleOpenProgram, szIniFile);
  GetPrivateProfileDWORDA("Options", "MDI", (LPDWORD)&bRegMDI, szIniFile);
  GetPrivateProfileDWORDA("Options", "DefaultCodepage", (LPDWORD)&nDefaultCodePage, szIniFile);
  GetPrivateProfileDWORDA("Options", "CodepageRecognition", (LPDWORD)&wLangCodepageRecognition, szIniFile);
  GetPrivateProfileDWORDA("Options", "RecentFiles", (LPDWORD)&nRecentFiles, szIniFile);
  GetPrivateProfileDWORDA("Options", "SearchStrings", (LPDWORD)&nSearchStrings, szIniFile);
  GetPrivateProfileDWORDA("Options", "SearchOptions", (LPDWORD)&ftflags, szIniFile);
  GetPrivateProfileDWORDA("Options", "WordDelimitersSize", (LPDWORD)&i, szIniFile);
  GetPrivateProfileStruct("Options", "WordDelimiters", wszDelimiters, i, szIniFile);
  GetPrivateProfileString("Options", "ExecuteCommand", "", szCommand, BUFFER_SIZE, szIniFile);
  GetPrivateProfileString("Options", "ExecuteDirectory", "", szWorkDir, MAX_PATH, szIniFile);
  GetPrivateProfileString("Options", "FileTypesOpen", "", szFileTypesOpen, MAX_PATH, szIniFile);
  GetPrivateProfileString("Options", "FileTypesEdit", "", szFileTypesEdit, MAX_PATH, szIniFile);
  GetPrivateProfileString("Options", "FileTypesPrint", "", szFileTypesPrint, MAX_PATH, szIniFile);
  GetPrivateProfileDWORDA("Options", "FileTypesAssociated", (LPDWORD)&dwFileTypesAssociated, szIniFile);
  GetPrivateProfileDWORDA("Options", "TabStopSize", (LPDWORD)&nTabStopSize, szIniFile);
  GetPrivateProfileDWORDA("Options", "TabStopAsSpaces", (LPDWORD)&bTabStopAsSpaces, szIniFile);
  GetPrivateProfileDWORDA("Options", "MarginsEdit", (LPDWORD)&dwEditMargins, szIniFile);
  GetPrivateProfileStruct("Options", "MarginsPrint", &psdPage.rtMargin, sizeof(RECT), szIniFile);
  GetPrivateProfileStruct("Options", "FontA", &logfont, sizeof(LOGFONT), szIniFile);
  GetPrivateProfileDWORDA("Options", "TextColor", (LPDWORD)&crFont, szIniFile);
  GetPrivateProfileDWORDA("Options", "BackgroundColor", (LPDWORD)&crBackground, szIniFile);
  GetPrivateProfileDWORDA("Options", "WindowStyle", (LPDWORD)&nMainStyle, szIniFile);
  GetPrivateProfileStruct("Options", "WindowPosition", &rcMainWindow, sizeof(RECT), szIniFile);

  if (bRegMDI)
  {
    GetPrivateProfileDWORDA("Options", "TabViewMDI", (LPDWORD)&nTabView, szIniFile);
    GetPrivateProfileDWORDA("Options", "TabTypeMDI", (LPDWORD)&nTabType, szIniFile);
    GetPrivateProfileDWORDA("Options", "WindowStyleMDI", (LPDWORD)&nMdiStyle, szIniFile);
  }
  return TRUE;
}

BOOL IniReadOptionsW()
{
  int i;

  GetPrivateProfileStringW(L"Options", L"LanguageModule", L"", wszLangModule, MAX_PATH, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"WordWrap", (LPDWORD)&bWordWrap, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"OnTop", (LPDWORD)&bOnTop, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"StatusBar", (LPDWORD)&bStatusBar, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"SaveTime", (LPDWORD)&bSaveTime, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"KeepSpace", (LPDWORD)&bKeepSpace, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"WatchFile", (LPDWORD)&bWatchFile, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"SingleOpenFile", (LPDWORD)&bSingleOpenFile, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"SingleOpenProgram", (LPDWORD)&bSingleOpenProgram, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"MDI", (LPDWORD)&bRegMDI, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"DefaultCodepage", (LPDWORD)&nDefaultCodePage, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"CodepageRecognition", (LPDWORD)&wLangCodepageRecognition, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"RecentFiles", (LPDWORD)&nRecentFiles, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"SearchStrings", (LPDWORD)&nSearchStrings, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"SearchOptions", (LPDWORD)&ftflags, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"WordDelimitersSize", (LPDWORD)&i, wszIniFile);
  GetPrivateProfileStructW(L"Options", L"WordDelimiters", wszDelimiters, i, wszIniFile);
  GetPrivateProfileStringW(L"Options", L"ExecuteCommand", L"", wszCommand, BUFFER_SIZE, wszIniFile);
  GetPrivateProfileStringW(L"Options", L"ExecuteDirectory", L"", wszWorkDir, MAX_PATH, wszIniFile);
  GetPrivateProfileStringW(L"Options", L"FileTypesOpen", L"", wszFileTypesOpen, MAX_PATH, wszIniFile);
  GetPrivateProfileStringW(L"Options", L"FileTypesEdit", L"", wszFileTypesEdit, MAX_PATH, wszIniFile);
  GetPrivateProfileStringW(L"Options", L"FileTypesPrint", L"", wszFileTypesPrint, MAX_PATH, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"FileTypesAssociated", (LPDWORD)&dwFileTypesAssociated, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"TabStopSize", (LPDWORD)&nTabStopSize, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"TabStopAsSpaces", (LPDWORD)&bTabStopAsSpaces, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"MarginsEdit", (LPDWORD)&dwEditMargins, wszIniFile);
  GetPrivateProfileStructW(L"Options", L"MarginsPrint", &psdPage.rtMargin, sizeof(RECT), wszIniFile);
  GetPrivateProfileStructW(L"Options", L"FontW", &logfontW, sizeof(LOGFONTW), wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"TextColor", (LPDWORD)&crFont, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"BackgroundColor", (LPDWORD)&crBackground, wszIniFile);
  GetPrivateProfileDWORDW(L"Options", L"WindowStyle", (LPDWORD)&nMainStyle, wszIniFile);
  GetPrivateProfileStructW(L"Options", L"WindowPosition", &rcMainWindow, sizeof(RECT), wszIniFile);

  if (bRegMDI)
  {
    GetPrivateProfileDWORDW(L"Options", L"TabViewMDI", (LPDWORD)&nTabView, wszIniFile);
    GetPrivateProfileDWORDW(L"Options", L"TabTypeMDI", (LPDWORD)&nTabType, wszIniFile);
    GetPrivateProfileDWORDW(L"Options", L"WindowStyleMDI", (LPDWORD)&nMdiStyle, wszIniFile);
  }
  return TRUE;
}

void RegReadSearchA()
{
  HKEY hKey;
  DWORD dwType;
  DWORD dwSize;

  if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad\\Search", 0, KEY_READ, &hKey) != ERROR_SUCCESS)
    return;

  if (RegQueryValueEx(hKey, "find0", NULL, &dwType, NULL, &dwSize) == ERROR_SUCCESS && dwSize > 0)
  {
    if (szFind_orig=szFind=(char *)API_HeapAlloc(hHeap, 0, dwSize + 1))
    {
      if (RegQueryValueEx(hKey, "find0", NULL, &dwType, (LPBYTE)szFind_orig, &dwSize) == ERROR_SUCCESS)
      {
        if (ftflags & FR_ESCAPESEQ)
        {
          if (szFind=(char *)API_HeapAlloc(hHeap, 0, dwSize + 1))
          {
            EscapeStringToEscapeDataA(szFind_orig, szFind);
          }
        }
      }
    }
  }
  RegCloseKey(hKey);
}

void RegReadSearchW()
{
  HKEY hKey;
  DWORD dwType;
  DWORD dwSize;

  if (RegOpenKeyExW(HKEY_CURRENT_USER, L"Software\\Akelsoft\\AkelPad\\Search", 0, KEY_READ, &hKey) != ERROR_SUCCESS)
    return;

  if (RegQueryValueExW(hKey, L"find0", NULL, &dwType, NULL, &dwSize) == ERROR_SUCCESS && dwSize > 0)
  {
    if (wszFind_orig=wszFind=(wchar_t *)API_HeapAlloc(hHeap, 0, dwSize + 2))
    {
      if (RegQueryValueExW(hKey, L"find0", NULL, &dwType, (LPBYTE)wszFind_orig, &dwSize) == ERROR_SUCCESS)
      {
        if (ftflags & FR_ESCAPESEQ)
        {
          if (wszFind=(wchar_t *)API_HeapAlloc(hHeap, 0, dwSize + 2))
          {
            EscapeStringToEscapeDataW(wszFind_orig, wszFind);
          }
        }
      }
    }
  }
  RegCloseKey(hKey);
}

BOOL RegSaveOptionsA()
{
  HKEY hKey;

  nMainStyle=GetWindowLong(hMainWnd, GWL_STYLE);
  nMainStyle=((nMainStyle & WS_MAXIMIZE) || ((nMainStyle & WS_MINIMIZE) && nLastMainSize == SIZE_MAXIMIZED))?WS_MAXIMIZE:0;
  if (hWndMdiActive) SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
  nMdiStyle=(bMdiMaximize == TRUE)?WS_MAXIMIZE:0;

  if (RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad\\Options", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) != ERROR_SUCCESS)
    return FALSE;

  if (RegSetValueEx(hKey, "LanguageModule", 0, REG_SZ, (LPBYTE)szLangModule, lstrlen(szLangModule) + 1) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "WordWrap", 0, REG_DWORD, (LPBYTE)&bWordWrap, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "OnTop", 0, REG_DWORD, (LPBYTE)&bOnTop, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "StatusBar", 0, REG_DWORD, (LPBYTE)&bStatusBar, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "SaveTime", 0, REG_DWORD, (LPBYTE)&bSaveTime, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "KeepSpace", 0, REG_DWORD, (LPBYTE)&bKeepSpace, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "WatchFile", 0, REG_DWORD, (LPBYTE)&bWatchFile, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "SingleOpenFile", 0, REG_DWORD, (LPBYTE)&bSingleOpenFile, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "SingleOpenProgram", 0, REG_DWORD, (LPBYTE)&bSingleOpenProgram, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "MDI", 0, REG_DWORD, (LPBYTE)&bRegMDI, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "DefaultCodepage", 0, REG_DWORD, (LPBYTE)&nDefaultCodePage, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "CodepageRecognition", 0, REG_DWORD, (LPBYTE)&wLangCodepageRecognition, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "RecentFiles", 0, REG_DWORD, (LPBYTE)&nRecentFiles, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "SearchStrings", 0, REG_DWORD, (LPBYTE)&nSearchStrings, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "SearchOptions", 0, REG_DWORD, (LPBYTE)&ftflags, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "WordDelimiters", 0, REG_BINARY, (LPBYTE)wszDelimiters, wcslen(wszDelimiters) * sizeof(wchar_t) + 2) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "ExecuteCommand", 0, REG_SZ, (LPBYTE)szCommand, lstrlen(szCommand) + 1) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "ExecuteDirectory", 0, REG_SZ, (LPBYTE)szWorkDir, lstrlen(szCommand) + 1) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "FileTypesOpen", 0, REG_SZ, (LPBYTE)szFileTypesOpen, lstrlen(szFileTypesOpen) + 1) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "FileTypesEdit", 0, REG_SZ, (LPBYTE)szFileTypesEdit, lstrlen(szFileTypesEdit) + 1) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "FileTypesPrint", 0, REG_SZ, (LPBYTE)szFileTypesPrint, lstrlen(szFileTypesPrint) + 1) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "FileTypesAssociated", 0, REG_DWORD, (LPBYTE)&dwFileTypesAssociated, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "TabStopSize", 0, REG_DWORD, (LPBYTE)&nTabStopSize, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "TabStopAsSpaces", 0, REG_DWORD, (LPBYTE)&bTabStopAsSpaces, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "MarginsEdit", 0, REG_DWORD, (LPBYTE)&dwEditMargins, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "MarginsPrint", 0, REG_BINARY, (LPBYTE)&psdPage.rtMargin, sizeof(RECT)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "FontA", 0, REG_BINARY, (LPBYTE)&logfont, sizeof(LOGFONT)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "TextColor", 0, REG_DWORD, (LPBYTE)&crFont, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "BackgroundColor", 0, REG_DWORD, (LPBYTE)&crBackground, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "WindowStyle", 0, REG_DWORD, (LPBYTE)&nMainStyle, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueEx(hKey, "WindowPosition", 0, REG_BINARY, (LPBYTE)&rcMainWindow, sizeof(RECT)) != ERROR_SUCCESS)
    goto Error;

  if (bMDI)
  {
    if (RegSetValueEx(hKey, "TabViewMDI", 0, REG_DWORD, (LPBYTE)&nTabView, sizeof(DWORD)) != ERROR_SUCCESS)
      goto Error;

    if (RegSetValueEx(hKey, "TabTypeMDI", 0, REG_DWORD, (LPBYTE)&nTabType, sizeof(DWORD)) != ERROR_SUCCESS)
      goto Error;

    if (RegSetValueEx(hKey, "WindowStyleMDI", 0, REG_DWORD, (LPBYTE)&nMdiStyle, sizeof(DWORD)) != ERROR_SUCCESS)
      goto Error;
  }

  RegCloseKey(hKey);
  return TRUE;

  Error:
  RegCloseKey(hKey);
  return FALSE;
}

BOOL RegSaveOptionsW()
{
  HKEY hKey;

  nMainStyle=GetWindowLong(hMainWnd, GWL_STYLE);
  nMainStyle=((nMainStyle & WS_MAXIMIZE) || ((nMainStyle & WS_MINIMIZE) && nLastMainSize == SIZE_MAXIMIZED))?WS_MAXIMIZE:0;
  if (hWndMdiActive) SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
  nMdiStyle=(bMdiMaximize == TRUE)?WS_MAXIMIZE:0;

  if (RegCreateKeyExW(HKEY_CURRENT_USER, L"Software\\Akelsoft\\AkelPad\\Options", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) != ERROR_SUCCESS)
    return FALSE;

  if (RegSetValueExW(hKey, L"LanguageModule", 0, REG_SZ, (LPBYTE)wszLangModule, lstrlenW(wszLangModule) * sizeof(wchar_t) + 2) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"WordWrap", 0, REG_DWORD, (LPBYTE)&bWordWrap, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"OnTop", 0, REG_DWORD, (LPBYTE)&bOnTop, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"StatusBar", 0, REG_DWORD, (LPBYTE)&bStatusBar, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"SaveTime", 0, REG_DWORD, (LPBYTE)&bSaveTime, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"KeepSpace", 0, REG_DWORD, (LPBYTE)&bKeepSpace, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"WatchFile", 0, REG_DWORD, (LPBYTE)&bWatchFile, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"SingleOpenFile", 0, REG_DWORD, (LPBYTE)&bSingleOpenFile, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"SingleOpenProgram", 0, REG_DWORD, (LPBYTE)&bSingleOpenProgram, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"MDI", 0, REG_DWORD, (LPBYTE)&bRegMDI, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"DefaultCodepage", 0, REG_DWORD, (LPBYTE)&nDefaultCodePage, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"CodepageRecognition", 0, REG_DWORD, (LPBYTE)&wLangCodepageRecognition, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"RecentFiles", 0, REG_DWORD, (LPBYTE)&nRecentFiles, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"SearchStrings", 0, REG_DWORD, (LPBYTE)&nSearchStrings, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"SearchOptions", 0, REG_DWORD, (LPBYTE)&ftflags, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"WordDelimiters", 0, REG_BINARY, (LPBYTE)wszDelimiters, lstrlenW(wszDelimiters) * sizeof(wchar_t) + 2) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"ExecuteCommand", 0, REG_SZ, (LPBYTE)wszCommand, lstrlenW(wszCommand) * sizeof(wchar_t) + 2) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"ExecuteDirectory", 0, REG_SZ, (LPBYTE)wszWorkDir, lstrlenW(wszWorkDir) * sizeof(wchar_t) + 2) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"FileTypesOpen", 0, REG_SZ, (LPBYTE)wszFileTypesOpen, lstrlenW(wszFileTypesOpen) * sizeof(wchar_t) + 2) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"FileTypesEdit", 0, REG_SZ, (LPBYTE)wszFileTypesEdit, lstrlenW(wszFileTypesEdit) * sizeof(wchar_t) + 2) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"FileTypesPrint", 0, REG_SZ, (LPBYTE)wszFileTypesPrint, lstrlenW(wszFileTypesPrint) * sizeof(wchar_t) + 2) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"FileTypesAssociated", 0, REG_DWORD, (LPBYTE)&dwFileTypesAssociated, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"TabStopSize", 0, REG_DWORD, (LPBYTE)&nTabStopSize, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"TabStopAsSpaces", 0, REG_DWORD, (LPBYTE)&bTabStopAsSpaces, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"MarginsEdit", 0, REG_DWORD, (LPBYTE)&dwEditMargins, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"MarginsPrint", 0, REG_BINARY, (LPBYTE)&psdPageW.rtMargin, sizeof(RECT)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"FontW", 0, REG_BINARY, (LPBYTE)&logfontW, sizeof(LOGFONTW)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"TextColor", 0, REG_DWORD, (LPBYTE)&crFont, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"BackgroundColor", 0, REG_DWORD, (LPBYTE)&crBackground, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"WindowStyle", 0, REG_DWORD, (LPBYTE)&nMainStyle, sizeof(DWORD)) != ERROR_SUCCESS)
    goto Error;

  if (RegSetValueExW(hKey, L"WindowPosition", 0, REG_BINARY, (LPBYTE)&rcMainWindow, sizeof(RECT)) != ERROR_SUCCESS)
    goto Error;

  if (bMDI)
  {
    if (RegSetValueExW(hKey, L"TabViewMDI", 0, REG_DWORD, (LPBYTE)&nTabView, sizeof(DWORD)) != ERROR_SUCCESS)
      goto Error;

    if (RegSetValueExW(hKey, L"TabTypeMDI", 0, REG_DWORD, (LPBYTE)&nTabType, sizeof(DWORD)) != ERROR_SUCCESS)
      goto Error;

    if (RegSetValueExW(hKey, L"WindowStyleMDI", 0, REG_DWORD, (LPBYTE)&nMdiStyle, sizeof(DWORD)) != ERROR_SUCCESS)
      goto Error;
  }

  RegCloseKey(hKey);
  return TRUE;

  Error:
  RegCloseKey(hKey);
  return FALSE;
}

BOOL IniSaveOptionsA()
{
  int i;

  nMainStyle=GetWindowLong(hMainWnd, GWL_STYLE);
  nMainStyle=((nMainStyle & WS_MAXIMIZE) || ((nMainStyle & WS_MINIMIZE) && nLastMainSize == SIZE_MAXIMIZED))?WS_MAXIMIZE:0;
  if (hWndMdiActive) SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
  nMdiStyle=(bMdiMaximize == TRUE)?WS_MAXIMIZE:0;

  if (!WritePrivateProfileString("Options", "LanguageModule", szLangModule, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "WordWrap", bWordWrap, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "OnTop", bOnTop, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "StatusBar", bStatusBar, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "SaveTime", bSaveTime, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "KeepSpace", bKeepSpace, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "WatchFile", bWatchFile, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "SingleOpenFile", bSingleOpenFile, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "SingleOpenProgram", bSingleOpenProgram, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "MDI", bRegMDI, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "DefaultCodepage", nDefaultCodePage, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "CodepageRecognition", wLangCodepageRecognition, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "RecentFiles", nRecentFiles, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "SearchStrings", nSearchStrings, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "SearchOptions", ftflags, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "WordDelimitersSize", (i=wcslen(wszDelimiters) * sizeof(wchar_t) + 2), szIniFile))
    return FALSE;

  if (!WritePrivateProfileStruct("Options", "WordDelimiters", wszDelimiters, i, szIniFile))
    return FALSE;

  if (!WritePrivateProfileString("Options", "ExecuteCommand", szCommand, szIniFile))
    return FALSE;

  if (!WritePrivateProfileString("Options", "ExecuteDirectory", szWorkDir, szIniFile))
    return FALSE;

  if (!WritePrivateProfileString("Options", "FileTypesOpen", szFileTypesOpen, szIniFile))
    return FALSE;

  if (!WritePrivateProfileString("Options", "FileTypesEdit", szFileTypesEdit, szIniFile))
    return FALSE;

  if (!WritePrivateProfileString("Options", "FileTypesPrint", szFileTypesPrint, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "FileTypesAssociated", dwFileTypesAssociated, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "TabStopSize", nTabStopSize, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "TabStopAsSpaces", bTabStopAsSpaces, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "MarginsEdit", dwEditMargins, szIniFile))
    return FALSE;

  if (!WritePrivateProfileStruct("Options", "MarginsPrint", &psdPage.rtMargin, sizeof(RECT), szIniFile))
    return FALSE;

  if (!WritePrivateProfileStruct("Options", "FontA", &logfont, sizeof(LOGFONT), szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "TextColor", crFont, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "BackgroundColor", crBackground, szIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDA("Options", "WindowStyle", nMainStyle, szIniFile))
    return FALSE;

  if (!WritePrivateProfileStruct("Options", "WindowPosition", &rcMainWindow, sizeof(RECT), szIniFile))
    return FALSE;

  if (bMDI)
  {
    if (!WritePrivateProfileDWORDA("Options", "TabViewMDI", nTabView, szIniFile))
      return FALSE;

    if (!WritePrivateProfileDWORDA("Options", "TabTypeMDI", nTabType, szIniFile))
      return FALSE;

    if (!WritePrivateProfileDWORDA("Options", "WindowStyleMDI", nMdiStyle, szIniFile))
      return FALSE;
  }
  return TRUE;
}

BOOL IniSaveOptionsW()
{
  int i;

  nMainStyle=GetWindowLong(hMainWnd, GWL_STYLE);
  nMainStyle=((nMainStyle & WS_MAXIMIZE) || ((nMainStyle & WS_MINIMIZE) && nLastMainSize == SIZE_MAXIMIZED))?WS_MAXIMIZE:0;
  if (hWndMdiActive) SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
  nMdiStyle=(bMdiMaximize == TRUE)?WS_MAXIMIZE:0;

  if (!WritePrivateProfileStringW(L"Options", L"LanguageModule", wszLangModule, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"WordWrap", bWordWrap, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"OnTop", bOnTop, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"StatusBar", bStatusBar, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"SaveTime", bSaveTime, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"KeepSpace", bKeepSpace, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"WatchFile", bWatchFile, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"SingleOpenFile", bSingleOpenFile, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"SingleOpenProgram", bSingleOpenProgram, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"MDI", bRegMDI, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"DefaultCodepage", nDefaultCodePage, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"CodepageRecognition", wLangCodepageRecognition, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"RecentFiles", nRecentFiles, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"SearchStrings", nSearchStrings, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"SearchOptions", ftflags, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"WordDelimitersSize", (i=lstrlenW(wszDelimiters) * sizeof(wchar_t) + 2), wszIniFile))
    return FALSE;

  if (!WritePrivateProfileStructW(L"Options", L"WordDelimiters", wszDelimiters, i, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileStringW(L"Options", L"ExecuteCommand", wszCommand, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileStringW(L"Options", L"ExecuteDirectory", wszWorkDir, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileStringW(L"Options", L"FileTypesOpen", wszFileTypesOpen, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileStringW(L"Options", L"FileTypesEdit", wszFileTypesEdit, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileStringW(L"Options", L"FileTypesPrint", wszFileTypesPrint, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"FileTypesAssociated", dwFileTypesAssociated, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"TabStopSize", nTabStopSize, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"TabStopAsSpaces", bTabStopAsSpaces, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"MarginsEdit", dwEditMargins, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileStructW(L"Options", L"MarginsPrint", &psdPage.rtMargin, sizeof(RECT), wszIniFile))
    return FALSE;

  if (!WritePrivateProfileStructW(L"Options", L"FontW", &logfontW, sizeof(LOGFONTW), wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"TextColor", crFont, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"BackgroundColor", crBackground, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileDWORDW(L"Options", L"WindowStyle", nMainStyle, wszIniFile))
    return FALSE;

  if (!WritePrivateProfileStructW(L"Options", L"WindowPosition", &rcMainWindow, sizeof(RECT), wszIniFile))
    return FALSE;

  if (bMDI)
  {
    if (!WritePrivateProfileDWORDW(L"Options", L"TabViewMDI", nTabView, wszIniFile))
      return FALSE;

    if (!WritePrivateProfileDWORDW(L"Options", L"TabTypeMDI", nTabType, wszIniFile))
      return FALSE;

    if (!WritePrivateProfileDWORDW(L"Options", L"WindowStyleMDI", nMdiStyle, wszIniFile))
      return FALSE;
  }
  return TRUE;
}


//// Open/Save document

int OpenDocumentA(char *szFile, DWORD Flags, int nCodePage, BOOL bBOM)
{
  HANDLE hFile;
  STREAMDATA sd;
  EDITSTREAM es;
  HWND hWndFriend;
  char *pFileName;
  BOOL bNewFile=FALSE;
  int i;

  //Check that file exists
  if (!FileExistsA(szFile))
  {
    if (nMsgCreate == AUTOANSWER_ASK)
    {
      API_LoadStringA(hLangLib, MSG_FILE_DOES_NOT_EXIST, buf, BUFFER_SIZE);
      wsprintf(buf2, buf, szFile);
      if (MessageBox(hMainWnd, buf2, APP_MAIN_TITLE, MB_OKCANCEL|MB_ICONEXCLAMATION) == IDCANCEL)
        return EDT_CANCEL;
    }
    else if (nMsgCreate == AUTOANSWER_NO)
        return EDT_CANCEL;
    bNewFile=TRUE;
  }

  //Get full path
  GetFullPathName(szFile, BUFFER_SIZE, buf, &pFileName);
  if (GetLongPathNameAPtr) (*GetLongPathNameAPtr)(buf, szFile, MAX_PATH);
  else lstrcpy(szFile, buf);

  if (bNewFile)
  {
    nCodePage=nDefaultCodePage;
    bBOM=bDefaultBOM;
  }
  else
  {
    if (bMDI && !bMdiReopen && bSingleOpenFile)
    {
      if (hWndFriend=FindWindowEx(hMdiClient, NULL, APP_MDI_CLASS, szFile))
      {
        SetFocus(hWndFriend);
        return 0;
      }
    }

    //Autodetect code page
    if ((i=AutodetectCodePageA(szFile, DETECT_CODEPAGE_SIZE, Flags, &nCodePage, &bBOM)) < 0)
    {
      if (i == EDT_BINARY)
      {
        if (nMsgBinary == AUTOANSWER_ASK)
        {
          API_LoadStringA(hLangLib, MSG_ERROR_BINARY, buf, BUFFER_SIZE);
          wsprintf(buf2, buf, szFile);
          if (MessageBox(hMainWnd, buf2, APP_MAIN_TITLE, MB_OKCANCEL|MB_ICONEXCLAMATION|MB_DEFBUTTON2) == IDCANCEL)
            return EDT_CANCEL;
        }
        else if (nMsgBinary == AUTOANSWER_NO)
            return EDT_CANCEL;
      }
      else return i;
    }
  }

  //Open file
  if ((hFile=API_CreateFileA(szFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL)) == INVALID_HANDLE_VALUE)
    return EDT_OPEN;

  //Save position of the previous file before load new document
  if (nRecentFiles && *szCurrentFile)
  {
    RecentFilesZeroA();
    RecentFilesReadA();
    RecentFilesUpdateA(szCurrentFile, nPosition, MAKELONG(nCurrentCodePage, bCurrentBOM));
    RecentFilesSaveA();
  }

  if (bBOM)
  {
    if (nCodePage == CP_UNICODE_UCS2_LE)
      SetFilePointer(hFile, 2, NULL, FILE_BEGIN);
    else if (nCodePage == CP_UNICODE_UCS2_BE)
      SetFilePointer(hFile, 2, NULL, FILE_BEGIN);
    else if (nCodePage == CP_UNICODE_UTF8)
      SetFilePointer(hFile, 3, NULL, FILE_BEGIN);
  }

  if (bMDI && !bMdiReopen && (!hWndMdiActive || bModified || *szCurrentFile))
  {
    if (hWndMdiActive) SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
    hWndMdiActive=CreateMDIWindow(APP_MDI_CLASS, "", (bMdiMaximize == TRUE)?WS_MAXIMIZE:0, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hMdiClient, hInstance, 0);
  }

  //Get file write time
  GetFileTime(hFile, NULL, NULL, &ft);

  SetNewLineA(NEWLINE_WIN, FALSE);
  bNewLineDetected=FALSE;
  HideCaret(NULL);

  //Load text
  sd.hFile=hFile;
  sd.nCodePage=nCodePage;
  sd.nBytes=-1;
  sd.nBytesRead=0;
  es.dwCookie=(DWORD)&sd;
  es.pfnCallback=InputStreamCallbackA;
  SendMessage(hWndEdit, EM_STREAMIN, SF_TEXT|SF_UNICODE, (LPARAM)&es);

  ShowCaret(NULL);
  SetModifyA(FALSE, FALSE);
  CloseHandle(hFile);

  //Update titles and icons
  if (szCurrentFile != szFile)
    UpdateTitleA(szFile);

  //Read position of the new document
  if (szCurrentFile != szFile || nCurrentCodePage != nCodePage)
  {
    if (nRecentFiles)
    {
      RecentFilesZeroA();
      RecentFilesReadA();
      RecentFilesUpdateA(szFile, -1, MAKELONG(nCodePage, bBOM));
      RecentFilesSaveA();
    }
    if (szCurrentFile != szFile)
    {
      if (nRecentFiles)
        RecentFilesMenuA();
      lstrcpy(szCurrentFile, szFile);
    }
  }
  if (nRecentFiles)
    SendMessage(hWndEdit, EM_SETSEL, szRecentPositions[0], szRecentPositions[0]);

  //Update edit window
  InvalidateRect(hWndEdit, NULL, FALSE);

  //Update codepage
  SetCodePageA(MAKELONG(nCodePage, bBOM), FALSE);

  //Print if "/p" option used in command line
  if (bGlobalPrint)
  {
    DoFilePrintA();
    bGlobalPrint=FALSE;

    if (!bMDI)
    {
      SendMessage(hMainWnd, WM_CLOSE, 0, 0);
    }
    else
    {
      SendMessage(hMdiClient, WM_MDIDESTROY, (WPARAM)hWndMdiActive, 0);
      if (!bSingleOpenProgram && !hWndMdiActive) SendMessage(hMainWnd, WM_CLOSE, 0, 0);
    }
  }
  return 0;
}

int OpenDocumentW(wchar_t *wszFile, DWORD Flags, int nCodePage, BOOL bBOM)
{
  HANDLE hFile;
  STREAMDATA sd;
  EDITSTREAM es;
  HWND hWndFriend;
  wchar_t *wpFileName;
  BOOL bNewFile=FALSE;
  int i;

  //Check that file exists
  if (!FileExistsW(wszFile))
  {
    if (nMsgCreate == AUTOANSWER_ASK)
    {
      API_LoadStringW(hLangLib, MSG_FILE_DOES_NOT_EXIST, wbuf, BUFFER_SIZE);
      wsprintfW(wbuf2, wbuf, wszFile);
      if (MessageBoxW(hMainWnd, wbuf2, APP_MAIN_TITLEW, MB_OKCANCEL|MB_ICONEXCLAMATION) == IDCANCEL)
        return EDT_CANCEL;
    }
    else if (nMsgCreate == AUTOANSWER_NO)
        return EDT_CANCEL;
    bNewFile=TRUE;
  }

  //Get full path
  GetFullPathNameW(wszFile, BUFFER_SIZE, wbuf, &wpFileName);
  if (GetLongPathNameWPtr) (*GetLongPathNameWPtr)(wbuf, wszFile, MAX_PATH);
  else lstrcpyW(wszFile, wbuf);

  if (bNewFile)
  {
    nCodePage=nDefaultCodePage;
    bBOM=bDefaultBOM;
  }
  else
  {
    if (bMDI && !bMdiReopen && bSingleOpenFile)
    {
      if (hWndFriend=FindWindowExW(hMdiClient, NULL, APP_MDI_CLASSW, wszFile))
      {
        SetFocus(hWndFriend);
        return 0;
      }
    }

    //Autodetect code page
    if ((i=AutodetectCodePageW(wszFile, DETECT_CODEPAGE_SIZE, Flags, &nCodePage, &bBOM)) < 0)
    {
      if (i == EDT_BINARY)
      {
        if (nMsgBinary == AUTOANSWER_ASK)
        {
          API_LoadStringW(hLangLib, MSG_ERROR_BINARY, wbuf, BUFFER_SIZE);
          wsprintfW(wbuf2, wbuf, wszFile);
          if (MessageBoxW(hMainWnd, wbuf2, APP_MAIN_TITLEW, MB_OKCANCEL|MB_ICONEXCLAMATION|MB_DEFBUTTON2) == IDCANCEL)
            return EDT_CANCEL;
        }
        else if (nMsgBinary == AUTOANSWER_NO)
            return EDT_CANCEL;
      }
      else return i;
    }
  }

  //Open file
  if ((hFile=API_CreateFileW(wszFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL)) == INVALID_HANDLE_VALUE)
    return EDT_OPEN;

  //Save position of the previous file before load new document
  if (nRecentFiles && *wszCurrentFile)
  {
    RecentFilesZeroW();
    RecentFilesReadW();
    RecentFilesUpdateW(wszCurrentFile, nPosition, MAKELONG(nCurrentCodePage, bCurrentBOM));
    RecentFilesSaveW();
  }

  if (bBOM)
  {
    if (nCodePage == CP_UNICODE_UCS2_LE)
      SetFilePointer(hFile, 2, NULL, FILE_BEGIN);
    else if (nCodePage == CP_UNICODE_UCS2_BE)
      SetFilePointer(hFile, 2, NULL, FILE_BEGIN);
    else if (nCodePage == CP_UNICODE_UTF8)
      SetFilePointer(hFile, 3, NULL, FILE_BEGIN);
  }

  if (bMDI && !bMdiReopen && (!hWndMdiActive || bModified || *wszCurrentFile))
  {
    if (hWndMdiActive) SendMessage(hMdiClient, WM_MDIGETACTIVE, 0, (LPARAM)&bMdiMaximize);
    hWndMdiActive=CreateMDIWindowW(APP_MDI_CLASSW, L"", (bMdiMaximize == TRUE)?WS_MAXIMIZE:0, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hMdiClient, hInstance, 0);
  }

  //Get file write time
  GetFileTime(hFile, NULL, NULL, &ft);

  SetNewLineW(NEWLINE_WIN, FALSE);
  bNewLineDetected=FALSE;
  HideCaret(NULL);

  //Load text
  sd.hFile=hFile;
  sd.nCodePage=nCodePage;
  sd.nBytes=-1;
  sd.nBytesRead=0;
  es.dwCookie=(DWORD)&sd;
  es.pfnCallback=InputStreamCallbackW;
  SendMessage(hWndEdit, EM_STREAMIN, SF_TEXT|SF_UNICODE, (LPARAM)&es);

  ShowCaret(NULL);
  SetModifyW(FALSE, FALSE);
  CloseHandle(hFile);

  //Update titles and icons
  if (wszCurrentFile != wszFile)
    UpdateTitleW(wszFile);

  //Read position of the new document
  if (wszCurrentFile != wszFile || nCurrentCodePage != nCodePage)
  {
    if (nRecentFiles)
    {
      RecentFilesZeroW();
      RecentFilesReadW();
      RecentFilesUpdateW(wszFile, -1, MAKELONG(nCodePage, bBOM));
      RecentFilesSaveW();
    }
    if (wszCurrentFile != wszFile)
    {
      if (nRecentFiles)
        RecentFilesMenuW();
      lstrcpyW(wszCurrentFile, wszFile);
    }
  }
  if (nRecentFiles)
    SendMessage(hWndEdit, EM_SETSEL, szRecentPositions[0], szRecentPositions[0]);

  //Update edit window
  InvalidateRect(hWndEdit, NULL, FALSE);

  //Update codepage
  SetCodePageW(MAKELONG(nCodePage, bBOM), FALSE);

  //Print if "/p" option used in command line
  if (bGlobalPrint)
  {
    DoFilePrintW();
    bGlobalPrint=FALSE;

    if (!bMDI)
    {
      SendMessage(hMainWnd, WM_CLOSE, 0, 0);
    }
    else
    {
      SendMessage(hMdiClient, WM_MDIDESTROY, (WPARAM)hWndMdiActive, 0);
      if (!bSingleOpenProgram && !hWndMdiActive) SendMessage(hMainWnd, WM_CLOSE, 0, 0);
    }
  }
  return 0;
}

DWORD CALLBACK InputStreamCallbackA(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
  static int nBytesConverted;
  STREAMDATA *lpData=(STREAMDATA *)dwCookie;

  if (nBytesConverted == 0)
  {
    if (lpData->nBytes != -1 && (lpData->nBytesRead+=cb) > lpData->nBytes)
      return 0xFFFFFFFF;

    if (!API_ReadFileA(lpData->hFile, pbBuff, (DWORD)cb, (DWORD *)pcb, NULL))
      return 0xFFFFFFFF;

    if (*pcb == 0)
      return 0xFFFFFFFF;
  }

  if (lpData->nCodePage == CP_UNICODE_UCS2_LE)
  {
  }
  else if (lpData->nCodePage == CP_UNICODE_UCS2_BE)
  {
    ChangeByteOrder(pbBuff, *pcb);
  }
  else
  {
    if (nBytesConverted == 0)
    {
      int nBytesRead=*pcb;

      if (lpData->nCodePage == CP_UNICODE_UTF8)
        nBytesConverted=UTF8toUTF16((char *)pbBuff, (unsigned int *)&nBytesRead, (wchar_t *)pcTranslateBuffer, TRANSLATE_BUFFER_SIZE / sizeof(wchar_t)) * sizeof(wchar_t);
      else
        nBytesConverted=MultiByteToWideChar(lpData->nCodePage, 0, (char *)pbBuff, *pcb, (wchar_t *)pcTranslateBuffer, TRANSLATE_BUFFER_SIZE / sizeof(wchar_t)) * sizeof(wchar_t);

      if (lpData->nCodePage == CP_UNICODE_UTF8 && nBytesRead != *pcb)
        SetFilePointer(lpData->hFile, nBytesRead - *pcb, NULL, FILE_CURRENT);

      if (nBytesConverted <= cb)
      {
        memcpy(pbBuff, pcTranslateBuffer, nBytesConverted);
        *pcb=nBytesConverted;
        nBytesConverted=0;
      }
      else
      {
        memcpy(pbBuff, pcTranslateBuffer, cb);
        *pcb=cb;
        nBytesConverted-=cb;
      }
    }
    else
    {
      memcpy(pbBuff, pcTranslateBuffer + cb, nBytesConverted);
      *pcb=nBytesConverted;
      nBytesConverted=0;
    }
  }

  if (!bNewLineDetected)
  {
    wchar_t *wpbBuff=(wchar_t *)pbBuff;
    int nBytes=*pcb / sizeof(wchar_t);
    int i;

    for (i=0; i < nBytes; ++i)
    {
      if (wpbBuff[i] == '\n')
      {
        if (i == 0 || wpbBuff[i - 1] != '\r')
        {
          SetNewLineA(NEWLINE_UNIX, FALSE);
        }
        bNewLineDetected=TRUE;
        break;
      }
      else if (wpbBuff[i] == '\r')
      {
        bNewLineDetected=TRUE;
      }
    }
  }
  return 0;
}

DWORD CALLBACK InputStreamCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
  static int nBytesConverted;
  STREAMDATA *lpData=(STREAMDATA *)dwCookie;

  if (nBytesConverted == 0)
  {
    if (lpData->nBytes != -1 && (lpData->nBytesRead+=cb) > lpData->nBytes)
      return 0xFFFFFFFF;

    if (!API_ReadFileW(lpData->hFile, pbBuff, (DWORD)cb, (DWORD *)pcb, NULL))
      return 0xFFFFFFFF;

    if (*pcb == 0)
      return 0xFFFFFFFF;
  }

  if (lpData->nCodePage == CP_UNICODE_UCS2_LE)
  {
  }
  else if (lpData->nCodePage == CP_UNICODE_UCS2_BE)
  {
    ChangeByteOrder(pbBuff, *pcb);
  }
  else
  {
    if (nBytesConverted == 0)
    {
      int nBytesRead=*pcb;

      if (lpData->nCodePage == CP_UNICODE_UTF8)
        nBytesConverted=UTF8toUTF16((char *)pbBuff, (unsigned int *)&nBytesRead, (wchar_t *)pcTranslateBuffer, TRANSLATE_BUFFER_SIZE / sizeof(wchar_t)) * sizeof(wchar_t);
      else
        nBytesConverted=MultiByteToWideChar(lpData->nCodePage, 0, (char *)pbBuff, *pcb, (wchar_t *)pcTranslateBuffer, TRANSLATE_BUFFER_SIZE / sizeof(wchar_t)) * sizeof(wchar_t);

      if (lpData->nCodePage == CP_UNICODE_UTF8 && nBytesRead != *pcb)
        SetFilePointer(lpData->hFile, nBytesRead - *pcb, NULL, FILE_CURRENT);

      if (nBytesConverted <= cb)
      {
        memcpy(pbBuff, pcTranslateBuffer, nBytesConverted);
        *pcb=nBytesConverted;
        nBytesConverted=0;
      }
      else
      {
        memcpy(pbBuff, pcTranslateBuffer, cb);
        *pcb=cb;
        nBytesConverted-=cb;
      }
    }
    else
    {
      memcpy(pbBuff, pcTranslateBuffer + cb, nBytesConverted);
      *pcb=nBytesConverted;
      nBytesConverted=0;
    }
  }

  if (!bNewLineDetected)
  {
    wchar_t *wpbBuff=(wchar_t *)pbBuff;
    int nBytes=*pcb / sizeof(wchar_t);
    int i;

    for (i=0; i < nBytes; ++i)
    {
      if (wpbBuff[i] == '\n')
      {
        if (i == 0 || wpbBuff[i - 1] != '\r')
        {
          SetNewLineW(NEWLINE_UNIX, FALSE);
        }
        bNewLineDetected=TRUE;
        break;
      }
      else if (wpbBuff[i] == '\r')
      {
        bNewLineDetected=TRUE;
      }
    }
  }
  return 0;
}

BOOL SaveDocumentA(char *szFile, int nCodePage, BOOL bBOM)
{
  WIN32_FIND_DATA w32fdInfo;
  HANDLE hFile;
  STREAMDATA sd;
  EDITSTREAM es;
  DWORD dwAttr;
  unsigned int nBytesWritten;
  int nError;

  dwAttr=GetFileAttributes(szFile);
  if (dwAttr != 0xFFFFFFFF)
  {
    if ((dwAttr & FILE_ATTRIBUTE_READONLY) || (dwAttr & FILE_ATTRIBUTE_HIDDEN) || (dwAttr & FILE_ATTRIBUTE_SYSTEM))
      SetFileAttributes(szFile, dwAttr & (!FILE_ATTRIBUTE_READONLY) & (!FILE_ATTRIBUTE_HIDDEN) & (!FILE_ATTRIBUTE_SYSTEM));
    if (bSaveTime)
    {
      if ((hFile=FindFirstFile(szFile, &w32fdInfo)) != INVALID_HANDLE_VALUE)
        FindClose(hFile);
    }
  }

  hFile=API_CreateFileA(szFile, GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL);

  if (hFile == INVALID_HANDLE_VALUE)
  {
    if (dwAttr != 0xFFFFFFFF) SetFileAttributes(szFile, dwAttr);
    return FALSE;
  }

  if (bBOM)
  {
    if (nCodePage == CP_UNICODE_UCS2_LE)
      nError=API_WriteFileA(hFile, "\xFF\xFE", 2, (DWORD *)&nBytesWritten, NULL);
    else if (nCodePage == CP_UNICODE_UCS2_BE)
      nError=API_WriteFileA(hFile, "\xFE\xFF", 2, (DWORD *)&nBytesWritten, NULL);
    else if (nCodePage == CP_UNICODE_UTF8)
      nError=API_WriteFileA(hFile, "\xEF\xBB\xBF", 3, (DWORD *)&nBytesWritten, NULL);

    if (!nError)
    {
      if (dwAttr != 0xFFFFFFFF) SetFileAttributes(szFile, dwAttr);
      return FALSE;
    }
  }

  sd.hFile=hFile;
  sd.nCodePage=nCodePage;
  es.dwCookie=(DWORD)&sd;
  es.pfnCallback=OutputStreamCallbackA;
  SendMessage(hWndEdit, EM_STREAMOUT, SF_TEXT|SF_UNICODE, (LPARAM)&es);

  SetModifyA(FALSE, FALSE);
  CloseHandle(hFile);

  //Change back file attributes
  if (dwAttr != 0xFFFFFFFF)
  {
    SetFileAttributes(szFile, dwAttr);
    if (bSaveTime)
    {
      if ((hFile=API_CreateFileA(szFile, FILE_WRITE_ATTRIBUTES, 0, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL)) != INVALID_HANDLE_VALUE)
      {
        SetFileTime(hFile, NULL, NULL, &w32fdInfo.ftLastWriteTime);
        CloseHandle(hFile);
      }
    }
  }

  //Get file write time
  GetFileWriteTimeA(szFile, &ft);

  //Update titles and icons
  if (szCurrentFile != szFile)
    UpdateTitleA(szFile);

  //Save position of the document
  if (szCurrentFile != szFile || nCurrentCodePage != nCodePage)
  {
    if (nRecentFiles)
    {
      RecentFilesZeroA();
      RecentFilesReadA();
      RecentFilesUpdateA(szFile, nPosition, MAKELONG(nCodePage, bBOM));
      RecentFilesSaveA();
    }
    if (szCurrentFile != szFile)
    {
      if (nRecentFiles)
        RecentFilesMenuA();
      lstrcpy(szCurrentFile, szFile);
    }
  }

  //Update codepage
  SetCodePageA(MAKELONG(nCodePage, bBOM), FALSE);

  return TRUE;
}

BOOL SaveDocumentW(wchar_t *wszFile, int nCodePage, BOOL bBOM)
{
  WIN32_FIND_DATAW w32fdInfoW;
  HANDLE hFile;
  STREAMDATA sd;
  EDITSTREAM es;
  DWORD dwAttr;
  unsigned int nBytesWritten;
  int nError;

  dwAttr=GetFileAttributesW(wszFile);
  if (dwAttr != 0xFFFFFFFF)
  {
    if ((dwAttr & FILE_ATTRIBUTE_READONLY) || (dwAttr & FILE_ATTRIBUTE_HIDDEN) || (dwAttr & FILE_ATTRIBUTE_SYSTEM))
      SetFileAttributesW(wszFile, dwAttr & (!FILE_ATTRIBUTE_READONLY) & (!FILE_ATTRIBUTE_HIDDEN) & (!FILE_ATTRIBUTE_SYSTEM));
    if (bSaveTime)
    {
      if ((hFile=FindFirstFileW(wszFile, &w32fdInfoW)) != INVALID_HANDLE_VALUE)
        FindClose(hFile);
    }
  }

  hFile=API_CreateFileW(wszFile, GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL);

  if (hFile == INVALID_HANDLE_VALUE)
  {
    if (dwAttr != 0xFFFFFFFF) SetFileAttributesW(wszFile, dwAttr);
    return FALSE;
  }

  if (bBOM)
  {
    if (nCodePage == CP_UNICODE_UCS2_LE)
      nError=API_WriteFileW(hFile, "\xFF\xFE", 2, (DWORD *)&nBytesWritten, NULL);
    else if (nCodePage == CP_UNICODE_UCS2_BE)
      nError=API_WriteFileW(hFile, "\xFE\xFF", 2, (DWORD *)&nBytesWritten, NULL);
    else if (nCodePage == CP_UNICODE_UTF8)
      nError=API_WriteFileW(hFile, "\xEF\xBB\xBF", 3, (DWORD *)&nBytesWritten, NULL);

    if (!nError)
    {
      if (dwAttr != 0xFFFFFFFF) SetFileAttributesW(wszFile, dwAttr);
      return FALSE;
    }
  }

  sd.hFile=hFile;
  sd.nCodePage=nCodePage;
  es.dwCookie=(DWORD)&sd;
  es.pfnCallback=OutputStreamCallbackW;
  SendMessage(hWndEdit, EM_STREAMOUT, SF_TEXT|SF_UNICODE, (LPARAM)&es);

  SetModifyW(FALSE, FALSE);
  CloseHandle(hFile);

  //Change back file attributes
  if (dwAttr != 0xFFFFFFFF)
  {
    SetFileAttributesW(wszFile, dwAttr);
    if (bSaveTime)
    {
      if ((hFile=API_CreateFileW(wszFile, FILE_WRITE_ATTRIBUTES, 0, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL)) != INVALID_HANDLE_VALUE)
      {
        SetFileTime(hFile, NULL, NULL, &w32fdInfoW.ftLastWriteTime);
        CloseHandle(hFile);
      }
    }
  }

  //Get file write time
  GetFileWriteTimeW(wszFile, &ft);

  //Update titles and icons
  if (wszCurrentFile != wszFile)
    UpdateTitleW(wszFile);

  //Save position of the document
  if (wszCurrentFile != wszFile || nCurrentCodePage != nCodePage)
  {
    if (nRecentFiles)
    {
      RecentFilesZeroW();
      RecentFilesReadW();
      RecentFilesUpdateW(wszFile, nPosition, MAKELONG(nCodePage, bBOM));
      RecentFilesSaveW();
    }
    if (wszCurrentFile != wszFile)
    {
      if (nRecentFiles)
        RecentFilesMenuW();
      lstrcpyW(wszCurrentFile, wszFile);
    }
  }

  //Update codepage
  SetCodePageW(MAKELONG(nCodePage, bBOM), FALSE);

  return TRUE;
}

DWORD CALLBACK OutputStreamCallbackA(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
  unsigned int nBytesConverted;
  unsigned int nBytesToWrite;
  unsigned int nBytesWritten;
  unsigned int nBytesRead;
  unsigned char *pDataToWrite=pbBuff;
  STREAMDATA *lpData=(STREAMDATA *)dwCookie;

  if (nNewLine == NEWLINE_UNIX)
  {
    nBytesRead=cb/2;
    nBytesToWrite=TranslateNewLinesToUnixW((wchar_t *)pbBuff, &nBytesRead) * sizeof(wchar_t);
  }
  else nBytesToWrite=cb;

  if (lpData->nCodePage == CP_UNICODE_UCS2_LE)
  {
  }
  else if (lpData->nCodePage == CP_UNICODE_UCS2_BE)
  {
    ChangeByteOrder(pbBuff, nBytesToWrite);
  }
  else
  {
    if (lpData->nCodePage == CP_UNICODE_UTF8)
      nBytesConverted=UTF16toUTF8((wchar_t *)pbBuff, nBytesToWrite/2, (char *)pcTranslateBuffer, TRANSLATE_BUFFER_SIZE);
    else
      nBytesConverted=WideCharToMultiByte(lpData->nCodePage, 0, (wchar_t *)pbBuff, nBytesToWrite/2, (char *)pcTranslateBuffer, TRANSLATE_BUFFER_SIZE, NULL, NULL);

    pDataToWrite=pcTranslateBuffer;
    nBytesToWrite=nBytesConverted;
  }

  if (!API_WriteFileA(lpData->hFile, pDataToWrite, nBytesToWrite, (DWORD *)&nBytesWritten, NULL))
    return 0xFFFFFFFF;

  *pcb=cb;

  return 0;
}

DWORD CALLBACK OutputStreamCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
  unsigned int nBytesConverted;
  unsigned int nBytesToWrite;
  unsigned int nBytesWritten;
  unsigned int nBytesRead;
  unsigned char *pDataToWrite=pbBuff;
  STREAMDATA *lpData=(STREAMDATA *)dwCookie;

  if (nNewLine == NEWLINE_UNIX)
  {
    nBytesRead=cb/2;
    nBytesToWrite=TranslateNewLinesToUnixW((wchar_t *)pbBuff, &nBytesRead) * sizeof(wchar_t);
  }
  else nBytesToWrite=cb;

  if (lpData->nCodePage == CP_UNICODE_UCS2_LE)
  {
  }
  else if (lpData->nCodePage == CP_UNICODE_UCS2_BE)
  {
    ChangeByteOrder(pbBuff, nBytesToWrite);
  }
  else
  {
    if (lpData->nCodePage == CP_UNICODE_UTF8)
      nBytesConverted=UTF16toUTF8((wchar_t *)pbBuff, nBytesToWrite/2, (char *)pcTranslateBuffer, TRANSLATE_BUFFER_SIZE);
    else
      nBytesConverted=WideCharToMultiByte(lpData->nCodePage, 0, (wchar_t *)pbBuff, nBytesToWrite/2, (char *)pcTranslateBuffer, TRANSLATE_BUFFER_SIZE, NULL, NULL);

    pDataToWrite=pcTranslateBuffer;
    nBytesToWrite=nBytesConverted;
  }

  if (!API_WriteFileW(lpData->hFile, pDataToWrite, nBytesToWrite, (DWORD *)&nBytesWritten, NULL))
    return 0xFFFFFFFF;

  *pcb=cb;

  return 0;
}

BOOL OpenDirectoryA(char *pPath, BOOL bSubDir)
{
  char szName[MAX_PATH];
  WIN32_FIND_DATA data;
  HANDLE hSearch;

  if (bSubDir)
  {
    wsprintf(szName, "%s\\*.*", pPath);

    if ((hSearch=FindFirstFile(szName, &data)) != INVALID_HANDLE_VALUE)
    {
      do
      {
        if (data.cFileName[0] == '.' && (data.cFileName[1] == '\0' || (data.cFileName[1] == '.' && data.cFileName[2] == '\0'))) continue;

        wsprintf(szName, "%s\\%s", pPath, data.cFileName);

        if (data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
          OpenDirectoryA(szName, TRUE);
        else
          OpenDocumentA(szName, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0, FALSE);
      }
      while (FindNextFile(hSearch, &data));
    }
    else return FALSE;

    FindClose(hSearch);
  }
  return TRUE;
}

BOOL OpenDirectoryW(wchar_t *wpPath, BOOL bSubDir)
{
  wchar_t wszName[MAX_PATH];
  WIN32_FIND_DATAW dataW;
  HANDLE hSearch;

  if (bSubDir)
  {
    wsprintfW(wszName, L"%s\\*.*", wpPath);

    if ((hSearch=FindFirstFileW(wszName, &dataW)) != INVALID_HANDLE_VALUE)
    {
      do
      {
        if (dataW.cFileName[0] == '.' && (dataW.cFileName[1] == '\0' || (dataW.cFileName[1] == '.' && dataW.cFileName[2] == '\0'))) continue;

        wsprintfW(wszName, L"%s\\%s", wpPath, dataW.cFileName);

        if (dataW.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
          OpenDirectoryW(wszName, TRUE);
        else
          OpenDocumentW(wszName, ADT_BINARY_ERROR|ADT_REG_CODEPAGE, 0, FALSE);
      }
      while (FindNextFileW(hSearch, &dataW));
    }
    else return FALSE;

    FindClose(hSearch);
  }
  return TRUE;
}


//// Code pages

unsigned int CALLBACK CodePageDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndCP;
  static HWND hWndPreview;
  static HWND hWndAutodetect;
  static HWND hDlgEdit;
  static RECT rcDlg;
  static RECT rcCP;
  static RECT rcPreview;
  static RECT rcAutodetect;
  static char szFile[MAX_PATH];
  static int nCodePage;
  static BOOL bBOM;
  int i;

  if (uMsg == WM_INITDIALOG)
  {
    if (bMDI) hDlgEdit=FindWindowEx(GetParent(hDlg), NULL, "Edit", NULL);
    hWndCP=GetDlgItem(hDlg, IDC_OFN_CODEPAGE);
    hWndPreview=GetDlgItem(hDlg, IDC_OFN_PREVIEW);
    hWndAutodetect=GetDlgItem(hDlg, IDC_OFN_AUTODETECT);

    GetWindowRect(hDlg, &rcDlg);
    GetWindowRect(hWndCP, &rcCP);
    GetWindowRect(hWndPreview, &rcPreview);
    rcDlg.right-=rcDlg.left;
    rcDlg.bottom-=rcDlg.top;
    rcCP.right-=rcCP.left;
    rcCP.bottom-=rcCP.top;
    rcPreview.right-=rcPreview.left;
    rcPreview.bottom-=rcPreview.top;

    nCodePage=nCurrentCodePage;
    FillComboboxCodepageA(hWndCP);
    SelectComboboxCodepageA(hWndCP, nCodePage);

    if (bSaveDlg)
    {
      SetWindowPos(hDlg, 0, 0, 0, rcDlg.right, rcDlg.bottom - ((rcDlg.bottom + rcDlg.top) - rcPreview.top), SWP_NOMOVE|SWP_NOZORDER);
      SetWindowText(hWndAutodetect, "&BOM");

      if (nCodePage == CP_UNICODE_UCS2_LE || nCodePage == CP_UNICODE_UCS2_BE || nCodePage == CP_UNICODE_UTF8)
      {
        SendMessage(hWndAutodetect, BM_SETCHECK, (WPARAM)bCurrentBOM, 0);
        EnableWindow(hWndAutodetect, TRUE);
      }
      else
      {
        SendMessage(hWndAutodetect, BM_SETCHECK, (WPARAM)FALSE, 0);
        EnableWindow(hWndAutodetect, FALSE);
      }
    }
    else
    {
      API_LoadStringA(hLangLib, STR_AUTODETECT, buf, BUFFER_SIZE);
      SetWindowText(hWndAutodetect, buf);
      SendMessage(hWndAutodetect, BM_SETCHECK, (WPARAM)bAutodetect, 0);
      EnableWindow(hWndCP, !bAutodetect);
    }

    OldPreviewProc=(WNDPROC)GetWindowLong(hWndPreview, GWL_WNDPROC);
    SetWindowLong(hWndPreview, GWL_WNDPROC, (LONG)NewPreviewProcA);
  }
  else if (uMsg == WM_SIZE)
  {
    RECT rcTmp;

    GetWindowRect(hDlg, &rcTmp);
    GetWindowRect(hWndAutodetect, &rcAutodetect);
    rcAutodetect.left-=rcTmp.left;
    rcAutodetect.top-=rcTmp.top;

    i=LOWORD(lParam) - rcDlg.right;
    rcDlg.right=LOWORD(lParam);
    rcDlg.bottom=HIWORD(lParam);
    rcCP.right+=i;
    rcPreview.right+=i;
    rcAutodetect.left+=i;

    SetWindowPos(hWndCP, 0, 0, 0, rcCP.right, rcCP.bottom, SWP_NOMOVE|SWP_NOZORDER);
    SetWindowPos(hWndPreview, 0, 0, 0, rcPreview.right, rcPreview.bottom, SWP_NOMOVE|SWP_NOZORDER);
    SetWindowPos(hWndAutodetect, 0, rcAutodetect.left, rcAutodetect.top, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
    return TRUE;
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    if ((HWND)wParam == hWndPreview)
    {
      RECT rcRect;
      POINT pt;
      CHARRANGE cr;

      if (lParam == ((UINT)-1))
      {
        GetWindowRect((HWND)wParam, &rcRect);
        pt.x=rcRect.left;
        pt.y=rcRect.top;
      }
      else
      {
        pt.x=LOWORD(lParam);
        pt.y=HIWORD(lParam);
      }
      SendMessage((HWND)wParam, EM_EXGETSEL, 0, (LPARAM)&cr);
      EnableMenuItem(hPopupView, IDM_EDIT_COPY, (cr.cpMin == cr.cpMax)?MF_GRAYED:MF_ENABLED);
      i=TrackPopupMenu(hPopupView, TPM_RETURNCMD|TPM_NONOTIFY|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pt.x, pt.y, 0, hDlg, NULL);

      if (i == IDM_EDIT_COPY)
        SendMessage((HWND)wParam, WM_COPY, 0, 0);
      else if (i == IDM_EDIT_SELECTALL)
        SendMessage((HWND)wParam, EM_SETSEL, 0, -1);
    }
    return TRUE;
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (((LPNMHDR)lParam)->code == CDN_FILEOK)
    {
      char ch='A';
      wchar_t wch;

      nCodePage=GetComboboxCodepageA(hWndCP);

      if (!bSaveDlg && bAutodetect)
      {
        dwOfnFlags=ADT_BINARY_ERROR|ADT_REG_CODEPAGE;
        nOfnCodePage=0;
        bOfnBOM=FALSE;
      }
      else if (nCodePage == CP_UNICODE_UCS2_LE || nCodePage == CP_UNICODE_UCS2_BE || nCodePage == CP_UNICODE_UTF8)
      {
        dwOfnFlags=0;
        nOfnCodePage=nCodePage;
        if (!bSaveDlg)
          bOfnBOM=bBOM;
        else
          bOfnBOM=(BOOL)SendMessage(hWndAutodetect, BM_GETCHECK, 0, 0);
      }
      else if (MultiByteToWideChar(nCodePage, 0, &ch, 1, &wch, 1))
      {
        dwOfnFlags=0;
        nOfnCodePage=nCodePage;
        bOfnBOM=FALSE;
      }
      else
      {
        API_LoadStringA(hLangLib, MSG_CP_UNIMPLEMENTED, buf, BUFFER_SIZE);
        MessageBox(hDlg, buf, APP_MAIN_TITLE, MB_OK|MB_ICONERROR);
        SetWindowLong(hDlg, DWL_MSGRESULT, 1);
      }
    }
    else if (((LPNMHDR)lParam)->code == CDN_SELCHANGE)
    {
      if (!bSaveDlg)
      {
        if (bMDI)
        {
          if (GetWindowTextLength(hDlgEdit) > FILELIST_BUFFER_SIZE)
          {
            API_LoadStringA(hLangLib, MSG_LONG_FILELIST, buf, BUFFER_SIZE);
            MessageBox(hDlg, buf, APP_MAIN_TITLE, MB_OK|MB_ICONEXCLAMATION);
          }
        }

        SendMessage(((OFNOTIFY*)lParam)->hdr.hwndFrom, CDM_GETFILEPATH, (LPARAM)MAX_PATH, (WPARAM)szFile);

        if (FilePreviewA(hWndPreview, szFile, PREVIEW_SIZE, bAutodetect?(ADT_BINARY_ERROR|ADT_REG_CODEPAGE):ADT_DETECT_BOM, &nCodePage, &bBOM) < 0)
        {
          EnableWindow(hWndPreview, FALSE);
          if (bAutodetect) SelectComboboxCodepageA(hWndCP, nDefaultCodePage);
          SetWindowText(hWndPreview, "");
          return TRUE;
        }
        EnableWindow(hWndPreview, TRUE);
        if (bAutodetect) SelectComboboxCodepageA(hWndCP, nCodePage);
      }
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_OFN_CODEPAGE && HIWORD(wParam) == CBN_SELCHANGE)
    {
      nCodePage=GetComboboxCodepageA(hWndCP);

      if (bSaveDlg)
      {
        if (nCodePage == CP_UNICODE_UCS2_LE || nCodePage == CP_UNICODE_UCS2_BE || nCodePage == CP_UNICODE_UTF8)
        {
          EnableWindow(hWndAutodetect, TRUE);
          SendMessage(hWndAutodetect, BM_SETCHECK, (WPARAM)TRUE, 0);
        }
        else
        {
          EnableWindow(hWndAutodetect, FALSE);
          SendMessage(hWndAutodetect, BM_SETCHECK, (WPARAM)FALSE, 0);
        }
      }
      else
      {
        if (FilePreviewA(hWndPreview, szFile, PREVIEW_SIZE, ADT_DETECT_BOM, &nCodePage, &bBOM) < 0)
          SetWindowText(hWndPreview, "");
      }
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_OFN_AUTODETECT)
    {
      if (!bSaveDlg)
      {
        bAutodetect=(BOOL)SendMessage(hWndAutodetect, BM_GETCHECK, 0, 0);
        EnableWindow(hWndCP, !bAutodetect);

        if (FilePreviewA(hWndPreview, szFile, PREVIEW_SIZE, bAutodetect?(ADT_BINARY_ERROR|ADT_REG_CODEPAGE):ADT_DETECT_BOM, &nCodePage, &bBOM) < 0)
        {
          EnableWindow(hWndPreview, FALSE);
          if (bAutodetect) SelectComboboxCodepageA(hWndCP, nDefaultCodePage);
          SetWindowText(hWndPreview, "");
          return TRUE;
        }
        EnableWindow(hWndPreview, TRUE);
        if (bAutodetect) SelectComboboxCodepageA(hWndCP, nCodePage);
      }
      return TRUE;
    }
  }
  return FALSE;
}

unsigned int CALLBACK CodePageDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndCP;
  static HWND hWndPreview;
  static HWND hWndAutodetect;
  static HWND hDlgEdit;
  static RECT rcDlg;
  static RECT rcCP;
  static RECT rcPreview;
  static RECT rcAutodetect;
  static wchar_t wszFile[MAX_PATH];
  static int nCodePage;
  static BOOL bBOM;
  int i;

  if (uMsg == WM_INITDIALOG)
  {
    if (bMDI) hDlgEdit=FindWindowExW(GetParent(hDlg), NULL, L"Edit", NULL);
    hWndCP=GetDlgItem(hDlg, IDC_OFN_CODEPAGE);
    hWndPreview=GetDlgItem(hDlg, IDC_OFN_PREVIEW);
    hWndAutodetect=GetDlgItem(hDlg, IDC_OFN_AUTODETECT);

    GetWindowRect(hDlg, &rcDlg);
    GetWindowRect(hWndCP, &rcCP);
    GetWindowRect(hWndPreview, &rcPreview);
    rcDlg.right-=rcDlg.left;
    rcDlg.bottom-=rcDlg.top;
    rcCP.right-=rcCP.left;
    rcCP.bottom-=rcCP.top;
    rcPreview.right-=rcPreview.left;
    rcPreview.bottom-=rcPreview.top;

    nCodePage=nCurrentCodePage;
    FillComboboxCodepageW(hWndCP);
    SelectComboboxCodepageW(hWndCP, nCodePage);

    if (bSaveDlg)
    {
      SetWindowPos(hDlg, 0, 0, 0, rcDlg.right, rcDlg.bottom - ((rcDlg.bottom + rcDlg.top) - rcPreview.top), SWP_NOMOVE|SWP_NOZORDER);
      SetWindowTextW(hWndAutodetect, L"&BOM");

      if (nCodePage == CP_UNICODE_UCS2_LE || nCodePage == CP_UNICODE_UCS2_BE || nCodePage == CP_UNICODE_UTF8)
      {
        SendMessage(hWndAutodetect, BM_SETCHECK, (WPARAM)bCurrentBOM, 0);
        EnableWindow(hWndAutodetect, TRUE);
      }
      else
      {
        SendMessage(hWndAutodetect, BM_SETCHECK, (WPARAM)FALSE, 0);
        EnableWindow(hWndAutodetect, FALSE);
      }
    }
    else
    {
      API_LoadStringW(hLangLib, STR_AUTODETECT, wbuf, BUFFER_SIZE);
      SetWindowTextW(hWndAutodetect, wbuf);
      SendMessage(hWndAutodetect, BM_SETCHECK, (WPARAM)bAutodetect, 0);
      EnableWindow(hWndCP, !bAutodetect);
    }

    OldPreviewProc=(WNDPROC)GetWindowLongW(hWndPreview, GWL_WNDPROC);
    SetWindowLongW(hWndPreview, GWL_WNDPROC, (LONG)NewPreviewProcW);
  }
  else if (uMsg == WM_SIZE)
  {
    RECT rcTmp;

    GetWindowRect(hDlg, &rcTmp);
    GetWindowRect(hWndAutodetect, &rcAutodetect);
    rcAutodetect.left-=rcTmp.left;
    rcAutodetect.top-=rcTmp.top;

    i=LOWORD(lParam) - rcDlg.right;
    rcDlg.right=LOWORD(lParam);
    rcDlg.bottom=HIWORD(lParam);
    rcCP.right+=i;
    rcPreview.right+=i;
    rcAutodetect.left+=i;

    SetWindowPos(hWndCP, 0, 0, 0, rcCP.right, rcCP.bottom, SWP_NOMOVE|SWP_NOZORDER);
    SetWindowPos(hWndPreview, 0, 0, 0, rcPreview.right, rcPreview.bottom, SWP_NOMOVE|SWP_NOZORDER);
    SetWindowPos(hWndAutodetect, 0, rcAutodetect.left, rcAutodetect.top, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
    return TRUE;
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    if ((HWND)wParam == hWndPreview)
    {
      RECT rcRect;
      POINT pt;
      CHARRANGE cr;

      if (lParam == ((UINT)-1))
      {
        GetWindowRect((HWND)wParam, &rcRect);
        pt.x=rcRect.left;
        pt.y=rcRect.top;
      }
      else
      {
        pt.x=LOWORD(lParam);
        pt.y=HIWORD(lParam);
      }
      SendMessage((HWND)wParam, EM_EXGETSEL, 0, (LPARAM)&cr);
      EnableMenuItem(hPopupView, IDM_EDIT_COPY, (cr.cpMin == cr.cpMax)?MF_GRAYED:MF_ENABLED);
      i=TrackPopupMenu(hPopupView, TPM_RETURNCMD|TPM_NONOTIFY|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pt.x, pt.y, 0, hDlg, NULL);

      if (i == IDM_EDIT_COPY)
        SendMessage((HWND)wParam, WM_COPY, 0, 0);
      else if (i == IDM_EDIT_SELECTALL)
        SendMessage((HWND)wParam, EM_SETSEL, 0, -1);
    }
    return TRUE;
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (((LPNMHDR)lParam)->code == CDN_FILEOK)
    {
      char ch='A';
      wchar_t wch;

      nCodePage=GetComboboxCodepageW(hWndCP);

      if (!bSaveDlg && bAutodetect)
      {
        dwOfnFlags=ADT_BINARY_ERROR|ADT_REG_CODEPAGE;
        nOfnCodePage=0;
        bOfnBOM=FALSE;
      }
      else if (nCodePage == CP_UNICODE_UCS2_LE || nCodePage == CP_UNICODE_UCS2_BE || nCodePage == CP_UNICODE_UTF8)
      {
        dwOfnFlags=0;
        nOfnCodePage=nCodePage;
        if (!bSaveDlg)
          bOfnBOM=bBOM;
        else
          bOfnBOM=(BOOL)SendMessage(hWndAutodetect, BM_GETCHECK, 0, 0);
      }
      else if (MultiByteToWideChar(nCodePage, 0, &ch, 1, &wch, 1))
      {
        dwOfnFlags=0;
        nOfnCodePage=nCodePage;
        bOfnBOM=FALSE;
      }
      else
      {
        API_LoadStringW(hLangLib, MSG_CP_UNIMPLEMENTED, wbuf, BUFFER_SIZE);
        MessageBoxW(hDlg, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONERROR);
        SetWindowLong(hDlg, DWL_MSGRESULT, 1);
      }
    }
    else if (((LPNMHDR)lParam)->code == CDN_SELCHANGE)
    {
      if (!bSaveDlg)
      {
        if (bMDI)
        {
          if (GetWindowTextLengthW(hDlgEdit) > FILELIST_BUFFER_SIZE)
          {
            API_LoadStringW(hLangLib, MSG_LONG_FILELIST, wbuf, BUFFER_SIZE);
            MessageBoxW(hDlg, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONEXCLAMATION);
          }
        }

        SendMessageW(((OFNOTIFY*)lParam)->hdr.hwndFrom, CDM_GETFILEPATH, (LPARAM)MAX_PATH, (WPARAM)wszFile);

        if (FilePreviewW(hWndPreview, wszFile, PREVIEW_SIZE, bAutodetect?(ADT_BINARY_ERROR|ADT_REG_CODEPAGE):ADT_DETECT_BOM, &nCodePage, &bBOM) < 0)
        {
          EnableWindow(hWndPreview, FALSE);
          if (bAutodetect) SelectComboboxCodepageW(hWndCP, nDefaultCodePage);
          SetWindowTextW(hWndPreview, L"");
          return TRUE;
        }
        EnableWindow(hWndPreview, TRUE);
        if (bAutodetect) SelectComboboxCodepageW(hWndCP, nCodePage);
      }
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_OFN_CODEPAGE && HIWORD(wParam) == CBN_SELCHANGE)
    {
      nCodePage=GetComboboxCodepageW(hWndCP);

      if (bSaveDlg)
      {
        if (nCodePage == CP_UNICODE_UCS2_LE || nCodePage == CP_UNICODE_UCS2_BE || nCodePage == CP_UNICODE_UTF8)
        {
          EnableWindow(hWndAutodetect, TRUE);
          SendMessage(hWndAutodetect, BM_SETCHECK, (WPARAM)TRUE, 0);
        }
        else
        {
          EnableWindow(hWndAutodetect, FALSE);
          SendMessage(hWndAutodetect, BM_SETCHECK, (WPARAM)FALSE, 0);
        }
      }
      else
      {
        if (FilePreviewW(hWndPreview, wszFile, PREVIEW_SIZE, ADT_DETECT_BOM, &nCodePage, &bBOM) < 0)
          SetWindowTextW(hWndPreview, L"");
      }
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_OFN_AUTODETECT)
    {
      if (!bSaveDlg)
      {
        bAutodetect=(BOOL)SendMessage(hWndAutodetect, BM_GETCHECK, 0, 0);
        EnableWindow(hWndCP, !bAutodetect);

        if (FilePreviewW(hWndPreview, wszFile, PREVIEW_SIZE, bAutodetect?(ADT_BINARY_ERROR|ADT_REG_CODEPAGE):ADT_DETECT_BOM, &nCodePage, &bBOM) < 0)
        {
          EnableWindow(hWndPreview, FALSE);
          if (bAutodetect) SelectComboboxCodepageW(hWndCP, nDefaultCodePage);
          SetWindowTextW(hWndPreview, L"");
          return TRUE;
        }
        EnableWindow(hWndPreview, TRUE);
        if (bAutodetect) SelectComboboxCodepageW(hWndCP, nCodePage);
      }
      return TRUE;
    }
  }
  return FALSE;
}

LRESULT CALLBACK NewPreviewProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_KEYDOWN)
  {
    if (wParam == VK_ESCAPE)
    {
      PostMessage(GetParent(hWnd), WM_KEYDOWN, VK_ESCAPE, 0);
      return TRUE;
    }
  }
  return CallWindowProc(OldPreviewProc, hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewPreviewProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_KEYDOWN)
  {
    if (wParam == VK_ESCAPE)
    {
      PostMessage(GetParent(hWnd), WM_KEYDOWN, VK_ESCAPE, 0);
      return TRUE;
    }
  }
  return CallWindowProcW(OldPreviewProc, hWnd, uMsg, wParam, lParam);
}

BOOL RegEnumCodePages(int *codepages, int size)
{
  HKEY hKey;
  DWORD dwSizeValue;
  DWORD dwSizeString;
  DWORD dwType;
  DWORD dwIndex=0;
  int i;

  memset(codepages, 0, size);

  if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SYSTEM\\CurrentControlSet\\Control\\Nls\\CodePage", 0, KEY_READ, &hKey) != ERROR_SUCCESS)
    return FALSE;

  while(1)
  {
    dwSizeValue=BUFFER_SIZE;
    dwSizeString=BUFFER_SIZE;
    buf2[0]='\0';

    if (RegEnumValue(hKey, dwIndex++, buf, &dwSizeValue, NULL, &dwType, (LPBYTE)buf2, &dwSizeString) != ERROR_SUCCESS)
      break;

    if (*buf2 != '\0' && (i=xatoi(buf)) != 0 && i < size)
      codepages[i]=TRUE;
  }
  RegCloseKey(hKey);

  return TRUE;
}

void FillComboboxCodepageA(HWND hWnd)
{
  CPINFOEX CPInfoEx;
  int nCount;
  int i;

  if (!bEnumCodePages)
  {
    RegEnumCodePages(codepages, sizeof(codepages));
    codepages[65000]=TRUE;
    bEnumCodePages=TRUE;
  }

  if (!bRecodeDlg) SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)STR_SYSTEM_ANSI);
  SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)STR_SYSTEM_OEM);
  if (!bRecodeDlg) SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)STR_UNICODE_UCS2_LE);
  if (!bRecodeDlg) SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)STR_UNICODE_UCS2_BE);
  SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)STR_UNICODE_UTF8);
  nCount=SendMessage(hWnd, CB_GETCOUNT, 0, 0);

  for (i=0; i <= 65535; ++i)
  {
    if (codepages[i])
    {
      if (GetCPInfoExAPtr && (*GetCPInfoExAPtr)(i, 0, &CPInfoEx) && i == xatoi(CPInfoEx.CodePageName))
      {
        SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)CPInfoEx.CodePageName);
      }
      else
      {
        wsprintf(buf, "%d", i);
        SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)buf);
      }
      codepages[i]=nCount++;
    }
  }
}

void FillComboboxCodepageW(HWND hWnd)
{
  CPINFOEXW CPInfoExW;
  int nCount;
  int i;

  if (!bEnumCodePages)
  {
    RegEnumCodePages(codepages, sizeof(codepages));
    bEnumCodePages=TRUE;
  }

  if (!bRecodeDlg) SendMessageW(hWnd, CB_ADDSTRING, 0, (LPARAM)STR_SYSTEM_ANSIW);
  SendMessageW(hWnd, CB_ADDSTRING, 0, (LPARAM)STR_SYSTEM_OEMW);
  if (!bRecodeDlg) SendMessageW(hWnd, CB_ADDSTRING, 0, (LPARAM)STR_UNICODE_UCS2_LEW);
  if (!bRecodeDlg) SendMessageW(hWnd, CB_ADDSTRING, 0, (LPARAM)STR_UNICODE_UCS2_BEW);
  SendMessageW(hWnd, CB_ADDSTRING, 0, (LPARAM)STR_UNICODE_UTF8W);
  nCount=SendMessage(hWnd, CB_GETCOUNT, 0, 0);

  for (i=0; i <= 65535; ++i)
  {
    if (codepages[i])
    {
      if (GetCPInfoExWPtr && (*GetCPInfoExWPtr)(i, 0, &CPInfoExW) && i == xatoiW(CPInfoExW.CodePageName))
      {
        SendMessageW(hWnd, CB_ADDSTRING, 0, (LPARAM)CPInfoExW.CodePageName);
      }
      else
      {
        wsprintfW(wbuf, L"%d", i);
        SendMessageW(hWnd, CB_ADDSTRING, 0, (LPARAM)wbuf);
      }
      codepages[i]=nCount++;
    }
  }
}

int GetComboboxCodepageA(HWND hWnd)
{
  int nCodePage;

  SendMessage(hWnd, CB_GETLBTEXT, (WPARAM)SendMessage(hWnd, CB_GETCURSEL, 0, 0), (LPARAM)buf);

  if (!lstrcmp(buf, STR_SYSTEM_ANSI))
    nCodePage=nAnsiCodePage;
  else if (!lstrcmp(buf, STR_SYSTEM_OEM))
    nCodePage=nOemCodePage;
  else
    nCodePage=xatoi(buf);

  return nCodePage;
}

int GetComboboxCodepageW(HWND hWnd)
{
  int nCodePage;

  SendMessageW(hWnd, CB_GETLBTEXT, (WPARAM)SendMessage(hWnd, CB_GETCURSEL, 0, 0), (LPARAM)wbuf);

  if (!lstrcmpW(wbuf, STR_SYSTEM_ANSIW))
    nCodePage=nAnsiCodePage;
  else if (!lstrcmpW(wbuf, STR_SYSTEM_OEMW))
    nCodePage=nOemCodePage;
  else
    nCodePage=xatoiW(wbuf);

  return nCodePage;
}

int SelectComboboxCodepageA(HWND hWnd, int nCodepage)
{
  int nSelectIndex;

  if (nCodepage == nAnsiCodePage)
    nSelectIndex=SendMessage(hWnd, CB_FINDSTRING, 0, (LPARAM)STR_SYSTEM_ANSI);
  else if (nCodepage == nOemCodePage)
    nSelectIndex=SendMessage(hWnd, CB_FINDSTRING, 0, (LPARAM)STR_SYSTEM_OEM);
  else if (nCodepage == CP_UNICODE_UCS2_LE)
    nSelectIndex=SendMessage(hWnd, CB_FINDSTRING, 0, (LPARAM)STR_UNICODE_UCS2_LE);
  else if (nCodepage == CP_UNICODE_UCS2_BE)
    nSelectIndex=SendMessage(hWnd, CB_FINDSTRING, 0, (LPARAM)STR_UNICODE_UCS2_BE);
  else if (nCodepage == CP_UNICODE_UTF8)
    nSelectIndex=SendMessage(hWnd, CB_FINDSTRING, 0, (LPARAM)STR_UNICODE_UTF8);
  else
    nSelectIndex=codepages[nCodepage];

  if (nSelectIndex == CB_ERR) nSelectIndex=0;
  SendMessage(hWnd, CB_SETCURSEL, (WPARAM)nSelectIndex, 0);

  return nSelectIndex;
}

int SelectComboboxCodepageW(HWND hWnd, int nCodepage)
{
  int nSelectIndex;

  if (nCodepage == nAnsiCodePage)
    nSelectIndex=SendMessageW(hWnd, CB_FINDSTRING, 0, (LPARAM)STR_SYSTEM_ANSIW);
  else if (nCodepage == nOemCodePage)
    nSelectIndex=SendMessageW(hWnd, CB_FINDSTRING, 0, (LPARAM)STR_SYSTEM_OEMW);
  else if (nCodepage == CP_UNICODE_UCS2_LE)
    nSelectIndex=SendMessageW(hWnd, CB_FINDSTRING, 0, (LPARAM)STR_UNICODE_UCS2_LEW);
  else if (nCodepage == CP_UNICODE_UCS2_BE)
    nSelectIndex=SendMessageW(hWnd, CB_FINDSTRING, 0, (LPARAM)STR_UNICODE_UCS2_BEW);
  else if (nCodepage == CP_UNICODE_UTF8)
    nSelectIndex=SendMessageW(hWnd, CB_FINDSTRING, 0, (LPARAM)STR_UNICODE_UTF8W);
  else
    nSelectIndex=codepages[nCodepage];

  if (nSelectIndex == CB_ERR) nSelectIndex=0;
  SendMessage(hWnd, CB_SETCURSEL, (WPARAM)nSelectIndex, 0);

  return nSelectIndex;
}

int FilePreviewA(HWND hWnd, char *pFile, int nPreviewBytes, DWORD Flags, int *nCodePage, BOOL *bBOM)
{
  HANDLE hFile;
  STREAMDATA sd;
  EDITSTREAM es;
  int i;

  if (IsFileA(pFile) != ERROR_SUCCESS)
    return EDT_OPEN;

  if ((i=AutodetectCodePageA(pFile, DETECT_CODEPAGE_SIZE, Flags, nCodePage, bBOM)) < 0)
    return i;

  if ((hFile=API_CreateFileA(pFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL)) == INVALID_HANDLE_VALUE)
    return EDT_OPEN;

  if (*bBOM)
  {
    if (*nCodePage == CP_UNICODE_UCS2_LE)
      SetFilePointer(hFile, 2, NULL, FILE_BEGIN);
    else if (*nCodePage == CP_UNICODE_UCS2_BE)
      SetFilePointer(hFile, 2, NULL, FILE_BEGIN);
    else if (*nCodePage == CP_UNICODE_UTF8)
      SetFilePointer(hFile, 3, NULL, FILE_BEGIN);
  }

  sd.hFile=hFile;
  sd.nCodePage=*nCodePage;
  sd.nBytes=nPreviewBytes;
  sd.nBytesRead=0;
  es.dwCookie=(DWORD)&sd;
  es.pfnCallback=InputStreamCallbackW;
  SendMessage(hWnd, EM_STREAMIN, SF_TEXT|SF_UNICODE, (LPARAM)&es);

  CloseHandle(hFile);
  return 0;
}

int FilePreviewW(HWND hWnd, wchar_t *wpFile, int nPreviewBytes, DWORD Flags, int *nCodePage, BOOL *bBOM)
{
  HANDLE hFile;
  STREAMDATA sd;
  EDITSTREAM es;
  int i;

  if (IsFileW(wpFile) != ERROR_SUCCESS)
    return EDT_OPEN;

  if ((i=AutodetectCodePageW(wpFile, DETECT_CODEPAGE_SIZE, Flags, nCodePage, bBOM)) < 0)
    return i;

  if ((hFile=API_CreateFileW(wpFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL)) == INVALID_HANDLE_VALUE)
    return EDT_OPEN;

  if (*bBOM)
  {
    if (*nCodePage == CP_UNICODE_UCS2_LE)
      SetFilePointer(hFile, 2, NULL, FILE_BEGIN);
    else if (*nCodePage == CP_UNICODE_UCS2_BE)
      SetFilePointer(hFile, 2, NULL, FILE_BEGIN);
    else if (*nCodePage == CP_UNICODE_UTF8)
      SetFilePointer(hFile, 3, NULL, FILE_BEGIN);
  }

  sd.hFile=hFile;
  sd.nCodePage=*nCodePage;
  sd.nBytes=nPreviewBytes;
  sd.nBytesRead=0;
  es.dwCookie=(DWORD)&sd;
  es.pfnCallback=InputStreamCallbackW;
  SendMessage(hWnd, EM_STREAMIN, SF_TEXT|SF_UNICODE, (LPARAM)&es);

  CloseHandle(hFile);
  return 0;
}

int AutodetectCodePageA(char *pFile, DWORD dwBytesToCheck, DWORD Flags, int *nCodePage, BOOL *bBOM)
{
  HANDLE hFile;
  DWORD dwBytesRead;
  DWORD dwCount;
  unsigned char *pBuffer;
  int nUTF=0;
  int i;

  if (!dwBytesToCheck || !Flags) return 0;

  if (Flags & ADT_REG_CODEPAGE)
  {
    if (nRecentFiles)
    {
      RecentFilesZeroA();
      RecentFilesReadA();
    }
    if (nRecentFiles && RecentFilesGetA(pFile, 0, &i) && i)
    {
      if (nCodePage) *nCodePage=LOWORD(i);
      if (bBOM) *bBOM=HIWORD(i);
      Flags&=~ADT_DETECT_CODEPAGE;
      Flags&=~ADT_DETECT_BOM;
    }
    else
    {
      if (nCodePage) *nCodePage=nDefaultCodePage;
      if (bBOM) *bBOM=bDefaultBOM;
      Flags&=~ADT_REG_CODEPAGE;
      Flags|=ADT_DETECT_CODEPAGE;
      Flags|=ADT_DETECT_BOM;
    }
  }

  if (Flags & ADT_BINARY_ERROR || Flags & ADT_DETECT_CODEPAGE || Flags & ADT_DETECT_BOM)
  {
    if ((hFile=API_CreateFileA(pFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL)) == INVALID_HANDLE_VALUE)
      return EDT_OPEN;

    if (!(pBuffer=(unsigned char *)API_HeapAlloc(hHeap, 0, dwBytesToCheck + 1)))
    {
      CloseHandle(hFile);
      return EDT_ALLOC;
    }

    if (!API_ReadFileA(hFile, pBuffer, dwBytesToCheck, &dwBytesRead, NULL))
    {
      API_HeapFree(hHeap, 0, (LPVOID)pBuffer);
      CloseHandle(hFile);
      return EDT_READ;
    }
    CloseHandle(hFile);
  }

  if (Flags & ADT_BINARY_ERROR || Flags & ADT_DETECT_CODEPAGE)
  {
    if (dwBytesRead)
    {
      for (dwCount=0, --dwBytesRead; dwCount < dwBytesRead; ++dwCount)
      {
        if (Flags & ADT_BINARY_ERROR)
        {
          if (pBuffer[dwCount] == 0x00 && pBuffer[dwCount + 1] == 0x00)
          {
            API_HeapFree(hHeap, 0, (LPVOID)pBuffer);
            return EDT_BINARY;
          }
        }
        if (Flags & ADT_DETECT_CODEPAGE)
        {
          if (nUTF == 0 && dwCount % 2 == 0)
          {
            if (pBuffer[dwCount] != 0x00 && pBuffer[dwCount + 1] == 0x00)
              nUTF=CP_UNICODE_UCS2_LE;
            else if (pBuffer[dwCount] == 0x00 && pBuffer[dwCount + 1] != 0x00)
              nUTF=CP_UNICODE_UCS2_BE;
          }
        }
      }
    }
  }

  if (Flags & ADT_DETECT_CODEPAGE || Flags & ADT_DETECT_BOM)
  {
    if (pBuffer[0] == 0xFF && pBuffer[1] == 0xFE)
    {
      if (Flags & ADT_DETECT_CODEPAGE) *nCodePage=CP_UNICODE_UCS2_LE;
      if (Flags & ADT_DETECT_BOM) *bBOM=TRUE;
    }
    else if (pBuffer[0] == 0xFE && pBuffer[1] == 0xFF)
    {
      if (Flags & ADT_DETECT_CODEPAGE) *nCodePage=CP_UNICODE_UCS2_BE;
      if (Flags & ADT_DETECT_BOM) *bBOM=TRUE;
    }
    else if (pBuffer[0] == 0xEF && pBuffer[1] == 0xBB && pBuffer[2] == 0xBF)
    {
      if (Flags & ADT_DETECT_CODEPAGE) *nCodePage=CP_UNICODE_UTF8;
      if (Flags & ADT_DETECT_BOM) *bBOM=TRUE;
    }
    else if (nUTF)
    {
      *nCodePage=nUTF;
      if (Flags & ADT_DETECT_BOM) *bBOM=FALSE;
    }
    else
    {
      if (Flags & ADT_DETECT_CODEPAGE)
      {
        if (!AutodetectMultibyte(wLangCodepageRecognition, pBuffer, dwBytesRead, nCodePage))
          *nCodePage=nDefaultCodePage;
      }
      if (Flags & ADT_DETECT_BOM) *bBOM=FALSE;
    }
  }

  if (Flags & ADT_BINARY_ERROR || Flags & ADT_DETECT_CODEPAGE || Flags & ADT_DETECT_BOM)
  {
    API_HeapFree(hHeap, 0, (LPVOID)pBuffer);
  }
  return 0;
}

int AutodetectCodePageW(wchar_t *wpFile, DWORD dwBytesToCheck, DWORD Flags, int *nCodePage, BOOL *bBOM)
{
  HANDLE hFile;
  DWORD dwBytesRead;
  DWORD dwCount;
  unsigned char *pBuffer;
  int nUTF=0;
  int i;

  if (!dwBytesToCheck || !Flags) return 0;

  if (Flags & ADT_REG_CODEPAGE)
  {
    if (nRecentFiles)
    {
      RecentFilesZeroW();
      RecentFilesReadW();
    }
    if (nRecentFiles && RecentFilesGetW(wpFile, 0, &i) && i)
    {
      if (nCodePage) *nCodePage=LOWORD(i);
      if (bBOM) *bBOM=HIWORD(i);
      Flags&=~ADT_DETECT_CODEPAGE;
      Flags&=~ADT_DETECT_BOM;
    }
    else
    {
      if (nCodePage) *nCodePage=nDefaultCodePage;
      if (bBOM) *bBOM=bDefaultBOM;
      Flags&=~ADT_REG_CODEPAGE;
      Flags|=ADT_DETECT_CODEPAGE;
      Flags|=ADT_DETECT_BOM;
    }
  }

  if (Flags & ADT_BINARY_ERROR || Flags & ADT_DETECT_CODEPAGE || Flags & ADT_DETECT_BOM)
  {
    if ((hFile=API_CreateFileW(wpFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL)) == INVALID_HANDLE_VALUE)
      return EDT_OPEN;

    if (!(pBuffer=(unsigned char *)API_HeapAlloc(hHeap, 0, dwBytesToCheck + 1)))
    {
      CloseHandle(hFile);
      return EDT_ALLOC;
    }

    if (!API_ReadFileW(hFile, pBuffer, dwBytesToCheck, &dwBytesRead, NULL))
    {
      API_HeapFree(hHeap, 0, (LPVOID)pBuffer);
      CloseHandle(hFile);
      return EDT_READ;
    }
    CloseHandle(hFile);
  }

  if (Flags & ADT_BINARY_ERROR || Flags & ADT_DETECT_CODEPAGE)
  {
    if (dwBytesRead)
    {
      for (dwCount=0, --dwBytesRead; dwCount < dwBytesRead; ++dwCount)
      {
        if (Flags & ADT_BINARY_ERROR)
        {
          if (pBuffer[dwCount] == 0x00 && pBuffer[dwCount + 1] == 0x00)
          {
            API_HeapFree(hHeap, 0, (LPVOID)pBuffer);
            return EDT_BINARY;
          }
        }
        if (Flags & ADT_DETECT_CODEPAGE)
        {
          if (nUTF == 0 && dwCount % 2 == 0)
          {
            if (pBuffer[dwCount] != 0x00 && pBuffer[dwCount + 1] == 0x00)
              nUTF=CP_UNICODE_UCS2_LE;
            else if (pBuffer[dwCount] == 0x00 && pBuffer[dwCount + 1] != 0x00)
              nUTF=CP_UNICODE_UCS2_BE;
          }
        }
      }
    }
  }

  if (Flags & ADT_DETECT_CODEPAGE || Flags & ADT_DETECT_BOM)
  {
    if (pBuffer[0] == 0xFF && pBuffer[1] == 0xFE)
    {
      if (Flags & ADT_DETECT_CODEPAGE) *nCodePage=CP_UNICODE_UCS2_LE;
      if (Flags & ADT_DETECT_BOM) *bBOM=TRUE;
    }
    else if (pBuffer[0] == 0xFE && pBuffer[1] == 0xFF)
    {
      if (Flags & ADT_DETECT_CODEPAGE) *nCodePage=CP_UNICODE_UCS2_BE;
      if (Flags & ADT_DETECT_BOM) *bBOM=TRUE;
    }
    else if (pBuffer[0] == 0xEF && pBuffer[1] == 0xBB && pBuffer[2] == 0xBF)
    {
      if (Flags & ADT_DETECT_CODEPAGE) *nCodePage=CP_UNICODE_UTF8;
      if (Flags & ADT_DETECT_BOM) *bBOM=TRUE;
    }
    else if (nUTF)
    {
      *nCodePage=nUTF;
      if (Flags & ADT_DETECT_BOM) *bBOM=FALSE;
    }
    else
    {
      if (Flags & ADT_DETECT_CODEPAGE)
      {
        if (!AutodetectMultibyte(wLangCodepageRecognition, pBuffer, dwBytesRead, nCodePage))
          *nCodePage=nDefaultCodePage;
      }
      if (Flags & ADT_DETECT_BOM) *bBOM=FALSE;
    }
  }

  if (Flags & ADT_BINARY_ERROR || Flags & ADT_DETECT_CODEPAGE || Flags & ADT_DETECT_BOM)
  {
    API_HeapFree(hHeap, 0, (LPVOID)pBuffer);
  }
  return 0;
}

BOOL AutodetectMultibyte(DWORD dwLangID, unsigned char *pBuffer, DWORD dwBytesToCheck, int *nCodePage)
{
  if (dwLangID == LANGID_RUSSIAN)
  {
    char szANSIwatermark[]="\xEE\xE5\xE0\xE8\xED\xF2\xCE\xC5\xC0\xC8\xD2\x97";
    char szOEMwatermark[]="\xAE\xA5\xA0\xA8\xBA\xCD\xB3\xC4\xB0\xB1\xB2\xDB";
    char szKOIwatermark[]="\xCF\xC5\xC1\xC9\xCE\xD4\xEF\xE5\x80";
    char szUTF8watermark[]="\xD0\xD1";
    int nANSIrate=0;
    int nOEMrate=0;
    int nKOIrate=0;
    int nUTF8rate=0;
    DWORD dwCounter[0x80];
    DWORD dwMaxIndex;
    DWORD dwMaxCount;
    DWORD i;
    DWORD j;

    memset(dwCounter, 0, 0x80 * sizeof(DWORD));

    //Count number of each character in input buffer
    for(j=0, i=0; i < dwBytesToCheck; ++i)
    {
      if (pBuffer[i] >= 0x80 && pBuffer[i] <= 0x100)
      {
        ++j;
        dwCounter[pBuffer[i] - 0x80]++;
      }
    }

    //Give it up if there's no representative selection
    if (j > 15)
    {
      for (j=0; j < 10; ++j)
      {
        //Get max element
        for (dwMaxCount=0, i=0; i < 0x80; ++i)
        {
          if (dwCounter[i] > dwMaxCount)
          {
            dwMaxCount=dwCounter[i];
            dwMaxIndex=i;
          }
        }
        if (!dwCounter[dwMaxIndex]) break;

        if (strchr(szANSIwatermark, dwMaxIndex + 0x80)) nANSIrate+=dwCounter[dwMaxIndex];
        if (strchr(szOEMwatermark, dwMaxIndex + 0x80)) nOEMrate+=dwCounter[dwMaxIndex];
        if (strchr(szKOIwatermark, dwMaxIndex + 0x80)) nKOIrate+=dwCounter[dwMaxIndex];
        if (strchr(szUTF8watermark, dwMaxIndex + 0x80)) nUTF8rate+=dwCounter[dwMaxIndex];
        dwCounter[dwMaxIndex]=0;
      }

      if (nANSIrate >= nOEMrate && nANSIrate >= nKOIrate && nANSIrate >= nUTF8rate)
        *nCodePage=1251;
      else if (nOEMrate >= nKOIrate && nOEMrate >= nUTF8rate)
        *nCodePage=866;
      else if (nKOIrate >= nUTF8rate)
        *nCodePage=CP_KOI8_R;
      else
        *nCodePage=CP_UNICODE_UTF8;
      return TRUE;
    }
  }
  return FALSE;
}

unsigned int UTF8toUTF16(const char *buf, unsigned int *len, wchar_t *tbuf, unsigned int tlen)
{
  const unsigned char *ubuf=(const unsigned char *)buf;
  unsigned int i;
  unsigned int ti;

  for (i=0, ti=0; i < *len && ti < tlen && ubuf[i]; ++ti)
  {
    if (ubuf[i] < 0x80)
    {
      tbuf[ti]=ubuf[i++];
    }
    else if (ubuf[i] < 0x80 + 0x40 + 0x20)
    {
      tbuf[ti]=(ubuf[i++] & 0x1F) << 6;
      if (i >= *len || !ubuf[i]) {*len=i - 1; return ti;}
      tbuf[ti]=tbuf[ti] + (ubuf[i++] & 0x7F);
    }
    else
    {
      tbuf[ti]=(ubuf[i++] & 0xF) << 12;
      if (i >= *len || !ubuf[i]) {*len=i - 1; return ti;}
      tbuf[ti]=tbuf[ti] + ((ubuf[i++] & 0x7F) << 6);
      if (i >= *len || !ubuf[i]) {*len=i - 2; return ti;}
      tbuf[ti]=tbuf[ti] + (ubuf[i++] & 0x7F);
    }
  }
  if (i < *len && ti < tlen)
    tbuf[ti++]='\0';
  *len=i;
  return ti;
}

unsigned int UTF16toUTF8(const wchar_t *tbuf, unsigned int tlen, char *buf, unsigned int len)
{
  unsigned char *ubuf=(unsigned char *)buf;
  unsigned int i;
  unsigned int ti;

  for (i=0, ti=0; ti < tlen && tbuf[ti]; ++ti)
  {
    if (tbuf[ti] < 0x80)
    {
      if (i + 1 > len) return i;
      ubuf[i++]=(unsigned char)tbuf[ti];
    }
    else if (tbuf[ti] < 0x800)
    {
      if (i + 2 > len) return i;
      ubuf[i++]=0xC0|((tbuf[ti] >> 6) & 0x1F);
      ubuf[i++]=0x80|(tbuf[ti] & 0x3F);
    }
    else
    {
      if (i + 3 > len) return i;
      ubuf[i++]=0xE0|((tbuf[ti] >> 12) & 0xF);
      ubuf[i++]=0x80|((tbuf[ti] >> 6) & 0x3F);
      ubuf[i++]=0x80|(tbuf[ti] & 0x3F);
    }
  }
  if (ti < tlen)
    ubuf[i++]='\0';
  return i;
}

void ChangeByteOrder(unsigned char *buf, unsigned int len)
{
  unsigned char ch;
  unsigned int a;
  unsigned int b;

  for (a=0, b=1; a < len; a+=2, b+=2)
  {
    ch=buf[a];
    buf[a]=buf[b];
    buf[b]=ch;
  }
}

unsigned int TranslateNewLinesToUnixW(wchar_t *tbuf, unsigned int *tlen)
{
  unsigned int a;
  unsigned int b;

  for (a=0, b=0; a < *tlen && tbuf[a]; ++a, ++b)
  {
    if (tbuf[a] == '\r' && tbuf[a + 1] == '\n') ++a;

    tbuf[b]=tbuf[a];
  }
  *tlen=a;
  return b;
}


//// Find/Replace
BOOL CALLBACK FindAndReplaceDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndFind;
  static HWND hWndReplace;
  static HWND hWndMatchCase;
  static HWND hWndWholeWord;
  static HWND hWndEscapeSeq;
  static HWND hWndForward;
  static HWND hWndBackward;
  static HWND hWndBeginning;
  static HWND hWndInSelection;
  static HWND hWndAllFiles;
  static HWND hWndAllFilesGroup;
  static HWND hWndFindNextButton;
  static HWND hWndReplaceButton;
  static HWND hWndReplaceAllButton;
  static HWND hWndCancelButton;
  static BOOL bCanReplace=TRUE;
  static BOOL bSpecialCheck=FALSE;
  BOOL bStates[16];
  char *szData;
  BOOL bReplace=FALSE;
  BOOL bReplaceAll=FALSE;
  int nResult;
  int i;

  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    hWndFind=GetDlgItem(hDlg, IDC_SEARCH_FIND);
    hWndFindNextButton=GetDlgItem(hDlg, IDC_SEARCH_FIND_BUTTON);
    hWndCancelButton=GetDlgItem(hDlg, IDCANCEL);
    hWndMatchCase=GetDlgItem(hDlg, IDC_SEARCH_MATCHCASE);
    hWndWholeWord=GetDlgItem(hDlg, IDC_SEARCH_WHOLEWORD);
    hWndEscapeSeq=GetDlgItem(hDlg, IDC_SEARCH_ESCAPESEQ);
    hWndForward=GetDlgItem(hDlg, IDC_SEARCH_FORWARD);
    hWndBackward=GetDlgItem(hDlg, IDC_SEARCH_BACKWARD);
    hWndBeginning=GetDlgItem(hDlg, IDC_SEARCH_BEGINNING);
    if (bReplaceDlg == TRUE)
    {
      hWndReplace=GetDlgItem(hDlg, IDC_SEARCH_REPLACE);
      hWndReplaceButton=GetDlgItem(hDlg, IDC_SEARCH_REPLACE_BUTTON);
      hWndReplaceAllButton=GetDlgItem(hDlg, IDC_SEARCH_ALL_BUTTON);
      hWndInSelection=GetDlgItem(hDlg, IDC_SEARCH_INSEL);
    }
    hWndAllFiles=GetDlgItem(hDlg, IDC_SEARCH_ALLFILES);
    hWndAllFilesGroup=GetDlgItem(hDlg, IDC_SEARCH_ALLFILES_GROUP);

    FillComboboxSearchA(hWndFind, hWndReplace);

    if (chrg.cpMin == chrg.cpMax || (ftflags & FR_SELECTION))
    {
      SendMessage(hWndFind, CB_SETCURSEL, 0, 0);
    }
    else
    {
      if (GetSelTextA(hWndEdit, &szData))
      {
        SetWindowText(hWndFind, szData);
        FreeSelText((LPVOID)szData);
      }
    }
    if (!bMDI)
    {
      ShowWindow(hWndAllFiles, SW_HIDE);
      ShowWindow(hWndAllFilesGroup, SW_HIDE);
    }
    if (bReplaceDlg == TRUE) SendMessage(hWndReplace, CB_SETCURSEL, 0, 0);

    if ((ftflags & FR_DOWN) && !(ftflags & FR_BEGINNING) && !(ftflags & FR_SELECTION))
      SendMessage(hWndForward, BM_SETCHECK, BST_CHECKED, 0);
    else if (ftflags & FR_UP)
      SendMessage(hWndBackward, BM_SETCHECK, BST_CHECKED, 0);
    else if ((ftflags & FR_BEGINNING) && !(ftflags & FR_ALLFILES))
      SendMessage(hWndBeginning, BM_SETCHECK, BST_CHECKED, 0);
    else if (ftflags & FR_SELECTION)
    {
      SendMessage(hWndInSelection, BM_SETCHECK, BST_CHECKED, 0);
      EnableWindow(hWndFindNextButton, FALSE);
      EnableWindow(hWndReplaceButton, FALSE);
    }
    else if (ftflags & FR_ALLFILES)
      SendMessage(hWndAllFiles, BM_SETCHECK, BST_CHECKED, 0);

    SendMessage(hWndMatchCase, BM_SETCHECK, (BOOL)(ftflags & FR_MATCHCASE), 0);
    SendMessage(hWndWholeWord, BM_SETCHECK, (BOOL)(ftflags & FR_WHOLEWORD), 0);
    SendMessage(hWndEscapeSeq, BM_SETCHECK, (BOOL)(ftflags & FR_ESCAPESEQ), 0);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_SEARCH_REPLACE)
      return TRUE;
    else if (LOWORD(wParam) == IDC_SEARCH_MATCHCASE)
    {
      if (SendMessage(hWndMatchCase, BM_GETCHECK, 0, 0)) ftflags|=FR_MATCHCASE;
      else ftflags&=~FR_MATCHCASE;
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_WHOLEWORD)
    {
      if (SendMessage(hWndWholeWord, BM_GETCHECK, 0, 0)) ftflags|=FR_WHOLEWORD;
      else ftflags&=~FR_WHOLEWORD;
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_ESCAPESEQ)
    {
      if (SendMessage(hWndEscapeSeq, BM_GETCHECK, 0, 0)) ftflags|=FR_ESCAPESEQ;
      else ftflags&=~FR_ESCAPESEQ;
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_FORWARD)
    {
      ftflags&=~FR_UP&~FR_BEGINNING&~FR_SELECTION&~FR_ALLFILES;
      ftflags|=FR_DOWN;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_BACKWARD)
    {
      ftflags&=~FR_DOWN&~FR_BEGINNING&~FR_SELECTION&~FR_ALLFILES;
      ftflags|=FR_UP;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_BEGINNING)
    {
      ftflags&=~FR_UP&~FR_SELECTION&~FR_ALLFILES;
      ftflags|=FR_DOWN|FR_BEGINNING;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_INSEL)
    {
      ftflags&=~FR_UP&~FR_BEGINNING&~FR_ALLFILES;
      ftflags|=FR_DOWN|FR_SELECTION;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_ALLFILES)
    {
      ftflags&=~FR_UP&~FR_SELECTION;
      ftflags|=FR_DOWN|FR_BEGINNING|FR_ALLFILES;
    }
    if (LOWORD(wParam) == IDC_SEARCH_FIND ||
        LOWORD(wParam) == IDC_SEARCH_FORWARD ||
        LOWORD(wParam) == IDC_SEARCH_BACKWARD ||
        LOWORD(wParam) == IDC_SEARCH_BEGINNING ||
        LOWORD(wParam) == IDC_SEARCH_INSEL ||
        LOWORD(wParam) == IDC_SEARCH_ALLFILES)
    {
      EnableWindow(hWndFindNextButton, TRUE);
      if (bReplaceDlg == TRUE)
      {
        EnableWindow(hWndReplaceButton, TRUE);
        EnableWindow(hWndReplaceAllButton, TRUE);
      }
      if (LOWORD(wParam) != IDC_SEARCH_FIND)
      {
        bSpecialCheck=FALSE;
        SendMessage(hWndBeginning, BM_SETSTATE, FALSE, 0);
        if (bMDI) SendMessage(hWndAllFiles, BM_SETSTATE, FALSE, 0);
      }

      if (HIWORD(wParam) == CBN_SELCHANGE)
      {
        i=SendMessage(hWndFind, CB_GETLBTEXTLEN, (WPARAM)SendMessage(hWndFind, CB_GETCURSEL, 0, 0), 0);
      }
      else
      {
        i=GetWindowTextLengthA(hWndFind);
      }

      if (i == 0)
      {
        EnableWindow(hWndFindNextButton, FALSE);
        if (bReplaceDlg == TRUE)
        {
          EnableWindow(hWndReplaceButton, FALSE);
          EnableWindow(hWndReplaceAllButton, FALSE);
        }
      }
      else if (bReplaceDlg == TRUE)
      {
        if (ftflags & FR_SELECTION)
        {
          EnableWindow(hWndFindNextButton, FALSE);
          EnableWindow(hWndReplaceButton, FALSE);
        }
      }
      return TRUE;
    }
    else if (LOWORD(wParam) == IDCANCEL)
    {
      if (bSpecialCheck == TRUE || (ftflags & FR_ALLFILES)) ftflags|=FR_BEGINNING;
      SaveComboboxSearchA(hWndFind, hWndReplace);
      DestroyWindow(hDlg);
      hDlgModeless=0;
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_REPLACE_BUTTON)
    {
      bReplace=TRUE;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_ALL_BUTTON)
    {
      bReplaceAll=TRUE;
    }
    if (LOWORD(wParam) == IDC_SEARCH_FIND_BUTTON ||
        LOWORD(wParam) == IDC_SEARCH_REPLACE_BUTTON ||
        LOWORD(wParam) == IDC_SEARCH_ALL_BUTTON)
    {
      FreeMemorySearchA();

      if (!GetComboboxSearchTextA(hWndFind, &szFind_orig, &szFind))
      {
        FreeMemorySearchA();
        return TRUE;
      }

      if (bReplaceDlg == TRUE)
      {
        if (!GetComboboxSearchTextA(hWndReplace, &szReplace_orig, &szReplace))
        {
          FreeMemorySearchA();
          return TRUE;
        }
      }

      if (bReplaceAll)
      {
        bStates[0]=EnableWindow(hWndFind, FALSE);
        bStates[1]=EnableWindow(hWndReplace, FALSE);
        bStates[2]=EnableWindow(hWndMatchCase, FALSE);
        bStates[3]=EnableWindow(hWndWholeWord, FALSE);
        bStates[4]=EnableWindow(hWndEscapeSeq, FALSE);
        bStates[5]=EnableWindow(hWndForward, FALSE);
        bStates[6]=EnableWindow(hWndBackward, FALSE);
        bStates[7]=EnableWindow(hWndBeginning, FALSE);
        bStates[8]=EnableWindow(hWndInSelection, FALSE);
        bStates[9]=EnableWindow(hWndAllFiles, FALSE);
        bStates[10]=EnableWindow(hWndFindNextButton, FALSE);
        bStates[11]=EnableWindow(hWndReplaceButton, FALSE);
        bStates[12]=EnableWindow(hWndReplaceAllButton, FALSE);
        SetFocus(hWndCancelButton);
      }

      if (ftflags & FR_ALLFILES)
      {
        HWND hWndTmp=hWndMdiActive;
        int nChanges=0;
        int nChangedFiles=0;

        if (bReplaceDlg == TRUE && bReplaceAll == TRUE)
        {
          ftflags|=FR_BEGINNING;
          if (bSpecialCheck == TRUE)
          {
            bSpecialCheck=FALSE;
            SendMessage(hWndAllFiles, BM_SETSTATE, FALSE, 0);
          }

          do
          {
            ReplaceTextA(hWndEdit, TRUE);
            if (!hDlgModeless) break;

            if (nReplaceCount)
            {
              ++nChangedFiles;
              nChanges+=nReplaceCount;
            }
            SendMessage(hMdiClient, WM_MDINEXT, (WPARAM)hWndMdiActive, FALSE);
          }
          while (hWndMdiActive != hWndTmp);

          API_LoadStringA(hLangLib, MSG_REPLACE_COUNT_ALLFILES, buf, BUFFER_SIZE);
          wsprintf(buf2, buf, nChangedFiles, nChanges);
          MessageBox(hDlg, buf2, APP_MAIN_TITLE, MB_OK|MB_ICONINFORMATION);
        }
        else
        {
          if (bSpecialCheck == FALSE)
          {
            bSpecialCheck=TRUE;
            SendMessage(hWndAllFiles, BM_SETSTATE, TRUE, 0);
          }

          do
          {
            if (bReplace == TRUE && bCanReplace == TRUE)
              nResult=ReplaceTextA(hWndEdit, FALSE);
            else
              nResult=FindTextA(hWndEdit);

            if (nResult == -1)
            {
              bCanReplace=FALSE;
              ftflags|=FR_BEGINNING;
              SendMessage(hMdiClient, WM_MDINEXT, (WPARAM)hWndMdiActive, FALSE);
            }
            else
            {
              bCanReplace=TRUE;
              ftflags&=~FR_BEGINNING;
              break;
            }
          }
          while (hWndMdiActive != hWndTmp);

          if (nResult == -1)
          {
            bSpecialCheck=FALSE;
            SendMessage(hWndAllFiles, BM_SETSTATE, FALSE, 0);
            API_LoadStringA(hLangLib, MSG_SEARCH_ENDED, buf, BUFFER_SIZE);
            MessageBox(hDlg, buf, APP_MAIN_TITLE, MB_OK|MB_ICONINFORMATION);
          }
        }
      }
      else
      {
        if (bReplaceDlg == TRUE && (bReplace == TRUE || bReplaceAll == TRUE))
          nResult=ReplaceTextA(hWndEdit, bReplaceAll);
        else
          nResult=FindTextA(hWndEdit);

        if (nResult == -1)
        {
          if (bSpecialCheck == TRUE)
          {
            ftflags|=FR_BEGINNING;
            bSpecialCheck=FALSE;
            SendMessage(hWndBeginning, BM_SETSTATE, FALSE, 0);
          }
          if (bReplaceAll == TRUE)
          {
            API_LoadStringA(hLangLib, MSG_REPLACE_COUNT, buf, BUFFER_SIZE);
            wsprintf(buf2, buf, nReplaceCount);
            MessageBox(hDlg, buf2, APP_MAIN_TITLE, MB_OK|MB_ICONINFORMATION);
          }
          else
          {
            API_LoadStringA(hLangLib, MSG_SEARCH_ENDED, buf, BUFFER_SIZE);
            MessageBox(hDlg, buf, APP_MAIN_TITLE, MB_OK|MB_ICONINFORMATION);
          }
        }
        else
        {
          if (ftflags & FR_BEGINNING)
          {
            ftflags&=~FR_BEGINNING;
            bSpecialCheck=TRUE;
            SendMessage(hWndBeginning, BM_SETSTATE, TRUE, 0);
          }
        }
      }

      if (bReplaceAll)
      {
        EnableWindow(hWndFind, !bStates[0]);
        EnableWindow(hWndReplace, !bStates[1]);
        EnableWindow(hWndMatchCase, !bStates[2]);
        EnableWindow(hWndWholeWord, !bStates[3]);
        EnableWindow(hWndEscapeSeq, !bStates[4]);
        EnableWindow(hWndForward, !bStates[5]);
        EnableWindow(hWndBackward, !bStates[6]);
        EnableWindow(hWndBeginning, !bStates[7]);
        EnableWindow(hWndInSelection, !bStates[8]);
        EnableWindow(hWndAllFiles, !bStates[9]);
        EnableWindow(hWndFindNextButton, !bStates[10]);
        EnableWindow(hWndReplaceButton, !bStates[11]);
        EnableWindow(hWndReplaceAllButton, !bStates[12]);
      }
      return TRUE;
    }
  }
  return FALSE;
}

BOOL CALLBACK FindAndReplaceDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndFind;
  static HWND hWndReplace;
  static HWND hWndMatchCase;
  static HWND hWndWholeWord;
  static HWND hWndEscapeSeq;
  static HWND hWndForward;
  static HWND hWndBackward;
  static HWND hWndBeginning;
  static HWND hWndInSelection;
  static HWND hWndAllFiles;
  static HWND hWndAllFilesGroup;
  static HWND hWndFindNextButton;
  static HWND hWndReplaceButton;
  static HWND hWndReplaceAllButton;
  static HWND hWndCancelButton;
  static BOOL bCanReplace=TRUE;
  static BOOL bSpecialCheck=FALSE;
  BOOL bStates[16];
  wchar_t *wszData;
  BOOL bReplace=FALSE;
  BOOL bReplaceAll=FALSE;
  int nResult;
  int i;

  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    hWndFind=GetDlgItem(hDlg, IDC_SEARCH_FIND);
    hWndFindNextButton=GetDlgItem(hDlg, IDC_SEARCH_FIND_BUTTON);
    hWndCancelButton=GetDlgItem(hDlg, IDCANCEL);
    hWndMatchCase=GetDlgItem(hDlg, IDC_SEARCH_MATCHCASE);
    hWndWholeWord=GetDlgItem(hDlg, IDC_SEARCH_WHOLEWORD);
    hWndEscapeSeq=GetDlgItem(hDlg, IDC_SEARCH_ESCAPESEQ);
    hWndForward=GetDlgItem(hDlg, IDC_SEARCH_FORWARD);
    hWndBackward=GetDlgItem(hDlg, IDC_SEARCH_BACKWARD);
    hWndBeginning=GetDlgItem(hDlg, IDC_SEARCH_BEGINNING);
    if (bReplaceDlg == TRUE)
    {
      hWndReplace=GetDlgItem(hDlg, IDC_SEARCH_REPLACE);
      hWndReplaceButton=GetDlgItem(hDlg, IDC_SEARCH_REPLACE_BUTTON);
      hWndReplaceAllButton=GetDlgItem(hDlg, IDC_SEARCH_ALL_BUTTON);
      hWndInSelection=GetDlgItem(hDlg, IDC_SEARCH_INSEL);
    }
    hWndAllFiles=GetDlgItem(hDlg, IDC_SEARCH_ALLFILES);
    hWndAllFilesGroup=GetDlgItem(hDlg, IDC_SEARCH_ALLFILES_GROUP);

    FillComboboxSearchW(hWndFind, hWndReplace);

    if (chrg.cpMin == chrg.cpMax || (ftflags & FR_SELECTION))
    {
      SendMessage(hWndFind, CB_SETCURSEL, 0, 0);
    }
    else
    {
      if (GetSelTextW(hWndEdit, &wszData))
      {
        SetWindowTextW(hWndFind, wszData);
        FreeSelText((LPVOID)wszData);
      }
    }
    if (!bMDI)
    {
      ShowWindow(hWndAllFiles, SW_HIDE);
      ShowWindow(hWndAllFilesGroup, SW_HIDE);
    }
    if (bReplaceDlg == TRUE) SendMessage(hWndReplace, CB_SETCURSEL, 0, 0);

    if ((ftflags & FR_DOWN) && !(ftflags & FR_BEGINNING) && !(ftflags & FR_SELECTION))
      SendMessage(hWndForward, BM_SETCHECK, BST_CHECKED, 0);
    else if (ftflags & FR_UP)
      SendMessage(hWndBackward, BM_SETCHECK, BST_CHECKED, 0);
    else if ((ftflags & FR_BEGINNING) && !(ftflags & FR_ALLFILES))
      SendMessage(hWndBeginning, BM_SETCHECK, BST_CHECKED, 0);
    else if (ftflags & FR_SELECTION)
    {
      SendMessage(hWndInSelection, BM_SETCHECK, BST_CHECKED, 0);
      EnableWindow(hWndFindNextButton, FALSE);
      EnableWindow(hWndReplaceButton, FALSE);
    }
    else if (ftflags & FR_ALLFILES)
      SendMessage(hWndAllFiles, BM_SETCHECK, BST_CHECKED, 0);

    SendMessage(hWndMatchCase, BM_SETCHECK, (BOOL)(ftflags & FR_MATCHCASE), 0);
    SendMessage(hWndWholeWord, BM_SETCHECK, (BOOL)(ftflags & FR_WHOLEWORD), 0);
    SendMessage(hWndEscapeSeq, BM_SETCHECK, (BOOL)(ftflags & FR_ESCAPESEQ), 0);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_SEARCH_REPLACE)
      return TRUE;
    else if (LOWORD(wParam) == IDC_SEARCH_MATCHCASE)
    {
      if (SendMessage(hWndMatchCase, BM_GETCHECK, 0, 0)) ftflags|=FR_MATCHCASE;
      else ftflags&=~FR_MATCHCASE;
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_WHOLEWORD)
    {
      if (SendMessage(hWndWholeWord, BM_GETCHECK, 0, 0)) ftflags|=FR_WHOLEWORD;
      else ftflags&=~FR_WHOLEWORD;
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_ESCAPESEQ)
    {
      if (SendMessage(hWndEscapeSeq, BM_GETCHECK, 0, 0)) ftflags|=FR_ESCAPESEQ;
      else ftflags&=~FR_ESCAPESEQ;
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_FORWARD)
    {
      ftflags&=~FR_UP&~FR_BEGINNING&~FR_SELECTION&~FR_ALLFILES;
      ftflags|=FR_DOWN;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_BACKWARD)
    {
      ftflags&=~FR_DOWN&~FR_BEGINNING&~FR_SELECTION&~FR_ALLFILES;
      ftflags|=FR_UP;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_BEGINNING)
    {
      ftflags&=~FR_UP&~FR_SELECTION&~FR_ALLFILES;
      ftflags|=FR_DOWN|FR_BEGINNING;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_INSEL)
    {
      ftflags&=~FR_UP&~FR_BEGINNING&~FR_ALLFILES;
      ftflags|=FR_DOWN|FR_SELECTION;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_ALLFILES)
    {
      ftflags&=~FR_UP&~FR_SELECTION;
      ftflags|=FR_DOWN|FR_BEGINNING|FR_ALLFILES;
    }
    if (LOWORD(wParam) == IDC_SEARCH_FIND ||
        LOWORD(wParam) == IDC_SEARCH_FORWARD ||
        LOWORD(wParam) == IDC_SEARCH_BACKWARD ||
        LOWORD(wParam) == IDC_SEARCH_BEGINNING ||
        LOWORD(wParam) == IDC_SEARCH_INSEL ||
        LOWORD(wParam) == IDC_SEARCH_ALLFILES)
    {
      EnableWindow(hWndFindNextButton, TRUE);
      if (bReplaceDlg == TRUE)
      {
        EnableWindow(hWndReplaceButton, TRUE);
        EnableWindow(hWndReplaceAllButton, TRUE);
      }
      if (LOWORD(wParam) != IDC_SEARCH_FIND)
      {
        bSpecialCheck=FALSE;
        SendMessage(hWndBeginning, BM_SETSTATE, FALSE, 0);
        if (bMDI) SendMessage(hWndAllFiles, BM_SETSTATE, FALSE, 0);
      }

      if (HIWORD(wParam) == CBN_SELCHANGE)
      {
        i=SendMessageW(hWndFind, CB_GETLBTEXTLEN, (WPARAM)SendMessage(hWndFind, CB_GETCURSEL, 0, 0), 0);
      }
      else
      {
        i=GetWindowTextLengthW(hWndFind);
      }

      if (i == 0)
      {
        EnableWindow(hWndFindNextButton, FALSE);
        if (bReplaceDlg == TRUE)
        {
          EnableWindow(hWndReplaceButton, FALSE);
          EnableWindow(hWndReplaceAllButton, FALSE);
        }
      }
      else if (bReplaceDlg == TRUE)
      {
        if (ftflags & FR_SELECTION)
        {
          EnableWindow(hWndFindNextButton, FALSE);
          EnableWindow(hWndReplaceButton, FALSE);
        }
      }
      return TRUE;
    }
    else if (LOWORD(wParam) == IDCANCEL)
    {
      if (bSpecialCheck == TRUE || (ftflags & FR_ALLFILES)) ftflags|=FR_BEGINNING;
      SaveComboboxSearchW(hWndFind, hWndReplace);
      DestroyWindow(hDlg);
      hDlgModeless=0;
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_REPLACE_BUTTON)
    {
      bReplace=TRUE;
    }
    else if (LOWORD(wParam) == IDC_SEARCH_ALL_BUTTON)
    {
      bReplaceAll=TRUE;
    }
    if (LOWORD(wParam) == IDC_SEARCH_FIND_BUTTON ||
        LOWORD(wParam) == IDC_SEARCH_REPLACE_BUTTON ||
        LOWORD(wParam) == IDC_SEARCH_ALL_BUTTON)
    {
      FreeMemorySearchW();

      if (!GetComboboxSearchTextW(hWndFind, &wszFind_orig, &wszFind))
      {
        FreeMemorySearchW();
        return TRUE;
      }

      if (bReplaceDlg == TRUE)
      {
        if (!GetComboboxSearchTextW(hWndReplace, &wszReplace_orig, &wszReplace))
        {
          FreeMemorySearchW();
          return TRUE;
        }
      }

      if (bReplaceAll)
      {
        bStates[0]=EnableWindow(hWndFind, FALSE);
        bStates[1]=EnableWindow(hWndReplace, FALSE);
        bStates[2]=EnableWindow(hWndMatchCase, FALSE);
        bStates[3]=EnableWindow(hWndWholeWord, FALSE);
        bStates[4]=EnableWindow(hWndEscapeSeq, FALSE);
        bStates[5]=EnableWindow(hWndForward, FALSE);
        bStates[6]=EnableWindow(hWndBackward, FALSE);
        bStates[7]=EnableWindow(hWndBeginning, FALSE);
        bStates[8]=EnableWindow(hWndInSelection, FALSE);
        bStates[9]=EnableWindow(hWndAllFiles, FALSE);
        bStates[10]=EnableWindow(hWndFindNextButton, FALSE);
        bStates[11]=EnableWindow(hWndReplaceButton, FALSE);
        bStates[12]=EnableWindow(hWndReplaceAllButton, FALSE);
        SetFocus(hWndCancelButton);
      }

      if (ftflags & FR_ALLFILES)
      {
        HWND hWndTmp=hWndMdiActive;
        int nChanges=0;
        int nChangedFiles=0;

        if (bReplaceDlg == TRUE && bReplaceAll == TRUE)
        {
          ftflags|=FR_BEGINNING;
          if (bSpecialCheck == TRUE)
          {
            bSpecialCheck=FALSE;
            SendMessage(hWndAllFiles, BM_SETSTATE, FALSE, 0);
          }

          do
          {
            ReplaceTextW(hWndEdit, TRUE);
            if (!hDlgModeless) break;

            if (nReplaceCount)
            {
              ++nChangedFiles;
              nChanges+=nReplaceCount;
            }
            SendMessage(hMdiClient, WM_MDINEXT, (WPARAM)hWndMdiActive, FALSE);
          }
          while (hWndMdiActive != hWndTmp);

          API_LoadStringW(hLangLib, MSG_REPLACE_COUNT_ALLFILES, wbuf, BUFFER_SIZE);
          wsprintfW(wbuf2, wbuf, nChangedFiles, nChanges);
          MessageBoxW(hDlg, wbuf2, APP_MAIN_TITLEW, MB_OK|MB_ICONINFORMATION);
        }
        else
        {
          if (bSpecialCheck == FALSE)
          {
            bSpecialCheck=TRUE;
            SendMessage(hWndAllFiles, BM_SETSTATE, TRUE, 0);
          }

          do
          {
            if (bReplace == TRUE && bCanReplace == TRUE)
              nResult=ReplaceTextW(hWndEdit, FALSE);
            else
              nResult=FindTextW(hWndEdit);

            if (nResult == -1)
            {
              bCanReplace=FALSE;
              ftflags|=FR_BEGINNING;
              SendMessage(hMdiClient, WM_MDINEXT, (WPARAM)hWndMdiActive, FALSE);
            }
            else
            {
              bCanReplace=TRUE;
              ftflags&=~FR_BEGINNING;
              break;
            }
          }
          while (hWndMdiActive != hWndTmp);

          if (nResult == -1)
          {
            bSpecialCheck=FALSE;
            SendMessage(hWndAllFiles, BM_SETSTATE, FALSE, 0);
            API_LoadStringW(hLangLib, MSG_SEARCH_ENDED, wbuf, BUFFER_SIZE);
            MessageBoxW(hDlg, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONINFORMATION);
          }
        }
      }
      else
      {
        if (bReplaceDlg == TRUE && (bReplace == TRUE || bReplaceAll == TRUE))
          nResult=ReplaceTextW(hWndEdit, bReplaceAll);
        else
          nResult=FindTextW(hWndEdit);

        if (nResult == -1)
        {
          if (bSpecialCheck == TRUE)
          {
            ftflags|=FR_BEGINNING;
            bSpecialCheck=FALSE;
            SendMessage(hWndBeginning, BM_SETSTATE, FALSE, 0);
          }
          if (bReplaceAll == TRUE)
          {
            API_LoadStringW(hLangLib, MSG_REPLACE_COUNT, wbuf, BUFFER_SIZE);
            wsprintfW(wbuf2, wbuf, nReplaceCount);
            MessageBoxW(hDlg, wbuf2, APP_MAIN_TITLEW, MB_OK|MB_ICONINFORMATION);
          }
          else
          {
            API_LoadStringW(hLangLib, MSG_SEARCH_ENDED, wbuf, BUFFER_SIZE);
            MessageBoxW(hDlg, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONINFORMATION);
          }
        }
        else
        {
          if (ftflags & FR_BEGINNING)
          {
            ftflags&=~FR_BEGINNING;
            bSpecialCheck=TRUE;
            SendMessage(hWndBeginning, BM_SETSTATE, TRUE, 0);
          }
        }
      }

      if (bReplaceAll)
      {
        EnableWindow(hWndFind, !bStates[0]);
        EnableWindow(hWndReplace, !bStates[1]);
        EnableWindow(hWndMatchCase, !bStates[2]);
        EnableWindow(hWndWholeWord, !bStates[3]);
        EnableWindow(hWndEscapeSeq, !bStates[4]);
        EnableWindow(hWndForward, !bStates[5]);
        EnableWindow(hWndBackward, !bStates[6]);
        EnableWindow(hWndBeginning, !bStates[7]);
        EnableWindow(hWndInSelection, !bStates[8]);
        EnableWindow(hWndAllFiles, !bStates[9]);
        EnableWindow(hWndFindNextButton, !bStates[10]);
        EnableWindow(hWndReplaceButton, !bStates[11]);
        EnableWindow(hWndReplaceAllButton, !bStates[12]);
      }
      return TRUE;
    }
  }
  return FALSE;
}

void FillComboboxSearchA(HWND hWndFind, HWND hWndReplace)
{
  HWND hWnd;
  HKEY hKey;
  DWORD dwType;
  DWORD dwSize;
  int i;
  char szRegValue[32];
  char *szData;

  if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad\\Search", 0, KEY_READ, &hKey) != ERROR_SUCCESS)
    return;

  hWnd=hWndFind;
  lstrcpy(buf, "find%d");

  Read:
  for (i=0; i < nSearchStrings; ++i)
  {
    wsprintf(szRegValue, buf, i);

    if (RegQueryValueEx(hKey, szRegValue, NULL, &dwType, NULL, &dwSize) == ERROR_SUCCESS && dwSize > 0)
    {
      if (szData=(char *)API_HeapAlloc(hHeap, 0, dwSize + 1))
      {
        if (RegQueryValueEx(hKey, szRegValue, NULL, &dwType, (LPBYTE)szData, &dwSize) == ERROR_SUCCESS)
        {
          SendMessage(hWnd, CB_ADDSTRING, 0, (LPARAM)szData);
          API_HeapFree(hHeap, 0, (LPVOID)szData);
          continue;
        }
      }
    }
    break;
  }
  if (bReplaceDlg && hWnd != hWndReplace)
  {
    hWnd=hWndReplace;
    lstrcpy(buf, "replace%d");
    goto Read;
  }
  RegCloseKey(hKey);
}

void FillComboboxSearchW(HWND hWndFind, HWND hWndReplace)
{
  HWND hWnd;
  HKEY hKey;
  DWORD dwType;
  DWORD dwSize;
  int i;
  wchar_t wszRegValue[32];
  wchar_t *wszData;

  if (RegOpenKeyExW(HKEY_CURRENT_USER, L"Software\\Akelsoft\\AkelPad\\Search", 0, KEY_READ, &hKey) != ERROR_SUCCESS)
    return;

  hWnd=hWndFind;
  lstrcpyW(wbuf, L"find%d");

  ReadW:
  for (i=0; i < nSearchStrings; ++i)
  {
    wsprintfW(wszRegValue, wbuf, i);

    if (RegQueryValueExW(hKey, wszRegValue, NULL, &dwType, NULL, &dwSize) == ERROR_SUCCESS && dwSize > 0)
    {
      if (wszData=(wchar_t *)API_HeapAlloc(hHeap, 0, dwSize + 2))
      {
        if (RegQueryValueExW(hKey, wszRegValue, NULL, &dwType, (LPBYTE)wszData, &dwSize) == ERROR_SUCCESS)
        {
          SendMessageW(hWnd, CB_ADDSTRING, 0, (LPARAM)wszData);
          API_HeapFree(hHeap, 0, (LPVOID)wszData);
          continue;
        }
      }
    }
    break;
  }
  if (bReplaceDlg && hWnd != hWndReplace)
  {
    hWnd=hWndReplace;
    lstrcpyW(wbuf, L"replace%d");
    goto ReadW;
  }
  RegCloseKey(hKey);
}

BOOL GetComboboxSearchTextA(HWND hWnd, char **szText_orig, char **szText)
{
  int nIndex;
  int nTextLen;
  int nItemLen;

  nTextLen=GetWindowTextLengthA(hWnd) + 1;

  if (*szText_orig=*szText=(char *)API_HeapAlloc(hHeap, 0, nTextLen + 1))
  {
    GetWindowText(hWnd, *szText_orig, nTextLen);

    if (nSearchStrings)
    {
      if (**szText_orig)
      {
        if ((nIndex=SendMessage(hWnd, CB_FINDSTRINGEXACT, 0, (LPARAM)*szText_orig)) != CB_ERR)
          SendMessage(hWnd, CB_DELETESTRING, (WPARAM)nIndex, 0);
      }
      else
      {
        for (nIndex=0; (nItemLen=SendMessage(hWnd, CB_GETLBTEXTLEN, nIndex, 0)) != CB_ERR && nItemLen; ++nIndex);
        if (!nItemLen) SendMessage(hWnd, CB_DELETESTRING, (WPARAM)nIndex, 0);
      }
      SendMessage(hWnd, CB_DELETESTRING, nSearchStrings - 1, 0);
      SendMessage(hWnd, CB_INSERTSTRING, 0, (LPARAM)*szText_orig);
      SendMessage(hWnd, CB_SETCURSEL, 0, 0);
    }

    if (ftflags & FR_ESCAPESEQ)
    {
      if (*szText=(char *)API_HeapAlloc(hHeap, 0, nTextLen + 1))
      {
        if (!EscapeStringToEscapeDataA(*szText_orig, *szText))
        {
          API_LoadStringA(hLangLib, MSG_ERROR_SYNTAX, buf, BUFFER_SIZE);
          MessageBox(GetParent(hWnd), buf, APP_MAIN_TITLE, MB_OK|MB_ICONERROR);
          return FALSE;
        }
      }
      else return FALSE;
    }
  }
  else return FALSE;

  return TRUE;
}

BOOL GetComboboxSearchTextW(HWND hWnd, wchar_t **wszText_orig, wchar_t **wszText)
{
  int nIndex;
  int nTextLen;
  int nItemLen;

  nTextLen=GetWindowTextLengthW(hWnd) + 1;

  if (*wszText_orig=*wszText=(wchar_t *)API_HeapAlloc(hHeap, 0, nTextLen * sizeof(wchar_t) + 2))
  {
    GetWindowTextW(hWnd, *wszText_orig, nTextLen);

    if (nSearchStrings)
    {
      if (**wszText_orig)
      {
        if ((nIndex=SendMessageW(hWnd, CB_FINDSTRINGEXACT, 0, (LPARAM)*wszText_orig)) != CB_ERR)
          SendMessage(hWnd, CB_DELETESTRING, (WPARAM)nIndex, 0);
      }
      else
      {
        for (nIndex=0; (nItemLen=SendMessageW(hWnd, CB_GETLBTEXTLEN, nIndex, 0)) != CB_ERR && nItemLen; ++nIndex);
        if (!nItemLen) SendMessage(hWnd, CB_DELETESTRING, (WPARAM)nIndex, 0);
      }
      SendMessage(hWnd, CB_DELETESTRING, nSearchStrings - 1, 0);
      SendMessageW(hWnd, CB_INSERTSTRING, 0, (LPARAM)*wszText_orig);
      SendMessage(hWnd, CB_SETCURSEL, 0, 0);
    }

    if (ftflags & FR_ESCAPESEQ)
    {
      if (*wszText=(wchar_t *)API_HeapAlloc(hHeap, 0, nTextLen * sizeof(wchar_t) + 2))
      {
        if (!EscapeStringToEscapeDataW(*wszText_orig, *wszText))
        {
          API_LoadStringW(hLangLib, MSG_ERROR_SYNTAX, wbuf, BUFFER_SIZE);
          MessageBoxW(GetParent(hWnd), wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONERROR);
          return FALSE;
        }
      }
      else return FALSE;
    }
  }
  else return FALSE;

  return TRUE;
}

void SaveComboboxSearchA(HWND hWndFind, HWND hWndReplace)
{
  HWND hWnd;
  HKEY hKey;
  int nSize;
  int i;
  char szRegValue[32];
  char *szData;

  if (RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad\\Search", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) != ERROR_SUCCESS)
    return;

  hWnd=hWndFind;
  lstrcpy(buf, "find%d");

  Save:
  for (i=0; i < nSearchStrings; ++i)
  {
    wsprintf(szRegValue, buf, i);

    if ((nSize=SendMessage(hWnd, CB_GETLBTEXTLEN, (WPARAM)i, 0)) != CB_ERR)
    {
      ++nSize;

      if (szData=(char *)API_HeapAlloc(hHeap, 0, nSize + 1))
      {
        SendMessage(hWnd, CB_GETLBTEXT, (WPARAM)i, (LPARAM)szData);
        RegSetValueEx(hKey, szRegValue, 0, REG_SZ, (LPBYTE)szData, nSize);
        API_HeapFree(hHeap, 0, (LPVOID)szData);
        continue;
      }
    }
    break;
  }
  if (bReplaceDlg && hWnd != hWndReplace)
  {
    hWnd=hWndReplace;
    lstrcpy(buf, "replace%d");
    goto Save;
  }
  RegCloseKey(hKey);
}

void SaveComboboxSearchW(HWND hWndFind, HWND hWndReplace)
{
  HWND hWnd;
  HKEY hKey;
  int nSize;
  int i;
  wchar_t wszRegValue[32];
  wchar_t *wszData;

  if (RegCreateKeyExW(HKEY_CURRENT_USER, L"Software\\Akelsoft\\AkelPad\\Search", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) != ERROR_SUCCESS)
    return;

  hWnd=hWndFind;
  lstrcpyW(wbuf, L"find%d");

  SaveW:
  for (i=0; i < nSearchStrings; ++i)
  {
    wsprintfW(wszRegValue, wbuf, i);

    if ((nSize=SendMessageW(hWnd, CB_GETLBTEXTLEN, (WPARAM)i, 0)) != CB_ERR)
    {
      ++nSize;

      if (wszData=(wchar_t *)API_HeapAlloc(hHeap, 0, nSize * sizeof(wchar_t) + 2))
      {
        SendMessageW(hWnd, CB_GETLBTEXT, (WPARAM)i, (LPARAM)wszData);
        RegSetValueExW(hKey, wszRegValue, 0, REG_SZ, (LPBYTE)wszData, nSize * sizeof(wchar_t));
        API_HeapFree(hHeap, 0, (LPVOID)wszData);
        continue;
      }
    }
    break;
  }
  if (bReplaceDlg && hWnd != hWndReplace)
  {
    hWnd=hWndReplace;
    lstrcpyW(wbuf, L"replace%d");
    goto SaveW;
  }
  RegCloseKey(hKey);
}

int FindTextA(HWND hWnd)
{
  FINDTEXTEX ft;
  int nResult;
  int nLayout;

  nLayout=SetLayout();

  if ((ftflags & FR_DOWN) && !(ftflags&FR_BEGINNING) && !(ftflags&FR_SELECTION))
  {
    ft.chrg.cpMin=chrg.cpMax;
    ft.chrg.cpMax=-1;
  }
  else if (ftflags & FR_UP)
  {
    ft.chrg.cpMin=chrg.cpMin;
    ft.chrg.cpMax=0;
  }
  else if (ftflags & FR_BEGINNING)
  {
    ft.chrg.cpMin=0;
    ft.chrg.cpMax=-1;
  }
  ft.lpstrText=szFind;

  if ((nResult=SendMessage(hWnd, EM_FINDTEXTEX, ftflags, (LPARAM)&ft)) != -1)
  {
    //EM_FINDTEXTEX bug workarround
    if (ft.chrgText.cpMax - ft.chrgText.cpMin == 1)
    {
      TEXTRANGE txtrng;
      txtrng.lpstrText=buf;
      txtrng.chrg.cpMin=ft.chrgText.cpMin;
      txtrng.chrg.cpMax=ft.chrgText.cpMax;
      SendMessage(hWnd, EM_GETTEXTRANGE, 0, (LPARAM)&txtrng);
      if (*buf == 0x00) nResult=-1;
    }
    if (nResult != -1) SendMessage(hWnd, EM_EXSETSEL, 0, (LPARAM)&ft.chrgText);
  }
  RestoreLayout(nLayout);

  return nResult;
}

int FindTextW(HWND hWnd)
{
  FINDTEXTEXW ftW;
  int nResult;

  if ((ftflags & FR_DOWN) && !(ftflags&FR_BEGINNING) && !(ftflags&FR_SELECTION))
  {
    ftW.chrg.cpMin=chrg.cpMax;
    ftW.chrg.cpMax=-1;
  }
  else if (ftflags & FR_UP)
  {
    ftW.chrg.cpMin=chrg.cpMin;
    ftW.chrg.cpMax=0;
  }
  else if (ftflags & FR_BEGINNING)
  {
    ftW.chrg.cpMin=0;
    ftW.chrg.cpMax=-1;
  }
  ftW.lpstrText=wszFind;

  if ((nResult=SendMessage(hWnd, EM_FINDTEXTEXW, ftflags, (LPARAM)&ftW)) != -1)
  {
    //EM_FINDTEXTEX bug workarround
    if (ftW.chrgText.cpMax - ftW.chrgText.cpMin == 1)
    {
      TEXTRANGE txtrng;
      txtrng.lpstrText=buf;
      txtrng.chrg.cpMin=ftW.chrgText.cpMin;
      txtrng.chrg.cpMax=ftW.chrgText.cpMax;
      SendMessage(hWnd, EM_GETTEXTRANGE, 0, (LPARAM)&txtrng);
      if (*buf == 0x00) nResult=-1;
    }
    if (nResult != -1) SendMessage(hWnd, EM_EXSETSEL, 0, (LPARAM)&ftW.chrgText);
  }
  return nResult;
}

int ReplaceTextA(HWND hWnd, BOOL all)
{
  MSG msg;
  FINDTEXTEX ft;
  CHARRANGE crInitial;
  CHARRANGE crSelection;
  CHARRANGE crPrevious;
  char *szData;
  BOOL bFirstCall=TRUE;
  int nFirstLine;
  int nCurrentLine;
  int nResult;
  int nLayout;
  int i;

  nLayout=SetLayout();
  nReplaceCount=0;

  if (all)
  {
    crInitial.cpMin=chrg.cpMin;
    crInitial.cpMax=chrg.cpMax;
    nFirstLine=SendMessage(hWnd, EM_GETFIRSTVISIBLELINE, 0, 0);
  }
  if (ftflags & FR_SELECTION)
  {
    crSelection.cpMin=chrg.cpMin;
    crSelection.cpMax=chrg.cpMax;
  }
  else if (!(all && (ftflags & FR_BEGINNING)))
  {
    if (GetSelTextA(hWnd, &szData))
    {
      if (((ftflags & FR_MATCHCASE) && !lstrcmp(szFind, szData)) ||
          (!(ftflags & FR_MATCHCASE) && !lstrcmpi(szFind, szData)))
      {
        FreeSelText((LPVOID)szData);
        goto Replace;
      }
      FreeSelText((LPVOID)szData);
    }
  }
  goto Find;

  do
  {
    if (hDlgModeless)
    {
      while (PeekMessage(&msg, hDlgModeless, 0, 0, PM_REMOVE))
      {
        if (!IsDialogMessage(hDlgModeless, &msg))
        {
          TranslateMessage(&msg);
          DispatchMessage(&msg);
        }
      }
      if (!hDlgModeless) break;
    }

    Replace:
    crPrevious.cpMin=chrg.cpMin;
    crPrevious.cpMax=chrg.cpMax;

    ++nReplaceCount;
    ReplaceSelA(hWnd, szReplace);
    i=lstrlen(szFind) - lstrlen(szReplace);

    if (all)
    {
      if (crInitial.cpMin >= crPrevious.cpMax) crInitial.cpMin-=i;
      else if (crInitial.cpMin < crPrevious.cpMax && crInitial.cpMin > crPrevious.cpMin) crInitial.cpMin=crPrevious.cpMin;

      if (crInitial.cpMax >= crPrevious.cpMax) crInitial.cpMax-=i;
      else if (crInitial.cpMax < crPrevious.cpMax && crInitial.cpMax > crPrevious.cpMin) crInitial.cpMax=nPosition;
    }
    if (ftflags & FR_SELECTION) crSelection.cpMax-=i;
    else if (ftflags & FR_UP) SendMessage(hWnd, EM_SETSEL, crPrevious.cpMin, crPrevious.cpMin);

    Find:
    if (ftflags & FR_SELECTION)
    {
      ft.chrg.cpMin=(bFirstCall)?crSelection.cpMin:chrg.cpMax;
      ft.chrg.cpMax=crSelection.cpMax;
    }
    else if (ftflags & FR_BEGINNING)
    {
      ft.chrg.cpMin=(bFirstCall)?0:chrg.cpMax;
      ft.chrg.cpMax=-1;
    }
    else if (ftflags & FR_DOWN)
    {
      ft.chrg.cpMin=chrg.cpMax;
      ft.chrg.cpMax=-1;
    }
    else if (ftflags & FR_UP)
    {
      ft.chrg.cpMin=chrg.cpMin;
      ft.chrg.cpMax=0;
    }
    bFirstCall=FALSE;
    ft.lpstrText=szFind;

    if ((nResult=SendMessage(hWnd, EM_FINDTEXTEX, ftflags, (LPARAM)&ft)) != -1)
    {
      //EM_FINDTEXTEX bug workarround
      if (ft.chrgText.cpMax - ft.chrgText.cpMin == 1)
      {
        TEXTRANGE txtrng;
        txtrng.lpstrText=buf;
        txtrng.chrg.cpMin=ft.chrgText.cpMin;
        txtrng.chrg.cpMax=ft.chrgText.cpMax;
        SendMessage(hWnd, EM_GETTEXTRANGE, 0, (LPARAM)&txtrng);
        if (*buf == 0x00) nResult=-1;
      }
      if (nResult != -1) SendMessage(hWnd, EM_EXSETSEL, 0, (LPARAM)&ft.chrgText);
    }
  }
  while (all && nResult != -1);

  if (all)
  {
    SendMessage(hWnd, EM_EXSETSEL, 0, (LPARAM)&crInitial);
    nCurrentLine=SendMessage(hWnd, EM_GETFIRSTVISIBLELINE, 0, 0);
    if (bOldRichEdit)
    {
      SendMessage(hWnd, EM_LINESCROLL, 0, -1);
      SendMessage(hWnd, EM_LINESCROLL, 0, nFirstLine);
    }
    else SendMessage(hWnd, EM_LINESCROLL, 0, nFirstLine - nCurrentLine);
  }
  RestoreLayout(nLayout);

  return nResult;
}

int ReplaceTextW(HWND hWnd, BOOL all)
{
  MSG msg;
  FINDTEXTEXW ftW;
  CHARRANGE crInitial;
  CHARRANGE crSelection;
  CHARRANGE crPrevious;
  wchar_t *wszData;
  BOOL bFirstCall=TRUE;
  int nFirstLine;
  int nCurrentLine;
  int nResult;
  int i;

  nReplaceCount=0;

  if (all)
  {
    crInitial.cpMin=chrg.cpMin;
    crInitial.cpMax=chrg.cpMax;
    nFirstLine=SendMessage(hWnd, EM_GETFIRSTVISIBLELINE, 0, 0);
  }
  if (ftflags & FR_SELECTION)
  {
    crSelection.cpMin=chrg.cpMin;
    crSelection.cpMax=chrg.cpMax;
  }
  else if (!(all && (ftflags & FR_BEGINNING)))
  {
    if (GetSelTextW(hWnd, &wszData))
    {
      if (((ftflags & FR_MATCHCASE) && !lstrcmpW(wszFind, wszData)) ||
          (!(ftflags & FR_MATCHCASE) && !lstrcmpiW(wszFind, wszData)))
      {
        FreeSelText((LPVOID)wszData);
        goto Replace;
      }
      FreeSelText((LPVOID)wszData);
    }
  }
  goto Find;

  do
  {
    if (hDlgModeless)
    {
      while (PeekMessageW(&msg, hDlgModeless, 0, 0, PM_REMOVE))
      {
        if (!IsDialogMessageW(hDlgModeless, &msg))
        {
          TranslateMessage(&msg);
          DispatchMessageW(&msg);
        }
      }
      if (!hDlgModeless) break;
    }

    Replace:
    crPrevious.cpMin=chrg.cpMin;
    crPrevious.cpMax=chrg.cpMax;

    ++nReplaceCount;
    ReplaceSelW(hWnd, wszReplace);
    i=lstrlenW(wszFind) - lstrlenW(wszReplace);

    if (all)
    {
      if (crInitial.cpMin >= crPrevious.cpMax) crInitial.cpMin-=i;
      else if (crInitial.cpMin < crPrevious.cpMax && crInitial.cpMin > crPrevious.cpMin) crInitial.cpMin=crPrevious.cpMin;

      if (crInitial.cpMax >= crPrevious.cpMax) crInitial.cpMax-=i;
      else if (crInitial.cpMax < crPrevious.cpMax && crInitial.cpMax > crPrevious.cpMin) crInitial.cpMax=nPosition;
    }
    if (ftflags & FR_SELECTION) crSelection.cpMax-=i;
    else if (ftflags & FR_UP) SendMessage(hWnd, EM_SETSEL, crPrevious.cpMin, crPrevious.cpMin);

    Find:
    if (ftflags & FR_SELECTION)
    {
      ftW.chrg.cpMin=(bFirstCall)?crSelection.cpMin:chrg.cpMax;
      ftW.chrg.cpMax=crSelection.cpMax;
    }
    else if (ftflags & FR_BEGINNING)
    {
      ftW.chrg.cpMin=(bFirstCall)?0:chrg.cpMax;
      ftW.chrg.cpMax=-1;
    }
    else if (ftflags & FR_DOWN)
    {
      ftW.chrg.cpMin=chrg.cpMax;
      ftW.chrg.cpMax=-1;
    }
    else if (ftflags & FR_UP)
    {
      ftW.chrg.cpMin=chrg.cpMin;
      ftW.chrg.cpMax=0;
    }
    bFirstCall=FALSE;
    ftW.lpstrText=wszFind;

    if ((nResult=SendMessage(hWnd, EM_FINDTEXTEXW, ftflags, (LPARAM)&ftW)) != -1)
    {
      //EM_FINDTEXTEX bug workarround
      if (ftW.chrgText.cpMax - ftW.chrgText.cpMin == 1)
      {
        TEXTRANGE txtrng;
        txtrng.lpstrText=buf;
        txtrng.chrg.cpMin=ftW.chrgText.cpMin;
        txtrng.chrg.cpMax=ftW.chrgText.cpMax;
        SendMessage(hWnd, EM_GETTEXTRANGE, 0, (LPARAM)&txtrng);
        if (*buf == 0x00) nResult=-1;
      }
      if (nResult != -1) SendMessage(hWnd, EM_EXSETSEL, 0, (LPARAM)&ftW.chrgText);
    }
  }
  while (all && nResult != -1);

  if (all)
  {
    SendMessage(hWnd, EM_EXSETSEL, 0, (LPARAM)&crInitial);
    nCurrentLine=SendMessage(hWnd, EM_GETFIRSTVISIBLELINE, 0, 0);
    if (bOldRichEdit)
    {
      SendMessage(hWnd, EM_LINESCROLL, 0, -1);
      SendMessage(hWnd, EM_LINESCROLL, 0, nFirstLine);
    }
    else SendMessage(hWnd, EM_LINESCROLL, 0, nFirstLine - nCurrentLine);
  }
  return nResult;
}

BOOL EscapeStringToEscapeDataA(char *pInput, char *szOutput)
{
  char *a=pInput;
  char *b=szOutput;
  char hex[3];

  for (hex[2]='\0'; *a; ++b, ++a)
  {
    if (*a == '\\')
    {
      if (*++a == '\\') *b='\\';
      else if (*a == 'n') *b='\r';
      else if (*a == 't') *b='\t';
      else if (*a == '[')
      {
        --b, ++a;

        do
        {
          hex[0]=*a;
          if (*a == 0) goto Error;
          hex[1]=*++a;
          if (*a == 0) goto Error;
          *++b=hex2dec(hex);
          if (*b == -1) goto Error;
          while (*++a == ' ');
        }
        while (*a && *a != ']');
      }
    }
    else *b=*a;
  }
  *b='\0';
  return TRUE;

  Error:
  *szOutput='\0';
  return FALSE;
}

BOOL EscapeStringToEscapeDataW(wchar_t *wpInput, wchar_t *wszOutput)
{
  wchar_t *a=wpInput;
  wchar_t *b=wszOutput;
  wchar_t whex[5];

  for (whex[4]='\0'; *a; ++b, ++a)
  {
    if (*a == '\\')
    {
      if (*++a == '\\') *b='\\';
      else if (*a == 'n') *b='\r';
      else if (*a == 't') *b='\t';
      else if (*a == '[')
      {
        --b, ++a;

        do
        {
          whex[2]=*a;
          if (*a == 0) goto Error;
          whex[3]=*++a;
          if (*a == 0) goto Error;
          whex[0]=*++a;
          if (*a == 0) goto Error;
          whex[1]=*++a;
          if (*a == 0) goto Error;
          *++b=hex2decW(whex);
          if (*b == -1) goto Error;
          while (*++a == ' ');
        }
        while (*a && *a != ']');
      }
      else goto Error;
    }
    else *b=*a;
  }
  *b='\0';
  return TRUE;

  Error:
  *wszOutput='\0';
  return FALSE;
}

void EscapeDataToEscapeStringW(wchar_t *wpInput, wchar_t *wszOutput)
{
  wchar_t *a=wpInput;
  wchar_t *b=wszOutput;

  for (; *a; ++b, ++a)
  {
    if (*a == '\t') *b='\\', *++b='t';
    else if (*a == '\r') *b='\\', *++b='n';
    else if (*a == '\\') *b='\\', *++b='\\';
    else *b=*a;
  }
  *b='\0';
}


//// Paste operation

void ReplaceSelA(HWND hWnd, char *pData)
{
  EDITSTREAM es;
  PASTEDATA pd;

  pd.pData=(unsigned char *)pData;
  pd.nLength=0;
  es.dwCookie=(DWORD)&pd;
  es.pfnCallback=ReplaceSelCallbackA;
  SendMessage(hWnd, EM_STREAMIN, SF_TEXT|SFF_SELECTION, (LPARAM)&es);
}

void ReplaceSelW(HWND hWnd, wchar_t *wpData)
{
  EDITSTREAM es;
  PASTEDATA pd;

  pd.pData=(unsigned char *)wpData;
  pd.nLength=0;
  es.dwCookie=(DWORD)&pd;
  es.pfnCallback=ReplaceSelCallbackW;
  SendMessage(hWnd, EM_STREAMIN, SF_TEXT|SF_UNICODE|SFF_SELECTION, (LPARAM)&es);
}

DWORD CALLBACK ReplaceSelCallbackA(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
  PASTEDATA *lpData=(PASTEDATA *)dwCookie;
  char *pSrc=(char *)lpData->pData;
  char *pDest=(char *)pbBuff;
  int i;

  for (i=0, --cb; i < cb && pSrc[lpData->nLength]; ++i)
  {
    pDest[i]=pSrc[lpData->nLength++];

    if (pDest[i] == '\r' && pSrc[lpData->nLength] != '\n')
      pDest[++i]='\n';
  }
  *pcb=i;

  return 0;
}

DWORD CALLBACK ReplaceSelCallbackW(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
{
  PASTEDATA *lpData=(PASTEDATA *)dwCookie;
  wchar_t *pSrc=(wchar_t *)lpData->pData;
  wchar_t *pDest=(wchar_t *)pbBuff;
  int i;

  for (i=0, cb=cb / sizeof(wchar_t) - 1; i < cb && pSrc[lpData->nLength]; ++i)
  {
    pDest[i]=pSrc[lpData->nLength++];

    if (pDest[i] == '\r' && pSrc[lpData->nLength] != '\n')
      pDest[++i]='\n';
  }
  *pcb=i*sizeof(wchar_t);

  return 0;
}

int GetSelTextA(HWND hWnd, char **pText)
{
  CHARRANGE cr;
  int nLen;
  TEXTRANGE txtrng;
  int nLayout;

  if (chrg.cpMin == chrg.cpMax) goto Error;
  cr.cpMin=chrg.cpMin;
  cr.cpMax=chrg.cpMax;
  nLen=(cr.cpMax - cr.cpMin) + 1;

  if (*pText=txtrng.lpstrText=(char *)API_HeapAlloc(hHeap, 0, nLen + 1))
  {
    txtrng.chrg.cpMin=cr.cpMin;
    txtrng.chrg.cpMax=cr.cpMax;

    nLayout=SetLayout();
    SendMessage(hWnd, EM_GETTEXTRANGE, 0, (LPARAM)&txtrng);
    RestoreLayout(nLayout);

    return nLen;
  }

  Error:
  *pText=NULL;
  return 0;
}

int GetSelTextW(HWND hWnd, wchar_t **wpText)
{
  CHARRANGE cr;
  GETTEXTEX gt;
  int nLen;
  int nLenW;

  if (chrg.cpMin == chrg.cpMax) goto Error;
  cr.cpMin=chrg.cpMin;
  cr.cpMax=chrg.cpMax;
  nLen=(cr.cpMax - cr.cpMin) + 1;
  nLenW=nLen * sizeof(wchar_t);

  if (*wpText=(wchar_t *)API_HeapAlloc(hHeap, 0, nLenW + 2))
  {
    gt.cb=nLenW;
    gt.flags=GT_SELECTION;
    gt.codepage=1200;
    gt.lpDefaultChar=NULL;
    gt.lpUsedDefChar=NULL;
    SendMessage(hWnd, EM_GETTEXTEX, (WPARAM)&gt, (LPARAM)*wpText);

    return nLen;
  }

  Error:
  *wpText=NULL;
  return 0;
}

void FreeSelText(LPVOID pText)
{
  if (pText) API_HeapFree(hHeap, 0, pText);
}


//// Go to line

BOOL CALLBACK GoToLineDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  int nLine;
  int nColumn;
  int nLineNumber;
  int nNewLine;
  int nNewLineLen;

  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    nLine=SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, nPosition)+1;
    SetDlgItemInt(hDlg, IDC_GOTOLINE, nLine, FALSE);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDOK)
    {
      nLineNumber=GetDlgItemInt(hDlg, IDC_GOTOLINE, NULL, TRUE);

      if (!nLineNumber)
      {
        API_LoadStringA(hLangLib, MSG_WRONG_STRING, buf, BUFFER_SIZE);
        MessageBox(hDlg, buf, APP_MAIN_TITLE, MB_OK|MB_ICONERROR);
        return FALSE;
      }
      else if (nLineNumber < 0)
      {
        nLineNumber=SendMessage(hWndEdit, EM_GETLINECOUNT, 0, 0) + nLineNumber + 1;
        if (nLineNumber <= 0) nLineNumber=1;
      }

      nLine=SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, nPosition) + 1;
      nColumn=SendMessage(hWndEdit, EM_LINEINDEX, nLine - 1, 0);
      nColumn=nPosition - nColumn + 1;
      nNewLine=SendMessage(hWndEdit, EM_LINEINDEX, nLineNumber - 1, 0);
      if (nNewLine == -1) nNewLine=SendMessage(hWndEdit, EM_LINEINDEX, SendMessage(hWndEdit, EM_GETLINECOUNT, 0, 0) - 1, 0);
      nNewLineLen=SendMessage(hWndEdit, EM_LINELENGTH, nNewLine, 0);

      if (nColumn <= nNewLineLen) nNewLine+=nColumn - 1;
      else nNewLine+=nNewLineLen;
      SendMessage(hWndEdit, EM_SETSEL, nNewLine, nNewLine);
    }
    if (LOWORD(wParam) == IDOK ||
        LOWORD(wParam) == IDCANCEL)
    {
      DestroyWindow(hDlg);
      hDlgModeless=0;
      return TRUE;
    }
  }
  return FALSE;
}

BOOL CALLBACK GoToLineDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  int nLine;
  int nColumn;
  int nLineNumber;
  int nNewLine;
  int nNewLineLen;

  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    nLine=SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, nPosition)+1;
    SetDlgItemInt(hDlg, IDC_GOTOLINE, nLine, FALSE);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDOK)
    {
      nLineNumber=GetDlgItemInt(hDlg, IDC_GOTOLINE, NULL, TRUE);

      if (!nLineNumber)
      {
        API_LoadStringW(hLangLib, MSG_WRONG_STRING, wbuf, BUFFER_SIZE);
        MessageBoxW(hDlg, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONERROR);
        return FALSE;
      }
      else if (nLineNumber < 0)
      {
        nLineNumber=SendMessage(hWndEdit, EM_GETLINECOUNT, 0, 0) + nLineNumber + 1;
        if (nLineNumber <= 0) nLineNumber=1;
      }

      nLine=SendMessage(hWndEdit, EM_EXLINEFROMCHAR, 0, nPosition) + 1;
      nColumn=SendMessage(hWndEdit, EM_LINEINDEX, nLine - 1, 0);
      nColumn=nPosition - nColumn + 1;
      nNewLine=SendMessage(hWndEdit, EM_LINEINDEX, nLineNumber - 1, 0);
      if (nNewLine == -1) nNewLine=SendMessage(hWndEdit, EM_LINEINDEX, SendMessage(hWndEdit, EM_GETLINECOUNT, 0, 0) - 1, 0);
      nNewLineLen=SendMessage(hWndEdit, EM_LINELENGTH, nNewLine, 0);

      if (nColumn <= nNewLineLen) nNewLine+=nColumn - 1;
      else nNewLine+=nNewLineLen;
      SendMessage(hWndEdit, EM_SETSEL, nNewLine, nNewLine);
    }
    if (LOWORD(wParam) == IDOK ||
        LOWORD(wParam) == IDCANCEL)
    {
      DestroyWindow(hDlg);
      hDlgModeless=0;
      return TRUE;
    }
  }
  return FALSE;
}


//// Recent files

void RecentFilesZeroA()
{
  if (szRecentNames) memset(szRecentNames, 0, nRecentFiles * MAX_PATH);
  if (szRecentPositions) memset(szRecentPositions, 0, nRecentFiles * sizeof(DWORD));
  if (szRecentCodepages) memset(szRecentCodepages, 0, nRecentFiles * sizeof(DWORD));
}

void RecentFilesZeroW()
{
  if (wszRecentNames) memset(wszRecentNames, 0, nRecentFiles * MAX_PATH * sizeof(wchar_t));
  if (szRecentPositions) memset(szRecentPositions, 0, nRecentFiles * sizeof(DWORD));
  if (szRecentCodepages) memset(szRecentCodepages, 0, nRecentFiles * sizeof(DWORD));
}

void RecentFilesReadA()
{
  char szRegValue[32];
  HKEY hKey;
  DWORD dwType;
  DWORD dwSize;
  int i;

  //Read recent files array
  if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad\\Recent", 0, KEY_READ, &hKey) != ERROR_SUCCESS)
    return;

  for (i=0; i < nRecentFiles; ++i)
  {
    wsprintf(szRegValue, "name%d", i);
    dwSize=MAX_PATH;
    if (RegQueryValueEx(hKey, szRegValue, NULL, &dwType, (LPBYTE)szRecentNames[i], &dwSize) != ERROR_SUCCESS)
      break;

    wsprintf(szRegValue, "pos%d", i);
    dwSize=sizeof(DWORD);
    RegQueryValueEx(hKey, szRegValue, NULL, &dwType, (LPBYTE)&szRecentPositions[i], &dwSize);

    wsprintf(szRegValue, "cp%d", i);
    dwSize=sizeof(DWORD);
    RegQueryValueEx(hKey, szRegValue, NULL, &dwType, (LPBYTE)&szRecentCodepages[i], &dwSize);
  }
  RegCloseKey(hKey);
}

void RecentFilesReadW()
{
  wchar_t wszRegValue[32];
  HKEY hKey;
  DWORD dwType;
  DWORD dwSize;
  int i;

  //Read recent files array
  if (RegOpenKeyExW(HKEY_CURRENT_USER, L"Software\\Akelsoft\\AkelPad\\Recent", 0, KEY_READ, &hKey) != ERROR_SUCCESS)
    return;

  for (i=0; i < nRecentFiles; ++i)
  {
    wsprintfW(wszRegValue, L"name%d", i);
    dwSize=MAX_PATH * sizeof(wchar_t);
    if (RegQueryValueExW(hKey, wszRegValue, NULL, &dwType, (LPBYTE)wszRecentNames[i], &dwSize) != ERROR_SUCCESS)
      break;

    wsprintfW(wszRegValue, L"pos%d", i);
    dwSize=sizeof(DWORD);
    RegQueryValueExW(hKey, wszRegValue, NULL, &dwType, (LPBYTE)&szRecentPositions[i], &dwSize);

    wsprintfW(wszRegValue, L"cp%d", i);
    dwSize=sizeof(DWORD);
    RegQueryValueExW(hKey, wszRegValue, NULL, &dwType, (LPBYTE)&szRecentCodepages[i], &dwSize);
  }
  RegCloseKey(hKey);
}

BOOL RecentFilesGetA(char *file, int *position, int *codepage)
{
  int i;

  if (!*file) return FALSE;

  for (i=0; i < nRecentFiles; ++i)
    if (!lstrcmpi(szRecentNames[i], file))
    {
      if (position) *position=szRecentPositions[i];
      if (codepage) *codepage=szRecentCodepages[i];
      return TRUE;
    }

  return FALSE;
}

BOOL RecentFilesGetW(wchar_t *wfile, int *position, int *codepage)
{
  int i;

  if (!*wfile) return FALSE;

  for (i=0; i < nRecentFiles; ++i)
    if (!lstrcmpiW(wszRecentNames[i], wfile))
    {
      if (position) *position=szRecentPositions[i];
      if (codepage) *codepage=szRecentCodepages[i];
      return TRUE;
    }

  return FALSE;
}

BOOL RecentFilesUpdateA(char *file, int position, int codepage)
{
  int i;

  if (!*file) return FALSE;

  //Update recent files array - move/add current file to the first place
  for (i=0; i < nRecentFiles; ++i)
    if (!lstrcmpi(szRecentNames[i], file))
    {
      if (position == -1) position=szRecentPositions[i];
      if (codepage == -1) codepage=szRecentCodepages[i];
      ++i;
      break;
    }

  if (position == -1) position=0;
  if (codepage == -1) codepage=nDefaultCodePage;

  if (--i)
    for (; i > 0; --i)
    {
      lstrcpy(szRecentNames[i], szRecentNames[i-1]);
      szRecentPositions[i]=szRecentPositions[i-1];
      szRecentCodepages[i]=szRecentCodepages[i-1];
    }

  lstrcpy(szRecentNames[0], file);
  szRecentPositions[0]=position;
  szRecentCodepages[0]=codepage;

  return TRUE;
}

BOOL RecentFilesUpdateW(wchar_t *wfile, int position, int codepage)
{
  int i;

  if (!*wfile) return FALSE;

  //Update recent files array - move/add current file to the first place
  for (i=0; i < nRecentFiles; ++i)
    if (!lstrcmpiW(wszRecentNames[i], wfile))
    {
      if (position == -1) position=szRecentPositions[i];
      if (codepage == -1) codepage=szRecentCodepages[i];
      ++i;
      break;
    }

  if (position == -1) position=0;
  if (codepage == -1) codepage=nDefaultCodePage;

  if (--i)
    for (; i > 0; --i)
    {
      lstrcpyW(wszRecentNames[i], wszRecentNames[i-1]);
      szRecentPositions[i]=szRecentPositions[i-1];
      szRecentCodepages[i]=szRecentCodepages[i-1];
    }

  lstrcpyW(wszRecentNames[0], wfile);
  szRecentPositions[0]=position;
  szRecentCodepages[0]=codepage;

  return TRUE;
}

int RecentFilesDeleteDeadA()
{
  int i;
  int a;
  int nDead=0;

  //Delete files from recent files array if they doesn't exist
  for (i=0; i < nRecentFiles && *szRecentNames[i]; ++i)
  {
    while (*szRecentNames[i] && !FileExistsA(szRecentNames[i]))
    {
      for (a=i; a < nRecentFiles-1; ++a)
      {
        lstrcpy(szRecentNames[a], szRecentNames[a+1]);
        szRecentPositions[a]=szRecentPositions[a+1];
        szRecentCodepages[a]=szRecentCodepages[a+1];
      }
      *szRecentNames[nRecentFiles-1]='\0';
      szRecentPositions[nRecentFiles-1]=0;
      szRecentCodepages[nRecentFiles-1]=0;
      ++nDead;
    }
  }
  return nDead;
}

int RecentFilesDeleteDeadW()
{
  int i;
  int a;
  int nDead=0;

  //Delete files from recent files array if they doesn't exist
  for (i=0; i < nRecentFiles && *wszRecentNames[i]; ++i)
  {
    while (*wszRecentNames[i] && !FileExistsW(wszRecentNames[i]))
    {
      for (a=i; a < nRecentFiles-1; ++a)
      {
        lstrcpyW(wszRecentNames[a], wszRecentNames[a+1]);
        szRecentPositions[a]=szRecentPositions[a+1];
        szRecentCodepages[a]=szRecentCodepages[a+1];
      }
      *wszRecentNames[nRecentFiles-1]='\0';
      szRecentPositions[nRecentFiles-1]=0;
      szRecentCodepages[nRecentFiles-1]=0;
      ++nDead;
    }
  }
  return nDead;
}

void RecentFilesSaveA()
{
  char szRegValue[32];
  HKEY hKey;
  int i;

  //Save recent files array
  if (RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad\\Recent", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) != ERROR_SUCCESS)
    return;

  for (i=0; i < nRecentFiles; ++i)
  {
    wsprintf(szRegValue, "name%d", i);
    RegSetValueEx(hKey, szRegValue, 0, REG_SZ, (LPBYTE)(*szRecentNames[i]?szRecentNames[i]:""), *szRecentNames[i]?lstrlen(szRecentNames[i])+1:1);

    wsprintf(szRegValue, "pos%d", i);
    RegSetValueEx(hKey, szRegValue, 0, REG_DWORD, (LPBYTE)&szRecentPositions[i], sizeof(DWORD));

    wsprintf(szRegValue, "cp%d", i);
    RegSetValueEx(hKey, szRegValue, 0, REG_DWORD, (LPBYTE)&szRecentCodepages[i], sizeof(DWORD));
  }
  RegCloseKey(hKey);
}

void RecentFilesSaveW()
{
  wchar_t wszRegValue[32];
  HKEY hKey;
  int i;

  //Save recent files array
  if (RegCreateKeyExW(HKEY_CURRENT_USER, L"Software\\Akelsoft\\AkelPad\\Recent", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) != ERROR_SUCCESS)
    return;

  for (i=0; i < nRecentFiles; ++i)
  {
    wsprintfW(wszRegValue, L"name%d", i);
    RegSetValueExW(hKey, wszRegValue, 0, REG_SZ, (LPBYTE)(*wszRecentNames[i]?wszRecentNames[i]:L""), *wszRecentNames[i]?lstrlenW(wszRecentNames[i]) * sizeof(wchar_t) + 2:2);

    wsprintfW(wszRegValue, L"pos%d", i);
    RegSetValueExW(hKey, wszRegValue, 0, REG_DWORD, (LPBYTE)&szRecentPositions[i], sizeof(DWORD));

    wsprintfW(wszRegValue, L"cp%d", i);
    RegSetValueExW(hKey, wszRegValue, 0, REG_DWORD, (LPBYTE)&szRecentCodepages[i], sizeof(DWORD));
  }
  RegCloseKey(hKey);
}

void RecentFilesMenuA()
{
  int i;

  for (i=1; DeleteMenu(hMainMenu, IDM_RECENT_FILES+i, MF_BYCOMMAND); ++i);

  if (nRecentFiles && *szRecentNames[0])
  {
    API_LoadStringA(hLangLib, STR_RECENT_FILES_DELETE_DEAD, buf, BUFFER_SIZE);
    ModifyMenu(hMainMenu, IDM_RECENT_FILES, MF_BYCOMMAND|MF_STRING, IDM_RECENT_FILES, buf);

    for (i=0; i < nRecentFiles && *szRecentNames[i]; ++i)
    {
      TrimPathA(buf, szRecentNames[i], RECENTFILES_RECORD_LENGTH);
      InsertMenu(hMainMenu, IDM_RECENT_FILES, MF_BYCOMMAND|MF_STRING, IDM_RECENT_FILES+i+1, buf);
    }
    InsertMenu(hMainMenu, IDM_RECENT_FILES, MF_BYCOMMAND|MF_SEPARATOR, IDM_RECENT_FILES+i+1, NULL);
  }
  else
  {
    API_LoadStringA(hLangLib, STR_RECENT_FILES_EMPTY, buf, BUFFER_SIZE);
    ModifyMenu(hMainMenu, IDM_RECENT_FILES, MF_BYCOMMAND|MF_STRING|MF_GRAYED, IDM_RECENT_FILES, buf);
  }
}

void RecentFilesMenuW()
{
  int i;

  for (i=1; DeleteMenu(hMainMenu, IDM_RECENT_FILES+i, MF_BYCOMMAND); ++i);

  if (nRecentFiles && *wszRecentNames[0])
  {
    API_LoadStringW(hLangLib, STR_RECENT_FILES_DELETE_DEAD, wbuf, BUFFER_SIZE);
    ModifyMenuW(hMainMenu, IDM_RECENT_FILES, MF_BYCOMMAND|MF_STRING, IDM_RECENT_FILES, wbuf);

    for (i=0; i < nRecentFiles && *wszRecentNames[i]; ++i)
    {
      TrimPathW(wbuf, wszRecentNames[i], RECENTFILES_RECORD_LENGTH);
      InsertMenuW(hMainMenu, IDM_RECENT_FILES, MF_BYCOMMAND|MF_STRING, IDM_RECENT_FILES+i+1, wbuf);
    }
    InsertMenuW(hMainMenu, IDM_RECENT_FILES, MF_BYCOMMAND|MF_SEPARATOR, IDM_RECENT_FILES+i+1, NULL);
  }
  else
  {
    API_LoadStringW(hLangLib, STR_RECENT_FILES_EMPTY, wbuf, BUFFER_SIZE);
    ModifyMenuW(hMainMenu, IDM_RECENT_FILES, MF_BYCOMMAND|MF_STRING|MF_GRAYED, IDM_RECENT_FILES, wbuf);
  }
}

int TrimPathA(char *szResult, char *pPath, int nMax)
{
  int nFileLen;
  int nLen=lstrlen(pPath);
  char *pEnd=pPath + nLen;
  char *pFile=pEnd - 1;

  if (nLen <= nMax)
  {
    lstrcpy(szResult, pPath);
    return nLen;
  }

  while (pFile >= pPath && *pFile != '\\') --pFile;

  if (pFile >= pPath)
  {
    nFileLen=pEnd - pFile;

    if (nMax > nFileLen + 2)
    {
      lstrcpyn(szResult, pPath, nMax - nFileLen - 2);
      lstrcat(szResult, "...");
      lstrcat(szResult, pFile);
      return nMax;
    }
  }
  lstrcpy(szResult, "...");
  lstrcat(szResult, pEnd - nMax + 3);
  return nMax;
}

int TrimPathW(wchar_t *wszResult, wchar_t *wpPath, int nMax)
{
  int nFileLen;
  int nLen=lstrlenW(wpPath);
  wchar_t *wpEnd=wpPath + nLen;
  wchar_t *wpFile=wpEnd - 1;

  if (nLen <= nMax)
  {
    lstrcpyW(wszResult, wpPath);
    return nLen;
  }

  while (wpFile >= wpPath && *wpFile != '\\') --wpFile;

  if (wpFile >= wpPath)
  {
    nFileLen=wpEnd - wpFile;

    if (nMax > nFileLen + 2)
    {
      lstrcpynW(wszResult, wpPath, nMax - nFileLen - 2);
      lstrcatW(wszResult, L"...");
      lstrcatW(wszResult, wpFile);
      return nMax;
    }
  }
  lstrcpyW(wszResult, L"...");
  lstrcatW(wszResult, wpEnd - nMax + 3);
  return nMax;
}


//// Language menu

void LanguageMenuA()
{
  WIN32_FIND_DATA wfd;
  HANDLE hFind;
  UINT uFlags;
  int i;
  nLangModules=0;

  for (i=1; DeleteMenu(hMainMenu, IDM_LANGUAGE+i, MF_BYCOMMAND); ++i);

  wsprintf(buf, "%s\\AkelFiles\\Langs\\*.dll", szExeDir);

  if ((hFind=FindFirstFile(buf, &wfd)) != INVALID_HANDLE_VALUE)
  {
    i=1;

    do
    {
      if (!lstrcmpi(szLangModule, wfd.cFileName))
        uFlags=MF_BYCOMMAND|MF_STRING|MF_CHECKED;
      else
        uFlags=MF_BYCOMMAND|MF_STRING|MF_UNCHECKED;
      GetBaseNameA(wfd.cFileName, buf);
      InsertMenu(hMainMenu, IDM_LANGUAGE, uFlags, IDM_LANGUAGE+i, buf);
      ++i;
    }
    while (FindNextFile(hFind, &wfd));

    nLangModules=i-1;
    InsertMenu(hMainMenu, IDM_LANGUAGE, MF_BYCOMMAND|MF_SEPARATOR, IDM_LANGUAGE+i, NULL);
    FindClose(hFind);
  }

  API_LoadStringA(hLangLib, STR_LANGUAGE_NONE, buf, BUFFER_SIZE);
  if (!*szLangModule)
    uFlags=MF_BYCOMMAND|MF_STRING|MF_CHECKED;
  else
    uFlags=MF_BYCOMMAND|MF_STRING|MF_UNCHECKED;
  ModifyMenu(hMainMenu, IDM_LANGUAGE, uFlags, IDM_LANGUAGE, buf);
}

void LanguageMenuW()
{
  WIN32_FIND_DATAW wfdW;
  HANDLE hFind;
  UINT uFlags;
  int i;
  nLangModules=0;

  for (i=1; DeleteMenu(hMainMenu, IDM_LANGUAGE+i, MF_BYCOMMAND); ++i);

  wsprintfW(wbuf, L"%s\\AkelFiles\\Langs\\*.dll", wszExeDir);

  if ((hFind=FindFirstFileW(wbuf, &wfdW)) != INVALID_HANDLE_VALUE)
  {
    i=1;

    do
    {
      if (!lstrcmpiW(wszLangModule, wfdW.cFileName))
        uFlags=MF_BYCOMMAND|MF_STRING|MF_CHECKED;
      else
        uFlags=MF_BYCOMMAND|MF_STRING|MF_UNCHECKED;
      GetBaseNameW(wfdW.cFileName, wbuf);
      InsertMenuW(hMainMenu, IDM_LANGUAGE, uFlags, IDM_LANGUAGE+i, wbuf);
      ++i;
    }
    while (FindNextFileW(hFind, &wfdW));

    nLangModules=i-1;
    InsertMenuW(hMainMenu, IDM_LANGUAGE, MF_BYCOMMAND|MF_SEPARATOR, IDM_LANGUAGE+i, NULL);
    FindClose(hFind);
  }

  API_LoadStringW(hLangLib, STR_LANGUAGE_NONE, wbuf, BUFFER_SIZE);
  if (!*wszLangModule)
    uFlags=MF_BYCOMMAND|MF_STRING|MF_CHECKED;
  else
    uFlags=MF_BYCOMMAND|MF_STRING|MF_UNCHECKED;
  ModifyMenuW(hMainMenu, IDM_LANGUAGE, uFlags, IDM_LANGUAGE, wbuf);
}


//// Word breaking

BOOL isInDelimiterList(wchar_t c)
{
  if (wcschr(wszDelimiters, c) != NULL)
    return TRUE;
  else
    return FALSE;
}

int CALLBACK EditWordBreakProc(LPTSTR pchText, int ichCurrent, int cch, int code)
{
  int lRet=0;
  wchar_t *pchTextW=(wchar_t *)pchText;
  int cchW=cch/sizeof(wchar_t);

  if (code == WB_LEFTBREAK || code == WB_MOVEWORDLEFT)
  {
    // Finds the next character that begins a word before the specified position.
    {
      if (bFirstWordBreak)
      {
        do
          --ichCurrent;
        while (isInDelimiterList(pchTextW[ichCurrent]));
      }

      for (--ichCurrent; ichCurrent >= 0 && !isInDelimiterList(pchTextW[ichCurrent]); --ichCurrent);

      if (ichCurrent >= 0)
      {
        bFirstWordBreak=TRUE;
        lRet=ichCurrent+1;
      }
      else
      {
        bFirstWordBreak=FALSE;
        lRet=-1;
      }
    }
  }
  else if (code == WB_MOVEWORDRIGHT)
  {
    //Finds the next character that ends a word after the specified position.
    {
      if (bFirstWordBreak)
      {
        while (isInDelimiterList(pchTextW[ichCurrent]))
          ++ichCurrent;
        ++ichCurrent;
      }

      while (ichCurrent < cchW && !isInDelimiterList(pchTextW[ichCurrent]))
        ++ichCurrent;

      if (ichCurrent < cchW)
      {
        bFirstWordBreak=TRUE;
        lRet=ichCurrent;
      }
      else
      {
        bFirstWordBreak=FALSE;
        lRet=-1;
      }
    }
  }
  else if (code == WB_CLASSIFY)
  {
    //Retrieves the character class and word break flags of the character at the specified position.
    {
      if (!isInDelimiterList(pchTextW[ichCurrent]))
        lRet=WBF_ISWHITE; //WBF_BREAKAFTER|WBF_BREAKLINE;
      else
        lRet=-1;
    }
  }
  return lRet;
}


//// Recode

void RecodeTextW(HWND hWnd, int nCodePage)
{
  CHARRANGE cr;
  wchar_t *wszText;
  char *szText;
  BOOL bAllFile=FALSE;
  int i;

  cr.cpMin=chrg.cpMin;
  cr.cpMax=chrg.cpMax;

  if (cr.cpMin == cr.cpMax)
  {
    SendMessage(hWnd, EM_SETSEL, 0, -1);
    bAllFile=TRUE;
  }

  if (i=GetSelTextW(hWnd, &wszText))
  {
    if (szText=(char *)API_HeapAlloc(hHeap, 0, i + 1))
    {
      WideCharToMultiByte(CP_ACP, 0, wszText, i, szText, i, NULL, NULL);

      if (nCodePage == CP_UNICODE_UTF8)
        i=UTF8toUTF16(szText, (unsigned int *)&i, wszText, i);
      else
        MultiByteToWideChar(nCodePage, 0, szText, i, wszText, i);

      if (bAllFile == FALSE)
        cr.cpMax=cr.cpMin + i - 1;

      ReplaceSelW(hWnd, wszText);
      API_HeapFree(hHeap, 0, (LPVOID)szText);
    }
    FreeSelText(wszText);
  }
  SendMessage(hWnd, EM_EXSETSEL, 0, (LPARAM)&cr);
}

BOOL CALLBACK RecodeDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndCP;

  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    hWndCP=GetDlgItem(hDlg, IDC_RECODE_CODEPAGE);

    FillComboboxCodepageA(hWndCP);
    SelectComboboxCodepageA(hWndCP, nRecodeCodePage);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDOK)
    {
      nRecodeCodePage=GetComboboxCodepageA(hWndCP);
      EndDialog(hDlg, 0);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDCANCEL)
    {
      bRecodeDlg=FALSE;
      EndDialog(hDlg, 0);
      return TRUE;
    }
  }
  return FALSE;
}

BOOL CALLBACK RecodeDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndCP;

  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    hWndCP=GetDlgItem(hDlg, IDC_RECODE_CODEPAGE);

    FillComboboxCodepageW(hWndCP);
    SelectComboboxCodepageW(hWndCP, nRecodeCodePage);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDOK)
    {
      nRecodeCodePage=GetComboboxCodepageW(hWndCP);
      EndDialog(hDlg, 0);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDCANCEL)
    {
      bRecodeDlg=FALSE;
      EndDialog(hDlg, 0);
      return TRUE;
    }
  }
  return FALSE;
}


//Plugins

BOOL CALLBACK PluginsDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndList;
  static HWND hWndHotkey;
  static HWND hWndAssign;
  static HWND hWndCall;
  static int nSelItem;
  LVCOLUMN lvc;

  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    hWndList=GetDlgItem(hDlg, IDC_PLUGINS_LIST);
    hWndHotkey=GetDlgItem(hDlg, IDC_PLUGINS_HOTKEY);
    hWndAssign=GetDlgItem(hDlg, IDC_PLUGINS_ASSIGN);
    hWndCall=GetDlgItem(hDlg, IDC_PLUGINS_CALL);
    SendMessage(hWndList, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES, LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);
    EnableWindow(hWndHotkey, FALSE);
    EnableWindow(hWndAssign, FALSE);
    EnableWindow(hWndCall, FALSE);

    //Columns
    lvc.mask=LVCF_TEXT|LVCF_WIDTH|LVCF_SUBITEM;
    lvc.pszText=buf;
    lvc.cchTextMax=BUFFER_SIZE;

    lstrcpy(buf, "Plugin::Function");
    lvc.cx=170;
    lvc.iSubItem=LVI_FUNCTION_NAME;
    SendMessage(hWndList, LVM_INSERTCOLUMN, LVI_FUNCTION_NAME, (LPARAM)&lvc);

    lstrcpy(buf, "HotKey");
    lvc.cx=103;
    lvc.iSubItem=LVI_FUNCTION_HOTKEY;
    SendMessage(hWndList, LVM_INSERTCOLUMN, LVI_FUNCTION_HOTKEY, (LPARAM)&lvc);

    FillPluinsListA(hWndList);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_PLUGINS_ASSIGN)
    {
      LVITEM lvi;
      DWORD dwHotkey;

      dwHotkey=SendMessage(hWndHotkey, HKM_GETHOTKEY, 0, 0);
      GetHotkeyStringA(dwHotkey, buf);

      lvi.mask=LVIF_PARAM;
      lvi.iItem=nSelItem;
      lvi.iSubItem=LVI_FUNCTION_NAME;
      lvi.lParam=dwHotkey;
      SendMessage(hWndList, LVM_SETITEM, 0, (LPARAM)&lvi);

      lvi.mask=LVIF_TEXT;
      lvi.pszText=buf;
      lvi.cchTextMax=BUFFER_SIZE;
      lvi.iItem=nSelItem;
      lvi.iSubItem=LVI_FUNCTION_HOTKEY;
      SendMessage(hWndList, LVM_SETITEM, 0, (LPARAM)&lvi);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_PLUGINS_CALL)
    {
      LVITEM lvi;

      lvi.mask=LVIF_TEXT;
      lvi.pszText=buf;
      lvi.cchTextMax=BUFFER_SIZE;
      lvi.iItem=nSelItem;
      lvi.iSubItem=LVI_FUNCTION_NAME;
      SendMessage(hWndList, LVM_GETITEM, 0, (LPARAM)&lvi);

      DestroyWindow(hDlg);
      hDlgModeless=0;
      CallPluginA(buf);
    }
    else if (LOWORD(wParam) == IDOK)
    {
      SavePluinsListA(hWndList);
      DestroyWindow(hDlg);
      hDlgModeless=0;
      return TRUE;
    }
    else if (LOWORD(wParam) == IDCANCEL)
    {
      DestroyWindow(hDlg);
      hDlgModeless=0;
      return TRUE;
    }
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (wParam == IDC_PLUGINS_LIST)
    {
      if (((NMLISTVIEW *)lParam)->hdr.code == LVN_ITEMCHANGED)
      {
        if (((NMLISTVIEW *)lParam)->uNewState & LVIS_SELECTED)
        {
          SendMessage(hWndHotkey, HKM_SETHOTKEY, ((NMLISTVIEW *)lParam)->lParam, 0);
          EnableWindow(hWndHotkey, TRUE);
          EnableWindow(hWndAssign, TRUE);
          EnableWindow(hWndCall, TRUE);
          nSelItem=((NMLISTVIEW *)lParam)->iItem;
        }
        if (((NMLISTVIEW *)lParam)->uOldState & LVIS_SELECTED)
        {
          SendMessage(hWndHotkey, HKM_SETHOTKEY, 0, 0);
          EnableWindow(hWndHotkey, FALSE);
          EnableWindow(hWndAssign, FALSE);
          EnableWindow(hWndCall, FALSE);
          nSelItem=-1;
        }
      }
      else if (((NMHDR *)lParam)->code == NM_DBLCLK) PostMessage(hDlg, WM_COMMAND, IDC_PLUGINS_CALL, 0);
    }
  }
  return FALSE;
}

BOOL CALLBACK PluginsDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndList;
  static HWND hWndHotkey;
  static HWND hWndAssign;
  static HWND hWndCall;
  static int nSelItem;
  LVCOLUMNW lvcW;

  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    hWndList=GetDlgItem(hDlg, IDC_PLUGINS_LIST);
    hWndHotkey=GetDlgItem(hDlg, IDC_PLUGINS_HOTKEY);
    hWndAssign=GetDlgItem(hDlg, IDC_PLUGINS_ASSIGN);
    hWndCall=GetDlgItem(hDlg, IDC_PLUGINS_CALL);
    SendMessage(hWndList, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES, LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);
    EnableWindow(hWndHotkey, FALSE);
    EnableWindow(hWndAssign, FALSE);
    EnableWindow(hWndCall, FALSE);

    //Columns
    lvcW.mask=LVCF_TEXT|LVCF_WIDTH|LVCF_SUBITEM;
    lvcW.pszText=wbuf;
    lvcW.cchTextMax=BUFFER_SIZE;

    lstrcpyW(wbuf, L"Plugin::Function");
    lvcW.cx=170;
    lvcW.iSubItem=LVI_FUNCTION_NAME;
    SendMessage(hWndList, LVM_INSERTCOLUMNW, LVI_FUNCTION_NAME, (LPARAM)&lvcW);

    lstrcpyW(wbuf, L"HotKey");
    lvcW.cx=103;
    lvcW.iSubItem=LVI_FUNCTION_HOTKEY;
    SendMessage(hWndList, LVM_INSERTCOLUMNW, LVI_FUNCTION_HOTKEY, (LPARAM)&lvcW);

    FillPluinsListW(hWndList);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_PLUGINS_ASSIGN)
    {
      LVITEMW lviW;
      DWORD dwHotkey;

      dwHotkey=SendMessage(hWndHotkey, HKM_GETHOTKEY, 0, 0);
      GetHotkeyStringW(dwHotkey, wbuf);

      lviW.mask=LVIF_PARAM;
      lviW.iItem=nSelItem;
      lviW.iSubItem=LVI_FUNCTION_NAME;
      lviW.lParam=dwHotkey;
      SendMessage(hWndList, LVM_SETITEMW, 0, (LPARAM)&lviW);

      lviW.mask=LVIF_TEXT;
      lviW.pszText=wbuf;
      lviW.cchTextMax=BUFFER_SIZE;
      lviW.iItem=nSelItem;
      lviW.iSubItem=LVI_FUNCTION_HOTKEY;
      SendMessage(hWndList, LVM_SETITEMW, 0, (LPARAM)&lviW);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_PLUGINS_CALL)
    {
      LVITEMW lviW;

      lviW.mask=LVIF_TEXT;
      lviW.pszText=wbuf;
      lviW.cchTextMax=BUFFER_SIZE;
      lviW.iItem=nSelItem;
      lviW.iSubItem=LVI_FUNCTION_NAME;
      SendMessage(hWndList, LVM_GETITEMW, 0, (LPARAM)&lviW);

      DestroyWindow(hDlg);
      hDlgModeless=0;
      CallPluginW(wbuf);
    }
    else if (LOWORD(wParam) == IDOK)
    {
      SavePluinsListW(hWndList);
      DestroyWindow(hDlg);
      hDlgModeless=0;
      return TRUE;
    }
    else if (LOWORD(wParam) == IDCANCEL)
    {
      DestroyWindow(hDlg);
      hDlgModeless=0;
      return TRUE;
    }
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (wParam == IDC_PLUGINS_LIST)
    {
      if (((NMLISTVIEW *)lParam)->hdr.code == LVN_ITEMCHANGED)
      {
        if (((NMLISTVIEW *)lParam)->uNewState & LVIS_SELECTED)
        {
          SendMessage(hWndHotkey, HKM_SETHOTKEY, ((NMLISTVIEW *)lParam)->lParam, 0);
          EnableWindow(hWndHotkey, TRUE);
          EnableWindow(hWndAssign, TRUE);
          EnableWindow(hWndCall, TRUE);
          nSelItem=((NMLISTVIEW *)lParam)->iItem;
        }
        if (((NMLISTVIEW *)lParam)->uOldState & LVIS_SELECTED)
        {
          SendMessage(hWndHotkey, HKM_SETHOTKEY, 0, 0);
          EnableWindow(hWndHotkey, FALSE);
          EnableWindow(hWndAssign, FALSE);
          EnableWindow(hWndCall, FALSE);
          nSelItem=-1;
        }
      }
      else if (((NMHDR *)lParam)->code == NM_DBLCLK) PostMessage(hDlg, WM_COMMAND, IDC_PLUGINS_CALL, 0);
    }
  }
  return FALSE;
}

void FillPluinsListA(HWND hWnd)
{
  WIN32_FIND_DATA wfd;
  HANDLE hFind;
  HMODULE hInstance;
  PLUGINLISTDATA pld={0};
  char szBaseName[MAX_PATH];

  pld.hWndList=hWnd;
  if (nSaveSettings == SS_REGISTRY)
    RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad\\Plugs", 0, KEY_READ, &pld.hRegKey);
  else
    pld.bIniExists=FileExistsA(szIniFile);

  wsprintf(buf, "%s\\AkelFiles\\Plugs\\*.dll", szExeDir);

  if ((hFind=FindFirstFile(buf, &wfd)) != INVALID_HANDLE_VALUE)
  {
    do
    {
      wsprintf(buf, "%s\\AkelFiles\\Plugs\\%s", szExeDir, wfd.cFileName);

      if (hInstance=LoadLibrary(buf))
      {
        GetBaseNameA(wfd.cFileName, szBaseName);
        pld.pBaseName=(unsigned char *)szBaseName;
        GetExportNames(hInstance, FillPluinsListProcA, (LPARAM)&pld);
        FreeLibrary(hInstance);
      }
    }
    while (FindNextFile(hFind, &wfd));

    FindClose(hFind);
  }
  if (nSaveSettings == SS_REGISTRY && pld.hRegKey) RegCloseKey(pld.hRegKey);
}

void FillPluinsListW(HWND hWnd)
{
  WIN32_FIND_DATAW wfdW;
  HANDLE hFind;
  HMODULE hInstance;
  PLUGINLISTDATA pld={0};
  wchar_t wszBaseName[MAX_PATH];

  pld.hWndList=hWnd;
  if (nSaveSettings == SS_REGISTRY)
    RegOpenKeyExW(HKEY_CURRENT_USER, L"Software\\Akelsoft\\AkelPad\\Plugs", 0, KEY_READ, &pld.hRegKey);
  else
    pld.bIniExists=FileExistsW(wszIniFile);

  wsprintfW(wbuf, L"%s\\AkelFiles\\Plugs\\*.dll", wszExeDir);

  if ((hFind=FindFirstFileW(wbuf, &wfdW)) != INVALID_HANDLE_VALUE)
  {
    do
    {
      wsprintfW(wbuf, L"%s\\AkelFiles\\Plugs\\%s", wszExeDir, wfdW.cFileName);

      if (hInstance=LoadLibraryW(wbuf))
      {
        GetBaseNameW(wfdW.cFileName, wszBaseName);
        pld.pBaseName=(unsigned char *)wszBaseName;
        GetExportNames(hInstance, FillPluinsListProcW, (LPARAM)&pld);
        FreeLibrary(hInstance);
      }
    }
    while (FindNextFileW(hFind, &wfdW));

    FindClose(hFind);
  }
  if (nSaveSettings == SS_REGISTRY && pld.hRegKey) RegCloseKey(pld.hRegKey);
}

BOOL CALLBACK FillPluinsListProcA(char *pExportName, LPARAM lParam)
{
  PLUGINLISTDATA *pld=(PLUGINLISTDATA *)lParam;
  DWORD dwHotkey=0;
  LVITEM lvi;
  DWORD dwType;
  DWORD dwSize;
  int nIndex;

  wsprintf(buf, "%s::%s", (char *)pld->pBaseName, pExportName);
  lvi.mask=LVIF_TEXT;
  lvi.pszText=buf;
  lvi.cchTextMax=BUFFER_SIZE;
  lvi.iItem=0;
  lvi.iSubItem=LVI_FUNCTION_NAME;
  nIndex=SendMessage(pld->hWndList, LVM_INSERTITEM, 0, (LPARAM)&lvi);

  if ((nSaveSettings == SS_REGISTRY && pld->hRegKey) ||
      (nSaveSettings == SS_INI && pld->bIniExists))
  {
    if (nSaveSettings == SS_REGISTRY)
    {
      dwSize=sizeof(DWORD);
      RegQueryValueEx(pld->hRegKey, buf, NULL, &dwType, (LPBYTE)&dwHotkey, &dwSize);
    }
    else
    {
      GetPrivateProfileDWORDA("Plugs", buf, (LPDWORD)&dwHotkey, szIniFile);
    }

    lvi.mask=LVIF_PARAM;
    lvi.iItem=nIndex;
    lvi.iSubItem=LVI_FUNCTION_NAME;
    lvi.lParam=dwHotkey;
    SendMessage(pld->hWndList, LVM_SETITEM, 0, (LPARAM)&lvi);

    GetHotkeyStringA(dwHotkey, buf);
    lvi.mask=LVIF_TEXT;
    lvi.pszText=buf;
    lvi.cchTextMax=BUFFER_SIZE;
    lvi.iItem=nIndex;
    lvi.iSubItem=LVI_FUNCTION_HOTKEY;
    SendMessage(pld->hWndList, LVM_SETITEM, 0, (LPARAM)&lvi);
  }
  return TRUE;
}

BOOL CALLBACK FillPluinsListProcW(char *pExportName, LPARAM lParam)
{
  wchar_t wszExportName[MAX_PATH];
  PLUGINLISTDATA *pld=(PLUGINLISTDATA *)lParam;
  DWORD dwHotkey=0;
  LVITEMW lviW;
  DWORD dwType;
  DWORD dwSize;
  int nIndex;

  MultiByteToWideChar(CP_ACP, 0, pExportName, -1, wszExportName, MAX_PATH);
  wsprintfW(wbuf, L"%s::%s", (wchar_t *)pld->pBaseName, wszExportName);
  lviW.mask=LVIF_TEXT;
  lviW.pszText=wbuf;
  lviW.cchTextMax=BUFFER_SIZE;
  lviW.iItem=0;
  lviW.iSubItem=LVI_FUNCTION_NAME;
  nIndex=SendMessage(pld->hWndList, LVM_INSERTITEMW, 0, (LPARAM)&lviW);

  if ((nSaveSettings == SS_REGISTRY && pld->hRegKey) ||
      (nSaveSettings == SS_INI && pld->bIniExists))
  {
    if (nSaveSettings == SS_REGISTRY)
    {
      dwSize=sizeof(DWORD);
      RegQueryValueExW(pld->hRegKey, wbuf, NULL, &dwType, (LPBYTE)&dwHotkey, &dwSize);
    }
    else
    {
      GetPrivateProfileDWORDW(L"Plugs", wbuf, (LPDWORD)&dwHotkey, wszIniFile);
    }

    lviW.mask=LVIF_PARAM;
    lviW.iItem=nIndex;
    lviW.iSubItem=LVI_FUNCTION_NAME;
    lviW.lParam=dwHotkey;
    SendMessage(pld->hWndList, LVM_SETITEMW, 0, (LPARAM)&lviW);

    GetHotkeyStringW(dwHotkey, wbuf);
    lviW.mask=LVIF_TEXT;
    lviW.pszText=wbuf;
    lviW.cchTextMax=BUFFER_SIZE;
    lviW.iItem=nIndex;
    lviW.iSubItem=LVI_FUNCTION_HOTKEY;
    SendMessage(pld->hWndList, LVM_SETITEMW, 0, (LPARAM)&lviW);
  }
  return TRUE;
}

void SavePluinsListA(HWND hWnd)
{
  LVITEM lvi;
  ATOM nAtom;
  HKEY hKey;
  int i=0;

  if (nSaveSettings == SS_REGISTRY)
  {
   if (RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad\\Plugs", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) != ERROR_SUCCESS)
     return;
  }

  while (1)
  {
    lvi.mask=LVIF_TEXT|LVIF_PARAM;
    lvi.pszText=buf;
    lvi.cchTextMax=BUFFER_SIZE;
    lvi.iItem=i++;
    lvi.iSubItem=LVI_FUNCTION_NAME;
    if (!SendMessage(hWnd, LVM_GETITEM, 0, (LPARAM)&lvi)) break;

    if (nSaveSettings == SS_REGISTRY)
    {
      if (RegSetValueEx(hKey, lvi.pszText, 0, REG_DWORD, (LPBYTE)&lvi.lParam, sizeof(DWORD)) != ERROR_SUCCESS)
        break;
    }
    else
    {
      if (!WritePrivateProfileDWORDA("Plugs", lvi.pszText, lvi.lParam, szIniFile))
        break;
    }

    if (nAtom=FindAtom(lvi.pszText))
      UnregisterHotKey(hMainWnd, nAtom);
    else if (lvi.lParam)
      nAtom=AddAtom(lvi.pszText);

    if (lvi.lParam) RegisterHotKey(hMainWnd, nAtom, HotKeyToModKey(HIBYTE(lvi.lParam)), LOBYTE(lvi.lParam));
  }
  if (nSaveSettings == SS_REGISTRY) RegCloseKey(hKey);
}

void SavePluinsListW(HWND hWnd)
{
  LVITEMW lviW;
  ATOM nAtom;
  HKEY hKey;
  int i=0;

  if (nSaveSettings == SS_REGISTRY)
  {
   if (RegCreateKeyExW(HKEY_CURRENT_USER, L"Software\\Akelsoft\\AkelPad\\Plugs", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) != ERROR_SUCCESS)
     return;
  }

  while (1)
  {
    lviW.mask=LVIF_TEXT|LVIF_PARAM;
    lviW.pszText=wbuf;
    lviW.cchTextMax=BUFFER_SIZE;
    lviW.iItem=i++;
    lviW.iSubItem=LVI_FUNCTION_NAME;
    if (!SendMessage(hWnd, LVM_GETITEMW, 0, (LPARAM)&lviW)) break;

    if (nSaveSettings == SS_REGISTRY)
    {
      if (RegSetValueExW(hKey, lviW.pszText, 0, REG_DWORD, (LPBYTE)&lviW.lParam, sizeof(DWORD)) != ERROR_SUCCESS)
        break;
    }
    else
    {
      if (!WritePrivateProfileDWORDW(L"Plugs", lviW.pszText, lviW.lParam, wszIniFile))
        break;
    }

    if (nAtom=FindAtomW(lviW.pszText))
      UnregisterHotKey(hMainWnd, nAtom);
    else if (lviW.lParam)
      nAtom=AddAtomW(lviW.pszText);

    if (lviW.lParam) RegisterHotKey(hMainWnd, nAtom, HotKeyToModKey(HIBYTE(lviW.lParam)), LOBYTE(lviW.lParam));
  }
  if (nSaveSettings == SS_REGISTRY) RegCloseKey(hKey);
}

void GetHotkeyStringA(DWORD dwHotkey, char *szString)
{
  char szKeyText[100];
  LONG lScan;

  szString[0]='\0';

  if (dwHotkey)
  {
    if (HIBYTE(dwHotkey) & HOTKEYF_CONTROL)
      lstrcat(szString, "Ctrl + ");
    if (HIBYTE(dwHotkey) & HOTKEYF_SHIFT)
      lstrcat(szString, "Shift + ");
    if (HIBYTE(dwHotkey) & HOTKEYF_ALT)
      lstrcat(szString, "Alt + ");
    lScan=MapVirtualKey(LOBYTE(dwHotkey), 0) << 16;
    if (HIBYTE(dwHotkey) & HOTKEYF_EXT) lScan|=0x01000000L;
    GetKeyNameText(lScan, szKeyText, 100);
    lstrcat(szString, szKeyText);
  }
}

void GetHotkeyStringW(DWORD dwHotkey, wchar_t *wszString)
{
  wchar_t wszKeyText[100];
  LONG lScan;

  wszString[0]='\0';

  if (dwHotkey)
  {
    if (HIBYTE(dwHotkey) & HOTKEYF_CONTROL)
      lstrcatW(wszString, L"Ctrl + ");
    if (HIBYTE(dwHotkey) & HOTKEYF_SHIFT)
      lstrcatW(wszString, L"Shift + ");
    if (HIBYTE(dwHotkey) & HOTKEYF_ALT)
      lstrcatW(wszString, L"Alt + ");
    lScan=MapVirtualKeyW(LOBYTE(dwHotkey), 0) << 16;
    if (HIBYTE(dwHotkey) & HOTKEYF_EXT) lScan|=0x01000000L;
    GetKeyNameTextW(lScan, wszKeyText, 100);
    lstrcatW(wszString, wszKeyText);
  }
}

void RegRegisterPluginsHotkeysA()
{
  char szPlugin[MAX_PATH];
  char *pFunction=&buf[0];
  HKEY hKey;
  DWORD dwType;
  DWORD dwSizeValue;
  DWORD dwSizeString;
  DWORD dwIndex=0;
  DWORD dwHotkey=0;

  if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad\\Plugs", 0, KEY_READ, &hKey) == ERROR_SUCCESS)
  {
    while (1)
    {
      dwSizeValue=BUFFER_SIZE;
      dwSizeString=sizeof(DWORD);
      if (RegEnumValue(hKey, dwIndex++, pFunction, &dwSizeValue, NULL, &dwType, (LPBYTE)&dwHotkey, &dwSizeString) != ERROR_SUCCESS)
        break;

      if (dwHotkey)
      {
        if (ParsePluginNameA(pFunction, szPlugin, NULL))
        {
          wsprintf(buf2, "%s\\AkelFiles\\Plugs\\%s.dll", szExeDir, szPlugin);

          if (FileExistsA(buf2)) RegisterHotKey(hMainWnd, AddAtom(pFunction), HotKeyToModKey(HIBYTE(dwHotkey)), LOBYTE(dwHotkey));
        }
      }
    }
    RegCloseKey(hKey);
  }
}

void RegRegisterPluginsHotkeysW()
{
  wchar_t wszPlugin[MAX_PATH];
  wchar_t *wpFunction=&wbuf[0];
  HKEY hKey;
  DWORD dwType;
  DWORD dwSizeValue;
  DWORD dwSizeString;
  DWORD dwIndex=0;
  DWORD dwHotkey=0;

  if (RegOpenKeyExW(HKEY_CURRENT_USER, L"Software\\Akelsoft\\AkelPad\\Plugs", 0, KEY_READ, &hKey) == ERROR_SUCCESS)
  {
    while (1)
    {
      dwSizeValue=BUFFER_SIZE;
      dwSizeString=sizeof(DWORD);
      if (RegEnumValueW(hKey, dwIndex++, wpFunction, &dwSizeValue, NULL, &dwType, (LPBYTE)&dwHotkey, &dwSizeString) != ERROR_SUCCESS)
        break;

      if (dwHotkey)
      {
        if (ParsePluginNameW(wpFunction, wszPlugin, NULL))
        {
          wsprintfW(wbuf2, L"%s\\AkelFiles\\Plugs\\%s.dll", wszExeDir, wszPlugin);

          if (FileExistsW(wbuf2)) RegisterHotKey(hMainWnd, AddAtomW(wpFunction), HotKeyToModKey(HIBYTE(dwHotkey)), LOBYTE(dwHotkey));
        }
      }
    }
    RegCloseKey(hKey);
  }
}

void IniRegisterPluginsHotkeysA()
{
  char szPlugin[MAX_PATH];
  char *szIniBuffer;
  char *pFunction;
  DWORD dwHotkey=0;

  if (!FileExistsA(szIniFile)) return;

  if (pFunction=szIniBuffer=(char *)API_HeapAlloc(hHeap, 0, MAX_INI_SIZE + 1))
  {
    if (GetPrivateProfileString("Plugs", NULL, "", szIniBuffer, MAX_INI_SIZE, szIniFile))
    {
      while (1)
      {
        GetPrivateProfileDWORDA("Plugs", pFunction, (LPDWORD)&dwHotkey, szIniFile);

        if (dwHotkey)
        {
          if (ParsePluginNameA(pFunction, szPlugin, NULL))
          {
            wsprintf(buf2, "%s\\AkelFiles\\Plugs\\%s.dll", szExeDir, szPlugin);

            if (FileExistsA(buf2)) RegisterHotKey(hMainWnd, AddAtom(pFunction), HotKeyToModKey(HIBYTE(dwHotkey)), LOBYTE(dwHotkey));
          }
        }
        if (!*(pFunction+=lstrlen(pFunction) + 1)) break;
      }
    }
    API_HeapFree(hHeap, 0, (LPVOID)szIniBuffer);
  }
}

void IniRegisterPluginsHotkeysW()
{
  wchar_t wszPlugin[MAX_PATH];
  wchar_t *wszIniBuffer;
  wchar_t *wpFunction;
  DWORD dwHotkey=0;

  if (!FileExistsW(wszIniFile)) return;

  if (wpFunction=wszIniBuffer=(wchar_t *)API_HeapAlloc(hHeap, 0, MAX_INI_SIZE * sizeof(wchar_t) + 2))
  {
    if (GetPrivateProfileStringW(L"Plugs", NULL, L"", wszIniBuffer, MAX_INI_SIZE, wszIniFile))
    {
      while (1)
      {
        GetPrivateProfileDWORDW(L"Plugs", wpFunction, (LPDWORD)&dwHotkey, wszIniFile);

        if (dwHotkey)
        {
          if (ParsePluginNameW(wpFunction, wszPlugin, NULL))
          {
            wsprintfW(wbuf2, L"%s\\AkelFiles\\Plugs\\%s.dll", wszExeDir, wszPlugin);

            if (FileExistsW(wbuf2)) RegisterHotKey(hMainWnd, AddAtomW(wpFunction), HotKeyToModKey(HIBYTE(dwHotkey)), LOBYTE(dwHotkey));
          }
        }
        if (!*(wpFunction+=lstrlenW(wpFunction) + 1)) break;
      }
    }
    API_HeapFree(hHeap, 0, (LPVOID)wszIniBuffer);
  }
}

BOOL ParsePluginNameA(char *pFullName, char *szPlugin, char *szFunction)
{
  char *pFunction;

  if ((pFunction=strchr(pFullName, ':')) && *(pFunction + 1) == ':')
  {
    if (szPlugin) lstrcpyn(szPlugin, pFullName, pFunction - pFullName + 1);
    if (szFunction) lstrcpy(szFunction, pFunction + 2);
    return TRUE;
  }
  return FALSE;
}

BOOL ParsePluginNameW(wchar_t *wpFullName, wchar_t *wszPlugin, wchar_t *wszFunction)
{
  wchar_t *wpFunction;

  if ((wpFunction=wcschr(wpFullName, ':')) && *(wpFunction + 1) == ':')
  {
    if (wszPlugin) lstrcpynW(wszPlugin, wpFullName, wpFunction - wpFullName + 1);
    if (wszFunction) lstrcpyW(wszFunction, wpFunction + 2);
    return TRUE;
  }
  return FALSE;
}

void CallPluginA(char *pFullName)
{
  char szPlugin[MAX_PATH];
  char szFunction[MAX_PATH];
  HMODULE hModule;
  PLUGINDATA pd;
  void (*PluginFunctionPtr)(PLUGINDATA *);

  if (ParsePluginNameA(pFullName, szPlugin, szFunction))
  {
    wsprintf(buf, "%s\\AkelFiles\\Plugs\\%s.dll", szExeDir, szPlugin);

    if (hModule=LoadLibrary(buf))
    {
      if (PluginFunctionPtr=(void (*)(PLUGINDATA *))GetProcAddress(hModule, szFunction))
      {
        pd.cb=sizeof(PLUGINDATA);
        pd.hInstance=hInstance;
        pd.hMainWnd=hMainWnd;
        pd.hWndEdit=hWndEdit;
        pd.hStatus=hStatus;
        pd.hMainMenu=hMainMenu;
        pd.hPopupMenu=hPopupEdit;
        pd.bOldWindows=bOldWindows;
        pd.bOldRichEdit=bOldRichEdit;
        pd.bOldComctl32=bOldComctl32;
        pd.bMDI=bMDI;
        pd.pFile=(unsigned char *)szCurrentFile;
        pd.nCodePage=nCurrentCodePage;
        pd.bBOM=bCurrentBOM;
        pd.bModified=bModified;

        (*PluginFunctionPtr)(&pd);
      }
      FreeLibrary(hModule);
    }
  }
}

void CallPluginW(wchar_t *wpFullName)
{
  wchar_t wszPlugin[MAX_PATH];
  wchar_t wszFunction[MAX_PATH];
  char szFunction[MAX_PATH];
  HMODULE hModule;
  PLUGINDATA pd;
  void (*PluginFunctionPtr)(PLUGINDATA *);

  if (ParsePluginNameW(wpFullName, wszPlugin, wszFunction))
  {
    WideCharToMultiByte(CP_ACP, 0, wszFunction, -1, szFunction, MAX_PATH, NULL, NULL);
    wsprintfW(wbuf, L"%s\\AkelFiles\\Plugs\\%s.dll", wszExeDir, wszPlugin);

    if (hModule=LoadLibraryW(wbuf))
    {
      if (PluginFunctionPtr=(void (*)(PLUGINDATA *))GetProcAddress(hModule, szFunction))
      {
        pd.cb=sizeof(PLUGINDATA);
        pd.hInstance=hInstance;
        pd.hMainWnd=hMainWnd;
        pd.hWndEdit=hWndEdit;
        pd.hStatus=hStatus;
        pd.hMainMenu=hMainMenu;
        pd.hPopupMenu=hPopupEdit;
        pd.bOldWindows=bOldWindows;
        pd.bOldRichEdit=bOldRichEdit;
        pd.bOldComctl32=bOldComctl32;
        pd.bMDI=bMDI;
        pd.pFile=(unsigned char *)wszCurrentFile;
        pd.nCodePage=nCurrentCodePage;
        pd.bBOM=bCurrentBOM;
        pd.bModified=bModified;

        (*PluginFunctionPtr)(&pd);
      }
      FreeLibrary(hModule);
    }
  }
}

UINT HotKeyToModKey(WORD wHot)
{
  UINT uMod=0;

  if (wHot & HOTKEYF_ALT) uMod|=MOD_ALT;
  if (wHot & HOTKEYF_SHIFT) uMod|=MOD_SHIFT;
  if (wHot & HOTKEYF_CONTROL) uMod|=MOD_CONTROL;

  return uMod;
}

BOOL GetExportNames(HMODULE hInstance, EXPORTNAMESPROC lpExportNamesProc, LPARAM lParam)
{
  PIMAGE_DOS_HEADER pDOSHead;
  PIMAGE_NT_HEADERS pPEHeader;
  PIMAGE_EXPORT_DIRECTORY pImportDesc;
  unsigned long *pchName;
  char *pName;
  DWORD i;

  pDOSHead=(PIMAGE_DOS_HEADER)hInstance;
  if (pDOSHead->e_magic != IMAGE_DOS_SIGNATURE)
    return FALSE;

  pPEHeader=(PIMAGE_NT_HEADERS)((DWORD)hInstance + pDOSHead->e_lfanew);
  if (pPEHeader->Signature != IMAGE_NT_SIGNATURE)
    return FALSE;

  pImportDesc=(PIMAGE_EXPORT_DIRECTORY)((DWORD)hInstance + pPEHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress);
  pchName=(unsigned long *)((DWORD)hInstance + pImportDesc->AddressOfNames);

  for (i=0; i < pImportDesc->NumberOfNames; ++i)
  {
    pName=(char *)((DWORD)hInstance + pchName[i]);
    if ((*lpExportNamesProc)(pName, lParam) == FALSE) return TRUE;
  }
  return TRUE;
}


//// Options

LRESULT CALLBACK CBTProc(int iCode, WPARAM wParam, LPARAM lParam)
{
  //Center PropertySheet
  if (iCode == HCBT_ACTIVATE)
  {
    RECT rcEdit;
    RECT rcSheet;

    UnhookWindowsHookEx(cbtHook);

    GetWindowRect(hMainWnd, &rcEdit);
    GetWindowRect((HWND)wParam, &rcSheet);
    rcSheet.left=rcEdit.left + ((rcEdit.right - rcEdit.left) / 2) - ((rcSheet.right - rcSheet.left) / 2);
    rcSheet.top=rcEdit.top + ((rcEdit.bottom - rcEdit.top) / 2) - ((rcSheet.bottom - rcSheet.top) / 2);
    if (rcSheet.left < 0) rcSheet.left=0;
    if (rcSheet.top < 0) rcSheet.top=0;

    SetWindowPos((HWND)wParam, NULL, rcSheet.left, rcSheet.top, 0, 0, SWP_NOSIZE|SWP_NOZORDER);
  }
  return 0;
}

int CALLBACK PropSheetProc(HWND hDlg, UINT uMsg, LPARAM lParam)
{
  //Remove "?"
  if (uMsg == PSCB_PRECREATE)
    ((DLGTEMPLATE *)lParam)->style&=~DS_CONTEXTHELP;

  return TRUE;
}

BOOL CALLBACK OptionsGeneralDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndDefaultCP;
  static HWND hWndAutodetectCP;
  HWND hWndRecentFiles;
  HWND hWndRecentFilesSpin;
  HWND hWndRecentFilesClear;
  HWND hWndSearchStrings;
  HWND hWndSearchStringsSpin;
  HWND hWndSearchStringsClear;
  HWND hWndCommand;
  HWND hWndDirectory;
  HKEY hKey;
  int i;

  if (uMsg == WM_INITDIALOG)
  {
    hWndRecentFiles=GetDlgItem(hDlg, IDC_OPTIONS_RECENTFILES_AMOUNT);
    hWndRecentFilesSpin=GetDlgItem(hDlg, IDC_OPTIONS_RECENTFILES_AMOUNT_SPIN);
    hWndRecentFilesClear=GetDlgItem(hDlg, IDC_OPTIONS_RECENTFILES_CLEAR);
    hWndSearchStrings=GetDlgItem(hDlg, IDC_OPTIONS_SEARCHSTRINGS_AMOUNT);
    hWndSearchStringsSpin=GetDlgItem(hDlg, IDC_OPTIONS_SEARCHSTRINGS_AMOUNT_SPIN);
    hWndSearchStringsClear=GetDlgItem(hDlg, IDC_OPTIONS_SEARCHSTRINGS_CLEAR);
    hWndCommand=GetDlgItem(hDlg, IDC_OPTIONS_EXECCOM);
    hWndDirectory=GetDlgItem(hDlg, IDC_OPTIONS_EXECDIR);
    hWndDefaultCP=GetDlgItem(hDlg, IDC_OPTIONS_DEFAULT_CODEPAGE);
    hWndAutodetectCP=GetDlgItem(hDlg, IDC_OPTIONS_CODEPAGE_RECOGNITION);

    SendMessage(hWndCommand, EM_LIMITTEXT, (WPARAM)BUFFER_SIZE, 0);
    SendMessage(hWndDirectory, EM_LIMITTEXT, (WPARAM)MAX_PATH, 0);
    SendMessage(hWndRecentFilesSpin, UDM_SETBUDDY, (WPARAM)hWndRecentFiles, 0);
    SendMessage(hWndRecentFilesSpin, UDM_SETRANGE, 0, (LPARAM)MAKELONG(999, 0));
    SendMessage(hWndSearchStringsSpin, UDM_SETBUDDY, (WPARAM)hWndSearchStrings, 0);
    SendMessage(hWndSearchStringsSpin, UDM_SETRANGE, 0, (LPARAM)MAKELONG(999, 0));

    SetDlgItemInt(hDlg, IDC_OPTIONS_RECENTFILES_AMOUNT, nRecentFiles, FALSE);
    if (!nRecentFiles || !*szRecentNames[0]) EnableWindow(hWndRecentFilesClear, FALSE);
    SetDlgItemInt(hDlg, IDC_OPTIONS_SEARCHSTRINGS_AMOUNT, nSearchStrings, FALSE);
    if (!nSearchStrings) EnableWindow(hWndSearchStringsClear, FALSE);
    SetWindowText(hWndCommand, szCommand);
    SetWindowText(hWndDirectory, szWorkDir);

    FillComboboxCodepageA(hWndDefaultCP);
    SelectComboboxCodepageA(hWndDefaultCP, nDefaultCodePage);

    API_LoadStringA(hLangLib, STR_NONE, buf, BUFFER_SIZE);
    SendMessage(hWndAutodetectCP, CB_ADDSTRING, 0, (LPARAM)buf);
    API_LoadStringA(hLangLib, STR_AUTODETECT_RUSSIAN, buf, BUFFER_SIZE);
    SendMessage(hWndAutodetectCP, CB_ADDSTRING, 0, (LPARAM)buf);
    if (wLangCodepageRecognition == LANGID_RUSSIAN)
      SendMessage(hWndAutodetectCP, CB_SETCURSEL, (WPARAM)1, 0);
    else
      SendMessage(hWndAutodetectCP, CB_SETCURSEL, (WPARAM)0, 0);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_OPTIONS_RECENTFILES_CLEAR)
    {
      RecentFilesZeroA();
      RecentFilesSaveA();
      RecentFilesMenuA();
      EnableWindow((HWND)lParam, FALSE);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_OPTIONS_SEARCHSTRINGS_CLEAR)
    {
      if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad", 0, KEY_ENUMERATE_SUB_KEYS, &hKey) == ERROR_SUCCESS)
      {
        RegDeleteKey(hKey, "Search");
        RegCloseKey(hKey);

        if (RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad\\Search", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS)
          RegCloseKey(hKey);
      }
      EnableWindow((HWND)lParam, FALSE);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_OPTIONS_EXECCOM_BROWSE)
    {
      OPENFILENAME efn={0};

      buf[0]='\0';
      efn.lStructSize      =sizeof(OPENFILENAME);
      efn.hwndOwner        =hDlg;
      efn.lpstrFile        =(char *)&buf;
      efn.nMaxFile         =MAX_PATH;
      efn.lpstrFilter      ="Executable files (*.exe)\0*.exe\0All files (*.*)\0*.*";
      efn.nFilterIndex     =1;
      efn.Flags            =OFN_HIDEREADONLY|OFN_PATHMUSTEXIST;

      if (GetOpenFileName(&efn))
      {
        wsprintf(buf2, "\"%s\"", buf);
        SetDlgItemText(hDlg, IDC_OPTIONS_EXECCOM, buf2);
      }
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_OPTIONS_EXECDIR_BROWSE)
    {
      BROWSEINFO bi={0};
      LPITEMIDLIST pIdList;
      LPMALLOC pMalloc;

      GetDlgItemText(hDlg, IDC_OPTIONS_EXECDIR, buf, BUFFER_SIZE);
      bi.hwndOwner=hDlg;
      bi.pszDisplayName=buf;
      bi.ulFlags=BIF_RETURNONLYFSDIRS|BIF_NEWDIALOGSTYLE;
      bi.lpfn=BrowseCallbackProcA;
      bi.lParam=(LPARAM)buf;

      if (pIdList=(*SHBrowseForFolderAPrt)(&bi))
      {
        (*SHGetPathFromIDListAPrt)(pIdList, buf);

        if (SHGetMalloc(&pMalloc))
        {
          pMalloc->Free(pIdList);
          pMalloc->Release();
        }
        SetDlgItemText(hDlg, IDC_OPTIONS_EXECDIR, buf);
      }
      return TRUE;
    }
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (((NMHDR *)lParam)->code == PSN_APPLY)
    {
      //Recent files
      i=GetDlgItemInt(hDlg, IDC_OPTIONS_RECENTFILES_AMOUNT, NULL, FALSE);
      if (nRecentFiles != i)
      {
        nRecentFiles=i;
        FreeMemoryRecentFilesA();

        if (nRecentFiles)
        {
          if ((szRecentNames=(char (*)[MAX_PATH])API_HeapAlloc(hHeap, 0, nRecentFiles * MAX_PATH)) &&
              (szRecentPositions=(DWORD *)API_HeapAlloc(hHeap, 0, nRecentFiles * sizeof(DWORD))) &&
              (szRecentCodepages=(DWORD *)API_HeapAlloc(hHeap, 0, nRecentFiles * sizeof(DWORD))))
          {
            RecentFilesZeroA();
            RecentFilesReadA();
          }
        }
        RecentFilesMenuA();

        if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Akelsoft\\AkelPad", 0, KEY_ENUMERATE_SUB_KEYS, &hKey) == ERROR_SUCCESS)
        {
          RegDeleteKey(hKey, "Recent");
          RegCloseKey(hKey);
          RecentFilesSaveA();
        }
      }

      //Search history
      nSearchStrings=GetDlgItemInt(hDlg, IDC_OPTIONS_SEARCHSTRINGS_AMOUNT, NULL, FALSE);

      //Execute
      GetDlgItemText(hDlg, IDC_OPTIONS_EXECCOM, szCommand, BUFFER_SIZE);
      GetDlgItemText(hDlg, IDC_OPTIONS_EXECDIR, szWorkDir, MAX_PATH);

      //Default codepage
      nDefaultCodePage=GetComboboxCodepageA(hWndDefaultCP);

      //Autodetect codepage
      i=SendMessage(hWndAutodetectCP, CB_GETCURSEL, 0, 0);

      if (i == 0)
        wLangCodepageRecognition=0;
      else if (i == 1)
        wLangCodepageRecognition=LANGID_RUSSIAN;
    }
  }
  return FALSE;
}

BOOL CALLBACK OptionsGeneralDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndDefaultCP;
  static HWND hWndAutodetectCP;
  HWND hWndRecentFiles;
  HWND hWndRecentFilesSpin;
  HWND hWndRecentFilesClear;
  HWND hWndSearchStrings;
  HWND hWndSearchStringsSpin;
  HWND hWndSearchStringsClear;
  HWND hWndCommand;
  HWND hWndDirectory;
  HKEY hKey;
  int i;

  if (uMsg == WM_INITDIALOG)
  {
    hWndRecentFiles=GetDlgItem(hDlg, IDC_OPTIONS_RECENTFILES_AMOUNT);
    hWndRecentFilesSpin=GetDlgItem(hDlg, IDC_OPTIONS_RECENTFILES_AMOUNT_SPIN);
    hWndRecentFilesClear=GetDlgItem(hDlg, IDC_OPTIONS_RECENTFILES_CLEAR);
    hWndSearchStrings=GetDlgItem(hDlg, IDC_OPTIONS_SEARCHSTRINGS_AMOUNT);
    hWndSearchStringsSpin=GetDlgItem(hDlg, IDC_OPTIONS_SEARCHSTRINGS_AMOUNT_SPIN);
    hWndSearchStringsClear=GetDlgItem(hDlg, IDC_OPTIONS_SEARCHSTRINGS_CLEAR);
    hWndCommand=GetDlgItem(hDlg, IDC_OPTIONS_EXECCOM);
    hWndDirectory=GetDlgItem(hDlg, IDC_OPTIONS_EXECDIR);
    hWndDefaultCP=GetDlgItem(hDlg, IDC_OPTIONS_DEFAULT_CODEPAGE);
    hWndAutodetectCP=GetDlgItem(hDlg, IDC_OPTIONS_CODEPAGE_RECOGNITION);

    SendMessage(hWndCommand, EM_LIMITTEXT, (WPARAM)BUFFER_SIZE, 0);
    SendMessage(hWndDirectory, EM_LIMITTEXT, (WPARAM)MAX_PATH, 0);
    SendMessage(hWndRecentFilesSpin, UDM_SETBUDDY, (WPARAM)hWndRecentFiles, 0);
    SendMessage(hWndRecentFilesSpin, UDM_SETRANGE, 0, (LPARAM)MAKELONG(999, 0));
    SendMessage(hWndSearchStringsSpin, UDM_SETBUDDY, (WPARAM)hWndSearchStrings, 0);
    SendMessage(hWndSearchStringsSpin, UDM_SETRANGE, 0, (LPARAM)MAKELONG(999, 0));

    SetDlgItemInt(hDlg, IDC_OPTIONS_RECENTFILES_AMOUNT, nRecentFiles, FALSE);
    if (!nRecentFiles || !*wszRecentNames[0]) EnableWindow(hWndRecentFilesClear, FALSE);
    SetDlgItemInt(hDlg, IDC_OPTIONS_SEARCHSTRINGS_AMOUNT, nSearchStrings, FALSE);
    if (!nSearchStrings) EnableWindow(hWndSearchStringsClear, FALSE);
    SetWindowTextW(hWndCommand, wszCommand);
    SetWindowTextW(hWndDirectory, wszWorkDir);

    FillComboboxCodepageW(hWndDefaultCP);
    SelectComboboxCodepageW(hWndDefaultCP, nDefaultCodePage);

    API_LoadStringW(hLangLib, STR_NONE, wbuf, BUFFER_SIZE);
    SendMessageW(hWndAutodetectCP, CB_ADDSTRING, 0, (LPARAM)wbuf);
    API_LoadStringW(hLangLib, STR_AUTODETECT_RUSSIAN, wbuf, BUFFER_SIZE);
    SendMessageW(hWndAutodetectCP, CB_ADDSTRING, 0, (LPARAM)wbuf);
    if (wLangCodepageRecognition == LANGID_RUSSIAN)
      SendMessage(hWndAutodetectCP, CB_SETCURSEL, (WPARAM)1, 0);
    else
      SendMessage(hWndAutodetectCP, CB_SETCURSEL, (WPARAM)0, 0);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_OPTIONS_RECENTFILES_CLEAR)
    {
      RecentFilesZeroW();
      RecentFilesSaveW();
      RecentFilesMenuW();
      EnableWindow((HWND)lParam, FALSE);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_OPTIONS_SEARCHSTRINGS_CLEAR)
    {
      if (RegOpenKeyExW(HKEY_CURRENT_USER, L"Software\\Akelsoft\\AkelPad", 0, KEY_ENUMERATE_SUB_KEYS, &hKey) == ERROR_SUCCESS)
      {
        RegDeleteKeyW(hKey, L"Search");
        RegCloseKey(hKey);

        if (RegCreateKeyExW(HKEY_CURRENT_USER, L"Software\\Akelsoft\\AkelPad\\Search", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS)
          RegCloseKey(hKey);
      }
      EnableWindow((HWND)lParam, FALSE);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_OPTIONS_EXECCOM_BROWSE)
    {
      OPENFILENAMEW efnW={0};

      wbuf[0]='\0';
      efnW.lStructSize      =sizeof(OPENFILENAMEW);
      efnW.hwndOwner        =hDlg;
      efnW.lpstrFile        =wbuf;
      efnW.nMaxFile         =MAX_PATH;
      efnW.lpstrFilter      =L"Executable files (*.exe)\0*.exe\0All files (*.*)\0*.*";
      efnW.nFilterIndex     =1;
      efnW.Flags            =OFN_HIDEREADONLY|OFN_PATHMUSTEXIST;

      if (GetOpenFileNameW(&efnW))
      {
        wsprintfW(wbuf2, L"\"%s\"", wbuf);
        SetDlgItemTextW(hDlg, IDC_OPTIONS_EXECCOM, wbuf2);
      }
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_OPTIONS_EXECDIR_BROWSE)
    {
      BROWSEINFOW biW={0};
      LPITEMIDLIST pIdList;
      LPMALLOC pMalloc;

      GetDlgItemTextW(hDlg, IDC_OPTIONS_EXECDIR, wbuf, BUFFER_SIZE);
      biW.hwndOwner=hDlg;
      biW.pszDisplayName=wbuf;
      biW.ulFlags=BIF_RETURNONLYFSDIRS|BIF_NEWDIALOGSTYLE;
      biW.lpfn=BrowseCallbackProcW;
      biW.lParam=(LPARAM)wbuf;

      if (pIdList=(*SHBrowseForFolderWPrt)(&biW))
      {
        (*SHGetPathFromIDListWPrt)(pIdList, wbuf);

        if (SHGetMalloc(&pMalloc))
        {
          pMalloc->Free(pIdList);
          pMalloc->Release();
        }
        SetDlgItemTextW(hDlg, IDC_OPTIONS_EXECDIR, wbuf);
      }
      return TRUE;
    }
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (((NMHDR *)lParam)->code == PSN_APPLY)
    {
      //Recent files
      i=GetDlgItemInt(hDlg, IDC_OPTIONS_RECENTFILES_AMOUNT, NULL, FALSE);
      if (nRecentFiles != i)
      {
        nRecentFiles=i;
        FreeMemoryRecentFilesW();

        if (nRecentFiles)
        {
          if ((wszRecentNames=(wchar_t (*)[MAX_PATH])API_HeapAlloc(hHeap, 0, nRecentFiles * MAX_PATH * sizeof(wchar_t))) &&
              (szRecentPositions=(DWORD *)API_HeapAlloc(hHeap, 0, nRecentFiles * sizeof(DWORD))) &&
              (szRecentCodepages=(DWORD *)API_HeapAlloc(hHeap, 0, nRecentFiles * sizeof(DWORD))))
          {
            RecentFilesZeroW();
            RecentFilesReadW();
          }
        }
        RecentFilesMenuW();

        if (RegOpenKeyExW(HKEY_CURRENT_USER, L"Software\\Akelsoft\\AkelPad", 0, KEY_ENUMERATE_SUB_KEYS, &hKey) == ERROR_SUCCESS)
        {
          RegDeleteKeyW(hKey, L"Recent");
          RegCloseKey(hKey);
          RecentFilesSaveW();
        }
      }

      //Search history
      nSearchStrings=GetDlgItemInt(hDlg, IDC_OPTIONS_SEARCHSTRINGS_AMOUNT, NULL, FALSE);

      //Execute
      GetDlgItemTextW(hDlg, IDC_OPTIONS_EXECCOM, wszCommand, BUFFER_SIZE);
      GetDlgItemTextW(hDlg, IDC_OPTIONS_EXECDIR, wszWorkDir, MAX_PATH);

      //Default codepage
      nDefaultCodePage=GetComboboxCodepageW(hWndDefaultCP);

      //Autodetect codepage
      i=SendMessage(hWndAutodetectCP, CB_GETCURSEL, 0, 0);

      if (i == 0)
        wLangCodepageRecognition=0;
      else if (i == 1)
        wLangCodepageRecognition=LANGID_RUSSIAN;
    }
  }
  return FALSE;
}

int CALLBACK BrowseCallbackProcA(HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
  if (uMsg == BFFM_INITIALIZED)
  {
    SendMessage(hWnd, BFFM_SETSELECTION, TRUE, lpData);
  }
  return 0;
}

int CALLBACK BrowseCallbackProcW(HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
  if (uMsg == BFFM_INITIALIZED)
  {
    SendMessage(hWnd, BFFM_SETSELECTIONW, TRUE, lpData);
  }
  return 0;
}

BOOL CALLBACK OptionsAdvancedDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndFileTypesOpen;
  static HWND hWndAssociateOpen;
  static HWND hWndFileTypesEdit;
  static HWND hWndAssociateEdit;
  static HWND hWndFileTypesPrint;
  static HWND hWndAssociatePrint;
  static HWND hWndTabSize;
  static HWND hWndTabSizeSpaces;
  static HWND hWndSaveRegistry;
  static HWND hWndSaveINI;
  HWND hWndTabSizeSpin;
  HWND hWndMarginLeft;
  HWND hWndMarginLeftSpin;
  HWND hWndMarginRight;
  HWND hWndMarginRightSpin;
  HWND hWndDelimiters;
  BOOL bState;

  if (uMsg == WM_INITDIALOG)
  {
    hWndFileTypesOpen=GetDlgItem(hDlg, IDC_OPTIONS_FILETYPES_OPEN);
    hWndAssociateOpen=GetDlgItem(hDlg, IDC_OPTIONS_ASSOCIATE_OPEN);
    hWndFileTypesEdit=GetDlgItem(hDlg, IDC_OPTIONS_FILETYPES_EDIT);
    hWndAssociateEdit=GetDlgItem(hDlg, IDC_OPTIONS_ASSOCIATE_EDIT);
    hWndFileTypesPrint=GetDlgItem(hDlg, IDC_OPTIONS_FILETYPES_PRINT);
    hWndAssociatePrint=GetDlgItem(hDlg, IDC_OPTIONS_ASSOCIATE_PRINT);
    hWndTabSize=GetDlgItem(hDlg, IDC_OPTIONS_TABSIZE);
    hWndTabSizeSpin=GetDlgItem(hDlg, IDC_OPTIONS_TABSIZE_SPIN);
    hWndTabSizeSpaces=GetDlgItem(hDlg, IDC_OPTIONS_TABSIZE_SPACES);
    hWndSaveRegistry=GetDlgItem(hDlg, IDC_OPTIONS_SAVESETTINGS_REGISTRY);
    hWndSaveINI=GetDlgItem(hDlg, IDC_OPTIONS_SAVESETTINGS_INI);
    hWndMarginLeft=GetDlgItem(hDlg, IDC_OPTIONS_EDITMARGIN_LEFT);
    hWndMarginLeftSpin=GetDlgItem(hDlg, IDC_OPTIONS_EDITMARGIN_LEFT_SPIN);
    hWndMarginRight=GetDlgItem(hDlg, IDC_OPTIONS_EDITMARGIN_RIGHT);
    hWndMarginRightSpin=GetDlgItem(hDlg, IDC_OPTIONS_EDITMARGIN_RIGHT_SPIN);
    hWndDelimiters=GetDlgItem(hDlg, IDC_OPTIONS_DELIMITERS);

    SendMessage(hWndAssociateOpen, BM_SETCHECK, (BOOL)(dwFileTypesAssociated & AE_OPEN), 0);
    SendMessage(hWndAssociateEdit, BM_SETCHECK, (BOOL)(dwFileTypesAssociated & AE_EDIT), 0);
    SendMessage(hWndAssociatePrint, BM_SETCHECK, (BOOL)(dwFileTypesAssociated & AE_PRINT), 0);
    EnableWindow(hWndFileTypesOpen, (BOOL)(dwFileTypesAssociated & AE_OPEN));
    EnableWindow(hWndFileTypesEdit, (BOOL)(dwFileTypesAssociated & AE_EDIT));
    EnableWindow(hWndFileTypesPrint, (BOOL)(dwFileTypesAssociated & AE_PRINT));
    SendMessage(hWndFileTypesOpen, EM_LIMITTEXT, (WPARAM)MAX_PATH, 0);
    SendMessage(hWndFileTypesEdit, EM_LIMITTEXT, (WPARAM)MAX_PATH, 0);
    SendMessage(hWndFileTypesPrint, EM_LIMITTEXT, (WPARAM)MAX_PATH, 0);
    SendMessage(hWndTabSizeSpin, UDM_SETBUDDY, (WPARAM)hWndTabSize, 0);
    SendMessage(hWndTabSizeSpin, UDM_SETRANGE, 0, (LPARAM)MAKELONG(999, 1));
    SendMessage(hWndMarginLeftSpin, UDM_SETBUDDY, (WPARAM)hWndMarginLeft, 0);
    SendMessage(hWndMarginLeftSpin, UDM_SETRANGE, 0, (LPARAM)MAKELONG(999, 0));
    SendMessage(hWndMarginRightSpin, UDM_SETBUDDY, (WPARAM)hWndMarginRight, 0);
    SendMessage(hWndMarginRightSpin, UDM_SETRANGE, 0, (LPARAM)MAKELONG(999, 0));
    SendMessage(hWndDelimiters, EM_LIMITTEXT, (WPARAM)DELIMITERS_SIZE, 0);

    SetWindowText(hWndFileTypesOpen, szFileTypesOpen);
    SetWindowText(hWndFileTypesEdit, szFileTypesEdit);
    SetWindowText(hWndFileTypesPrint, szFileTypesPrint);

    SetDlgItemInt(hDlg, IDC_OPTIONS_TABSIZE, nTabStopSize, FALSE);
    SetDlgItemInt(hDlg, IDC_OPTIONS_EDITMARGIN_LEFT, LOWORD(dwEditMargins), FALSE);
    SetDlgItemInt(hDlg, IDC_OPTIONS_EDITMARGIN_RIGHT, HIWORD(dwEditMargins), FALSE);

    if (bTabStopAsSpaces)
      SendMessage(hWndTabSizeSpaces, BM_SETCHECK, BST_CHECKED, 0);
    if (nSaveSettings == SS_REGISTRY)
      SendMessage(hWndSaveRegistry, BM_SETCHECK, BST_CHECKED, 0);
    else
      SendMessage(hWndSaveINI, BM_SETCHECK, BST_CHECKED, 0);

    EscapeDataToEscapeStringW(wszDelimiters, (wchar_t *)buf);
    WideCharToMultiByte(CP_ACP, 0, (wchar_t *)buf, -1, buf2, BUFFER_SIZE, NULL, NULL);
    SetWindowText(hWndDelimiters, buf2);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_OPTIONS_ASSOCIATE_OPEN)
    {
      bState=SendMessage(hWndAssociateOpen, BM_GETCHECK, 0, 0);
      EnableWindow(hWndFileTypesOpen, bState);
      if (!bState) SetWindowText(hWndFileTypesOpen, szFileTypesOpen);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_OPTIONS_ASSOCIATE_EDIT)
    {
      bState=SendMessage(hWndAssociateEdit, BM_GETCHECK, 0, 0);
      EnableWindow(hWndFileTypesEdit, bState);
      if (!bState) SetWindowText(hWndFileTypesEdit, szFileTypesEdit);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_OPTIONS_ASSOCIATE_PRINT)
    {
      bState=SendMessage(hWndAssociatePrint, BM_GETCHECK, 0, 0);
      EnableWindow(hWndFileTypesPrint, bState);
      if (!bState) SetWindowText(hWndFileTypesPrint, szFileTypesPrint);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_OPTIONS_RESET_DELIMITERS)
    {
      EscapeDataToEscapeStringW(WORD_DELIMITERSW, (wchar_t *)buf);
      WideCharToMultiByte(CP_ACP, 0, (wchar_t *)buf, -1, buf2, BUFFER_SIZE, NULL, NULL);
      SetDlgItemText(hDlg, IDC_OPTIONS_DELIMITERS, buf2);
      return TRUE;
    }
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (((NMHDR *)lParam)->code == PSN_APPLY)
    {
      char szModule[MAX_PATH];
      char szWindowText[MAX_PATH];
      BOOL bShellRefresh=FALSE;
      int a;
      int b;

      //Associations
      GetModuleFileName(hInstance, szModule, MAX_PATH);

      bState=SendMessage(hWndAssociateOpen, BM_GETCHECK, 0, 0);
      if (bState && !(dwFileTypesAssociated & AE_OPEN))
      {
        GetWindowText(hWndFileTypesOpen, szFileTypesOpen, MAX_PATH);
        AssociateFileTypesA(szFileTypesOpen, szModule, AE_OPEN|AE_ASSOCIATE);
        dwFileTypesAssociated|=AE_OPEN;
        bShellRefresh=TRUE;
      }
      else if (bState && (dwFileTypesAssociated & AE_OPEN))
      {
        GetWindowText(hWndFileTypesOpen, szWindowText, MAX_PATH);
        if (lstrcmpi(szWindowText, szFileTypesOpen))
        {
          AssociateFileTypesA(szFileTypesOpen, szModule, AE_OPEN|AE_DEASSOCIATE);
          AssociateFileTypesA(szWindowText, szModule, AE_OPEN|AE_ASSOCIATE);
          lstrcpy(szFileTypesOpen, szWindowText);
        }
        bShellRefresh=TRUE;
      }
      else if (!bState && (dwFileTypesAssociated & AE_OPEN))
      {
        AssociateFileTypesA(szFileTypesOpen, szModule, AE_OPEN|AE_DEASSOCIATE);
        dwFileTypesAssociated&=~AE_OPEN;
        bShellRefresh=TRUE;
      }

      bState=SendMessage(hWndAssociateEdit, BM_GETCHECK, 0, 0);
      if (bState && !(dwFileTypesAssociated & AE_EDIT))
      {
        GetWindowText(hWndFileTypesEdit, szFileTypesEdit, MAX_PATH);
        AssociateFileTypesA(szFileTypesEdit, szModule, AE_EDIT|AE_ASSOCIATE);
        dwFileTypesAssociated|=AE_EDIT;
        bShellRefresh=TRUE;
      }
      else if (bState && (dwFileTypesAssociated & AE_EDIT))
      {
        GetWindowText(hWndFileTypesEdit, szWindowText, MAX_PATH);
        if (lstrcmpi(szWindowText, szFileTypesEdit))
        {
          AssociateFileTypesA(szFileTypesEdit, szModule, AE_EDIT|AE_DEASSOCIATE);
          AssociateFileTypesA(szWindowText, szModule, AE_EDIT|AE_ASSOCIATE);
          lstrcpy(szFileTypesEdit, szWindowText);
        }
        bShellRefresh=TRUE;
      }
      else if (!bState && (dwFileTypesAssociated & AE_EDIT))
      {
        AssociateFileTypesA(szFileTypesEdit, szModule, AE_EDIT|AE_DEASSOCIATE);
        dwFileTypesAssociated&=~AE_EDIT;
        bShellRefresh=TRUE;
      }

      bState=SendMessage(hWndAssociatePrint, BM_GETCHECK, 0, 0);
      if (bState && !(dwFileTypesAssociated & AE_PRINT))
      {
        GetWindowText(hWndFileTypesPrint, szFileTypesPrint, MAX_PATH);
        AssociateFileTypesA(szFileTypesPrint, szModule, AE_PRINT|AE_ASSOCIATE);
        dwFileTypesAssociated|=AE_PRINT;
        bShellRefresh=TRUE;
      }
      else if (bState && (dwFileTypesAssociated & AE_PRINT))
      {
        GetWindowText(hWndFileTypesPrint, szWindowText, MAX_PATH);
        if (lstrcmpi(szWindowText, szFileTypesPrint))
        {
          AssociateFileTypesA(szFileTypesPrint, szModule, AE_PRINT|AE_DEASSOCIATE);
          AssociateFileTypesA(szWindowText, szModule, AE_PRINT|AE_ASSOCIATE);
          lstrcpy(szFileTypesPrint, szWindowText);
        }
        bShellRefresh=TRUE;
      }
      else if (!bState && (dwFileTypesAssociated & AE_PRINT))
      {
        AssociateFileTypesA(szFileTypesPrint, szModule, AE_PRINT|AE_DEASSOCIATE);
        dwFileTypesAssociated&=~AE_PRINT;
        bShellRefresh=TRUE;
      }
      if (bShellRefresh) SHChangeNotify(SHCNE_ASSOCCHANGED, 0, 0, 0);

      //Tab stops
      a=GetDlgItemInt(hDlg, IDC_OPTIONS_TABSIZE, NULL, FALSE);
      if (nTabStopSize != a)
      {
        nTabStopSize=a;
        SetTabStopsA(hWndEdit, nTabStopSize);
      }
      bTabStopAsSpaces=SendMessage(hWndTabSizeSpaces, BM_GETCHECK, 0, 0);

      //Margins
      a=GetDlgItemInt(hDlg, IDC_OPTIONS_EDITMARGIN_LEFT, NULL, FALSE);
      b=GetDlgItemInt(hDlg, IDC_OPTIONS_EDITMARGIN_RIGHT, NULL, FALSE);
      if (dwEditMargins != (DWORD)MAKELONG(a, b))
      {
        dwEditMargins=MAKELONG(a, b);
        API_LoadStringA(hLangLib, MSG_RESTART_PROGRAM, buf, BUFFER_SIZE);
        MessageBox(hMainWnd, buf, APP_MAIN_TITLE, MB_OK|MB_ICONEXCLAMATION);
      }

      //Word delimiters
      a=GetDlgItemText(hDlg, IDC_OPTIONS_DELIMITERS, buf, BUFFER_SIZE);
      MultiByteToWideChar(CP_ACP, 0, buf, ++a, (wchar_t *)buf2, BUFFER_SIZE / sizeof(wchar_t));
      EscapeStringToEscapeDataW((wchar_t *)buf2, wszDelimiters);

      //Save settings
      if (SendMessage(hWndSaveRegistry, BM_GETCHECK, 0, 0) == BST_CHECKED)
        a=SS_REGISTRY;
      else
        a=SS_INI;

      if (nSaveSettings != a)
      {
        nSaveSettings=a;

        if (nSaveSettings == SS_REGISTRY)
        {
          if (FileExistsA(szIniFile))
            WritePrivateProfileDWORDA("Options", "SaveSettings", SS_REGISTRY, szIniFile);
        }
        else
        {
          WritePrivateProfileDWORDA("Options", "SaveSettings", SS_INI, szIniFile);
        }
      }
      if (nSaveSettings == SS_REGISTRY)
        RegSaveOptionsA();
      else
        IniSaveOptionsA();
    }
  }
  return FALSE;
}

BOOL CALLBACK OptionsAdvancedDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndFileTypesOpen;
  static HWND hWndAssociateOpen;
  static HWND hWndFileTypesEdit;
  static HWND hWndAssociateEdit;
  static HWND hWndFileTypesPrint;
  static HWND hWndAssociatePrint;
  static HWND hWndTabSize;
  static HWND hWndTabSizeSpaces;
  static HWND hWndSaveRegistry;
  static HWND hWndSaveINI;
  HWND hWndTabSizeSpin;
  HWND hWndMarginLeft;
  HWND hWndMarginLeftSpin;
  HWND hWndMarginRight;
  HWND hWndMarginRightSpin;
  HWND hWndDelimiters;
  BOOL bState;

  if (uMsg == WM_INITDIALOG)
  {
    hWndFileTypesOpen=GetDlgItem(hDlg, IDC_OPTIONS_FILETYPES_OPEN);
    hWndAssociateOpen=GetDlgItem(hDlg, IDC_OPTIONS_ASSOCIATE_OPEN);
    hWndFileTypesEdit=GetDlgItem(hDlg, IDC_OPTIONS_FILETYPES_EDIT);
    hWndAssociateEdit=GetDlgItem(hDlg, IDC_OPTIONS_ASSOCIATE_EDIT);
    hWndFileTypesPrint=GetDlgItem(hDlg, IDC_OPTIONS_FILETYPES_PRINT);
    hWndAssociatePrint=GetDlgItem(hDlg, IDC_OPTIONS_ASSOCIATE_PRINT);
    hWndTabSize=GetDlgItem(hDlg, IDC_OPTIONS_TABSIZE);
    hWndTabSizeSpin=GetDlgItem(hDlg, IDC_OPTIONS_TABSIZE_SPIN);
    hWndTabSizeSpaces=GetDlgItem(hDlg, IDC_OPTIONS_TABSIZE_SPACES);
    hWndSaveRegistry=GetDlgItem(hDlg, IDC_OPTIONS_SAVESETTINGS_REGISTRY);
    hWndSaveINI=GetDlgItem(hDlg, IDC_OPTIONS_SAVESETTINGS_INI);
    hWndMarginLeft=GetDlgItem(hDlg, IDC_OPTIONS_EDITMARGIN_LEFT);
    hWndMarginLeftSpin=GetDlgItem(hDlg, IDC_OPTIONS_EDITMARGIN_LEFT_SPIN);
    hWndMarginRight=GetDlgItem(hDlg, IDC_OPTIONS_EDITMARGIN_RIGHT);
    hWndMarginRightSpin=GetDlgItem(hDlg, IDC_OPTIONS_EDITMARGIN_RIGHT_SPIN);
    hWndDelimiters=GetDlgItem(hDlg, IDC_OPTIONS_DELIMITERS);

    SendMessage(hWndAssociateOpen, BM_SETCHECK, (BOOL)(dwFileTypesAssociated & AE_OPEN), 0);
    SendMessage(hWndAssociateEdit, BM_SETCHECK, (BOOL)(dwFileTypesAssociated & AE_EDIT), 0);
    SendMessage(hWndAssociatePrint, BM_SETCHECK, (BOOL)(dwFileTypesAssociated & AE_PRINT), 0);
    EnableWindow(hWndFileTypesOpen, (BOOL)(dwFileTypesAssociated & AE_OPEN));
    EnableWindow(hWndFileTypesEdit, (BOOL)(dwFileTypesAssociated & AE_EDIT));
    EnableWindow(hWndFileTypesPrint, (BOOL)(dwFileTypesAssociated & AE_PRINT));
    SendMessage(hWndFileTypesOpen, EM_LIMITTEXT, (WPARAM)MAX_PATH, 0);
    SendMessage(hWndFileTypesEdit, EM_LIMITTEXT, (WPARAM)MAX_PATH, 0);
    SendMessage(hWndFileTypesPrint, EM_LIMITTEXT, (WPARAM)MAX_PATH, 0);
    SendMessage(hWndTabSizeSpin, UDM_SETBUDDY, (WPARAM)hWndTabSize, 0);
    SendMessage(hWndTabSizeSpin, UDM_SETRANGE, 0, (LPARAM)MAKELONG(999, 1));
    SendMessage(hWndMarginLeftSpin, UDM_SETBUDDY, (WPARAM)hWndMarginLeft, 0);
    SendMessage(hWndMarginLeftSpin, UDM_SETRANGE, 0, (LPARAM)MAKELONG(999, 0));
    SendMessage(hWndMarginRightSpin, UDM_SETBUDDY, (WPARAM)hWndMarginRight, 0);
    SendMessage(hWndMarginRightSpin, UDM_SETRANGE, 0, (LPARAM)MAKELONG(999, 0));
    SendMessage(hWndDelimiters, EM_LIMITTEXT, (WPARAM)DELIMITERS_SIZE, 0);

    SetWindowTextW(hWndFileTypesOpen, wszFileTypesOpen);
    SetWindowTextW(hWndFileTypesEdit, wszFileTypesEdit);
    SetWindowTextW(hWndFileTypesPrint, wszFileTypesPrint);

    SetDlgItemInt(hDlg, IDC_OPTIONS_TABSIZE, nTabStopSize, FALSE);
    SetDlgItemInt(hDlg, IDC_OPTIONS_EDITMARGIN_LEFT, LOWORD(dwEditMargins), FALSE);
    SetDlgItemInt(hDlg, IDC_OPTIONS_EDITMARGIN_RIGHT, HIWORD(dwEditMargins), FALSE);

    if (bTabStopAsSpaces)
      SendMessage(hWndTabSizeSpaces, BM_SETCHECK, BST_CHECKED, 0);
    if (nSaveSettings == SS_REGISTRY)
      SendMessage(hWndSaveRegistry, BM_SETCHECK, BST_CHECKED, 0);
    else
      SendMessage(hWndSaveINI, BM_SETCHECK, BST_CHECKED, 0);

    EscapeDataToEscapeStringW(wszDelimiters, wbuf);
    SetWindowTextW(hWndDelimiters, wbuf);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_OPTIONS_ASSOCIATE_OPEN)
    {
      bState=SendMessage(hWndAssociateOpen, BM_GETCHECK, 0, 0);
      EnableWindow(hWndFileTypesOpen, bState);
      if (!bState) SetWindowTextW(hWndFileTypesOpen, wszFileTypesOpen);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_OPTIONS_ASSOCIATE_EDIT)
    {
      bState=SendMessage(hWndAssociateEdit, BM_GETCHECK, 0, 0);
      EnableWindow(hWndFileTypesEdit, bState);
      if (!bState) SetWindowTextW(hWndFileTypesEdit, wszFileTypesEdit);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_OPTIONS_ASSOCIATE_PRINT)
    {
      bState=SendMessage(hWndAssociatePrint, BM_GETCHECK, 0, 0);
      EnableWindow(hWndFileTypesPrint, bState);
      if (!bState) SetWindowTextW(hWndFileTypesPrint, wszFileTypesPrint);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_OPTIONS_RESET_DELIMITERS)
    {
      EscapeDataToEscapeStringW(WORD_DELIMITERSW, wbuf);
      SetDlgItemTextW(hDlg, IDC_OPTIONS_DELIMITERS, wbuf);
      return TRUE;
    }
  }
  else if (uMsg == WM_NOTIFY)
  {
    if (((NMHDR *)lParam)->code == PSN_APPLY)
    {
      wchar_t wszModule[MAX_PATH];
      wchar_t wszWindowText[MAX_PATH];
      BOOL bShellRefresh=FALSE;
      int a;
      int b;

      //Associations
      GetModuleFileNameW(hInstance, wszModule, MAX_PATH);

      bState=SendMessage(hWndAssociateOpen, BM_GETCHECK, 0, 0);
      if (bState && !(dwFileTypesAssociated & AE_OPEN))
      {
        GetWindowTextW(hWndFileTypesOpen, wszFileTypesOpen, MAX_PATH);
        AssociateFileTypesW(wszFileTypesOpen, wszModule, AE_OPEN|AE_ASSOCIATE);
        dwFileTypesAssociated|=AE_OPEN;
        bShellRefresh=TRUE;
      }
      else if (bState && (dwFileTypesAssociated & AE_OPEN))
      {
        GetWindowTextW(hWndFileTypesOpen, wszWindowText, MAX_PATH);
        if (lstrcmpiW(wszWindowText, wszFileTypesOpen))
        {
          AssociateFileTypesW(wszFileTypesOpen, wszModule, AE_OPEN|AE_DEASSOCIATE);
          AssociateFileTypesW(wszWindowText, wszModule, AE_OPEN|AE_ASSOCIATE);
          lstrcpyW(wszFileTypesOpen, wszWindowText);
        }
        bShellRefresh=TRUE;
      }
      else if (!bState && (dwFileTypesAssociated & AE_OPEN))
      {
        AssociateFileTypesW(wszFileTypesOpen, wszModule, AE_OPEN|AE_DEASSOCIATE);
        dwFileTypesAssociated&=~AE_OPEN;
        bShellRefresh=TRUE;
      }

      bState=SendMessage(hWndAssociateEdit, BM_GETCHECK, 0, 0);
      if (bState && !(dwFileTypesAssociated & AE_EDIT))
      {
        GetWindowTextW(hWndFileTypesEdit, wszFileTypesEdit, MAX_PATH);
        AssociateFileTypesW(wszFileTypesEdit, wszModule, AE_EDIT|AE_ASSOCIATE);
        dwFileTypesAssociated|=AE_EDIT;
        bShellRefresh=TRUE;
      }
      else if (bState && (dwFileTypesAssociated & AE_EDIT))
      {
        GetWindowTextW(hWndFileTypesEdit, wszWindowText, MAX_PATH);
        if (lstrcmpiW(wszWindowText, wszFileTypesEdit))
        {
          AssociateFileTypesW(wszFileTypesEdit, wszModule, AE_EDIT|AE_DEASSOCIATE);
          AssociateFileTypesW(wszWindowText, wszModule, AE_EDIT|AE_ASSOCIATE);
          lstrcpyW(wszFileTypesEdit, wszWindowText);
        }
        bShellRefresh=TRUE;
      }
      else if (!bState && (dwFileTypesAssociated & AE_EDIT))
      {
        AssociateFileTypesW(wszFileTypesEdit, wszModule, AE_EDIT|AE_DEASSOCIATE);
        dwFileTypesAssociated&=~AE_EDIT;
        bShellRefresh=TRUE;
      }

      bState=SendMessage(hWndAssociatePrint, BM_GETCHECK, 0, 0);
      if (bState && !(dwFileTypesAssociated & AE_PRINT))
      {
        GetWindowTextW(hWndFileTypesPrint, wszFileTypesPrint, MAX_PATH);
        AssociateFileTypesW(wszFileTypesPrint, wszModule, AE_PRINT|AE_ASSOCIATE);
        dwFileTypesAssociated|=AE_PRINT;
        bShellRefresh=TRUE;
      }
      else if (bState && (dwFileTypesAssociated & AE_PRINT))
      {
        GetWindowTextW(hWndFileTypesPrint, wszWindowText, MAX_PATH);
        if (lstrcmpiW(wszWindowText, wszFileTypesPrint))
        {
          AssociateFileTypesW(wszFileTypesPrint, wszModule, AE_PRINT|AE_DEASSOCIATE);
          AssociateFileTypesW(wszWindowText, wszModule, AE_PRINT|AE_ASSOCIATE);
          lstrcpyW(wszFileTypesPrint, wszWindowText);
        }
        bShellRefresh=TRUE;
      }
      else if (!bState && (dwFileTypesAssociated & AE_PRINT))
      {
        AssociateFileTypesW(wszFileTypesPrint, wszModule, AE_PRINT|AE_DEASSOCIATE);
        dwFileTypesAssociated&=~AE_PRINT;
        bShellRefresh=TRUE;
      }
      if (bShellRefresh) SHChangeNotify(SHCNE_ASSOCCHANGED, 0, 0, 0);

      //Tab stops
      a=GetDlgItemInt(hDlg, IDC_OPTIONS_TABSIZE, NULL, FALSE);
      if (nTabStopSize != a)
      {
        nTabStopSize=a;
        SetTabStopsW(hWndEdit, nTabStopSize);
      }
      bTabStopAsSpaces=SendMessage(hWndTabSizeSpaces, BM_GETCHECK, 0, 0);

      //Margins
      a=GetDlgItemInt(hDlg, IDC_OPTIONS_EDITMARGIN_LEFT, NULL, FALSE);
      b=GetDlgItemInt(hDlg, IDC_OPTIONS_EDITMARGIN_RIGHT, NULL, FALSE);
      if (dwEditMargins != (DWORD)MAKELONG(a, b))
      {
        dwEditMargins=MAKELONG(a, b);
        API_LoadStringW(hLangLib, MSG_RESTART_PROGRAM, wbuf, BUFFER_SIZE);
        MessageBoxW(hMainWnd, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONEXCLAMATION);
      }

      //Word delimiters
      GetDlgItemTextW(hDlg, IDC_OPTIONS_DELIMITERS, wbuf, BUFFER_SIZE);
      EscapeStringToEscapeDataW(wbuf, wszDelimiters);

      //Save settings
      if (SendMessage(hWndSaveRegistry, BM_GETCHECK, 0, 0) == BST_CHECKED)
        a=SS_REGISTRY;
      else
        a=SS_INI;

      if (a != nSaveSettings)
      {
        nSaveSettings=a;

        if (nSaveSettings == SS_REGISTRY)
        {
          if (FileExistsW(wszIniFile))
            WritePrivateProfileDWORDW(L"Options", L"SaveSettings", SS_REGISTRY, wszIniFile);
        }
        else
        {
          WritePrivateProfileDWORDW(L"Options", L"SaveSettings", SS_INI, wszIniFile);
        }
      }
      if (nSaveSettings == SS_REGISTRY)
        RegSaveOptionsW();
      else
        IniSaveOptionsW();
    }
  }
  return FALSE;
}


//// About

BOOL CALLBACK AboutDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    SetDlgItemText(hDlg, IDC_ABOUT_VERSION, APP_ABOUT_VERSION);
    SetDlgItemText(hDlg, IDC_ABOUT_HOMEPAGE, APP_ABOUT_HOMEPAGE);
    SetDlgItemText(hDlg, IDC_ABOUT_EMAIL_KUZNETSOV, APP_ABOUT_EMAIL_KUZNETSOV);
    SetDlgItemText(hDlg, IDC_ABOUT_ICQ_KUZNETSOV, APP_ABOUT_ICQ_KUZNETSOV);
    SetDlgItemText(hDlg, IDC_ABOUT_EMAIL_SHENGALTS, APP_ABOUT_EMAIL_SHENGALTS);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
    {
      EndDialog(hDlg, 0);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_ABOUT_HOMEPAGE)
    {
      ShellExecute(GetParent(hDlg), "open", APP_ABOUT_HOMEPAGE, NULL, NULL, SW_MAXIMIZE);
      return TRUE;
    }
  }
  return FALSE;
}

BOOL CALLBACK AboutDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    SetDlgItemTextW(hDlg, IDC_ABOUT_VERSION, APP_ABOUT_VERSIONW);
    SetDlgItemTextW(hDlg, IDC_ABOUT_HOMEPAGE, APP_ABOUT_HOMEPAGEW);
    SetDlgItemTextW(hDlg, IDC_ABOUT_EMAIL_KUZNETSOV, APP_ABOUT_EMAIL_KUZNETSOVW);
    SetDlgItemTextW(hDlg, IDC_ABOUT_ICQ_KUZNETSOV, APP_ABOUT_ICQ_KUZNETSOVW);
    SetDlgItemTextW(hDlg, IDC_ABOUT_EMAIL_SHENGALTS, APP_ABOUT_EMAIL_SHENGALTSW);
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
    {
      EndDialog(hDlg, 0);
      return TRUE;
    }
    else if (LOWORD(wParam) == IDC_ABOUT_HOMEPAGE)
    {
      ShellExecuteW(GetParent(hDlg), L"open", APP_ABOUT_HOMEPAGEW, NULL, NULL, SW_MAXIMIZE);
      return TRUE;
    }
  }
  return FALSE;
}


//// Other functions

int SetLayout()
{
  int nLayout=LOWORD(GetKeyboardLayout(0));
  if (nLayout != wLangSystem && !ActivateKeyboardLayout((HKL)wLangSystem, 0))
    nLayout=0;
  return nLayout;
}

void RestoreLayout(int nLayout)
{
  if (nLayout) ActivateKeyboardLayout((HKL)nLayout, 0);
}

void SetChosenFontA(HWND hWnd, LOGFONT logfont)
{
  CHARFORMAT cfmt;

  cfmt.cbSize=sizeof(CHARFORMAT);
  cfmt.dwMask=CFM_SIZE|CFM_CHARSET|CFM_FACE|CFM_BOLD|CFM_ITALIC|CFM_UNDERLINE|CFM_STRIKEOUT;
  cfmt.yHeight=PixelsToTwips(hWnd, logfont.lfHeight);
  cfmt.bCharSet=logfont.lfCharSet;
  cfmt.bPitchAndFamily=logfont.lfPitchAndFamily;
  lstrcpy(cfmt.szFaceName, logfont.lfFaceName);
  cfmt.dwEffects=0;
  if (logfont.lfWeight >= FW_BOLD)
    cfmt.dwEffects|=CFE_BOLD;
  if (logfont.lfItalic)
    cfmt.dwEffects|=CFE_ITALIC;
  if (logfont.lfUnderline)
    cfmt.dwEffects|=CFE_UNDERLINE;
  if (logfont.lfStrikeOut)
    cfmt.dwEffects|=CFE_STRIKEOUT;

  SendMessage(hWnd, EM_SETCHARFORMAT, SCF_ALL, (LPARAM)&cfmt);

  //Update tab stops
  SetTabStopsA(hWnd, nTabStopSize);
}

void SetChosenFontW(HWND hWnd, LOGFONTW logfontW)
{
  CHARFORMATW cfmtW;

  cfmtW.cbSize=sizeof(CHARFORMATW);
  cfmtW.dwMask=CFM_SIZE|CFM_CHARSET|CFM_FACE|CFM_BOLD|CFM_ITALIC|CFM_UNDERLINE|CFM_STRIKEOUT;
  cfmtW.yHeight=PixelsToTwips(hWnd, logfontW.lfHeight);
  cfmtW.bCharSet=logfontW.lfCharSet;
  cfmtW.bPitchAndFamily=logfontW.lfPitchAndFamily;
  lstrcpyW(cfmtW.szFaceName, logfontW.lfFaceName);
  cfmtW.dwEffects=0;
  if (logfontW.lfWeight >= FW_BOLD)
    cfmtW.dwEffects|=CFE_BOLD;
  if (logfontW.lfItalic)
    cfmtW.dwEffects|=CFE_ITALIC;
  if (logfontW.lfUnderline)
    cfmtW.dwEffects|=CFE_UNDERLINE;
  if (logfontW.lfStrikeOut)
    cfmtW.dwEffects|=CFE_STRIKEOUT;

  SendMessage(hWnd, EM_SETCHARFORMAT, SCF_ALL, (LPARAM)&cfmtW);

  //Update tab stops
  SetTabStopsW(hWnd, nTabStopSize);
}

void SetChosenFontColor(HWND hWnd, COLORREF crFont)
{
  CHARFORMAT cfmt;

  cfmt.cbSize=sizeof(CHARFORMAT);
  cfmt.dwMask=CFM_COLOR;
  cfmt.dwEffects=0;
  cfmt.crTextColor=crFont;

  SendMessage(hWnd, EM_SETCHARFORMAT, SCF_ALL, (LPARAM)&cfmt);
}

void SetChosenFontSizeA(HWND hWnd, int nPixelHeight)
{
  CHARFORMAT cfmt;

  cfmt.cbSize=sizeof(CHARFORMAT);
  cfmt.dwMask=CFM_SIZE;
  cfmt.yHeight=PixelsToTwips(hWnd, nPixelHeight);

  SendMessage(hWnd, EM_SETCHARFORMAT, SCF_ALL, (LPARAM)&cfmt);

  //Update tab stops
  SetTabStopsA(hWnd, nTabStopSize);
}

void SetChosenFontSizeW(HWND hWnd, int nPixelHeight)
{
  CHARFORMAT cfmt;

  cfmt.cbSize=sizeof(CHARFORMAT);
  cfmt.dwMask=CFM_SIZE;
  cfmt.yHeight=PixelsToTwips(hWnd, nPixelHeight);

  SendMessage(hWnd, EM_SETCHARFORMAT, SCF_ALL, (LPARAM)&cfmt);

  //Update tab stops
  SetTabStopsW(hWnd, nTabStopSize);
}

void SetTabStopsA(HWND hWnd, int nTabStops)
{
  PARAFORMAT2 pf;
  CHARRANGE cr;
  int nWidthTwips;
  int i;

  if (nWidthTwips=GetCharWidthTwipsA(hWndEdit) * nTabStops)
  {
    pf.cbSize=sizeof(PARAFORMAT2);
    pf.dwMask=PFM_TABSTOPS;
    pf.cTabCount=MAX_TAB_STOPS;

    for(i=0; i < pf.cTabCount; ++i)
      pf.rgxTabs[i]=(i + 1) * nWidthTwips;

    //From KankowskiEdit
    SendMessage(hWndEdit, WM_SETREDRAW, FALSE, 0);
    SendMessage(hWndEdit, EM_EXGETSEL, 0, (LPARAM)&cr);
    SendMessage(hWndEdit, EM_SETSEL, 0, -1);
    SendMessage(hWndEdit, EM_SETPARAFORMAT, 0, (LPARAM)&pf);
    SendMessage(hWndEdit, EM_EXSETSEL, 0, (LPARAM)&cr);
    SendMessage(hWndEdit, WM_SETREDRAW, TRUE, 0);
    InvalidateRect(hWndEdit, NULL, FALSE);
  }
}

void SetTabStopsW(HWND hWnd, int nTabStops)
{
  PARAFORMAT2 pf;
  CHARRANGE cr;
  int nWidthTwips;
  int i;

  if (nWidthTwips=GetCharWidthTwipsW(hWndEdit) * nTabStops)
  {
    pf.cbSize=sizeof(PARAFORMAT2);
    pf.dwMask=PFM_TABSTOPS;
    pf.cTabCount=MAX_TAB_STOPS;

    for(i=0; i < pf.cTabCount; ++i)
      pf.rgxTabs[i]=(i + 1) * nWidthTwips;

    //From KankowskiEdit
    SendMessage(hWndEdit, WM_SETREDRAW, FALSE, 0);
    SendMessage(hWndEdit, EM_EXGETSEL, 0, (LPARAM)&cr);
    SendMessage(hWndEdit, EM_SETSEL, 0, -1);
    SendMessage(hWndEdit, EM_SETPARAFORMAT, 0, (LPARAM)&pf);
    SendMessage(hWndEdit, EM_EXSETSEL, 0, (LPARAM)&cr);
    SendMessage(hWndEdit, WM_SETREDRAW, TRUE, 0);
    InvalidateRect(hWndEdit, NULL, FALSE);
  }
}

int GetCharWidthTwipsA(HWND hWnd)
{
  HDC hDC;
  HFONT hFont;
  int nWidth=0;

  if (hDC=GetDC(hWnd))
  {
    if (hFont=CreateFontIndirect(&logfont))
    {
      SelectObject(hDC, hFont);

      if (GetCharWidth(hDC, 'A', 'A', &nWidth))
        nWidth=nWidth*72*20/GetDeviceCaps(hDC, LOGPIXELSX);

      DeleteObject(hFont);
    }
    ReleaseDC(hWnd, hDC);
  }
  return nWidth;
}

int GetCharWidthTwipsW(HWND hWnd)
{
  HDC hDC;
  HFONT hFont;
  int nWidth=0;

  if (hDC=GetDC(hWnd))
  {
    if (hFont=CreateFontIndirectW(&logfontW))
    {
      SelectObject(hDC, hFont);

      if (GetCharWidthW(hDC, 'A', 'A', &nWidth))
        nWidth=nWidth*72*20/GetDeviceCaps(hDC, LOGPIXELSX);

      DeleteObject(hFont);
    }
    ReleaseDC(hWnd, hDC);
  }
  return nWidth;
}

void InsertTabStop(HWND hWnd)
{
  int i;

  if (bTabStopAsSpaces)
  {
    for (i=0; i < nTabStopSize; ++i)
      wbuf[i]=' ';
    wbuf[i]='\0';
    ReplaceSelW(hWnd, (wchar_t *)wbuf);
  }
  else
    SendMessage(hWnd, WM_CHAR, (WPARAM)'\t', 0);
}

void IndentTabStop(HWND hWnd, int nAction)
{
  int i;

  if (bTabStopAsSpaces)
  {
    for (i=0; i < nTabStopSize; ++i)
      wbuf[i]=' ';
    wbuf[i]='\0';
    DoEditInsertStringInSelectionW(hWnd, nAction, wbuf);
  }
  else
    DoEditInsertStringInSelectionW(hWnd, nAction, L"\t");
}

int PixelsToTwips(HWND hWnd, int nPixels)
{
  HDC hDC;
  int nTwips;

  hDC=GetDC(hWnd);
  if (nPixels < 0) nPixels=0 - nPixels;
  nTwips=nPixels*72*20/GetDeviceCaps(hDC, LOGPIXELSY);
  ReleaseDC(hWnd, hDC);

  return nTwips;
}

char* GetCommandLineParamsA()
{
  char *lpCmdLine=GetCommandLine();

  if (*lpCmdLine++ == '\"')
    while (*lpCmdLine != '\"' && *lpCmdLine != '\0') ++lpCmdLine;
  else
    while (*lpCmdLine != ' ' && *lpCmdLine != '\0') ++lpCmdLine;
  if (*lpCmdLine != '\0')
    while (*++lpCmdLine == ' ');

  return lpCmdLine;
}

wchar_t* GetCommandLineParamsW()
{
  wchar_t *lpwCmdLine=GetCommandLineW();

  if (*lpwCmdLine++ == '\"')
    while (*lpwCmdLine != '\"' && *lpwCmdLine != '\0') ++lpwCmdLine;
  else
    while (*lpwCmdLine != ' ' && *lpwCmdLine != '\0') ++lpwCmdLine;
  if (*lpwCmdLine != '\0')
    while (*++lpwCmdLine == ' ');

  return lpwCmdLine;
}

int GetCommandLineArgA(char *lpCmdLine, char *szArg, char **lpNextArg)
{
  char *pCount=lpCmdLine;
  char *pArg=szArg;

  while (*pCount == ' ')
    ++pCount;

  while (*pCount != '\0' && *pCount != ' ')
  {
    for (; *pCount != '\"' && *pCount != ' ' && *pCount != '\0'; ++pArg, ++pCount)
      if (szArg) *pArg=*pCount;

    if (*pCount == '\"')
    {
      for (++pCount; *pCount != '\"' && *pCount != '\0'; ++pArg, ++pCount)
        if (szArg) *pArg=*pCount;
      if (*pCount == '\"') ++pCount;
    }
  }
  if (szArg) *pArg='\0';

  if (lpNextArg)
    for (*lpNextArg=pCount; **lpNextArg == ' '; ++*lpNextArg);

  return (pArg - szArg);
}

int GetCommandLineArgW(wchar_t *lpCmdLine, wchar_t *szArg, wchar_t **lpNextArg)
{
  wchar_t *pCount=lpCmdLine;
  wchar_t *pArg=szArg;

  while (*pCount == ' ')
    ++pCount;

  while (*pCount != '\0' && *pCount != ' ')
  {
    for (; *pCount != '\"' && *pCount != ' ' && *pCount != '\0'; ++pArg, ++pCount)
      if (szArg) *pArg=*pCount;

    if (*pCount == '\"')
    {
      for (++pCount; *pCount != '\"' && *pCount != '\0'; ++pArg, ++pCount)
        if (szArg) *pArg=*pCount;
      if (*pCount == '\"') ++pCount;
    }
  }
  if (szArg) *pArg='\0';

  if (lpNextArg)
    for (*lpNextArg=pCount; **lpNextArg == ' '; ++*lpNextArg);

  return (pArg - szArg);
}

void GetPrivateProfileDWORDA(LPCTSTR lpAppName, LPCTSTR lpKeyName, LPDWORD dwData, LPCTSTR lpFileName)
{
  char szString[32];

  GetPrivateProfileString(lpAppName, lpKeyName, "", szString, 32, lpFileName);
  if (*szString) *dwData=xatoui(szString);
}

void GetPrivateProfileDWORDW(LPCWSTR lpAppName, LPCWSTR lpKeyName, LPDWORD dwData, LPCWSTR lpFileName)
{
  wchar_t wszString[32];

  GetPrivateProfileStringW(lpAppName, lpKeyName, L"", wszString, 32, lpFileName);
  if (*wszString) *dwData=xatouiW(wszString);
}

BOOL WritePrivateProfileDWORDA(LPCTSTR lpAppName, LPCTSTR lpKeyName, DWORD dwData, LPCTSTR lpFileName)
{
  char szString[32];

  xuitoa(dwData, szString, 0);
  return WritePrivateProfileString(lpAppName, lpKeyName, szString, lpFileName);
}

BOOL WritePrivateProfileDWORDW(LPCWSTR lpAppName, LPCWSTR lpKeyName, DWORD dwData, LPCWSTR lpFileName)
{
  wchar_t wszString[32];

  xuitoaW(dwData, wszString, 0);
  return WritePrivateProfileStringW(lpAppName, lpKeyName, wszString, lpFileName);
}

void GetAssociatedIconA(char *pExt, char *szFile, int *nIconIndex, HICON *phiconLarge, HICON *phiconSmall)
{
  HKEY hKey;
  DWORD dwType;
  DWORD dwSize;
  int nIndex=0;
  int i;
  int j;

  if (pExt=GetFileExtA(pExt))
  {
    if (RegOpenKeyEx(HKEY_CLASSES_ROOT, pExt - 1, 0, KEY_READ, &hKey) == ERROR_SUCCESS)
    {
      dwSize=BUFFER_SIZE;
      RegQueryValueEx(hKey, "", NULL, &dwType, (LPBYTE)buf, &dwSize);
      RegCloseKey(hKey);

      wsprintf(buf2, "%s\\DefaultIcon", buf);

      if (RegOpenKeyEx(HKEY_CLASSES_ROOT, buf2, 0, KEY_READ, &hKey) == ERROR_SUCCESS)
      {
        dwSize=BUFFER_SIZE;
        RegQueryValueEx(hKey, "", NULL, &dwType, (LPBYTE)buf2, &dwSize);
        RegCloseKey(hKey);

        for (i=0, j=0; buf2[i]; ++i)
          if (buf2[i] != '\"') buf[j++]=buf2[i];
        buf[j]='\0';

        for (i=lstrlen(buf) - 1; i > 0; --i)
        {
          if (buf[i] == ',')
          {
            buf[i]='\0';
            nIndex=xatoi(buf + i + 1);
            if (nIndex == -1) nIndex=0;
            break;
          }
          else if (buf[i] == '-' || (buf[i] >= '0' && buf[i] <= '9'))
            continue;
          break;
        }
        ExpandEnvironmentStrings(buf, buf2, BUFFER_SIZE);
        (*ExtractIconExAPtr)(buf2, nIndex, phiconLarge, phiconSmall, 1);

        if (szFile) lstrcpy(szFile, buf2);
        if (nIconIndex) *nIconIndex=nIndex;
        return;
      }
    }
  }
  if (szFile) szFile[0]='\0';
  if (nIconIndex) *nIconIndex=0;
  if (phiconLarge) *phiconLarge=0;
  if (phiconSmall) *phiconSmall=0;
}

void GetAssociatedIconW(wchar_t *pExt, wchar_t *wszFile, int *nIconIndex, HICON *phiconLarge, HICON *phiconSmall)
{
  wchar_t *wbuf=(wchar_t *)buf;
  wchar_t *wbuf2=(wchar_t *)buf2;
  HKEY hKey;
  DWORD dwType;
  DWORD dwSize;
  int nIndex;
  int i;
  int j;

  if (pExt=GetFileExtW(pExt))
  {
    if (RegOpenKeyExW(HKEY_CLASSES_ROOT, pExt - 1, 0, KEY_READ, &hKey) == ERROR_SUCCESS)
    {
      dwSize=BUFFER_SIZE / sizeof(wchar_t);
      RegQueryValueExW(hKey, L"", NULL, &dwType, (LPBYTE)wbuf, &dwSize);
      RegCloseKey(hKey);

      wsprintfW(wbuf2, L"%s\\DefaultIcon", wbuf);

      if (RegOpenKeyExW(HKEY_CLASSES_ROOT, wbuf2, 0, KEY_READ, &hKey) == ERROR_SUCCESS)
      {
        dwSize=BUFFER_SIZE / sizeof(wchar_t);
        RegQueryValueExW(hKey, L"", NULL, &dwType, (LPBYTE)wbuf2, &dwSize);
        RegCloseKey(hKey);

        for (i=0, j=0; wbuf2[i]; ++i)
          if (wbuf2[i] != '\"') wbuf[j++]=wbuf2[i];
        wbuf[j]='\0';

        for (i=lstrlenW(wbuf) - 1; i > 0; --i)
        {
          if (wbuf[i] == ',')
          {
            wbuf[i]='\0';
            WideCharToMultiByte(CP_ACP, 0, wbuf + i + 1, -1, (char *)wbuf2, BUFFER_SIZE, 0, 0);
            nIndex=xatoi((char *)wbuf2);
            if (nIndex == -1) nIndex=0;
            break;
          }
          else if (wbuf[i] == '-' || (wbuf[i] >= '0' && wbuf[i] <= '9'))
            continue;
          break;
        }
        ExpandEnvironmentStringsW(wbuf, wbuf2, BUFFER_SIZE / sizeof(wchar_t));
        (*ExtractIconExWPtr)(wbuf2, nIndex, phiconLarge, phiconSmall, 1);

        if (wszFile) lstrcpyW(wszFile, wbuf2);
        if (nIconIndex) *nIconIndex=nIndex;
        return;
      }
    }
  }
  if (wszFile) wszFile[0]='\0';
  if (nIconIndex) *nIconIndex=0;
  if (phiconLarge) *phiconLarge=0;
  if (phiconSmall) *phiconSmall=0;
}

void AssociateFileTypesA(char *pFileTypes, char *pModule, DWORD Flags)
{
  char szAssocKey[MAX_PATH];
  char szTypeKey[16];
  char szExt[16];
  char *pExtStart=pFileTypes;
  char *pExtEnd=pFileTypes;
  HKEY hKey;
  DWORD dwType;
  DWORD dwSize;

  if (Flags & AE_OPEN) lstrcpy(szTypeKey, "Open");
  else if (Flags & AE_EDIT) lstrcpy(szTypeKey, "Edit");
  else if (Flags & AE_PRINT) lstrcpy(szTypeKey, "Print");

  while (1)
  {
    if (pExtEnd=strchr(pExtStart, ';'))
      lstrcpyn(buf, pExtStart, pExtEnd - pExtStart + 1);
    else
      lstrcpy(buf, pExtStart);
    if (!*buf) goto NextExt;
    wsprintf(szExt, ".%s", buf);

    if (RegCreateKeyEx(HKEY_CLASSES_ROOT, szExt, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS)
    {
      dwSize=MAX_PATH;
      if (RegQueryValueEx(hKey, "", NULL, &dwType, (LPBYTE)szAssocKey, &dwSize) != ERROR_SUCCESS || !*szAssocKey)
      {
        if (Flags & AE_ASSOCIATE)
        {
          wsprintf(szAssocKey, "%sfile", szExt + 1);
          RegSetValueEx(hKey, "", 0, REG_SZ, (LPBYTE)szAssocKey, lstrlen(szAssocKey) + 1);
        }
        else if (Flags & AE_DEASSOCIATE)
        {
          RegCloseKey(hKey);
          return;
        }
      }
      RegCloseKey(hKey);

      //Associate icon
      if (Flags & AE_OPEN)
      {
        wsprintf(buf2, "%s\\DefaultIcon", szAssocKey);

        if (RegCreateKeyEx(HKEY_CLASSES_ROOT, buf2, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS)
        {
          dwSize=BUFFER_SIZE;
          if (RegQueryValueEx(hKey, "", NULL, &dwType, (LPBYTE)buf2, &dwSize) != ERROR_SUCCESS || !*buf2)
          {
            if (Flags & AE_ASSOCIATE) RegSetValueEx(hKey, "", 0, REG_SZ, (LPBYTE)pModule, lstrlen(pModule) + 1);
          }
          else if (Flags & AE_DEASSOCIATE)
          {
            if (!lstrcmpi(buf2, pModule)) RegDeleteValue(hKey, "");
          }
          RegCloseKey(hKey);
        }
      }

      //Associate command
      wsprintf(buf2, "%s\\Shell\\%s\\Command", szAssocKey, szTypeKey);
      wsprintf(buf, "\"%s\"%s \"%%1\"", pModule, (Flags & AE_PRINT)?" /p":"");

      if (RegCreateKeyEx(HKEY_CLASSES_ROOT, buf2, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS)
      {
        if (Flags & AE_ASSOCIATE)
        {
          dwSize=BUFFER_SIZE;
          if (RegQueryValueEx(hKey, "", NULL, &dwType, (LPBYTE)buf2, &dwSize) == ERROR_SUCCESS)
          {
            if (*buf2 && lstrcmpi(buf, buf2))
            {
              if (RegQueryValueEx(hKey, "AkelUndo", NULL, NULL, NULL, NULL) != ERROR_SUCCESS)
                RegSetValueEx(hKey, "AkelUndo", 0, dwType, (LPBYTE)buf2, dwSize);
            }
          }
          RegSetValueEx(hKey, "", 0, REG_SZ, (LPBYTE)buf, lstrlen(buf) + 1);
        }
        else if (Flags & AE_DEASSOCIATE)
        {
          dwSize=BUFFER_SIZE;
          if (RegQueryValueEx(hKey, "AkelUndo", NULL, &dwType, (LPBYTE)buf2, &dwSize) == ERROR_SUCCESS)
          {
            if (*buf2) RegSetValueEx(hKey, "", 0, dwType, (LPBYTE)buf2, dwSize);
            RegDeleteValue(hKey, "AkelUndo");
          }
          dwSize=BUFFER_SIZE;
          if (RegQueryValueEx(hKey, "", NULL, &dwType, (LPBYTE)buf2, &dwSize) == ERROR_SUCCESS)
          {
            if (!*buf2 || !lstrcmpi(buf, buf2))
            {
              RegCloseKey(hKey);
              wsprintf(buf2, "%s\\Shell\\%s", szAssocKey, szTypeKey);
              if (RegOpenKeyEx(HKEY_CLASSES_ROOT, buf2, 0, KEY_ENUMERATE_SUB_KEYS, &hKey) == ERROR_SUCCESS)
              {
                RegDeleteKey(hKey, "Command");
                RegCloseKey(hKey);
                wsprintf(buf2, "%s\\Shell", szAssocKey);
                if (RegOpenKeyEx(HKEY_CLASSES_ROOT, buf2, 0, KEY_ENUMERATE_SUB_KEYS, &hKey) == ERROR_SUCCESS)
                {
                  RegDeleteKey(hKey, szTypeKey);
                  dwSize=BUFFER_SIZE;
                  if (RegEnumKeyEx(hKey, 0, buf2, &dwSize, NULL, NULL, NULL, NULL) != ERROR_SUCCESS)
                  {
                    RegCloseKey(hKey);
                    if (RegOpenKeyEx(HKEY_CLASSES_ROOT, szAssocKey, 0, KEY_ENUMERATE_SUB_KEYS, &hKey) == ERROR_SUCCESS)
                      RegDeleteKey(hKey, "Shell");
                  }
                }
              }
            }
          }
        }
        RegCloseKey(hKey);
      }
    }

    //Check off "Always open with this program"
    if (Flags & AE_OPEN)
    {
      wsprintf(buf, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\FileExts\\%s", szExt);

      if (RegOpenKeyEx(HKEY_CURRENT_USER, buf, 0, KEY_QUERY_VALUE|KEY_SET_VALUE, &hKey) == ERROR_SUCCESS)
      {
        if (Flags & AE_ASSOCIATE)
        {
          dwSize=BUFFER_SIZE;
          if (RegQueryValueEx(hKey, "Application", NULL, &dwType, (LPBYTE)buf, &dwSize) == ERROR_SUCCESS)
          {
            if (*buf) RegSetValueEx(hKey, "AkelUndo", 0, dwType, (LPBYTE)buf, dwSize);
            RegDeleteValue(hKey, "Application");
          }
        }
        else if (Flags & AE_DEASSOCIATE)
        {
          dwSize=BUFFER_SIZE;
          if (RegQueryValueEx(hKey, "AkelUndo", NULL, &dwType, (LPBYTE)buf, &dwSize) == ERROR_SUCCESS)
          {
            if (*buf) RegSetValueEx(hKey, "Application", 0, dwType, (LPBYTE)buf, dwSize);
            RegDeleteValue(hKey, "AkelUndo");
          }
        }
      }
    }
    NextExt:
    pExtStart=pExtEnd + 1;
    if (!pExtEnd) break;
    if (!*pExtStart) break;
  }
}

void AssociateFileTypesW(wchar_t *wpFileTypes, wchar_t *wpModule, DWORD Flags)
{
  wchar_t wszAssocKey[MAX_PATH];
  wchar_t wszTypeKey[16];
  wchar_t wszExt[16];
  wchar_t *wpExtStart=wpFileTypes;
  wchar_t *wpExtEnd=wpFileTypes;
  HKEY hKey;
  DWORD dwType;
  DWORD dwSize;

  if (Flags & AE_OPEN) lstrcpyW(wszTypeKey, L"Open");
  else if (Flags & AE_EDIT) lstrcpyW(wszTypeKey, L"Edit");
  else if (Flags & AE_PRINT) lstrcpyW(wszTypeKey, L"Print");

  while (1)
  {
    if (wpExtEnd=wcschr(wpExtStart, ';'))
      lstrcpynW(wbuf, wpExtStart, wpExtEnd - wpExtStart + 1);
    else
      lstrcpyW(wbuf, wpExtStart);
    if (!*wbuf) goto NextExt;
    wsprintfW(wszExt, L".%s", wbuf);

    if (RegCreateKeyExW(HKEY_CLASSES_ROOT, wszExt, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS)
    {
      dwSize=MAX_PATH * sizeof(wchar_t);
      if (RegQueryValueExW(hKey, L"", NULL, &dwType, (LPBYTE)wszAssocKey, &dwSize) != ERROR_SUCCESS || !*wszAssocKey)
      {
        if (Flags & AE_ASSOCIATE)
        {
          wsprintfW(wszAssocKey, L"%sfile", wszExt + 1);
          RegSetValueExW(hKey, L"", 0, REG_SZ, (LPBYTE)wszAssocKey, lstrlenW(wszAssocKey) * sizeof(wchar_t) + 2);
        }
        else if (Flags & AE_DEASSOCIATE)
        {
          RegCloseKey(hKey);
          return;
        }
      }
      RegCloseKey(hKey);

      //Associate icon
      if (Flags & AE_OPEN)
      {
        wsprintfW(wbuf2, L"%s\\DefaultIcon", wszAssocKey);

        if (RegCreateKeyExW(HKEY_CLASSES_ROOT, wbuf2, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS)
        {
          dwSize=BUFFER_SIZE * sizeof(wchar_t);
          if (RegQueryValueExW(hKey, L"", NULL, &dwType, (LPBYTE)wbuf2, &dwSize) != ERROR_SUCCESS || !*wbuf2)
          {
            if (Flags & AE_ASSOCIATE) RegSetValueExW(hKey, L"", 0, REG_SZ, (LPBYTE)wpModule, lstrlenW(wpModule) * sizeof(wchar_t) + 2);
          }
          else if (Flags & AE_DEASSOCIATE)
          {
            if (!lstrcmpiW(wbuf2, wpModule)) RegDeleteValueW(hKey, L"");
          }
          RegCloseKey(hKey);
        }
      }

      //Associate command
      wsprintfW(wbuf2, L"%s\\Shell\\%s\\Command", wszAssocKey, wszTypeKey);
      wsprintfW(wbuf, L"\"%s\"%s \"%%1\"", wpModule, (Flags & AE_PRINT)?L" /p":L"");

      if (RegCreateKeyExW(HKEY_CLASSES_ROOT, wbuf2, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS)
      {
        if (Flags & AE_ASSOCIATE)
        {
          dwSize=BUFFER_SIZE * sizeof(wchar_t);
          if (RegQueryValueExW(hKey, L"", NULL, &dwType, (LPBYTE)wbuf2, &dwSize) == ERROR_SUCCESS)
          {
            if (*wbuf2 && lstrcmpiW(wbuf, wbuf2))
            {
              if (RegQueryValueExW(hKey, L"AkelUndo", NULL, NULL, NULL, NULL) != ERROR_SUCCESS)
                RegSetValueExW(hKey, L"AkelUndo", 0, dwType, (LPBYTE)wbuf2, dwSize);
            }
          }
          RegSetValueExW(hKey, L"", 0, REG_SZ, (LPBYTE)wbuf, lstrlenW(wbuf) * sizeof(wchar_t) + 2);
        }
        else if (Flags & AE_DEASSOCIATE)
        {
          dwSize=BUFFER_SIZE * sizeof(wchar_t);
          if (RegQueryValueExW(hKey, L"AkelUndo", NULL, &dwType, (LPBYTE)wbuf2, &dwSize) == ERROR_SUCCESS)
          {
            if (*wbuf2) RegSetValueExW(hKey, L"", 0, dwType, (LPBYTE)wbuf2, dwSize);
            RegDeleteValueW(hKey, L"AkelUndo");
          }
          dwSize=BUFFER_SIZE * sizeof(wchar_t);
          if (RegQueryValueExW(hKey, L"", NULL, &dwType, (LPBYTE)wbuf2, &dwSize) == ERROR_SUCCESS)
          {
            if (!*wbuf2 || !lstrcmpiW(wbuf, wbuf2))
            {
              RegCloseKey(hKey);
              wsprintfW(wbuf2, L"%s\\Shell\\%s", wszAssocKey, wszTypeKey);
              if (RegOpenKeyExW(HKEY_CLASSES_ROOT, wbuf2, 0, KEY_ENUMERATE_SUB_KEYS, &hKey) == ERROR_SUCCESS)
              {
                RegDeleteKeyW(hKey, L"Command");
                RegCloseKey(hKey);
                wsprintfW(wbuf2, L"%s\\Shell", wszAssocKey);
                if (RegOpenKeyExW(HKEY_CLASSES_ROOT, wbuf2, 0, KEY_ENUMERATE_SUB_KEYS, &hKey) == ERROR_SUCCESS)
                {
                  RegDeleteKeyW(hKey, wszTypeKey);
                  dwSize=BUFFER_SIZE * sizeof(wchar_t);
                  if (RegEnumKeyExW(hKey, 0, wbuf2, &dwSize, NULL, NULL, NULL, NULL) != ERROR_SUCCESS)
                  {
                    RegCloseKey(hKey);
                    if (RegOpenKeyExW(HKEY_CLASSES_ROOT, wszAssocKey, 0, KEY_ENUMERATE_SUB_KEYS, &hKey) == ERROR_SUCCESS)
                      RegDeleteKeyW(hKey, L"Shell");
                  }
                }
              }
            }
          }
        }
        RegCloseKey(hKey);
      }
    }

    //Check off "Always open with this program"
    if (Flags & AE_OPEN)
    {
      wsprintfW(wbuf, L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\FileExts\\%s", wszExt);

      if (RegOpenKeyExW(HKEY_CURRENT_USER, wbuf, 0, KEY_QUERY_VALUE|KEY_SET_VALUE, &hKey) == ERROR_SUCCESS)
      {
        if (Flags & AE_ASSOCIATE)
        {
          dwSize=BUFFER_SIZE * sizeof(wchar_t);
          if (RegQueryValueExW(hKey, L"Application", NULL, &dwType, (LPBYTE)wbuf, &dwSize) == ERROR_SUCCESS)
          {
            if (*wbuf) RegSetValueExW(hKey, L"AkelUndo", 0, dwType, (LPBYTE)wbuf, dwSize);
            RegDeleteValueW(hKey, L"Application");
          }
        }
        else if (Flags & AE_DEASSOCIATE)
        {
          dwSize=BUFFER_SIZE * sizeof(wchar_t);
          if (RegQueryValueExW(hKey, L"AkelUndo", NULL, &dwType, (LPBYTE)wbuf, &dwSize) == ERROR_SUCCESS)
          {
            if (*wbuf) RegSetValueExW(hKey, L"Application", 0, dwType, (LPBYTE)wbuf, dwSize);
            RegDeleteValueW(hKey, L"AkelUndo");
          }
        }
      }
    }
    NextExt:
    wpExtStart=wpExtEnd + 1;
    if (!wpExtEnd) break;
    if (!*wpExtStart) break;
  }
}

BOOL GetFileWriteTimeA(char *pFile, FILETIME *ft)
{
  HANDLE hFile;

  if ((hFile=API_CreateFileA(pFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE)
    return FALSE;

  GetFileTime(hFile, NULL, NULL, ft);
  CloseHandle(hFile);
  return TRUE;
}

BOOL GetFileWriteTimeW(wchar_t *wpFile, FILETIME *ft)
{
  HANDLE hFile;

  if ((hFile=API_CreateFileW(wpFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE)
    return FALSE;

  GetFileTime(hFile, NULL, NULL, ft);
  CloseHandle(hFile);
  return TRUE;
}

BOOL SaveChangedA()
{
  int nChoice;

  if (bModified)
  {
    API_LoadStringA(hLangLib, MSG_DOCUMENT_CHANGED, buf, BUFFER_SIZE);
    nChoice=MessageBox(hMainWnd, buf, APP_MAIN_TITLE, MB_YESNOCANCEL|MB_ICONEXCLAMATION);

    if (nChoice == IDYES)
    {
      if (!DoFileSaveA()) return FALSE;
    }
    else if (nChoice == IDCANCEL) return FALSE;
  }
  return TRUE;
}

BOOL SaveChangedW()
{
  int nChoice;

  if (bModified)
  {
    API_LoadStringW(hLangLib, MSG_DOCUMENT_CHANGED, wbuf, BUFFER_SIZE);
    nChoice=MessageBoxW(hMainWnd, wbuf, APP_MAIN_TITLEW, MB_YESNOCANCEL|MB_ICONEXCLAMATION);

    if (nChoice == IDYES)
    {
      if (!DoFileSaveW()) return FALSE;
    }
    else if (nChoice == IDCANCEL) return FALSE;
  }
  return TRUE;
}

void SetModifyA(BOOL bState, BOOL bFirst)
{
  if (bFirst != TRUE && bModified == bState) return;
  bModified=bState;

  API_LoadStringA(hLangLib, STR_MODIFIED, buf, BUFFER_SIZE);
  SendMessage(hStatus, SB_SETTEXT, 1, (LPARAM)(bModified?buf:""));
}

void SetModifyW(BOOL bState, BOOL bFirst)
{
  if (bFirst != TRUE && bModified == bState) return;
  bModified=bState;

  API_LoadStringW(hLangLib, STR_MODIFIED, wbuf, BUFFER_SIZE);
  SendMessage(hStatus, SB_SETTEXTW, 1, (LPARAM)(bModified?wbuf:L""));
}

void SetNewLineA(int nState, BOOL bFirst)
{
  NMHDR nmhdr={hWndEdit, ID_EDIT, EN_SELCHANGE};

  if (bFirst != TRUE && nNewLine == nState) return;
  nNewLine=nState;

  if (nNewLine == NEWLINE_WIN)
    SendMessage(hStatus, SB_SETTEXT, 3, (LPARAM)"Win");
  else if (nNewLine == NEWLINE_UNIX)
    SendMessage(hStatus, SB_SETTEXT, 3, (LPARAM)"Unix");
  SendMessage(hMainWnd, WM_NOTIFY, ID_EDIT, (LPARAM)&nmhdr);
}

void SetNewLineW(int nState, BOOL bFirst)
{
  NMHDR nmhdr={hWndEdit, ID_EDIT, EN_SELCHANGE};

  if (bFirst != TRUE && nNewLine == nState) return;
  nNewLine=nState;

  if (nNewLine == NEWLINE_WIN)
    SendMessage(hStatus, SB_SETTEXTW, 3, (LPARAM)L"Win");
  else if (nNewLine == NEWLINE_UNIX)
    SendMessage(hStatus, SB_SETTEXTW, 3, (LPARAM)L"Unix");
  SendMessage(hMainWnd, WM_NOTIFY, ID_EDIT, (LPARAM)&nmhdr);
}

void SetInsertStateA(BOOL bState, BOOL bFirst)
{
  if (bFirst != TRUE && bInsertState == bState) return;
  bInsertState=bState;

  SendMessage(hStatus, SB_SETTEXT, 2, (LPARAM)(bInsertState?"Ovr":"Ins"));
}

void SetInsertStateW(BOOL bState, BOOL bFirst)
{
  if (bFirst != TRUE && bInsertState == bState) return;
  bInsertState=bState;

  SendMessage(hStatus, SB_SETTEXTW, 2, (LPARAM)(bInsertState?L"Ovr":L"Ins"));
}

void SetCodePageA(int nCodePage, BOOL bFirst)
{
  CPINFOEX CPInfoEx;

  if (bFirst != TRUE && nCurrentCodePage == LOWORD(nCodePage) && bCurrentBOM == HIWORD(nCodePage)) return;
  nCurrentCodePage=LOWORD(nCodePage);
  bCurrentBOM=HIWORD(nCodePage);

  if (nCurrentCodePage == CP_UNICODE_UCS2_LE)
  {
    lstrcpy(buf, STR_UNICODE_UCS2_LE);
  }
  else if (nCurrentCodePage == CP_UNICODE_UCS2_BE)
  {
    lstrcpy(buf, STR_UNICODE_UCS2_BE);
  }
  else if (nCurrentCodePage == CP_UNICODE_UTF8)
  {
    lstrcpy(buf, STR_UNICODE_UTF8);
  }
  else
  {
    if (GetCPInfoExAPtr && (*GetCPInfoExAPtr)(nCurrentCodePage, 0, &CPInfoEx) && nCurrentCodePage == xatoi(CPInfoEx.CodePageName))
      lstrcpy(buf, CPInfoEx.CodePageName);
    else
      wsprintf(buf, "CP-%u", nCurrentCodePage);
  }
  SendMessage(hStatus, SB_SETTEXT, 4, (LPARAM)buf);
}

void SetCodePageW(int nCodePage, BOOL bFirst)
{
  CPINFOEXW CPInfoExW;

  if (bFirst != TRUE && nCurrentCodePage == LOWORD(nCodePage) && bCurrentBOM == HIWORD(nCodePage)) return;
  nCurrentCodePage=LOWORD(nCodePage);
  bCurrentBOM=HIWORD(nCodePage);

  if (nCurrentCodePage == CP_UNICODE_UCS2_LE)
  {
    lstrcpyW(wbuf, STR_UNICODE_UCS2_LEW);
  }
  else if (nCurrentCodePage == CP_UNICODE_UCS2_BE)
  {
    lstrcpyW(wbuf, STR_UNICODE_UCS2_BEW);
  }
  else if (nCurrentCodePage == CP_UNICODE_UTF8)
  {
    lstrcpyW(wbuf, STR_UNICODE_UTF8W);
  }
  else
  {
    if (GetCPInfoExWPtr && (*GetCPInfoExWPtr)(nCurrentCodePage, 0, &CPInfoExW) && nCurrentCodePage == xatoiW(CPInfoExW.CodePageName))
      lstrcpyW(wbuf, CPInfoExW.CodePageName);
    else
      wsprintfW(wbuf, L"CP-%u", nCurrentCodePage);
  }
  SendMessage(hStatus, SB_SETTEXTW, 4, (LPARAM)wbuf);
}

BOOL FileExistsA(char *pFile)
{
  WIN32_FIND_DATA wfd;
  HANDLE hFind;

  if ((hFind=FindFirstFile(pFile, &wfd)) == INVALID_HANDLE_VALUE)
    return FALSE;

  FindClose(hFind);
  return TRUE;
}

BOOL FileExistsW(wchar_t *wpFile)
{
  WIN32_FIND_DATAW wfdW;
  HANDLE hFind;

  if ((hFind=FindFirstFileW(wpFile, &wfdW)) == INVALID_HANDLE_VALUE)
    return FALSE;

  FindClose(hFind);
  return TRUE;
}

int IsFileA(char *pFile)
{
  WIN32_FIND_DATA wfd;
  HANDLE hFind;

  if ((hFind=FindFirstFile(pFile, &wfd)) == INVALID_HANDLE_VALUE)
    return ERROR_INVALID_HANDLE;

  FindClose(hFind);

  if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
    return ERROR_FILE_NOT_FOUND;

  return ERROR_SUCCESS;
}

int IsFileW(wchar_t *wpFile)
{
  WIN32_FIND_DATAW wfdW;
  HANDLE hFind;

  if ((hFind=FindFirstFileW(wpFile, &wfdW)) == INVALID_HANDLE_VALUE)
    return ERROR_INVALID_HANDLE;

  FindClose(hFind);

  if (wfdW.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
    return ERROR_FILE_NOT_FOUND;

  return ERROR_SUCCESS;
}

BOOL IsPathFullA(char *pPath)
{
  if (pPath[0] == '\\' && pPath[1] == '\\') return TRUE;
  if (pPath[1] != '\0' && pPath[1] == ':') return TRUE;
  return FALSE;
}

BOOL IsPathFullW(wchar_t *wpPath)
{
  if (wpPath[0] == '\\' && wpPath[1] == '\\') return TRUE;
  if (wpPath[1] != '\0' && wpPath[1] == ':') return TRUE;
  return FALSE;
}

char* GetFileNameA(char *pFile)
{
  int i;

  for (i=lstrlen(pFile) - 1; i >= 0; --i)
    if (pFile[i] == '\\') return (pFile + i + 1);

  return pFile;
}

wchar_t* GetFileNameW(wchar_t *wpFile)
{
  int i;

  for (i=lstrlenW(wpFile) - 1; i >= 0; --i)
    if (wpFile[i] == '\\') return (wpFile + i + 1);

  return wpFile;
}

char* GetBaseNameA(char *pFile, char *szBaseName)
{
  int nStart=lstrlen(pFile);
  int nEnd=nStart;

  while (nStart > 0 && pFile[nStart] != '\\')
  {
    if (pFile[nStart] == '.') nEnd=nStart;
    --nStart;
  }
  if (pFile[nStart] == '\\') ++nStart;
  lstrcpyn(szBaseName, pFile + nStart, nEnd - nStart + 1);

  return szBaseName;
}

wchar_t* GetBaseNameW(wchar_t *wpFile, wchar_t *wszBaseName)
{
  int nStart=lstrlenW(wpFile);
  int nEnd=nStart;

  while (nStart > 0 && wpFile[nStart] != '\\')
  {
    if (wpFile[nStart] == '.') nEnd=nStart;
    --nStart;
  }
  if (wpFile[nStart] == '\\') ++nStart;
  lstrcpynW(wszBaseName, wpFile + nStart, nEnd - nStart + 1);

  return wszBaseName;
}

char* GetFileExtA(char *fname)
{
  int i;

  for (i=lstrlen(fname) - 1; i >= 0; --i)
    if (fname[i] == '.') return (fname + i + 1);
    else if (fname[i] == '\\') break;

  return "";
}

wchar_t* GetFileExtW(wchar_t *fname)
{
  int i;

  for (i=lstrlenW(fname) - 1; i >= 0; --i)
    if (fname[i] == '.') return (fname + i + 1);
    else if (fname[i] == '\\') break;

  return L"";
}

void GetFileVersionA(char *pFile, int *nMajor, int *nMinor, int *nRelease, int *nBuild)
{
  DWORD dwHandle;
  DWORD dwVerSize;
  void *pVerBuf;
  UINT uLen;
  VS_FIXEDFILEINFO ffi;
  VS_FIXEDFILEINFO *pffi=&ffi;
  *nMajor=*nMinor=*nRelease=*nBuild=0;

  if (dwVerSize=GetFileVersionInfoSize(pFile, &dwHandle))
  {
    if (pVerBuf=API_HeapAlloc(hHeap, 0, dwVerSize))
    {
      if (GetFileVersionInfo(pFile, dwHandle, dwVerSize, pVerBuf) && VerQueryValue(pVerBuf, "\\", (void **)&pffi, &uLen))
      {
        *nMajor=pffi->dwFileVersionMS / 0x00010000;
        *nMinor=pffi->dwFileVersionMS & 0x0000FFFF;
        *nRelease=pffi->dwFileVersionLS / 0x00010000;
        *nBuild=pffi->dwFileVersionLS & 0x0000FFFF;
      }
      API_HeapFree(hHeap, 0, pVerBuf);
    }
  }
}

void GetFileVersionW(wchar_t *wpFile, int *nMajor, int *nMinor, int *nRelease, int *nBuild)
{
  DWORD dwHandle;
  DWORD dwVerSize;
  void *pVerBuf;
  UINT uLen;
  VS_FIXEDFILEINFO ffi;
  VS_FIXEDFILEINFO *pffi=&ffi;
  *nMajor=*nMinor=*nRelease=*nBuild=0;

  if (dwVerSize=GetFileVersionInfoSizeW(wpFile, &dwHandle))
  {
    if (pVerBuf=API_HeapAlloc(hHeap, 0, dwVerSize))
    {
      if (GetFileVersionInfoW(wpFile, dwHandle, dwVerSize, pVerBuf) && VerQueryValueW(pVerBuf, L"\\", (void **)&pffi, &uLen))
      {
        *nMajor=pffi->dwFileVersionMS / 0x00010000;
        *nMinor=pffi->dwFileVersionMS & 0x0000FFFF;
        *nRelease=pffi->dwFileVersionLS / 0x00010000;
        *nBuild=pffi->dwFileVersionLS & 0x0000FFFF;
      }
      API_HeapFree(hHeap, 0, pVerBuf);
    }
  }
}

int ParseExecCommandA(char *pCommand, char *szBuffer, int nBufferSize)
{
  //%f == szCurrentFile, %a == szExeDir, %% == %
  int a;
  int b;
  char *pFile=szCurrentFile;
  char *pExeDir=szExeDir;
  int nFileLen=lstrlen(pFile);
  int nExeDirLen=lstrlen(pExeDir);

  for (a=0, b=0; pCommand[a] && (!szBuffer || b < nBufferSize); ++a, ++b)
  {
    if (pCommand[a] == '%')
    {
      if (pCommand[++a] == '%')
      {
        if (szBuffer) szBuffer[b]='%';
      }
      else if (pCommand[a] == 'f' || pCommand[a] == 'F')
      {
        if (!szBuffer || b + nFileLen <= nBufferSize)
        {
          if (szBuffer) lstrcpy(szBuffer + b, pFile);
          b+=nFileLen - 1;
        }
        else break;
      }
      else if (pCommand[a] == 'a' || pCommand[a] == 'A')
      {
        if (!szBuffer || b + nExeDirLen <= nBufferSize)
        {
          if (szBuffer) lstrcpy(szBuffer + b, pExeDir);
          b+=nExeDirLen - 1;
        }
        else break;
      }
      else break;
    }
    else if (szBuffer) szBuffer[b]=pCommand[a];
  }
  if (szBuffer && b < nBufferSize) szBuffer[b]='\0';
  return b;
}

int ParseExecCommandW(wchar_t *wpCommand, wchar_t *wszBuffer, int nBufferSize)
{
  //%f == wszCurrentFile, %a == wszExeDir, %% == %
  int a;
  int b;
  wchar_t *wpFile=wszCurrentFile;
  wchar_t *wpExeDir=wszExeDir;
  int nFileLen=lstrlenW(wpFile);
  int nExeDirLen=lstrlenW(wpExeDir);

  for (a=0, b=0; wpCommand[a] && (!wszBuffer || b < nBufferSize); ++a, ++b)
  {
    if (wpCommand[a] == '%')
    {
      if (wpCommand[++a] == '%')
      {
        if (wszBuffer) wszBuffer[b]='%';
      }
      else if (wpCommand[a] == 'f' || wpCommand[a] == 'F')
      {
        if (!wszBuffer || b + nFileLen <= nBufferSize)
        {
          if (wszBuffer) lstrcpyW(wszBuffer + b, wpFile);
          b+=nFileLen - 1;
        }
        else break;
      }
      else if (wpCommand[a] == 'a' || wpCommand[a] == 'A')
      {
        if (!wszBuffer || b + nExeDirLen <= nBufferSize)
        {
          if (wszBuffer) lstrcpyW(wszBuffer + b, wpExeDir);
          b+=nExeDirLen - 1;
        }
        else break;
      }
      else break;
    }
    else if (wszBuffer) wszBuffer[b]=wpCommand[a];
  }
  if (wszBuffer && b < nBufferSize) wszBuffer[b]='\0';
  return b;
}

void UpdateSize(int nWidth, int nHeight)
{
  int i;

  if (!bMDI)
  {
    MoveWindow(hWndEdit, 0, 0, nWidth, nHeight - (bStatusBar?nStatusHeight:0), TRUE);
  }
  else
  {
    i=nHeight - (bStatusBar?nStatusHeight:0) - (nTabView?TAB_HEIGHT:0);

    MoveWindow(hMdiClient, 0, (nTabView == TAB_VIEW_TOP)?TAB_HEIGHT:0, nWidth, i, TRUE);

    if (nTabView == TAB_VIEW_TOP)
      MoveWindow(hTab, 0, 0, nWidth, TAB_HEIGHT, TRUE);
    else if (nTabView == TAB_VIEW_BOTTOM)
      MoveWindow(hTab, 0, i, nWidth, TAB_HEIGHT, TRUE);
  }
}

void UpdateTitleA(char *szFile)
{
  char *pFileName;

  //Get file name without path
  pFileName=GetFileNameA(szFile);

  if (!bMDI)
  {
    //Set caption of synchronizing window
    SetWindowText(hDummyWindow, szFile);

    //Set caption of main window
    wsprintf(buf, "%s - %s", pFileName, APP_MAIN_TITLE);
    SetWindowText(hMainWnd, buf);
  }
  else
  {
    TCITEM tcItem;
    HICON hIcon;
    int nCurSel;
    int i;

    //Set caption of synchronizing window
    SetWindowText(hDummyWindow, "");

    //Set caption of MDI window
    SetWindowText(hWndMdiActive, szFile);

    //Find file icon
    GetAssociatedIconA(pFileName, NULL, NULL, NULL, &hIcon);
    if (!hIcon) hIcon=hIconEmpty;

    //Set tab icon and text
    nCurSel=SendMessage(hTab, TCM_GETCURSEL, 0, 0);
    ImageList_Remove(hImageList, nCurSel);
    i=ImageList_AddIcon(hImageList, hIcon);

    tcItem.mask=TCIF_TEXT|TCIF_IMAGE;
    tcItem.pszText=pFileName;
    tcItem.iImage=i;
    SendMessage(hTab, TCM_SETITEM, nCurSel, (LPARAM)&tcItem);

    //Set MDI window icon
    if (lpWindowData->hIcon != hIconEmpty) DestroyIcon(lpWindowData->hIcon);
    lpWindowData->hIcon=hIcon;
    SendMessage(hWndMdiActive, WM_SETICON, ICON_SMALL, (LPARAM)hIcon);
    DrawMenuBar(hMainWnd);
  }
}

void UpdateTitleW(wchar_t *wszFile)
{
  wchar_t *wpFileName;

  //Get file name without path
  wpFileName=GetFileNameW(wszFile);

  if (!bMDI)
  {
    //Set caption of synchronizing window
    SetWindowTextW(hDummyWindow, wszFile);

    //Set caption of main window
    wsprintfW(wbuf, L"%s - %s", wpFileName, APP_MAIN_TITLEW);
    SetWindowTextW(hMainWnd, wbuf);
  }
  else
  {
    TCITEMW tcItemW;
    HICON hIcon;
    int nCurSel;
    int i;

    //Set caption of synchronizing window
    SetWindowTextW(hDummyWindow, L"");

    //Set caption of MDI window
    SetWindowTextW(hWndMdiActive, wszFile);

    //Find file icon
    GetAssociatedIconW(wpFileName, NULL, NULL, NULL, &hIcon);
    if (!hIcon) hIcon=hIconEmpty;

    //Set tab icon and text
    nCurSel=SendMessage(hTab, TCM_GETCURSEL, 0, 0);
    ImageList_Remove(hImageList, nCurSel);
    i=ImageList_AddIcon(hImageList, hIcon);

    tcItemW.mask=TCIF_TEXT|TCIF_IMAGE;
    tcItemW.pszText=wpFileName;
    tcItemW.iImage=i;
    SendMessage(hTab, TCM_SETITEMW, nCurSel, (LPARAM)&tcItemW);

    //Set MDI window icon
    if (lpWindowData->hIcon != hIconEmpty) DestroyIcon(lpWindowData->hIcon);
    lpWindowData->hIcon=hIcon;
    SendMessage(hWndMdiActive, WM_SETICON, ICON_SMALL, (LPARAM)hIcon);
    DrawMenuBar(hMainWnd);
  }
}

void FreeMemorySearchA()
{
  if (szFind_orig)
  {
    API_HeapFree(hHeap, 0, (LPVOID)szFind_orig);
    if (szFind_orig == szFind)
      szFind=NULL;
    szFind_orig=NULL;
  }
  if (szReplace_orig)
  {
    API_HeapFree(hHeap, 0, (LPVOID)szReplace_orig);
    if (szReplace_orig == szReplace)
      szReplace=NULL;
    szReplace_orig=NULL;
  }

  if (szFind)
  {
    API_HeapFree(hHeap, 0, (LPVOID)szFind);
    szFind=NULL;
  }
  if (szReplace)
  {
    API_HeapFree(hHeap, 0, (LPVOID)szReplace);
    szReplace=NULL;
  }
}

void FreeMemorySearchW()
{
  if (wszFind_orig)
  {
    API_HeapFree(hHeap, 0, (LPVOID)wszFind_orig);
    if (wszFind_orig == wszFind)
      wszFind=NULL;
    wszFind_orig=NULL;
  }
  if (wszReplace_orig)
  {
    API_HeapFree(hHeap, 0, (LPVOID)wszReplace_orig);
    if (wszReplace_orig == wszReplace)
      wszReplace=NULL;
    wszReplace_orig=NULL;
  }

  if (wszFind)
  {
    API_HeapFree(hHeap, 0, (LPVOID)wszFind);
    wszFind=NULL;
  }
  if (wszReplace)
  {
    API_HeapFree(hHeap, 0, (LPVOID)wszReplace);
    wszReplace=NULL;
  }
}

void FreeMemoryRecentFilesA()
{
  if (szRecentNames)
  {
    API_HeapFree(hHeap, 0, (LPVOID)szRecentNames);
    szRecentNames=NULL;
  }
  if (szRecentPositions)
  {
    API_HeapFree(hHeap, 0, (LPVOID)szRecentPositions);
    szRecentPositions=NULL;
  }
  if (szRecentCodepages)
  {
    API_HeapFree(hHeap, 0, (LPVOID)szRecentCodepages);
    szRecentCodepages=NULL;
  }
}

void FreeMemoryRecentFilesW()
{
  if (wszRecentNames)
  {
    API_HeapFree(hHeap, 0, (LPVOID)wszRecentNames);
    wszRecentNames=NULL;
  }
  if (szRecentPositions)
  {
    API_HeapFree(hHeap, 0, (LPVOID)szRecentPositions);
    szRecentPositions=NULL;
  }
  if (szRecentCodepages)
  {
    API_HeapFree(hHeap, 0, (LPVOID)szRecentCodepages);
    szRecentCodepages=NULL;
  }
}


//// OLE Drag'n'Drop

ULONG WINAPI REOLE_AddRef(LPUNKNOWN lpTable)
{
  return ++(((REOLE *)lpTable)->uRefCount);
}

ULONG WINAPI REOLE_Release(LPUNKNOWN lpTable)
{
  return --(((REOLE *)lpTable)->uRefCount);
}

HRESULT WINAPI REOLE_QueryInterface(LPUNKNOWN lpTable, REFIID riid, void **ppvObj)
{
  if(IsEqualIID(riid, IID_IUnknown) || IsEqualIID(riid, IID_IRichEditOleCallback))
  {
    *ppvObj=lpTable;
    REOLE_AddRef((LPUNKNOWN)*ppvObj);
    return S_OK;
  }
  else
  {
    *ppvObj=NULL;
    return E_NOINTERFACE;
  }
}

HRESULT WINAPI REOLE_GetNewStorage(LPUNKNOWN lpTable, LPSTORAGE FAR *lplpstg)
{
  return E_NOTIMPL;
}

HRESULT WINAPI REOLE_GetInPlaceContext(LPUNKNOWN lpTable, LPOLEINPLACEFRAME FAR *lplpFrame, LPOLEINPLACEUIWINDOW FAR *lplpDoc, LPOLEINPLACEFRAMEINFO lpFrameInfo)
{
  return E_NOTIMPL;
}

HRESULT WINAPI REOLE_ShowContainerUI(LPUNKNOWN lpTable, BOOL fShow)
{
  return E_NOTIMPL;
}

HRESULT WINAPI REOLE_QueryInsertObject(LPUNKNOWN lpTable, LPCLSID lpclsid, LPSTORAGE lpstg, LONG cp)
{
  return E_NOTIMPL;
}

HRESULT WINAPI REOLE_DeleteObject(LPUNKNOWN lpTable, LPOLEOBJECT lpoleobj)
{
  return E_NOTIMPL;
}

HRESULT WINAPI REOLE_QueryAcceptData(LPUNKNOWN lpTable, LPDATAOBJECT lpdataobj, CLIPFORMAT FAR *lpcfFormat, DWORD reco, BOOL fReally, HGLOBAL hMetaPict)
{
  FORMATETC fmtetc={CF_UNICODETEXT, 0, DVASPECT_CONTENT, -1, TYMED_HGLOBAL};

  if (lpdataobj->QueryGetData(&fmtetc) == S_OK)
    *lpcfFormat=CF_UNICODETEXT;
  else
    *lpcfFormat=CF_TEXT;

  return S_OK;
}

HRESULT WINAPI REOLE_ContextSensitiveHelp(LPUNKNOWN lpTable, BOOL fEnterMode)
{
  return E_NOTIMPL;
}

HRESULT WINAPI REOLE_GetClipboardData(LPUNKNOWN lpTable, CHARRANGE FAR *lpchrg, DWORD reco, LPDATAOBJECT FAR *lplpdataobj)
{
  return E_NOTIMPL;
}

HRESULT WINAPI REOLE_GetDragDropEffect(LPUNKNOWN lpTable, BOOL fDrag, DWORD grfKeyState, LPDWORD pdwEffect)
{
  return E_NOTIMPL;
}

HRESULT WINAPI REOLE_GetContextMenu(LPUNKNOWN lpTable, WORD seltype, LPOLEOBJECT lpoleobj, CHARRANGE FAR *lpchrg, HMENU FAR *lphmenu)
{
  //HMENU FAR *lphmenu doesn't used, because IRichEditOleCallback interface destroys the menu
  POINT pt;

  if (seltype != GCM_RIGHTMOUSEDROP)
  {
    GetCursorPos(&pt);
    PostMessage(!bMDI?hMainWnd:hWndMdiActive, WM_CONTEXTMENU, (WPARAM)hWndEdit, (LPARAM)MAKELONG(pt.x, pt.y));
  }

  return S_OK;
}


//// API functions replacement

HMENU API_LoadMenuA(HINSTANCE hLoadInstance, LPCTSTR lpMenuName)
{
  HMENU hResult;

  if (!(hResult=LoadMenuA(hLoadInstance, lpMenuName)))
    if (hLoadInstance != hInstance)
      hResult=LoadMenuA(hInstance, lpMenuName);

  return hResult;
}

HMENU API_LoadMenuW(HINSTANCE hLoadInstance, LPCWSTR lpMenuName)
{
  HMENU hResult;

  if (!(hResult=LoadMenuW(hLoadInstance, lpMenuName)))
    if (hLoadInstance != hInstance)
      hResult=LoadMenuW(hInstance, lpMenuName);

  return hResult;
}

HACCEL API_LoadAcceleratorsA(HINSTANCE hLoadInstance, LPCTSTR lpTableName)
{
  HACCEL hResult;

  if (!(hResult=LoadAcceleratorsA(hLoadInstance, lpTableName)))
    if (hLoadInstance != hInstance)
      hResult=LoadAcceleratorsA(hInstance, lpTableName);

  return hResult;
}

HACCEL API_LoadAcceleratorsW(HINSTANCE hLoadInstance, LPCWSTR lpTableName)
{
  HACCEL hResult;

  if (!(hResult=LoadAcceleratorsW(hLoadInstance, lpTableName)))
    if (hLoadInstance != hInstance)
      hResult=LoadAcceleratorsW(hInstance, lpTableName);

  return hResult;
}

HICON API_LoadIconA(HINSTANCE hLoadInstance, LPCTSTR lpIconName)
{
  HICON hResult;

  if (!(hResult=LoadIconA(hLoadInstance, lpIconName)))
    if (hLoadInstance != hInstance)
      hResult=LoadIconA(hInstance, lpIconName);

  return hResult;
}

HICON API_LoadIconW(HINSTANCE hLoadInstance, LPCWSTR lpIconName)
{
  HICON hResult;

  if (!(hResult=LoadIconW(hLoadInstance, lpIconName)))
    if (hLoadInstance != hInstance)
      hResult=LoadIconW(hInstance, lpIconName);

  return hResult;
}

HANDLE API_LoadImageA(HINSTANCE hLoadInstance, LPCTSTR lpszName, UINT uType, int cxDesired, int cyDesired, UINT fuLoad)
{
  HANDLE hResult;

  if (!(hResult=LoadImage(hLoadInstance, lpszName, uType, cxDesired, cyDesired, fuLoad)))
    if (hLoadInstance != hInstance)
      hResult=LoadImage(hInstance, lpszName, uType, cxDesired, cyDesired, fuLoad);

  return hResult;
}

HANDLE API_LoadImageW(HINSTANCE hLoadInstance, LPCWSTR lpszName, UINT uType, int cxDesired, int cyDesired, UINT fuLoad)
{
  HANDLE hResult;

  if (!(hResult=LoadImageW(hLoadInstance, lpszName, uType, cxDesired, cyDesired, fuLoad)))
    if (hLoadInstance != hInstance)
      hResult=LoadImageW(hInstance, lpszName, uType, cxDesired, cyDesired, fuLoad);

  return hResult;
}

int API_LoadStringA(HINSTANCE hLoadInstance, UINT uID, LPTSTR lpBuffer, int nBufferMax)
{
  int nResult;

  if (!(nResult=LoadStringA(hLoadInstance, uID, lpBuffer, nBufferMax)))
    if (hLoadInstance != hInstance)
      if (!(nResult=LoadStringA(hInstance, uID, lpBuffer, nBufferMax)))
        lpBuffer[0]='\0';

  return nResult;
}

int API_LoadStringW(HINSTANCE hLoadInstance, UINT uID, LPWSTR lpBuffer, int nBufferMax)
{
  int nResult;

  if (!(nResult=LoadStringW(hLoadInstance, uID, lpBuffer, nBufferMax)))
    if (hLoadInstance != hInstance)
      if (!(nResult=LoadStringW(hInstance, uID, lpBuffer, nBufferMax)))
        lpBuffer[0]='\0';

  return nResult;
}

HWND API_CreateDialogA(HINSTANCE hLoadInstance, LPCTSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc)
{
  HWND hResult;

  if (!(hResult=CreateDialogA(hLoadInstance, lpTemplateName, hWndParent, lpDialogFunc)))
    if (hLoadInstance != hInstance)
      hResult=CreateDialogA(hInstance, lpTemplateName, hWndParent, lpDialogFunc);

  return hResult;
}

HWND API_CreateDialogW(HINSTANCE hLoadInstance, LPCWSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc)
{
  HWND hResult;

  if (!(hResult=CreateDialogW(hLoadInstance, lpTemplateName, hWndParent, lpDialogFunc)))
    if (hLoadInstance != hInstance)
      hResult=CreateDialogW(hInstance, lpTemplateName, hWndParent, lpDialogFunc);

  return hResult;
}

INT_PTR API_DialogBoxA(HINSTANCE hLoadInstance, LPCTSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc)
{
  INT_PTR nResult;

  if ((nResult=DialogBoxA(hLoadInstance, lpTemplateName, hWndParent, lpDialogFunc)) == -1)
    if (hLoadInstance != hInstance)
      nResult=DialogBoxA(hInstance, lpTemplateName, hWndParent, lpDialogFunc);

  return nResult;
}

INT_PTR API_DialogBoxW(HINSTANCE hLoadInstance, LPCWSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc)
{
  INT_PTR nResult;

  if ((nResult=DialogBoxW(hLoadInstance, lpTemplateName, hWndParent, lpDialogFunc)) == -1)
    if (hLoadInstance != hInstance)
      nResult=DialogBoxW(hInstance, lpTemplateName, hWndParent, lpDialogFunc);

  return nResult;
}

HANDLE API_CreateFileA(LPCTSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition, DWORD dwFlagsAndAttributes, HANDLE hTemplateFile)
{
  HANDLE hResult;

  if ((hResult=CreateFile(lpFileName, dwDesiredAccess, dwShareMode, lpSecurityAttributes, dwCreationDisposition, dwFlagsAndAttributes, hTemplateFile)) == INVALID_HANDLE_VALUE)
  {
    API_LoadStringA(hLangLib, MSG_ERROR_CANNOT_OPEN_FILE, buf, BUFFER_SIZE);
    wsprintf(buf2, buf, lpFileName);
    MessageBox(hMainWnd, buf2, APP_MAIN_TITLE, MB_OK|MB_ICONERROR);
  }

  return hResult;
}

HANDLE API_CreateFileW(LPCWSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition, DWORD dwFlagsAndAttributes, HANDLE hTemplateFile)
{
  HANDLE hResult;

  if ((hResult=CreateFileW(lpFileName, dwDesiredAccess, dwShareMode, lpSecurityAttributes, dwCreationDisposition, dwFlagsAndAttributes, hTemplateFile)) == INVALID_HANDLE_VALUE)
  {
    API_LoadStringW(hLangLib, MSG_ERROR_CANNOT_OPEN_FILE, wbuf, BUFFER_SIZE);
    wsprintfW(wbuf2, wbuf, lpFileName);
    MessageBoxW(hMainWnd, wbuf2, APP_MAIN_TITLEW, MB_OK|MB_ICONERROR);
  }

  return hResult;
}

BOOL API_ReadFileA(HANDLE hFile, LPVOID lpBuffer, DWORD nNumberOfBytesToRead, LPDWORD lpNumberOfBytesRead, LPOVERLAPPED lpOverlapped)
{
  BOOL bResult;

  if (!(bResult=ReadFile(hFile, lpBuffer, nNumberOfBytesToRead, lpNumberOfBytesRead, lpOverlapped)))
  {
    API_LoadStringA(hLangLib, MSG_ERROR_IO, buf, BUFFER_SIZE);
    MessageBox(hMainWnd, buf, APP_MAIN_TITLE, MB_OK|MB_ICONERROR);
  }

  return bResult;
}

BOOL API_ReadFileW(HANDLE hFile, LPVOID lpBuffer, DWORD nNumberOfBytesToRead, LPDWORD lpNumberOfBytesRead, LPOVERLAPPED lpOverlapped)
{
  BOOL bResult;

  if (!(bResult=ReadFile(hFile, lpBuffer, nNumberOfBytesToRead, lpNumberOfBytesRead, lpOverlapped)))
  {
    API_LoadStringW(hLangLib, MSG_ERROR_IO, wbuf, BUFFER_SIZE);
    MessageBoxW(hMainWnd, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONERROR);
  }

  return bResult;
}

BOOL API_WriteFileA(HANDLE hFile, LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite, LPDWORD lpNumberOfBytesWritten, LPOVERLAPPED lpOverlapped)
{
  BOOL bResult;

  if (!(bResult=WriteFile(hFile, lpBuffer, nNumberOfBytesToWrite, lpNumberOfBytesWritten, lpOverlapped)))
  {
    API_LoadStringA(hLangLib, MSG_ERROR_IO, buf, BUFFER_SIZE);
    MessageBox(hMainWnd, buf, APP_MAIN_TITLE, MB_OK|MB_ICONERROR);
  }

  return bResult;
}

BOOL API_WriteFileW(HANDLE hFile, LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite, LPDWORD lpNumberOfBytesWritten, LPOVERLAPPED lpOverlapped)
{
  BOOL bResult;

  if (!(bResult=WriteFile(hFile, lpBuffer, nNumberOfBytesToWrite, lpNumberOfBytesWritten, lpOverlapped)))
  {
    API_LoadStringW(hLangLib, MSG_ERROR_IO, wbuf, BUFFER_SIZE);
    MessageBoxW(hMainWnd, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONERROR);
  }

  return bResult;
}

LPVOID API_HeapAlloc(HANDLE hHeap, DWORD dwFlags, SIZE_T dwBytes)
{
  LPVOID lpResult;

  if (!(lpResult=HeapAlloc(hHeap, dwFlags, dwBytes)))
  {
    if (bOldWindows)
    {
      API_LoadStringA(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY, buf, BUFFER_SIZE);
      MessageBox(hMainWnd, buf, APP_MAIN_TITLE, MB_OK|MB_ICONERROR);
    }
    else
    {
      API_LoadStringW(hLangLib, MSG_ERROR_NOT_ENOUGH_MEMORY, wbuf, BUFFER_SIZE);
      MessageBoxW(hMainWnd, wbuf, APP_MAIN_TITLEW, MB_OK|MB_ICONERROR);
    }
  }

  return lpResult;
}

BOOL API_HeapFree(HANDLE hHeap, DWORD dwFlags, LPVOID lpMem)
{
  BOOL bResult;

  bResult=HeapFree(hHeap, dwFlags, lpMem);

  return bResult;
}
